// Code generated by go-swagger; DO NOT EDIT.

package cloud

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// CloudTargetCreateReader is a Reader for the CloudTargetCreate structure.
type CloudTargetCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CloudTargetCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewCloudTargetCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewCloudTargetCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCloudTargetCreateAccepted creates a CloudTargetCreateAccepted with default headers values
func NewCloudTargetCreateAccepted() *CloudTargetCreateAccepted {
	return &CloudTargetCreateAccepted{}
}

/*
CloudTargetCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type CloudTargetCreateAccepted struct {

	/* Useful for tracking the resource location
	 */
	Location string

	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this cloud target create accepted response has a 2xx status code
func (o *CloudTargetCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this cloud target create accepted response has a 3xx status code
func (o *CloudTargetCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this cloud target create accepted response has a 4xx status code
func (o *CloudTargetCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this cloud target create accepted response has a 5xx status code
func (o *CloudTargetCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this cloud target create accepted response a status code equal to that given
func (o *CloudTargetCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *CloudTargetCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /cloud/targets][%d] cloudTargetCreateAccepted  %+v", 202, o.Payload)
}

func (o *CloudTargetCreateAccepted) String() string {
	return fmt.Sprintf("[POST /cloud/targets][%d] cloudTargetCreateAccepted  %+v", 202, o.Payload)
}

func (o *CloudTargetCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *CloudTargetCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCloudTargetCreateDefault creates a CloudTargetCreateDefault with default headers values
func NewCloudTargetCreateDefault(code int) *CloudTargetCreateDefault {
	return &CloudTargetCreateDefault{
		_statusCode: code,
	}
}

/*
CloudTargetCreateDefault describes a response with status code -1, with default header values.

Error
*/
type CloudTargetCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the cloud target create default response
func (o *CloudTargetCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this cloud target create default response has a 2xx status code
func (o *CloudTargetCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this cloud target create default response has a 3xx status code
func (o *CloudTargetCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this cloud target create default response has a 4xx status code
func (o *CloudTargetCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this cloud target create default response has a 5xx status code
func (o *CloudTargetCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this cloud target create default response a status code equal to that given
func (o *CloudTargetCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *CloudTargetCreateDefault) Error() string {
	return fmt.Sprintf("[POST /cloud/targets][%d] cloud_target_create default  %+v", o._statusCode, o.Payload)
}

func (o *CloudTargetCreateDefault) String() string {
	return fmt.Sprintf("[POST /cloud/targets][%d] cloud_target_create default  %+v", o._statusCode, o.Payload)
}

func (o *CloudTargetCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *CloudTargetCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
