// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewClusterPeerDeleteParams creates a new ClusterPeerDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterPeerDeleteParams() *ClusterPeerDeleteParams {
	return &ClusterPeerDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterPeerDeleteParamsWithTimeout creates a new ClusterPeerDeleteParams object
// with the ability to set a timeout on a request.
func NewClusterPeerDeleteParamsWithTimeout(timeout time.Duration) *ClusterPeerDeleteParams {
	return &ClusterPeerDeleteParams{
		timeout: timeout,
	}
}

// NewClusterPeerDeleteParamsWithContext creates a new ClusterPeerDeleteParams object
// with the ability to set a context for a request.
func NewClusterPeerDeleteParamsWithContext(ctx context.Context) *ClusterPeerDeleteParams {
	return &ClusterPeerDeleteParams{
		Context: ctx,
	}
}

// NewClusterPeerDeleteParamsWithHTTPClient creates a new ClusterPeerDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterPeerDeleteParamsWithHTTPClient(client *http.Client) *ClusterPeerDeleteParams {
	return &ClusterPeerDeleteParams{
		HTTPClient: client,
	}
}

/*
ClusterPeerDeleteParams contains all the parameters to send to the API endpoint

	for the cluster peer delete operation.

	Typically these are written to a http.Request.
*/
type ClusterPeerDeleteParams struct {

	/* UUID.

	   Cluster peer relationship UUID
	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster peer delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterPeerDeleteParams) WithDefaults() *ClusterPeerDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster peer delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterPeerDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cluster peer delete params
func (o *ClusterPeerDeleteParams) WithTimeout(timeout time.Duration) *ClusterPeerDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster peer delete params
func (o *ClusterPeerDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster peer delete params
func (o *ClusterPeerDeleteParams) WithContext(ctx context.Context) *ClusterPeerDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster peer delete params
func (o *ClusterPeerDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster peer delete params
func (o *ClusterPeerDeleteParams) WithHTTPClient(client *http.Client) *ClusterPeerDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster peer delete params
func (o *ClusterPeerDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUID adds the uuid to the cluster peer delete params
func (o *ClusterPeerDeleteParams) WithUUID(uuid string) *ClusterPeerDeleteParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the cluster peer delete params
func (o *ClusterPeerDeleteParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterPeerDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
