// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMetroclusterInterconnectCollectionGetParams creates a new MetroclusterInterconnectCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMetroclusterInterconnectCollectionGetParams() *MetroclusterInterconnectCollectionGetParams {
	return &MetroclusterInterconnectCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMetroclusterInterconnectCollectionGetParamsWithTimeout creates a new MetroclusterInterconnectCollectionGetParams object
// with the ability to set a timeout on a request.
func NewMetroclusterInterconnectCollectionGetParamsWithTimeout(timeout time.Duration) *MetroclusterInterconnectCollectionGetParams {
	return &MetroclusterInterconnectCollectionGetParams{
		timeout: timeout,
	}
}

// NewMetroclusterInterconnectCollectionGetParamsWithContext creates a new MetroclusterInterconnectCollectionGetParams object
// with the ability to set a context for a request.
func NewMetroclusterInterconnectCollectionGetParamsWithContext(ctx context.Context) *MetroclusterInterconnectCollectionGetParams {
	return &MetroclusterInterconnectCollectionGetParams{
		Context: ctx,
	}
}

// NewMetroclusterInterconnectCollectionGetParamsWithHTTPClient creates a new MetroclusterInterconnectCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMetroclusterInterconnectCollectionGetParamsWithHTTPClient(client *http.Client) *MetroclusterInterconnectCollectionGetParams {
	return &MetroclusterInterconnectCollectionGetParams{
		HTTPClient: client,
	}
}

/*
MetroclusterInterconnectCollectionGetParams contains all the parameters to send to the API endpoint

	for the metrocluster interconnect collection get operation.

	Typically these are written to a http.Request.
*/
type MetroclusterInterconnectCollectionGetParams struct {

	/* Adapter.

	   Filter by adapter
	*/
	Adapter *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* InterfacesAddress.

	   Filter by interfaces.address
	*/
	InterfacesAddress *string

	/* InterfacesGateway.

	   Filter by interfaces.gateway
	*/
	InterfacesGateway *string

	/* InterfacesNetmask.

	   Filter by interfaces.netmask
	*/
	InterfacesNetmask *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* MirrorEnabled.

	   Filter by mirror.enabled
	*/
	MirrorEnabled *bool

	/* MirrorState.

	   Filter by mirror.state
	*/
	MirrorState *string

	/* MultipathPolicy.

	   Filter by multipath_policy
	*/
	MultipathPolicy *string

	/* NodeName.

	   Filter by node.name
	*/
	NodeName *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUID *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* PartnerType.

	   Filter by partner_type
	*/
	PartnerType *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* State.

	   Filter by state
	*/
	State *string

	/* Type.

	   Filter by type
	*/
	Type *string

	/* VlanID.

	   Filter by vlan_id
	*/
	VlanID *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the metrocluster interconnect collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterInterconnectCollectionGetParams) WithDefaults() *MetroclusterInterconnectCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the metrocluster interconnect collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterInterconnectCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := MetroclusterInterconnectCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithTimeout(timeout time.Duration) *MetroclusterInterconnectCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithContext(ctx context.Context) *MetroclusterInterconnectCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithHTTPClient(client *http.Client) *MetroclusterInterconnectCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAdapter adds the adapter to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithAdapter(adapter *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetAdapter(adapter)
	return o
}

// SetAdapter adds the adapter to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetAdapter(adapter *string) {
	o.Adapter = adapter
}

// WithFields adds the fields to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithFields(fields []string) *MetroclusterInterconnectCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithInterfacesAddress adds the interfacesAddress to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithInterfacesAddress(interfacesAddress *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetInterfacesAddress(interfacesAddress)
	return o
}

// SetInterfacesAddress adds the interfacesAddress to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetInterfacesAddress(interfacesAddress *string) {
	o.InterfacesAddress = interfacesAddress
}

// WithInterfacesGateway adds the interfacesGateway to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithInterfacesGateway(interfacesGateway *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetInterfacesGateway(interfacesGateway)
	return o
}

// SetInterfacesGateway adds the interfacesGateway to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetInterfacesGateway(interfacesGateway *string) {
	o.InterfacesGateway = interfacesGateway
}

// WithInterfacesNetmask adds the interfacesNetmask to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithInterfacesNetmask(interfacesNetmask *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetInterfacesNetmask(interfacesNetmask)
	return o
}

// SetInterfacesNetmask adds the interfacesNetmask to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetInterfacesNetmask(interfacesNetmask *string) {
	o.InterfacesNetmask = interfacesNetmask
}

// WithMaxRecords adds the maxRecords to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithMaxRecords(maxRecords *int64) *MetroclusterInterconnectCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMirrorEnabled adds the mirrorEnabled to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithMirrorEnabled(mirrorEnabled *bool) *MetroclusterInterconnectCollectionGetParams {
	o.SetMirrorEnabled(mirrorEnabled)
	return o
}

// SetMirrorEnabled adds the mirrorEnabled to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetMirrorEnabled(mirrorEnabled *bool) {
	o.MirrorEnabled = mirrorEnabled
}

// WithMirrorState adds the mirrorState to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithMirrorState(mirrorState *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetMirrorState(mirrorState)
	return o
}

// SetMirrorState adds the mirrorState to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetMirrorState(mirrorState *string) {
	o.MirrorState = mirrorState
}

// WithMultipathPolicy adds the multipathPolicy to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithMultipathPolicy(multipathPolicy *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetMultipathPolicy(multipathPolicy)
	return o
}

// SetMultipathPolicy adds the multipathPolicy to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetMultipathPolicy(multipathPolicy *string) {
	o.MultipathPolicy = multipathPolicy
}

// WithNodeName adds the nodeName to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithNodeName(nodeName *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetNodeName(nodeName)
	return o
}

// SetNodeName adds the nodeName to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetNodeName(nodeName *string) {
	o.NodeName = nodeName
}

// WithNodeUUID adds the nodeUUID to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithNodeUUID(nodeUUID *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetNodeUUID(nodeUUID)
	return o
}

// SetNodeUUID adds the nodeUuid to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetNodeUUID(nodeUUID *string) {
	o.NodeUUID = nodeUUID
}

// WithOrderBy adds the orderBy to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithOrderBy(orderBy []string) *MetroclusterInterconnectCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithPartnerType adds the partnerType to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithPartnerType(partnerType *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetPartnerType(partnerType)
	return o
}

// SetPartnerType adds the partnerType to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetPartnerType(partnerType *string) {
	o.PartnerType = partnerType
}

// WithReturnRecords adds the returnRecords to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithReturnRecords(returnRecords *bool) *MetroclusterInterconnectCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *MetroclusterInterconnectCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithState adds the state to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithState(state *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetState(state *string) {
	o.State = state
}

// WithType adds the typeVar to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithType(typeVar *string) *MetroclusterInterconnectCollectionGetParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WithVlanID adds the vlanID to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) WithVlanID(vlanID *int64) *MetroclusterInterconnectCollectionGetParams {
	o.SetVlanID(vlanID)
	return o
}

// SetVlanID adds the vlanId to the metrocluster interconnect collection get params
func (o *MetroclusterInterconnectCollectionGetParams) SetVlanID(vlanID *int64) {
	o.VlanID = vlanID
}

// WriteToRequest writes these params to a swagger request
func (o *MetroclusterInterconnectCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Adapter != nil {

		// query param adapter
		var qrAdapter string

		if o.Adapter != nil {
			qrAdapter = *o.Adapter
		}
		qAdapter := qrAdapter
		if qAdapter != "" {

			if err := r.SetQueryParam("adapter", qAdapter); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.InterfacesAddress != nil {

		// query param interfaces.address
		var qrInterfacesAddress string

		if o.InterfacesAddress != nil {
			qrInterfacesAddress = *o.InterfacesAddress
		}
		qInterfacesAddress := qrInterfacesAddress
		if qInterfacesAddress != "" {

			if err := r.SetQueryParam("interfaces.address", qInterfacesAddress); err != nil {
				return err
			}
		}
	}

	if o.InterfacesGateway != nil {

		// query param interfaces.gateway
		var qrInterfacesGateway string

		if o.InterfacesGateway != nil {
			qrInterfacesGateway = *o.InterfacesGateway
		}
		qInterfacesGateway := qrInterfacesGateway
		if qInterfacesGateway != "" {

			if err := r.SetQueryParam("interfaces.gateway", qInterfacesGateway); err != nil {
				return err
			}
		}
	}

	if o.InterfacesNetmask != nil {

		// query param interfaces.netmask
		var qrInterfacesNetmask string

		if o.InterfacesNetmask != nil {
			qrInterfacesNetmask = *o.InterfacesNetmask
		}
		qInterfacesNetmask := qrInterfacesNetmask
		if qInterfacesNetmask != "" {

			if err := r.SetQueryParam("interfaces.netmask", qInterfacesNetmask); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.MirrorEnabled != nil {

		// query param mirror.enabled
		var qrMirrorEnabled bool

		if o.MirrorEnabled != nil {
			qrMirrorEnabled = *o.MirrorEnabled
		}
		qMirrorEnabled := swag.FormatBool(qrMirrorEnabled)
		if qMirrorEnabled != "" {

			if err := r.SetQueryParam("mirror.enabled", qMirrorEnabled); err != nil {
				return err
			}
		}
	}

	if o.MirrorState != nil {

		// query param mirror.state
		var qrMirrorState string

		if o.MirrorState != nil {
			qrMirrorState = *o.MirrorState
		}
		qMirrorState := qrMirrorState
		if qMirrorState != "" {

			if err := r.SetQueryParam("mirror.state", qMirrorState); err != nil {
				return err
			}
		}
	}

	if o.MultipathPolicy != nil {

		// query param multipath_policy
		var qrMultipathPolicy string

		if o.MultipathPolicy != nil {
			qrMultipathPolicy = *o.MultipathPolicy
		}
		qMultipathPolicy := qrMultipathPolicy
		if qMultipathPolicy != "" {

			if err := r.SetQueryParam("multipath_policy", qMultipathPolicy); err != nil {
				return err
			}
		}
	}

	if o.NodeName != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeName != nil {
			qrNodeName = *o.NodeName
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUID != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUID != nil {
			qrNodeUUID = *o.NodeUUID
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PartnerType != nil {

		// query param partner_type
		var qrPartnerType string

		if o.PartnerType != nil {
			qrPartnerType = *o.PartnerType
		}
		qPartnerType := qrPartnerType
		if qPartnerType != "" {

			if err := r.SetQueryParam("partner_type", qPartnerType); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.State != nil {

		// query param state
		var qrState string

		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.VlanID != nil {

		// query param vlan_id
		var qrVlanID int64

		if o.VlanID != nil {
			qrVlanID = *o.VlanID
		}
		qVlanID := swag.FormatInt64(qrVlanID)
		if qVlanID != "" {

			if err := r.SetQueryParam("vlan_id", qVlanID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMetroclusterInterconnectCollectionGet binds the parameter fields
func (o *MetroclusterInterconnectCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamMetroclusterInterconnectCollectionGet binds the parameter order_by
func (o *MetroclusterInterconnectCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
