// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SoftwareUploadReader is a Reader for the SoftwareUpload structure.
type SoftwareUploadReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SoftwareUploadReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSoftwareUploadAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSoftwareUploadDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSoftwareUploadAccepted creates a SoftwareUploadAccepted with default headers values
func NewSoftwareUploadAccepted() *SoftwareUploadAccepted {
	return &SoftwareUploadAccepted{}
}

/*
SoftwareUploadAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SoftwareUploadAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this software upload accepted response has a 2xx status code
func (o *SoftwareUploadAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this software upload accepted response has a 3xx status code
func (o *SoftwareUploadAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this software upload accepted response has a 4xx status code
func (o *SoftwareUploadAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this software upload accepted response has a 5xx status code
func (o *SoftwareUploadAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this software upload accepted response a status code equal to that given
func (o *SoftwareUploadAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SoftwareUploadAccepted) Error() string {
	return fmt.Sprintf("[POST /cluster/software/upload][%d] softwareUploadAccepted  %+v", 202, o.Payload)
}

func (o *SoftwareUploadAccepted) String() string {
	return fmt.Sprintf("[POST /cluster/software/upload][%d] softwareUploadAccepted  %+v", 202, o.Payload)
}

func (o *SoftwareUploadAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SoftwareUploadAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSoftwareUploadDefault creates a SoftwareUploadDefault with default headers values
func NewSoftwareUploadDefault(code int) *SoftwareUploadDefault {
	return &SoftwareUploadDefault{
		_statusCode: code,
	}
}

/*
SoftwareUploadDefault describes a response with status code -1, with default header values.

Error
*/
type SoftwareUploadDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the software upload default response
func (o *SoftwareUploadDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this software upload default response has a 2xx status code
func (o *SoftwareUploadDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this software upload default response has a 3xx status code
func (o *SoftwareUploadDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this software upload default response has a 4xx status code
func (o *SoftwareUploadDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this software upload default response has a 5xx status code
func (o *SoftwareUploadDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this software upload default response a status code equal to that given
func (o *SoftwareUploadDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SoftwareUploadDefault) Error() string {
	return fmt.Sprintf("[POST /cluster/software/upload][%d] software_upload default  %+v", o._statusCode, o.Payload)
}

func (o *SoftwareUploadDefault) String() string {
	return fmt.Sprintf("[POST /cluster/software/upload][%d] software_upload default  %+v", o._statusCode, o.Payload)
}

func (o *SoftwareUploadDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SoftwareUploadDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
