// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewActiveDirectoryDeleteParams creates a new ActiveDirectoryDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewActiveDirectoryDeleteParams() *ActiveDirectoryDeleteParams {
	return &ActiveDirectoryDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewActiveDirectoryDeleteParamsWithTimeout creates a new ActiveDirectoryDeleteParams object
// with the ability to set a timeout on a request.
func NewActiveDirectoryDeleteParamsWithTimeout(timeout time.Duration) *ActiveDirectoryDeleteParams {
	return &ActiveDirectoryDeleteParams{
		timeout: timeout,
	}
}

// NewActiveDirectoryDeleteParamsWithContext creates a new ActiveDirectoryDeleteParams object
// with the ability to set a context for a request.
func NewActiveDirectoryDeleteParamsWithContext(ctx context.Context) *ActiveDirectoryDeleteParams {
	return &ActiveDirectoryDeleteParams{
		Context: ctx,
	}
}

// NewActiveDirectoryDeleteParamsWithHTTPClient creates a new ActiveDirectoryDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewActiveDirectoryDeleteParamsWithHTTPClient(client *http.Client) *ActiveDirectoryDeleteParams {
	return &ActiveDirectoryDeleteParams{
		HTTPClient: client,
	}
}

/*
ActiveDirectoryDeleteParams contains all the parameters to send to the API endpoint

	for the active directory delete operation.

	Typically these are written to a http.Request.
*/
type ActiveDirectoryDeleteParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.ActiveDirectoryDelete

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the active directory delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryDeleteParams) WithDefaults() *ActiveDirectoryDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the active directory delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the active directory delete params
func (o *ActiveDirectoryDeleteParams) WithTimeout(timeout time.Duration) *ActiveDirectoryDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the active directory delete params
func (o *ActiveDirectoryDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the active directory delete params
func (o *ActiveDirectoryDeleteParams) WithContext(ctx context.Context) *ActiveDirectoryDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the active directory delete params
func (o *ActiveDirectoryDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the active directory delete params
func (o *ActiveDirectoryDeleteParams) WithHTTPClient(client *http.Client) *ActiveDirectoryDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the active directory delete params
func (o *ActiveDirectoryDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the active directory delete params
func (o *ActiveDirectoryDeleteParams) WithInfo(info *models.ActiveDirectoryDelete) *ActiveDirectoryDeleteParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the active directory delete params
func (o *ActiveDirectoryDeleteParams) SetInfo(info *models.ActiveDirectoryDelete) {
	o.Info = info
}

// WithSvmUUID adds the svmUUID to the active directory delete params
func (o *ActiveDirectoryDeleteParams) WithSvmUUID(svmUUID string) *ActiveDirectoryDeleteParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the active directory delete params
func (o *ActiveDirectoryDeleteParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *ActiveDirectoryDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
