// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewActiveDirectoryPreferredDcGetParams creates a new ActiveDirectoryPreferredDcGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewActiveDirectoryPreferredDcGetParams() *ActiveDirectoryPreferredDcGetParams {
	return &ActiveDirectoryPreferredDcGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewActiveDirectoryPreferredDcGetParamsWithTimeout creates a new ActiveDirectoryPreferredDcGetParams object
// with the ability to set a timeout on a request.
func NewActiveDirectoryPreferredDcGetParamsWithTimeout(timeout time.Duration) *ActiveDirectoryPreferredDcGetParams {
	return &ActiveDirectoryPreferredDcGetParams{
		timeout: timeout,
	}
}

// NewActiveDirectoryPreferredDcGetParamsWithContext creates a new ActiveDirectoryPreferredDcGetParams object
// with the ability to set a context for a request.
func NewActiveDirectoryPreferredDcGetParamsWithContext(ctx context.Context) *ActiveDirectoryPreferredDcGetParams {
	return &ActiveDirectoryPreferredDcGetParams{
		Context: ctx,
	}
}

// NewActiveDirectoryPreferredDcGetParamsWithHTTPClient creates a new ActiveDirectoryPreferredDcGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewActiveDirectoryPreferredDcGetParamsWithHTTPClient(client *http.Client) *ActiveDirectoryPreferredDcGetParams {
	return &ActiveDirectoryPreferredDcGetParams{
		HTTPClient: client,
	}
}

/*
ActiveDirectoryPreferredDcGetParams contains all the parameters to send to the API endpoint

	for the active directory preferred dc get operation.

	Typically these are written to a http.Request.
*/
type ActiveDirectoryPreferredDcGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* Fqdn.

	   Fully Qualified Domain Name.
	*/
	Fqdn string

	/* ServerIP.

	   DC's IP address.
	*/
	ServerIP string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the active directory preferred dc get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryPreferredDcGetParams) WithDefaults() *ActiveDirectoryPreferredDcGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the active directory preferred dc get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ActiveDirectoryPreferredDcGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithTimeout(timeout time.Duration) *ActiveDirectoryPreferredDcGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithContext(ctx context.Context) *ActiveDirectoryPreferredDcGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithHTTPClient(client *http.Client) *ActiveDirectoryPreferredDcGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithFields(fields []string) *ActiveDirectoryPreferredDcGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithFqdn adds the fqdn to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithFqdn(fqdn string) *ActiveDirectoryPreferredDcGetParams {
	o.SetFqdn(fqdn)
	return o
}

// SetFqdn adds the fqdn to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetFqdn(fqdn string) {
	o.Fqdn = fqdn
}

// WithServerIP adds the serverIP to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithServerIP(serverIP string) *ActiveDirectoryPreferredDcGetParams {
	o.SetServerIP(serverIP)
	return o
}

// SetServerIP adds the serverIp to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetServerIP(serverIP string) {
	o.ServerIP = serverIP
}

// WithSvmUUID adds the svmUUID to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) WithSvmUUID(svmUUID string) *ActiveDirectoryPreferredDcGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the active directory preferred dc get params
func (o *ActiveDirectoryPreferredDcGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *ActiveDirectoryPreferredDcGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param fqdn
	if err := r.SetPathParam("fqdn", o.Fqdn); err != nil {
		return err
	}

	// path param server_ip
	if err := r.SetPathParam("server_ip", o.ServerIP); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamActiveDirectoryPreferredDcGet binds the parameter fields
func (o *ActiveDirectoryPreferredDcGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
