// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewKerberosRealmGetParams creates a new KerberosRealmGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewKerberosRealmGetParams() *KerberosRealmGetParams {
	return &KerberosRealmGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewKerberosRealmGetParamsWithTimeout creates a new KerberosRealmGetParams object
// with the ability to set a timeout on a request.
func NewKerberosRealmGetParamsWithTimeout(timeout time.Duration) *KerberosRealmGetParams {
	return &KerberosRealmGetParams{
		timeout: timeout,
	}
}

// NewKerberosRealmGetParamsWithContext creates a new KerberosRealmGetParams object
// with the ability to set a context for a request.
func NewKerberosRealmGetParamsWithContext(ctx context.Context) *KerberosRealmGetParams {
	return &KerberosRealmGetParams{
		Context: ctx,
	}
}

// NewKerberosRealmGetParamsWithHTTPClient creates a new KerberosRealmGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewKerberosRealmGetParamsWithHTTPClient(client *http.Client) *KerberosRealmGetParams {
	return &KerberosRealmGetParams{
		HTTPClient: client,
	}
}

/*
KerberosRealmGetParams contains all the parameters to send to the API endpoint

	for the kerberos realm get operation.

	Typically these are written to a http.Request.
*/
type KerberosRealmGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* Name.

	   Kerberos realm
	*/
	Name string

	/* SvmUUID.

	   SVM UUID
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the kerberos realm get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosRealmGetParams) WithDefaults() *KerberosRealmGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the kerberos realm get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosRealmGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the kerberos realm get params
func (o *KerberosRealmGetParams) WithTimeout(timeout time.Duration) *KerberosRealmGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the kerberos realm get params
func (o *KerberosRealmGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the kerberos realm get params
func (o *KerberosRealmGetParams) WithContext(ctx context.Context) *KerberosRealmGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the kerberos realm get params
func (o *KerberosRealmGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the kerberos realm get params
func (o *KerberosRealmGetParams) WithHTTPClient(client *http.Client) *KerberosRealmGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the kerberos realm get params
func (o *KerberosRealmGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the kerberos realm get params
func (o *KerberosRealmGetParams) WithFields(fields []string) *KerberosRealmGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the kerberos realm get params
func (o *KerberosRealmGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithName adds the name to the kerberos realm get params
func (o *KerberosRealmGetParams) WithName(name string) *KerberosRealmGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the kerberos realm get params
func (o *KerberosRealmGetParams) SetName(name string) {
	o.Name = name
}

// WithSvmUUID adds the svmUUID to the kerberos realm get params
func (o *KerberosRealmGetParams) WithSvmUUID(svmUUID string) *KerberosRealmGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the kerberos realm get params
func (o *KerberosRealmGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *KerberosRealmGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamKerberosRealmGet binds the parameter fields
func (o *KerberosRealmGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
