// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewKerberosRealmModifyParams creates a new KerberosRealmModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewKerberosRealmModifyParams() *KerberosRealmModifyParams {
	return &KerberosRealmModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewKerberosRealmModifyParamsWithTimeout creates a new KerberosRealmModifyParams object
// with the ability to set a timeout on a request.
func NewKerberosRealmModifyParamsWithTimeout(timeout time.Duration) *KerberosRealmModifyParams {
	return &KerberosRealmModifyParams{
		timeout: timeout,
	}
}

// NewKerberosRealmModifyParamsWithContext creates a new KerberosRealmModifyParams object
// with the ability to set a context for a request.
func NewKerberosRealmModifyParamsWithContext(ctx context.Context) *KerberosRealmModifyParams {
	return &KerberosRealmModifyParams{
		Context: ctx,
	}
}

// NewKerberosRealmModifyParamsWithHTTPClient creates a new KerberosRealmModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewKerberosRealmModifyParamsWithHTTPClient(client *http.Client) *KerberosRealmModifyParams {
	return &KerberosRealmModifyParams{
		HTTPClient: client,
	}
}

/*
KerberosRealmModifyParams contains all the parameters to send to the API endpoint

	for the kerberos realm modify operation.

	Typically these are written to a http.Request.
*/
type KerberosRealmModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.KerberosRealm

	/* Name.

	   Kerberos realm
	*/
	Name string

	/* SvmUUID.

	   SVM UUID
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the kerberos realm modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosRealmModifyParams) WithDefaults() *KerberosRealmModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the kerberos realm modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KerberosRealmModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithTimeout(timeout time.Duration) *KerberosRealmModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithContext(ctx context.Context) *KerberosRealmModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithHTTPClient(client *http.Client) *KerberosRealmModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithInfo(info *models.KerberosRealm) *KerberosRealmModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetInfo(info *models.KerberosRealm) {
	o.Info = info
}

// WithName adds the name to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithName(name string) *KerberosRealmModifyParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetName(name string) {
	o.Name = name
}

// WithSvmUUID adds the svmUUID to the kerberos realm modify params
func (o *KerberosRealmModifyParams) WithSvmUUID(svmUUID string) *KerberosRealmModifyParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the kerberos realm modify params
func (o *KerberosRealmModifyParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *KerberosRealmModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
