// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLocalCifsUserCollectionGetParams creates a new LocalCifsUserCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsUserCollectionGetParams() *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsUserCollectionGetParamsWithTimeout creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLocalCifsUserCollectionGetParamsWithTimeout(timeout time.Duration) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		timeout: timeout,
	}
}

// NewLocalCifsUserCollectionGetParamsWithContext creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a context for a request.
func NewLocalCifsUserCollectionGetParamsWithContext(ctx context.Context) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		Context: ctx,
	}
}

// NewLocalCifsUserCollectionGetParamsWithHTTPClient creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsUserCollectionGetParamsWithHTTPClient(client *http.Client) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		HTTPClient: client,
	}
}

/*
LocalCifsUserCollectionGetParams contains all the parameters to send to the API endpoint

	for the local cifs user collection get operation.

	Typically these are written to a http.Request.
*/
type LocalCifsUserCollectionGetParams struct {

	/* AccountDisabled.

	   Filter by account_disabled
	*/
	AccountDisabled *bool

	/* Description.

	   Filter by description
	*/
	Description *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* FullName.

	   Filter by full_name
	*/
	FullName *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* MembershipName.

	   Filter by membership.name
	*/
	MembershipName *string

	/* MembershipSid.

	   Filter by membership.sid
	*/
	MembershipSid *string

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* Sid.

	   Filter by sid
	*/
	Sid *string

	/* SvmName.

	   Filter by svm.name
	*/
	SvmName *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SvmUUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserCollectionGetParams) WithDefaults() *LocalCifsUserCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := LocalCifsUserCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithTimeout(timeout time.Duration) *LocalCifsUserCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithContext(ctx context.Context) *LocalCifsUserCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithHTTPClient(client *http.Client) *LocalCifsUserCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountDisabled adds the accountDisabled to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithAccountDisabled(accountDisabled *bool) *LocalCifsUserCollectionGetParams {
	o.SetAccountDisabled(accountDisabled)
	return o
}

// SetAccountDisabled adds the accountDisabled to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetAccountDisabled(accountDisabled *bool) {
	o.AccountDisabled = accountDisabled
}

// WithDescription adds the description to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithDescription(description *string) *LocalCifsUserCollectionGetParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetDescription(description *string) {
	o.Description = description
}

// WithFields adds the fields to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithFields(fields []string) *LocalCifsUserCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithFullName adds the fullName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithFullName(fullName *string) *LocalCifsUserCollectionGetParams {
	o.SetFullName(fullName)
	return o
}

// SetFullName adds the fullName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetFullName(fullName *string) {
	o.FullName = fullName
}

// WithMaxRecords adds the maxRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMaxRecords(maxRecords *int64) *LocalCifsUserCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMembershipName adds the membershipName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMembershipName(membershipName *string) *LocalCifsUserCollectionGetParams {
	o.SetMembershipName(membershipName)
	return o
}

// SetMembershipName adds the membershipName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMembershipName(membershipName *string) {
	o.MembershipName = membershipName
}

// WithMembershipSid adds the membershipSid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMembershipSid(membershipSid *string) *LocalCifsUserCollectionGetParams {
	o.SetMembershipSid(membershipSid)
	return o
}

// SetMembershipSid adds the membershipSid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMembershipSid(membershipSid *string) {
	o.MembershipSid = membershipSid
}

// WithName adds the name to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithName(name *string) *LocalCifsUserCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithOrderBy(orderBy []string) *LocalCifsUserCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithReturnRecords(returnRecords *bool) *LocalCifsUserCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *LocalCifsUserCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSid adds the sid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSid(sid *string) *LocalCifsUserCollectionGetParams {
	o.SetSid(sid)
	return o
}

// SetSid adds the sid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSid(sid *string) {
	o.Sid = sid
}

// WithSvmName adds the svmName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSvmName(svmName *string) *LocalCifsUserCollectionGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSvmUUID(svmUUID *string) *LocalCifsUserCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsUserCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountDisabled != nil {

		// query param account_disabled
		var qrAccountDisabled bool

		if o.AccountDisabled != nil {
			qrAccountDisabled = *o.AccountDisabled
		}
		qAccountDisabled := swag.FormatBool(qrAccountDisabled)
		if qAccountDisabled != "" {

			if err := r.SetQueryParam("account_disabled", qAccountDisabled); err != nil {
				return err
			}
		}
	}

	if o.Description != nil {

		// query param description
		var qrDescription string

		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FullName != nil {

		// query param full_name
		var qrFullName string

		if o.FullName != nil {
			qrFullName = *o.FullName
		}
		qFullName := qrFullName
		if qFullName != "" {

			if err := r.SetQueryParam("full_name", qFullName); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.MembershipName != nil {

		// query param membership.name
		var qrMembershipName string

		if o.MembershipName != nil {
			qrMembershipName = *o.MembershipName
		}
		qMembershipName := qrMembershipName
		if qMembershipName != "" {

			if err := r.SetQueryParam("membership.name", qMembershipName); err != nil {
				return err
			}
		}
	}

	if o.MembershipSid != nil {

		// query param membership.sid
		var qrMembershipSid string

		if o.MembershipSid != nil {
			qrMembershipSid = *o.MembershipSid
		}
		qMembershipSid := qrMembershipSid
		if qMembershipSid != "" {

			if err := r.SetQueryParam("membership.sid", qMembershipSid); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.Sid != nil {

		// query param sid
		var qrSid string

		if o.Sid != nil {
			qrSid = *o.Sid
		}
		qSid := qrSid
		if qSid != "" {

			if err := r.SetQueryParam("sid", qSid); err != nil {
				return err
			}
		}
	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string

		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLocalCifsUserCollectionGet binds the parameter fields
func (o *LocalCifsUserCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLocalCifsUserCollectionGet binds the parameter order_by
func (o *LocalCifsUserCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
