// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewS3AuditDeleteParams creates a new S3AuditDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3AuditDeleteParams() *S3AuditDeleteParams {
	return &S3AuditDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3AuditDeleteParamsWithTimeout creates a new S3AuditDeleteParams object
// with the ability to set a timeout on a request.
func NewS3AuditDeleteParamsWithTimeout(timeout time.Duration) *S3AuditDeleteParams {
	return &S3AuditDeleteParams{
		timeout: timeout,
	}
}

// NewS3AuditDeleteParamsWithContext creates a new S3AuditDeleteParams object
// with the ability to set a context for a request.
func NewS3AuditDeleteParamsWithContext(ctx context.Context) *S3AuditDeleteParams {
	return &S3AuditDeleteParams{
		Context: ctx,
	}
}

// NewS3AuditDeleteParamsWithHTTPClient creates a new S3AuditDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3AuditDeleteParamsWithHTTPClient(client *http.Client) *S3AuditDeleteParams {
	return &S3AuditDeleteParams{
		HTTPClient: client,
	}
}

/*
S3AuditDeleteParams contains all the parameters to send to the API endpoint

	for the s3 audit delete operation.

	Typically these are written to a http.Request.
*/
type S3AuditDeleteParams struct {

	/* Force.

	   Indicates whether a force deletion of the audit configuration is enabled.
	*/
	Force *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeout *int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 audit delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditDeleteParams) WithDefaults() *S3AuditDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 audit delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3AuditDeleteParams) SetDefaults() {
	var (
		returnTimeoutDefault = int64(0)
	)

	val := S3AuditDeleteParams{
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the s3 audit delete params
func (o *S3AuditDeleteParams) WithTimeout(timeout time.Duration) *S3AuditDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 audit delete params
func (o *S3AuditDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 audit delete params
func (o *S3AuditDeleteParams) WithContext(ctx context.Context) *S3AuditDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 audit delete params
func (o *S3AuditDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 audit delete params
func (o *S3AuditDeleteParams) WithHTTPClient(client *http.Client) *S3AuditDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 audit delete params
func (o *S3AuditDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithForce adds the force to the s3 audit delete params
func (o *S3AuditDeleteParams) WithForce(force *bool) *S3AuditDeleteParams {
	o.SetForce(force)
	return o
}

// SetForce adds the force to the s3 audit delete params
func (o *S3AuditDeleteParams) SetForce(force *bool) {
	o.Force = force
}

// WithReturnTimeout adds the returnTimeout to the s3 audit delete params
func (o *S3AuditDeleteParams) WithReturnTimeout(returnTimeout *int64) *S3AuditDeleteParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the s3 audit delete params
func (o *S3AuditDeleteParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSvmUUID adds the svmUUID to the s3 audit delete params
func (o *S3AuditDeleteParams) WithSvmUUID(svmUUID string) *S3AuditDeleteParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the s3 audit delete params
func (o *S3AuditDeleteParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3AuditDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Force != nil {

		// query param force
		var qrForce bool

		if o.Force != nil {
			qrForce = *o.Force
		}
		qForce := swag.FormatBool(qrForce)
		if qForce != "" {

			if err := r.SetQueryParam("force", qForce); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
