// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewVscanModifyParams creates a new VscanModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanModifyParams() *VscanModifyParams {
	return &VscanModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanModifyParamsWithTimeout creates a new VscanModifyParams object
// with the ability to set a timeout on a request.
func NewVscanModifyParamsWithTimeout(timeout time.Duration) *VscanModifyParams {
	return &VscanModifyParams{
		timeout: timeout,
	}
}

// NewVscanModifyParamsWithContext creates a new VscanModifyParams object
// with the ability to set a context for a request.
func NewVscanModifyParamsWithContext(ctx context.Context) *VscanModifyParams {
	return &VscanModifyParams{
		Context: ctx,
	}
}

// NewVscanModifyParamsWithHTTPClient creates a new VscanModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanModifyParamsWithHTTPClient(client *http.Client) *VscanModifyParams {
	return &VscanModifyParams{
		HTTPClient: client,
	}
}

/*
VscanModifyParams contains all the parameters to send to the API endpoint

	for the vscan modify operation.

	Typically these are written to a http.Request.
*/
type VscanModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.Vscan

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanModifyParams) WithDefaults() *VscanModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the vscan modify params
func (o *VscanModifyParams) WithTimeout(timeout time.Duration) *VscanModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan modify params
func (o *VscanModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan modify params
func (o *VscanModifyParams) WithContext(ctx context.Context) *VscanModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan modify params
func (o *VscanModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan modify params
func (o *VscanModifyParams) WithHTTPClient(client *http.Client) *VscanModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan modify params
func (o *VscanModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the vscan modify params
func (o *VscanModifyParams) WithInfo(info *models.Vscan) *VscanModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the vscan modify params
func (o *VscanModifyParams) SetInfo(info *models.Vscan) {
	o.Info = info
}

// WithSvmUUID adds the svmUUID to the vscan modify params
func (o *VscanModifyParams) WithSvmUUID(svmUUID string) *VscanModifyParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the vscan modify params
func (o *VscanModifyParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VscanModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
