// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNvmeNamespaceGetParams creates a new NvmeNamespaceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeNamespaceGetParams() *NvmeNamespaceGetParams {
	return &NvmeNamespaceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeNamespaceGetParamsWithTimeout creates a new NvmeNamespaceGetParams object
// with the ability to set a timeout on a request.
func NewNvmeNamespaceGetParamsWithTimeout(timeout time.Duration) *NvmeNamespaceGetParams {
	return &NvmeNamespaceGetParams{
		timeout: timeout,
	}
}

// NewNvmeNamespaceGetParamsWithContext creates a new NvmeNamespaceGetParams object
// with the ability to set a context for a request.
func NewNvmeNamespaceGetParamsWithContext(ctx context.Context) *NvmeNamespaceGetParams {
	return &NvmeNamespaceGetParams{
		Context: ctx,
	}
}

// NewNvmeNamespaceGetParamsWithHTTPClient creates a new NvmeNamespaceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeNamespaceGetParamsWithHTTPClient(client *http.Client) *NvmeNamespaceGetParams {
	return &NvmeNamespaceGetParams{
		HTTPClient: client,
	}
}

/*
NvmeNamespaceGetParams contains all the parameters to send to the API endpoint

	for the nvme namespace get operation.

	Typically these are written to a http.Request.
*/
type NvmeNamespaceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* UUID.

	   The unique identifier of the NVMe namespace to retrieve.

	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme namespace get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeNamespaceGetParams) WithDefaults() *NvmeNamespaceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme namespace get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeNamespaceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme namespace get params
func (o *NvmeNamespaceGetParams) WithTimeout(timeout time.Duration) *NvmeNamespaceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme namespace get params
func (o *NvmeNamespaceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme namespace get params
func (o *NvmeNamespaceGetParams) WithContext(ctx context.Context) *NvmeNamespaceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme namespace get params
func (o *NvmeNamespaceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme namespace get params
func (o *NvmeNamespaceGetParams) WithHTTPClient(client *http.Client) *NvmeNamespaceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme namespace get params
func (o *NvmeNamespaceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the nvme namespace get params
func (o *NvmeNamespaceGetParams) WithFields(fields []string) *NvmeNamespaceGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the nvme namespace get params
func (o *NvmeNamespaceGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithUUID adds the uuid to the nvme namespace get params
func (o *NvmeNamespaceGetParams) WithUUID(uuid string) *NvmeNamespaceGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the nvme namespace get params
func (o *NvmeNamespaceGetParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeNamespaceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNvmeNamespaceGet binds the parameter fields
func (o *NvmeNamespaceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
