// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewUnixGroupUsersCollectionGetParams creates a new UnixGroupUsersCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUnixGroupUsersCollectionGetParams() *UnixGroupUsersCollectionGetParams {
	return &UnixGroupUsersCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUnixGroupUsersCollectionGetParamsWithTimeout creates a new UnixGroupUsersCollectionGetParams object
// with the ability to set a timeout on a request.
func NewUnixGroupUsersCollectionGetParamsWithTimeout(timeout time.Duration) *UnixGroupUsersCollectionGetParams {
	return &UnixGroupUsersCollectionGetParams{
		timeout: timeout,
	}
}

// NewUnixGroupUsersCollectionGetParamsWithContext creates a new UnixGroupUsersCollectionGetParams object
// with the ability to set a context for a request.
func NewUnixGroupUsersCollectionGetParamsWithContext(ctx context.Context) *UnixGroupUsersCollectionGetParams {
	return &UnixGroupUsersCollectionGetParams{
		Context: ctx,
	}
}

// NewUnixGroupUsersCollectionGetParamsWithHTTPClient creates a new UnixGroupUsersCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewUnixGroupUsersCollectionGetParamsWithHTTPClient(client *http.Client) *UnixGroupUsersCollectionGetParams {
	return &UnixGroupUsersCollectionGetParams{
		HTTPClient: client,
	}
}

/*
UnixGroupUsersCollectionGetParams contains all the parameters to send to the API endpoint

	for the unix group users collection get operation.

	Typically these are written to a http.Request.
*/
type UnixGroupUsersCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	/* UnixGroupName.

	   UNIX group name.
	*/
	UnixGroupName string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the unix group users collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UnixGroupUsersCollectionGetParams) WithDefaults() *UnixGroupUsersCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the unix group users collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UnixGroupUsersCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := UnixGroupUsersCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithTimeout(timeout time.Duration) *UnixGroupUsersCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithContext(ctx context.Context) *UnixGroupUsersCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithHTTPClient(client *http.Client) *UnixGroupUsersCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithFields(fields []string) *UnixGroupUsersCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithMaxRecords adds the maxRecords to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithMaxRecords(maxRecords *int64) *UnixGroupUsersCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithName(name *string) *UnixGroupUsersCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithOrderBy(orderBy []string) *UnixGroupUsersCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithReturnRecords adds the returnRecords to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithReturnRecords(returnRecords *bool) *UnixGroupUsersCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *UnixGroupUsersCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSvmUUID adds the svmUUID to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithSvmUUID(svmUUID string) *UnixGroupUsersCollectionGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WithUnixGroupName adds the unixGroupName to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) WithUnixGroupName(unixGroupName string) *UnixGroupUsersCollectionGetParams {
	o.SetUnixGroupName(unixGroupName)
	return o
}

// SetUnixGroupName adds the unixGroupName to the unix group users collection get params
func (o *UnixGroupUsersCollectionGetParams) SetUnixGroupName(unixGroupName string) {
	o.UnixGroupName = unixGroupName
}

// WriteToRequest writes these params to a swagger request
func (o *UnixGroupUsersCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	// path param unix_group.name
	if err := r.SetPathParam("unix_group.name", o.UnixGroupName); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamUnixGroupUsersCollectionGet binds the parameter fields
func (o *UnixGroupUsersCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamUnixGroupUsersCollectionGet binds the parameter order_by
func (o *UnixGroupUsersCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
