// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewFcInterfaceDeleteParams creates a new FcInterfaceDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFcInterfaceDeleteParams() *FcInterfaceDeleteParams {
	return &FcInterfaceDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFcInterfaceDeleteParamsWithTimeout creates a new FcInterfaceDeleteParams object
// with the ability to set a timeout on a request.
func NewFcInterfaceDeleteParamsWithTimeout(timeout time.Duration) *FcInterfaceDeleteParams {
	return &FcInterfaceDeleteParams{
		timeout: timeout,
	}
}

// NewFcInterfaceDeleteParamsWithContext creates a new FcInterfaceDeleteParams object
// with the ability to set a context for a request.
func NewFcInterfaceDeleteParamsWithContext(ctx context.Context) *FcInterfaceDeleteParams {
	return &FcInterfaceDeleteParams{
		Context: ctx,
	}
}

// NewFcInterfaceDeleteParamsWithHTTPClient creates a new FcInterfaceDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewFcInterfaceDeleteParamsWithHTTPClient(client *http.Client) *FcInterfaceDeleteParams {
	return &FcInterfaceDeleteParams{
		HTTPClient: client,
	}
}

/*
FcInterfaceDeleteParams contains all the parameters to send to the API endpoint

	for the fc interface delete operation.

	Typically these are written to a http.Request.
*/
type FcInterfaceDeleteParams struct {

	/* UUID.

	   The unique identifier for the FC interface.

	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fc interface delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcInterfaceDeleteParams) WithDefaults() *FcInterfaceDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fc interface delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcInterfaceDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the fc interface delete params
func (o *FcInterfaceDeleteParams) WithTimeout(timeout time.Duration) *FcInterfaceDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fc interface delete params
func (o *FcInterfaceDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fc interface delete params
func (o *FcInterfaceDeleteParams) WithContext(ctx context.Context) *FcInterfaceDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fc interface delete params
func (o *FcInterfaceDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fc interface delete params
func (o *FcInterfaceDeleteParams) WithHTTPClient(client *http.Client) *FcInterfaceDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fc interface delete params
func (o *FcInterfaceDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUID adds the uuid to the fc interface delete params
func (o *FcInterfaceDeleteParams) WithUUID(uuid string) *FcInterfaceDeleteParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the fc interface delete params
func (o *FcInterfaceDeleteParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *FcInterfaceDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
