// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNetworkEthernetBroadcastDomainsGetParams creates a new NetworkEthernetBroadcastDomainsGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkEthernetBroadcastDomainsGetParams() *NetworkEthernetBroadcastDomainsGetParams {
	return &NetworkEthernetBroadcastDomainsGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkEthernetBroadcastDomainsGetParamsWithTimeout creates a new NetworkEthernetBroadcastDomainsGetParams object
// with the ability to set a timeout on a request.
func NewNetworkEthernetBroadcastDomainsGetParamsWithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainsGetParams {
	return &NetworkEthernetBroadcastDomainsGetParams{
		timeout: timeout,
	}
}

// NewNetworkEthernetBroadcastDomainsGetParamsWithContext creates a new NetworkEthernetBroadcastDomainsGetParams object
// with the ability to set a context for a request.
func NewNetworkEthernetBroadcastDomainsGetParamsWithContext(ctx context.Context) *NetworkEthernetBroadcastDomainsGetParams {
	return &NetworkEthernetBroadcastDomainsGetParams{
		Context: ctx,
	}
}

// NewNetworkEthernetBroadcastDomainsGetParamsWithHTTPClient creates a new NetworkEthernetBroadcastDomainsGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkEthernetBroadcastDomainsGetParamsWithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainsGetParams {
	return &NetworkEthernetBroadcastDomainsGetParams{
		HTTPClient: client,
	}
}

/*
NetworkEthernetBroadcastDomainsGetParams contains all the parameters to send to the API endpoint

	for the network ethernet broadcast domains get operation.

	Typically these are written to a http.Request.
*/
type NetworkEthernetBroadcastDomainsGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* IpspaceName.

	   Filter by ipspace.name
	*/
	IpspaceName *string

	/* IpspaceUUID.

	   Filter by ipspace.uuid
	*/
	IpspaceUUID *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Mtu.

	   Filter by mtu
	*/
	Mtu *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* PortsName.

	   Filter by ports.name
	*/
	PortsName *string

	/* PortsNodeName.

	   Filter by ports.node.name
	*/
	PortsNodeName *string

	/* PortsUUID.

	   Filter by ports.uuid
	*/
	PortsUUID *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* UUID.

	   Filter by uuid
	*/
	UUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network ethernet broadcast domains get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainsGetParams) WithDefaults() *NetworkEthernetBroadcastDomainsGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network ethernet broadcast domains get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainsGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := NetworkEthernetBroadcastDomainsGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithContext(ctx context.Context) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithFields(fields []string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIpspaceName adds the ipspaceName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithIpspaceName(ipspaceName *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetIpspaceName(ipspaceName)
	return o
}

// SetIpspaceName adds the ipspaceName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetIpspaceName(ipspaceName *string) {
	o.IpspaceName = ipspaceName
}

// WithIpspaceUUID adds the ipspaceUUID to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithIpspaceUUID(ipspaceUUID *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetIpspaceUUID(ipspaceUUID)
	return o
}

// SetIpspaceUUID adds the ipspaceUuid to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetIpspaceUUID(ipspaceUUID *string) {
	o.IpspaceUUID = ipspaceUUID
}

// WithMaxRecords adds the maxRecords to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithMaxRecords(maxRecords *int64) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMtu adds the mtu to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithMtu(mtu *int64) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetMtu(mtu)
	return o
}

// SetMtu adds the mtu to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetMtu(mtu *int64) {
	o.Mtu = mtu
}

// WithName adds the name to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithName(name *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetName(name *string) {
	o.Name = name
}

// WithOrderBy adds the orderBy to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithOrderBy(orderBy []string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithPortsName adds the portsName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithPortsName(portsName *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetPortsName(portsName)
	return o
}

// SetPortsName adds the portsName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetPortsName(portsName *string) {
	o.PortsName = portsName
}

// WithPortsNodeName adds the portsNodeName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithPortsNodeName(portsNodeName *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetPortsNodeName(portsNodeName)
	return o
}

// SetPortsNodeName adds the portsNodeName to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetPortsNodeName(portsNodeName *string) {
	o.PortsNodeName = portsNodeName
}

// WithPortsUUID adds the portsUUID to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithPortsUUID(portsUUID *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetPortsUUID(portsUUID)
	return o
}

// SetPortsUUID adds the portsUuid to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetPortsUUID(portsUUID *string) {
	o.PortsUUID = portsUUID
}

// WithReturnRecords adds the returnRecords to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithReturnRecords(returnRecords *bool) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithReturnTimeout(returnTimeout *int64) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) WithUUID(uuid *string) *NetworkEthernetBroadcastDomainsGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the network ethernet broadcast domains get params
func (o *NetworkEthernetBroadcastDomainsGetParams) SetUUID(uuid *string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkEthernetBroadcastDomainsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IpspaceName != nil {

		// query param ipspace.name
		var qrIpspaceName string

		if o.IpspaceName != nil {
			qrIpspaceName = *o.IpspaceName
		}
		qIpspaceName := qrIpspaceName
		if qIpspaceName != "" {

			if err := r.SetQueryParam("ipspace.name", qIpspaceName); err != nil {
				return err
			}
		}
	}

	if o.IpspaceUUID != nil {

		// query param ipspace.uuid
		var qrIpspaceUUID string

		if o.IpspaceUUID != nil {
			qrIpspaceUUID = *o.IpspaceUUID
		}
		qIpspaceUUID := qrIpspaceUUID
		if qIpspaceUUID != "" {

			if err := r.SetQueryParam("ipspace.uuid", qIpspaceUUID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Mtu != nil {

		// query param mtu
		var qrMtu int64

		if o.Mtu != nil {
			qrMtu = *o.Mtu
		}
		qMtu := swag.FormatInt64(qrMtu)
		if qMtu != "" {

			if err := r.SetQueryParam("mtu", qMtu); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PortsName != nil {

		// query param ports.name
		var qrPortsName string

		if o.PortsName != nil {
			qrPortsName = *o.PortsName
		}
		qPortsName := qrPortsName
		if qPortsName != "" {

			if err := r.SetQueryParam("ports.name", qPortsName); err != nil {
				return err
			}
		}
	}

	if o.PortsNodeName != nil {

		// query param ports.node.name
		var qrPortsNodeName string

		if o.PortsNodeName != nil {
			qrPortsNodeName = *o.PortsNodeName
		}
		qPortsNodeName := qrPortsNodeName
		if qPortsNodeName != "" {

			if err := r.SetQueryParam("ports.node.name", qPortsNodeName); err != nil {
				return err
			}
		}
	}

	if o.PortsUUID != nil {

		// query param ports.uuid
		var qrPortsUUID string

		if o.PortsUUID != nil {
			qrPortsUUID = *o.PortsUUID
		}
		qPortsUUID := qrPortsUUID
		if qPortsUUID != "" {

			if err := r.SetQueryParam("ports.uuid", qPortsUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUID != nil {

		// query param uuid
		var qrUUID string

		if o.UUID != nil {
			qrUUID = *o.UUID
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNetworkEthernetBroadcastDomainsGet binds the parameter fields
func (o *NetworkEthernetBroadcastDomainsGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamNetworkEthernetBroadcastDomainsGet binds the parameter order_by
func (o *NetworkEthernetBroadcastDomainsGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
