// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIgroupNestedGetParams creates a new IgroupNestedGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIgroupNestedGetParams() *IgroupNestedGetParams {
	return &IgroupNestedGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIgroupNestedGetParamsWithTimeout creates a new IgroupNestedGetParams object
// with the ability to set a timeout on a request.
func NewIgroupNestedGetParamsWithTimeout(timeout time.Duration) *IgroupNestedGetParams {
	return &IgroupNestedGetParams{
		timeout: timeout,
	}
}

// NewIgroupNestedGetParamsWithContext creates a new IgroupNestedGetParams object
// with the ability to set a context for a request.
func NewIgroupNestedGetParamsWithContext(ctx context.Context) *IgroupNestedGetParams {
	return &IgroupNestedGetParams{
		Context: ctx,
	}
}

// NewIgroupNestedGetParamsWithHTTPClient creates a new IgroupNestedGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewIgroupNestedGetParamsWithHTTPClient(client *http.Client) *IgroupNestedGetParams {
	return &IgroupNestedGetParams{
		HTTPClient: client,
	}
}

/*
IgroupNestedGetParams contains all the parameters to send to the API endpoint

	for the igroup nested get operation.

	Typically these are written to a http.Request.
*/
type IgroupNestedGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* IgroupUUID.

	   The unique identifier of the parent initiator group.

	*/
	IgroupUUID string

	/* UUID.

	   The unique identifier of the nested initiator group.

	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the igroup nested get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupNestedGetParams) WithDefaults() *IgroupNestedGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the igroup nested get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupNestedGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the igroup nested get params
func (o *IgroupNestedGetParams) WithTimeout(timeout time.Duration) *IgroupNestedGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the igroup nested get params
func (o *IgroupNestedGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the igroup nested get params
func (o *IgroupNestedGetParams) WithContext(ctx context.Context) *IgroupNestedGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the igroup nested get params
func (o *IgroupNestedGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the igroup nested get params
func (o *IgroupNestedGetParams) WithHTTPClient(client *http.Client) *IgroupNestedGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the igroup nested get params
func (o *IgroupNestedGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the igroup nested get params
func (o *IgroupNestedGetParams) WithFields(fields []string) *IgroupNestedGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the igroup nested get params
func (o *IgroupNestedGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIgroupUUID adds the igroupUUID to the igroup nested get params
func (o *IgroupNestedGetParams) WithIgroupUUID(igroupUUID string) *IgroupNestedGetParams {
	o.SetIgroupUUID(igroupUUID)
	return o
}

// SetIgroupUUID adds the igroupUuid to the igroup nested get params
func (o *IgroupNestedGetParams) SetIgroupUUID(igroupUUID string) {
	o.IgroupUUID = igroupUUID
}

// WithUUID adds the uuid to the igroup nested get params
func (o *IgroupNestedGetParams) WithUUID(uuid string) *IgroupNestedGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the igroup nested get params
func (o *IgroupNestedGetParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IgroupNestedGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param igroup.uuid
	if err := r.SetPathParam("igroup.uuid", o.IgroupUUID); err != nil {
		return err
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamIgroupNestedGet binds the parameter fields
func (o *IgroupNestedGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
