// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewWwpnAliasDeleteParams creates a new WwpnAliasDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWwpnAliasDeleteParams() *WwpnAliasDeleteParams {
	return &WwpnAliasDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWwpnAliasDeleteParamsWithTimeout creates a new WwpnAliasDeleteParams object
// with the ability to set a timeout on a request.
func NewWwpnAliasDeleteParamsWithTimeout(timeout time.Duration) *WwpnAliasDeleteParams {
	return &WwpnAliasDeleteParams{
		timeout: timeout,
	}
}

// NewWwpnAliasDeleteParamsWithContext creates a new WwpnAliasDeleteParams object
// with the ability to set a context for a request.
func NewWwpnAliasDeleteParamsWithContext(ctx context.Context) *WwpnAliasDeleteParams {
	return &WwpnAliasDeleteParams{
		Context: ctx,
	}
}

// NewWwpnAliasDeleteParamsWithHTTPClient creates a new WwpnAliasDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewWwpnAliasDeleteParamsWithHTTPClient(client *http.Client) *WwpnAliasDeleteParams {
	return &WwpnAliasDeleteParams{
		HTTPClient: client,
	}
}

/*
WwpnAliasDeleteParams contains all the parameters to send to the API endpoint

	for the wwpn alias delete operation.

	Typically these are written to a http.Request.
*/
type WwpnAliasDeleteParams struct {

	/* Alias.

	   The name of FC WWPN alias.

	*/
	Alias string

	/* SvmUUID.

	   The unique identifier of the SVM.

	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the wwpn alias delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WwpnAliasDeleteParams) WithDefaults() *WwpnAliasDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the wwpn alias delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WwpnAliasDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) WithTimeout(timeout time.Duration) *WwpnAliasDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) WithContext(ctx context.Context) *WwpnAliasDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) WithHTTPClient(client *http.Client) *WwpnAliasDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAlias adds the alias to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) WithAlias(alias string) *WwpnAliasDeleteParams {
	o.SetAlias(alias)
	return o
}

// SetAlias adds the alias to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) SetAlias(alias string) {
	o.Alias = alias
}

// WithSvmUUID adds the svmUUID to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) WithSvmUUID(svmUUID string) *WwpnAliasDeleteParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the wwpn alias delete params
func (o *WwpnAliasDeleteParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *WwpnAliasDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param alias
	if err := r.SetPathParam("alias", o.Alias); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
