// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// GcpKmsRekeyInternalReader is a Reader for the GcpKmsRekeyInternal structure.
type GcpKmsRekeyInternalReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GcpKmsRekeyInternalReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewGcpKmsRekeyInternalAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewGcpKmsRekeyInternalDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGcpKmsRekeyInternalAccepted creates a GcpKmsRekeyInternalAccepted with default headers values
func NewGcpKmsRekeyInternalAccepted() *GcpKmsRekeyInternalAccepted {
	return &GcpKmsRekeyInternalAccepted{}
}

/*
GcpKmsRekeyInternalAccepted describes a response with status code 202, with default header values.

Accepted
*/
type GcpKmsRekeyInternalAccepted struct {
}

// IsSuccess returns true when this gcp kms rekey internal accepted response has a 2xx status code
func (o *GcpKmsRekeyInternalAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this gcp kms rekey internal accepted response has a 3xx status code
func (o *GcpKmsRekeyInternalAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this gcp kms rekey internal accepted response has a 4xx status code
func (o *GcpKmsRekeyInternalAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this gcp kms rekey internal accepted response has a 5xx status code
func (o *GcpKmsRekeyInternalAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this gcp kms rekey internal accepted response a status code equal to that given
func (o *GcpKmsRekeyInternalAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *GcpKmsRekeyInternalAccepted) Error() string {
	return fmt.Sprintf("[POST /security/gcp-kms/{uuid}/rekey-internal][%d] gcpKmsRekeyInternalAccepted ", 202)
}

func (o *GcpKmsRekeyInternalAccepted) String() string {
	return fmt.Sprintf("[POST /security/gcp-kms/{uuid}/rekey-internal][%d] gcpKmsRekeyInternalAccepted ", 202)
}

func (o *GcpKmsRekeyInternalAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewGcpKmsRekeyInternalDefault creates a GcpKmsRekeyInternalDefault with default headers values
func NewGcpKmsRekeyInternalDefault(code int) *GcpKmsRekeyInternalDefault {
	return &GcpKmsRekeyInternalDefault{
		_statusCode: code,
	}
}

/*
	GcpKmsRekeyInternalDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 65537547 | One or more volume encryption keys for encrypted volumes of this data SVM are stored in the key manager configured for the admin SVM. Use the REST API POST method to migrate this data SVM's keys from the admin SVM's key manager to this data SVM's key manager before running the rekey operation. |
| 65537559 | There are no existing internal keys for the SVM. A rekey operation is allowed for an SVM with one or more encryption keys. |
| 65537721 | Google Cloud KMS is not configured for the given SVM. |
*/
type GcpKmsRekeyInternalDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the gcp kms rekey internal default response
func (o *GcpKmsRekeyInternalDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this gcp kms rekey internal default response has a 2xx status code
func (o *GcpKmsRekeyInternalDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this gcp kms rekey internal default response has a 3xx status code
func (o *GcpKmsRekeyInternalDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this gcp kms rekey internal default response has a 4xx status code
func (o *GcpKmsRekeyInternalDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this gcp kms rekey internal default response has a 5xx status code
func (o *GcpKmsRekeyInternalDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this gcp kms rekey internal default response a status code equal to that given
func (o *GcpKmsRekeyInternalDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *GcpKmsRekeyInternalDefault) Error() string {
	return fmt.Sprintf("[POST /security/gcp-kms/{uuid}/rekey-internal][%d] gcp_kms_rekey_internal default  %+v", o._statusCode, o.Payload)
}

func (o *GcpKmsRekeyInternalDefault) String() string {
	return fmt.Sprintf("[POST /security/gcp-kms/{uuid}/rekey-internal][%d] gcp_kms_rekey_internal default  %+v", o._statusCode, o.Payload)
}

func (o *GcpKmsRekeyInternalDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *GcpKmsRekeyInternalDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
