// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// IpsecGetReader is a Reader for the IpsecGet structure.
type IpsecGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *IpsecGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewIpsecGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewIpsecGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewIpsecGetOK creates a IpsecGetOK with default headers values
func NewIpsecGetOK() *IpsecGetOK {
	return &IpsecGetOK{}
}

/*
IpsecGetOK describes a response with status code 200, with default header values.

OK
*/
type IpsecGetOK struct {
	Payload *models.Ipsec
}

// IsSuccess returns true when this ipsec get o k response has a 2xx status code
func (o *IpsecGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this ipsec get o k response has a 3xx status code
func (o *IpsecGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this ipsec get o k response has a 4xx status code
func (o *IpsecGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this ipsec get o k response has a 5xx status code
func (o *IpsecGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this ipsec get o k response a status code equal to that given
func (o *IpsecGetOK) IsCode(code int) bool {
	return code == 200
}

func (o *IpsecGetOK) Error() string {
	return fmt.Sprintf("[GET /security/ipsec][%d] ipsecGetOK  %+v", 200, o.Payload)
}

func (o *IpsecGetOK) String() string {
	return fmt.Sprintf("[GET /security/ipsec][%d] ipsecGetOK  %+v", 200, o.Payload)
}

func (o *IpsecGetOK) GetPayload() *models.Ipsec {
	return o.Payload
}

func (o *IpsecGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Ipsec)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewIpsecGetDefault creates a IpsecGetDefault with default headers values
func NewIpsecGetDefault(code int) *IpsecGetDefault {
	return &IpsecGetDefault{
		_statusCode: code,
	}
}

/*
IpsecGetDefault describes a response with status code -1, with default header values.

Error
*/
type IpsecGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the ipsec get default response
func (o *IpsecGetDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this ipsec get default response has a 2xx status code
func (o *IpsecGetDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this ipsec get default response has a 3xx status code
func (o *IpsecGetDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this ipsec get default response has a 4xx status code
func (o *IpsecGetDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this ipsec get default response has a 5xx status code
func (o *IpsecGetDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this ipsec get default response a status code equal to that given
func (o *IpsecGetDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *IpsecGetDefault) Error() string {
	return fmt.Sprintf("[GET /security/ipsec][%d] ipsec_get default  %+v", o._statusCode, o.Payload)
}

func (o *IpsecGetDefault) String() string {
	return fmt.Sprintf("[GET /security/ipsec][%d] ipsec_get default  %+v", o._statusCode, o.Payload)
}

func (o *IpsecGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *IpsecGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
