// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// IpsecPolicyDeleteReader is a Reader for the IpsecPolicyDelete structure.
type IpsecPolicyDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *IpsecPolicyDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewIpsecPolicyDeleteOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewIpsecPolicyDeleteDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewIpsecPolicyDeleteOK creates a IpsecPolicyDeleteOK with default headers values
func NewIpsecPolicyDeleteOK() *IpsecPolicyDeleteOK {
	return &IpsecPolicyDeleteOK{}
}

/*
IpsecPolicyDeleteOK describes a response with status code 200, with default header values.

OK
*/
type IpsecPolicyDeleteOK struct {
}

// IsSuccess returns true when this ipsec policy delete o k response has a 2xx status code
func (o *IpsecPolicyDeleteOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this ipsec policy delete o k response has a 3xx status code
func (o *IpsecPolicyDeleteOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this ipsec policy delete o k response has a 4xx status code
func (o *IpsecPolicyDeleteOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this ipsec policy delete o k response has a 5xx status code
func (o *IpsecPolicyDeleteOK) IsServerError() bool {
	return false
}

// IsCode returns true when this ipsec policy delete o k response a status code equal to that given
func (o *IpsecPolicyDeleteOK) IsCode(code int) bool {
	return code == 200
}

func (o *IpsecPolicyDeleteOK) Error() string {
	return fmt.Sprintf("[DELETE /security/ipsec/policies/{uuid}][%d] ipsecPolicyDeleteOK ", 200)
}

func (o *IpsecPolicyDeleteOK) String() string {
	return fmt.Sprintf("[DELETE /security/ipsec/policies/{uuid}][%d] ipsecPolicyDeleteOK ", 200)
}

func (o *IpsecPolicyDeleteOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewIpsecPolicyDeleteDefault creates a IpsecPolicyDeleteDefault with default headers values
func NewIpsecPolicyDeleteDefault(code int) *IpsecPolicyDeleteDefault {
	return &IpsecPolicyDeleteDefault{
		_statusCode: code,
	}
}

/*
	IpsecPolicyDeleteDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 66257096 | Internal error. Failed to purge connections associated with the IPsec policy. |
| 66257116 | IPsec policy with the specified UUID was not found. |
*/
type IpsecPolicyDeleteDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the ipsec policy delete default response
func (o *IpsecPolicyDeleteDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this ipsec policy delete default response has a 2xx status code
func (o *IpsecPolicyDeleteDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this ipsec policy delete default response has a 3xx status code
func (o *IpsecPolicyDeleteDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this ipsec policy delete default response has a 4xx status code
func (o *IpsecPolicyDeleteDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this ipsec policy delete default response has a 5xx status code
func (o *IpsecPolicyDeleteDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this ipsec policy delete default response a status code equal to that given
func (o *IpsecPolicyDeleteDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *IpsecPolicyDeleteDefault) Error() string {
	return fmt.Sprintf("[DELETE /security/ipsec/policies/{uuid}][%d] ipsec_policy_delete default  %+v", o._statusCode, o.Payload)
}

func (o *IpsecPolicyDeleteDefault) String() string {
	return fmt.Sprintf("[DELETE /security/ipsec/policies/{uuid}][%d] ipsec_policy_delete default  %+v", o._statusCode, o.Payload)
}

func (o *IpsecPolicyDeleteDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *IpsecPolicyDeleteDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
