// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewKeyManagerConfigModifyParams creates a new KeyManagerConfigModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewKeyManagerConfigModifyParams() *KeyManagerConfigModifyParams {
	return &KeyManagerConfigModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewKeyManagerConfigModifyParamsWithTimeout creates a new KeyManagerConfigModifyParams object
// with the ability to set a timeout on a request.
func NewKeyManagerConfigModifyParamsWithTimeout(timeout time.Duration) *KeyManagerConfigModifyParams {
	return &KeyManagerConfigModifyParams{
		timeout: timeout,
	}
}

// NewKeyManagerConfigModifyParamsWithContext creates a new KeyManagerConfigModifyParams object
// with the ability to set a context for a request.
func NewKeyManagerConfigModifyParamsWithContext(ctx context.Context) *KeyManagerConfigModifyParams {
	return &KeyManagerConfigModifyParams{
		Context: ctx,
	}
}

// NewKeyManagerConfigModifyParamsWithHTTPClient creates a new KeyManagerConfigModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewKeyManagerConfigModifyParamsWithHTTPClient(client *http.Client) *KeyManagerConfigModifyParams {
	return &KeyManagerConfigModifyParams{
		HTTPClient: client,
	}
}

/*
KeyManagerConfigModifyParams contains all the parameters to send to the API endpoint

	for the key manager config modify operation.

	Typically these are written to a http.Request.
*/
type KeyManagerConfigModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.KeyManagerConfig

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the key manager config modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KeyManagerConfigModifyParams) WithDefaults() *KeyManagerConfigModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the key manager config modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *KeyManagerConfigModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the key manager config modify params
func (o *KeyManagerConfigModifyParams) WithTimeout(timeout time.Duration) *KeyManagerConfigModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the key manager config modify params
func (o *KeyManagerConfigModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the key manager config modify params
func (o *KeyManagerConfigModifyParams) WithContext(ctx context.Context) *KeyManagerConfigModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the key manager config modify params
func (o *KeyManagerConfigModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the key manager config modify params
func (o *KeyManagerConfigModifyParams) WithHTTPClient(client *http.Client) *KeyManagerConfigModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the key manager config modify params
func (o *KeyManagerConfigModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the key manager config modify params
func (o *KeyManagerConfigModifyParams) WithInfo(info *models.KeyManagerConfig) *KeyManagerConfigModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the key manager config modify params
func (o *KeyManagerConfigModifyParams) SetInfo(info *models.KeyManagerConfig) {
	o.Info = info
}

// WriteToRequest writes these params to a swagger request
func (o *KeyManagerConfigModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
