// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// RolePrivilegeCreateReader is a Reader for the RolePrivilegeCreate structure.
type RolePrivilegeCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RolePrivilegeCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewRolePrivilegeCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewRolePrivilegeCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewRolePrivilegeCreateCreated creates a RolePrivilegeCreateCreated with default headers values
func NewRolePrivilegeCreateCreated() *RolePrivilegeCreateCreated {
	return &RolePrivilegeCreateCreated{}
}

/*
RolePrivilegeCreateCreated describes a response with status code 201, with default header values.

Created
*/
type RolePrivilegeCreateCreated struct {

	/* Useful for tracking the resource location
	 */
	Location string
}

// IsSuccess returns true when this role privilege create created response has a 2xx status code
func (o *RolePrivilegeCreateCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this role privilege create created response has a 3xx status code
func (o *RolePrivilegeCreateCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this role privilege create created response has a 4xx status code
func (o *RolePrivilegeCreateCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this role privilege create created response has a 5xx status code
func (o *RolePrivilegeCreateCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this role privilege create created response a status code equal to that given
func (o *RolePrivilegeCreateCreated) IsCode(code int) bool {
	return code == 201
}

func (o *RolePrivilegeCreateCreated) Error() string {
	return fmt.Sprintf("[POST /security/roles/{owner.uuid}/{name}/privileges][%d] rolePrivilegeCreateCreated ", 201)
}

func (o *RolePrivilegeCreateCreated) String() string {
	return fmt.Sprintf("[POST /security/roles/{owner.uuid}/{name}/privileges][%d] rolePrivilegeCreateCreated ", 201)
}

func (o *RolePrivilegeCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Location
	hdrLocation := response.GetHeader("Location")

	if hdrLocation != "" {
		o.Location = hdrLocation
	}

	return nil
}

// NewRolePrivilegeCreateDefault creates a RolePrivilegeCreateDefault with default headers values
func NewRolePrivilegeCreateDefault(code int) *RolePrivilegeCreateDefault {
	return &RolePrivilegeCreateDefault{
		_statusCode: code,
	}
}

/*
	RolePrivilegeCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 5636129 | A role with given name has not been defined. |
| 5636143 | A Vserver admin cannot use the API with this access level. |
| 5636144 | The value specified for the access level is not valid. |
| 5636169 | A character in the URI is not valid. |
| 5636170 | The URI does not exist. |
| 5636173 | This feature requires an effective cluster version of 9.6 or later. |
| 5636175 | Vserver admin cannot have access to given API. |
| 5636184 | Expanded REST roles for granular resource control feature is currently disabled. |
| 5636185 | The specified UUID was not found. |
| 5636186 | Expanded REST roles for granular resource control requires an effective cluster version of 9.10.1 or later. |
| 13434890 | Vserver-ID failed for Vserver roles. |
| 13434891 | UUID LookUp failed for Vserver roles. |
| 13434892 | Roles is a required field. |
| 13434893 | The SVM does not exist. |
*/
type RolePrivilegeCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the role privilege create default response
func (o *RolePrivilegeCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this role privilege create default response has a 2xx status code
func (o *RolePrivilegeCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this role privilege create default response has a 3xx status code
func (o *RolePrivilegeCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this role privilege create default response has a 4xx status code
func (o *RolePrivilegeCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this role privilege create default response has a 5xx status code
func (o *RolePrivilegeCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this role privilege create default response a status code equal to that given
func (o *RolePrivilegeCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *RolePrivilegeCreateDefault) Error() string {
	return fmt.Sprintf("[POST /security/roles/{owner.uuid}/{name}/privileges][%d] role_privilege_create default  %+v", o._statusCode, o.Payload)
}

func (o *RolePrivilegeCreateDefault) String() string {
	return fmt.Sprintf("[POST /security/roles/{owner.uuid}/{name}/privileges][%d] role_privilege_create default  %+v", o._statusCode, o.Payload)
}

func (o *RolePrivilegeCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *RolePrivilegeCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
