// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVolumeDeleteParams creates a new VolumeDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVolumeDeleteParams() *VolumeDeleteParams {
	return &VolumeDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeDeleteParamsWithTimeout creates a new VolumeDeleteParams object
// with the ability to set a timeout on a request.
func NewVolumeDeleteParamsWithTimeout(timeout time.Duration) *VolumeDeleteParams {
	return &VolumeDeleteParams{
		timeout: timeout,
	}
}

// NewVolumeDeleteParamsWithContext creates a new VolumeDeleteParams object
// with the ability to set a context for a request.
func NewVolumeDeleteParamsWithContext(ctx context.Context) *VolumeDeleteParams {
	return &VolumeDeleteParams{
		Context: ctx,
	}
}

// NewVolumeDeleteParamsWithHTTPClient creates a new VolumeDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewVolumeDeleteParamsWithHTTPClient(client *http.Client) *VolumeDeleteParams {
	return &VolumeDeleteParams{
		HTTPClient: client,
	}
}

/*
VolumeDeleteParams contains all the parameters to send to the API endpoint

	for the volume delete operation.

	Typically these are written to a http.Request.
*/
type VolumeDeleteParams struct {

	/* Force.

	   Set the force flag to "true" to bypass the recovery queue, making the deleted volume non-recoverable.

	*/
	Force *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeout *int64

	/* UUID.

	   Unique identifier of the volume.
	*/
	UUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the volume delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeDeleteParams) WithDefaults() *VolumeDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the volume delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeDeleteParams) SetDefaults() {
	var (
		forceDefault = bool(false)

		returnTimeoutDefault = int64(0)
	)

	val := VolumeDeleteParams{
		Force:         &forceDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the volume delete params
func (o *VolumeDeleteParams) WithTimeout(timeout time.Duration) *VolumeDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume delete params
func (o *VolumeDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume delete params
func (o *VolumeDeleteParams) WithContext(ctx context.Context) *VolumeDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume delete params
func (o *VolumeDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume delete params
func (o *VolumeDeleteParams) WithHTTPClient(client *http.Client) *VolumeDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume delete params
func (o *VolumeDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithForce adds the force to the volume delete params
func (o *VolumeDeleteParams) WithForce(force *bool) *VolumeDeleteParams {
	o.SetForce(force)
	return o
}

// SetForce adds the force to the volume delete params
func (o *VolumeDeleteParams) SetForce(force *bool) {
	o.Force = force
}

// WithReturnTimeout adds the returnTimeout to the volume delete params
func (o *VolumeDeleteParams) WithReturnTimeout(returnTimeout *int64) *VolumeDeleteParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the volume delete params
func (o *VolumeDeleteParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithUUID adds the uuid to the volume delete params
func (o *VolumeDeleteParams) WithUUID(uuid string) *VolumeDeleteParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the volume delete params
func (o *VolumeDeleteParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Force != nil {

		// query param force
		var qrForce bool

		if o.Force != nil {
			qrForce = *o.Force
		}
		qForce := swag.FormatBool(qrForce)
		if qForce != "" {

			if err := r.SetQueryParam("force", qForce); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
