// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// VolumeModifyReader is a Reader for the VolumeModify structure.
type VolumeModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *VolumeModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewVolumeModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewVolumeModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewVolumeModifyAccepted creates a VolumeModifyAccepted with default headers values
func NewVolumeModifyAccepted() *VolumeModifyAccepted {
	return &VolumeModifyAccepted{}
}

/*
VolumeModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type VolumeModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this volume modify accepted response has a 2xx status code
func (o *VolumeModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this volume modify accepted response has a 3xx status code
func (o *VolumeModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this volume modify accepted response has a 4xx status code
func (o *VolumeModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this volume modify accepted response has a 5xx status code
func (o *VolumeModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this volume modify accepted response a status code equal to that given
func (o *VolumeModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *VolumeModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /storage/volumes/{uuid}][%d] volumeModifyAccepted  %+v", 202, o.Payload)
}

func (o *VolumeModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /storage/volumes/{uuid}][%d] volumeModifyAccepted  %+v", 202, o.Payload)
}

func (o *VolumeModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *VolumeModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewVolumeModifyDefault creates a VolumeModifyDefault with default headers values
func NewVolumeModifyDefault(code int) *VolumeModifyDefault {
	return &VolumeModifyDefault{
		_statusCode: code,
	}
}

/*
	VolumeModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 787141 | The specified \"aggregates.name\" and \"aggregates.uuid\" refer to different aggregates. |
| 917505 | SVM not found. |
| 917829 | Volume autosize grow threshold must be larger than autosize shrink threshold. |
| 917831 | Volume minimum autosize must be smaller than the maximum autosize. |
| 918193 | Cannot modify tiering min cooling days when vol move is in progress. |
| 918194 | Tiering min cooling days not supported for SVMDR. |
| 918195 | Tiering min cooling days not supported for non data volumes. |
| 918196 | Tiering min cooling days not allowed for the provided tiering policy. |
| 918248 | Specifying a value is not valid for initiating volume FlexClone split operation. |
| 918251 | Specifying a value is not valid for a Snapshot copy restore operation. |
| 918252 | specified \"nas.path\" is invalid. |
| 918265 | Volume is on the same aggregate. |
| 918266 | \"movement.destination_aggregate\" and \"movement.state\" are mutually exclusive, unless the state is \"cutover-wait\". |
| 918267 | The specified \"movement.destination_aggregate\" does not exist. |
| 918291 | Invalid volume cloud retrieval policy for the provided tiering policy. |
| 918292 | cloud retrieval policy not supported for non data volume. |
| 918293 | Cannot modify cloud retrieval policy when vol move is in progress. |
| 918521 | The volume maximum autosize must be smaller than or equal to the maximum volume size. |
| 918532 | The FlexClone match-parent-storage-tier option requires an effective cluster version of 9.9.1 or later. |
| 918533 | The FlexClone match-parent-storage-tier option not applicable for FlexClone volumes hosted on non-FabricPool storage. |
| 918534 | The tiering policy values are different for the FlexClone volume and its parent volume. The match-parent-storage-tier option cannot be set to true. |
| 918535 | The tiering minimum cooling day values are different for the FlexClone volume and its parent volume. The match-parent-storage-tier option cannot be set to true. |
| 918537 | Could not get the FlexClone volume tiering policy or its parent volume tiering policy. Wait a minute and try again. |
| 918538 | The match-parent-storage-tier option is not supported for clone creation. |
| 2424998 | Unable to determine whether MetroCluster is configured. |
| 9437885 | The volume is not online. |
| 13107256 | Operation is only supported on FlexGroup volumes. |
| 13107371 | Operation is only supported on read-write FlexGroup volumes. |
| 13107404 | When adding new resources to a FlexGroup by specifying \"aggregates.name\" or \"aggregates.uuid\", the FlexGroup cannot be resized using \"size\". These operations must be done separately. |
| 13107415 | Failed to lookup a volume property. |
| 13107431 | Failed to lookup an SVM property. |
| 13107433 | A Snapshot copy is scheduled to be taken within the volume capacity rebalancing runtime. |
| 13107434 | A SnapMirror update is scheduled within the volume capacity rebalancing runtime. |
| 13109187 | When adding new resources to a FlexGroup using \"sizing_method\", \"size\" must be specified.  Neither \"aggregates.name\" nor \"aggregates.uuid\" are allowed to be specified, as the aggregates are selected automatically by the system. |
| 13109198 | Resizing by adding new resources is only supported for FlexGroups. |
| 13109258 | Cannot enable granular data on volume \"name\" in Vserver \"svm.name\". This setting can only be enabled on FlexGroups. |
| 13109259 | Granular data cannot be disabled on volume \"name\" in Vserver \"svm.name\". This property can only be disabled by restoring a Snapshot copy. |
| 13109260 | Failed to enable granular data on the volume. |
| 111411201 | File system analytics cannot be enabled on the target volume because of the specified reason. |
| 111411202 | File system analytics cannot be disabled on the target volume because of the specified reason. |
| 111411205 | File system analytics requires an effective cluster version of 9.8 or later. |
| 111411206 | The specified \"analytics.state\" is invalid. |
| 111411207 | File system analytics cannot be enabled on volumes that contain LUNs. |
| 144180203 | Volume capacity rebalancing is not supported on FlexCache volumes. |
| 144180204 | Volume capacity rebalancing is not supported on object store volumes. |
| 144180207 | Volume capacity rebalancing is not supported on inactive MetroCluster configurations. |
| 144182201 | Volume capacity rebalancing using non-disruptive file move operations and granular data requires an effective cluster version of 9.11.1 or later. |
| 144182203 | The specified value for the \"rebalancing.state\" parameter is invalid for a PATCH operation. Valid values are \"starting\" and \"stopping\". |
| 144182207 | Modifying the volume capacity rebalancing configuration is not supported in the same operation that volume capacity rebalancing is being stopped. |
| 144182211 | The specified value for \"-max-file-moves\" is not valid. |
| 144182212 | The \"-min-file-size\" value specified must be larger than 0. |
| 144182213 | The \"-min-threshold\" value specified must be larger than 0. |
| 144182214 | The \"-max-threshold\" value specified must be larger than 0. |
| 144182215 | The maximum imbalance threshold value must be larger than the minimum imbalance threshold value. |
| 144182216 | Volume capacity rebalancing is running on the volume. |
| 144182219 | Volume capacity rebalancing for the volume has been started on some constituents. |
| 144182221 | The \"-max-runtime\" value specified must be 30 minutes or longer. |
| 144182223 | Volume capacity rebalancing is not running on the volume. |
| 144182225 | Internal error in the data component. |
| 144182226 | Failed to load the volume capacity rebalancing configuration for the volume. |
*/
type VolumeModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the volume modify default response
func (o *VolumeModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this volume modify default response has a 2xx status code
func (o *VolumeModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this volume modify default response has a 3xx status code
func (o *VolumeModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this volume modify default response has a 4xx status code
func (o *VolumeModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this volume modify default response has a 5xx status code
func (o *VolumeModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this volume modify default response a status code equal to that given
func (o *VolumeModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *VolumeModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /storage/volumes/{uuid}][%d] volume_modify default  %+v", o._statusCode, o.Payload)
}

func (o *VolumeModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /storage/volumes/{uuid}][%d] volume_modify default  %+v", o._statusCode, o.Payload)
}

func (o *VolumeModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *VolumeModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
