// Code generated by go-swagger; DO NOT EDIT.

package support

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCoredumpCollectionGetParams creates a new CoredumpCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCoredumpCollectionGetParams() *CoredumpCollectionGetParams {
	return &CoredumpCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCoredumpCollectionGetParamsWithTimeout creates a new CoredumpCollectionGetParams object
// with the ability to set a timeout on a request.
func NewCoredumpCollectionGetParamsWithTimeout(timeout time.Duration) *CoredumpCollectionGetParams {
	return &CoredumpCollectionGetParams{
		timeout: timeout,
	}
}

// NewCoredumpCollectionGetParamsWithContext creates a new CoredumpCollectionGetParams object
// with the ability to set a context for a request.
func NewCoredumpCollectionGetParamsWithContext(ctx context.Context) *CoredumpCollectionGetParams {
	return &CoredumpCollectionGetParams{
		Context: ctx,
	}
}

// NewCoredumpCollectionGetParamsWithHTTPClient creates a new CoredumpCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewCoredumpCollectionGetParamsWithHTTPClient(client *http.Client) *CoredumpCollectionGetParams {
	return &CoredumpCollectionGetParams{
		HTTPClient: client,
	}
}

/*
CoredumpCollectionGetParams contains all the parameters to send to the API endpoint

	for the coredump collection get operation.

	Typically these are written to a http.Request.
*/
type CoredumpCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* IsPartial.

	   Filter by is_partial
	*/
	IsPartial *bool

	/* IsSaved.

	   Filter by is_saved
	*/
	IsSaved *bool

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Md5DataChecksum.

	   Filter by md5_data_checksum
	*/
	Md5DataChecksum *string

	/* Name.

	   Filter by name
	*/
	Name *string

	/* NodeName.

	   Filter by node.name
	*/
	NodeName *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUID *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* PanicTime.

	   Filter by panic_time
	*/
	PanicTime *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* Size.

	   Filter by size
	*/
	Size *int64

	/* Type.

	   Filter by type
	*/
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the coredump collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CoredumpCollectionGetParams) WithDefaults() *CoredumpCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the coredump collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CoredumpCollectionGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := CoredumpCollectionGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithTimeout(timeout time.Duration) *CoredumpCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithContext(ctx context.Context) *CoredumpCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithHTTPClient(client *http.Client) *CoredumpCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithFields(fields []string) *CoredumpCollectionGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIsPartial adds the isPartial to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithIsPartial(isPartial *bool) *CoredumpCollectionGetParams {
	o.SetIsPartial(isPartial)
	return o
}

// SetIsPartial adds the isPartial to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetIsPartial(isPartial *bool) {
	o.IsPartial = isPartial
}

// WithIsSaved adds the isSaved to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithIsSaved(isSaved *bool) *CoredumpCollectionGetParams {
	o.SetIsSaved(isSaved)
	return o
}

// SetIsSaved adds the isSaved to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetIsSaved(isSaved *bool) {
	o.IsSaved = isSaved
}

// WithMaxRecords adds the maxRecords to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithMaxRecords(maxRecords *int64) *CoredumpCollectionGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithMd5DataChecksum adds the md5DataChecksum to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithMd5DataChecksum(md5DataChecksum *string) *CoredumpCollectionGetParams {
	o.SetMd5DataChecksum(md5DataChecksum)
	return o
}

// SetMd5DataChecksum adds the md5DataChecksum to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetMd5DataChecksum(md5DataChecksum *string) {
	o.Md5DataChecksum = md5DataChecksum
}

// WithName adds the name to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithName(name *string) *CoredumpCollectionGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetName(name *string) {
	o.Name = name
}

// WithNodeName adds the nodeName to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithNodeName(nodeName *string) *CoredumpCollectionGetParams {
	o.SetNodeName(nodeName)
	return o
}

// SetNodeName adds the nodeName to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetNodeName(nodeName *string) {
	o.NodeName = nodeName
}

// WithNodeUUID adds the nodeUUID to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithNodeUUID(nodeUUID *string) *CoredumpCollectionGetParams {
	o.SetNodeUUID(nodeUUID)
	return o
}

// SetNodeUUID adds the nodeUuid to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetNodeUUID(nodeUUID *string) {
	o.NodeUUID = nodeUUID
}

// WithOrderBy adds the orderBy to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithOrderBy(orderBy []string) *CoredumpCollectionGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithPanicTime adds the panicTime to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithPanicTime(panicTime *string) *CoredumpCollectionGetParams {
	o.SetPanicTime(panicTime)
	return o
}

// SetPanicTime adds the panicTime to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetPanicTime(panicTime *string) {
	o.PanicTime = panicTime
}

// WithReturnRecords adds the returnRecords to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithReturnRecords(returnRecords *bool) *CoredumpCollectionGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithReturnTimeout(returnTimeout *int64) *CoredumpCollectionGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSize adds the size to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithSize(size *int64) *CoredumpCollectionGetParams {
	o.SetSize(size)
	return o
}

// SetSize adds the size to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetSize(size *int64) {
	o.Size = size
}

// WithType adds the typeVar to the coredump collection get params
func (o *CoredumpCollectionGetParams) WithType(typeVar *string) *CoredumpCollectionGetParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the coredump collection get params
func (o *CoredumpCollectionGetParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *CoredumpCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IsPartial != nil {

		// query param is_partial
		var qrIsPartial bool

		if o.IsPartial != nil {
			qrIsPartial = *o.IsPartial
		}
		qIsPartial := swag.FormatBool(qrIsPartial)
		if qIsPartial != "" {

			if err := r.SetQueryParam("is_partial", qIsPartial); err != nil {
				return err
			}
		}
	}

	if o.IsSaved != nil {

		// query param is_saved
		var qrIsSaved bool

		if o.IsSaved != nil {
			qrIsSaved = *o.IsSaved
		}
		qIsSaved := swag.FormatBool(qrIsSaved)
		if qIsSaved != "" {

			if err := r.SetQueryParam("is_saved", qIsSaved); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Md5DataChecksum != nil {

		// query param md5_data_checksum
		var qrMd5DataChecksum string

		if o.Md5DataChecksum != nil {
			qrMd5DataChecksum = *o.Md5DataChecksum
		}
		qMd5DataChecksum := qrMd5DataChecksum
		if qMd5DataChecksum != "" {

			if err := r.SetQueryParam("md5_data_checksum", qMd5DataChecksum); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NodeName != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeName != nil {
			qrNodeName = *o.NodeName
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUID != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUID != nil {
			qrNodeUUID = *o.NodeUUID
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PanicTime != nil {

		// query param panic_time
		var qrPanicTime string

		if o.PanicTime != nil {
			qrPanicTime = *o.PanicTime
		}
		qPanicTime := qrPanicTime
		if qPanicTime != "" {

			if err := r.SetQueryParam("panic_time", qPanicTime); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.Size != nil {

		// query param size
		var qrSize int64

		if o.Size != nil {
			qrSize = *o.Size
		}
		qSize := swag.FormatInt64(qrSize)
		if qSize != "" {

			if err := r.SetQueryParam("size", qSize); err != nil {
				return err
			}
		}
	}

	if o.Type != nil {

		// query param type
		var qrType string

		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamCoredumpCollectionGet binds the parameter fields
func (o *CoredumpCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamCoredumpCollectionGet binds the parameter order_by
func (o *CoredumpCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
