// Code generated by go-swagger; DO NOT EDIT.

package svm

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SvmModifyReader is a Reader for the SvmModify structure.
type SvmModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SvmModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSvmModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSvmModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSvmModifyAccepted creates a SvmModifyAccepted with default headers values
func NewSvmModifyAccepted() *SvmModifyAccepted {
	return &SvmModifyAccepted{}
}

/*
SvmModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SvmModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this svm modify accepted response has a 2xx status code
func (o *SvmModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this svm modify accepted response has a 3xx status code
func (o *SvmModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this svm modify accepted response has a 4xx status code
func (o *SvmModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this svm modify accepted response has a 5xx status code
func (o *SvmModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this svm modify accepted response a status code equal to that given
func (o *SvmModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SvmModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /svm/svms/{uuid}][%d] svmModifyAccepted  %+v", 202, o.Payload)
}

func (o *SvmModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /svm/svms/{uuid}][%d] svmModifyAccepted  %+v", 202, o.Payload)
}

func (o *SvmModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SvmModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSvmModifyDefault creates a SvmModifyDefault with default headers values
func NewSvmModifyDefault(code int) *SvmModifyDefault {
	return &SvmModifyDefault{
		_statusCode: code,
	}
}

/*
	SvmModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

<br/>
```
| Error codes | Description |
| ----------- | ----------- |
| 13434880    | Failed to modify SVM parameters. |
| 13434881    | Failed to rename SVM. |
| 13434883    | SVM parameters except name modified successfully. |
| 13434885    | Non-UTF8 language(s) not supported. |
| 13434886    | Invalid Snapshot copy policy. |
| 13434902    | Modification of NSSwitch parameters failed for the SVM. |
| 13434906    | Operation not supported for an SVM of type sync-destination. |
| 12451843    | Certificate does not exist. |
| 13434908    | Invalid SVM name. The name is already in use by another SVM, IPSpace or cluster. |
| 13434916    | SVM is in the process of being created. Wait a few minutes, and then try the command again. |
| 13434915    | Failed to unlock the SVM because SVM create or delete job is in progress. Wait a few minutes, and then try the command again. |
| 13434911    | Invalid SVM name. Maximum supported length is 41 if SVM is of type \\\"sync-source\\\", otherwise 47. |
```
<br/>
*/
type SvmModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the svm modify default response
func (o *SvmModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this svm modify default response has a 2xx status code
func (o *SvmModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this svm modify default response has a 3xx status code
func (o *SvmModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this svm modify default response has a 4xx status code
func (o *SvmModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this svm modify default response has a 5xx status code
func (o *SvmModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this svm modify default response a status code equal to that given
func (o *SvmModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SvmModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /svm/svms/{uuid}][%d] svm_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SvmModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /svm/svms/{uuid}][%d] svm_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SvmModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SvmModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
