// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ConsistencyGroupClone consistency group clone
//
// swagger:model consistency_group_clone
type ConsistencyGroupClone struct {

	// guarantee
	Guarantee *ConsistencyGroupCloneInlineGuarantee `json:"guarantee,omitempty"`

	// parent consistency group
	ParentConsistencyGroup *ConsistencyGroupCloneInlineParentConsistencyGroup `json:"parent_consistency_group,omitempty"`

	// parent snapshot
	ParentSnapshot *ConsistencyGroupCloneInlineParentSnapshot `json:"parent_snapshot,omitempty"`

	// Splits volumes after cloning. Default is false.
	SplitInitiated *bool `json:"split_initiated,omitempty"`

	// volume
	Volume *ConsistencyGroupCloneInlineVolume `json:"volume,omitempty"`
}

// Validate validates this consistency group clone
func (m *ConsistencyGroupClone) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentConsistencyGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVolume(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupClone) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) validateParentConsistencyGroup(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentConsistencyGroup) { // not required
		return nil
	}

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) validateParentSnapshot(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentSnapshot) { // not required
		return nil
	}

	if m.ParentSnapshot != nil {
		if err := m.ParentSnapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_snapshot")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) validateVolume(formats strfmt.Registry) error {
	if swag.IsZero(m.Volume) { // not required
		return nil
	}

	if m.Volume != nil {
		if err := m.Volume.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group clone based on the context it is used
func (m *ConsistencyGroupClone) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentConsistencyGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentSnapshot(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVolume(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupClone) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) contextValidateParentConsistencyGroup(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) contextValidateParentSnapshot(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentSnapshot != nil {
		if err := m.ParentSnapshot.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_snapshot")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupClone) contextValidateVolume(ctx context.Context, formats strfmt.Registry) error {

	if m.Volume != nil {
		if err := m.Volume.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("volume")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupClone) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupClone) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupClone
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupCloneInlineGuarantee consistency group clone inline guarantee
//
// swagger:model consistency_group_clone_inline_guarantee
type ConsistencyGroupCloneInlineGuarantee struct {

	// The type of space guarantee of this volume in the aggregate.
	// Enum: [volume none]
	Type *string `json:"type,omitempty"`
}

// Validate validates this consistency group clone inline guarantee
func (m *ConsistencyGroupCloneInlineGuarantee) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupCloneInlineGuaranteeTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["volume","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupCloneInlineGuaranteeTypeTypePropEnum = append(consistencyGroupCloneInlineGuaranteeTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_clone_inline_guarantee
	// ConsistencyGroupCloneInlineGuarantee
	// type
	// Type
	// volume
	// END DEBUGGING
	// ConsistencyGroupCloneInlineGuaranteeTypeVolume captures enum value "volume"
	ConsistencyGroupCloneInlineGuaranteeTypeVolume string = "volume"

	// BEGIN DEBUGGING
	// consistency_group_clone_inline_guarantee
	// ConsistencyGroupCloneInlineGuarantee
	// type
	// Type
	// none
	// END DEBUGGING
	// ConsistencyGroupCloneInlineGuaranteeTypeNone captures enum value "none"
	ConsistencyGroupCloneInlineGuaranteeTypeNone string = "none"
)

// prop value enum
func (m *ConsistencyGroupCloneInlineGuarantee) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupCloneInlineGuaranteeTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupCloneInlineGuarantee) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("guarantee"+"."+"type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group clone inline guarantee based on context it is used
func (m *ConsistencyGroupCloneInlineGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupCloneInlineGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupCloneInlineParentConsistencyGroup Consistency group that is to be cloned.
//
// swagger:model consistency_group_clone_inline_parent_consistency_group
type ConsistencyGroupCloneInlineParentConsistencyGroup struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the consistency group.
	// Example: my_consistency_group
	Name *string `json:"name,omitempty"`

	// The unique identifier of the consistency group.
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group clone inline parent consistency group
func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group clone inline parent consistency group based on the context it is used
func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineParentConsistencyGroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupCloneInlineParentConsistencyGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupCloneInlineParentSnapshot consistency group clone inline parent snapshot
//
// swagger:model consistency_group_clone_inline_parent_snapshot
type ConsistencyGroupCloneInlineParentSnapshot struct {

	// Name of an existing Snapshot copy of a parent consistency group.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group clone inline parent snapshot
func (m *ConsistencyGroupCloneInlineParentSnapshot) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group clone inline parent snapshot based on context it is used
func (m *ConsistencyGroupCloneInlineParentSnapshot) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineParentSnapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineParentSnapshot) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupCloneInlineParentSnapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupCloneInlineVolume Volume name suffix/prefix for the cloned volumes.
//
// swagger:model consistency_group_clone_inline_volume
type ConsistencyGroupCloneInlineVolume struct {

	// Volume name prefix for cloned volumes.
	Prefix *string `json:"prefix,omitempty"`

	// Volume name suffix for cloned volumes.
	Suffix *string `json:"suffix,omitempty"`
}

// Validate validates this consistency group clone inline volume
func (m *ConsistencyGroupCloneInlineVolume) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group clone inline volume based on context it is used
func (m *ConsistencyGroupCloneInlineVolume) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineVolume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupCloneInlineVolume) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupCloneInlineVolume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
