// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ZappNvmeComponentsSubsystem components.subsystem
//
// swagger:model zapp_nvme_components_subsystem
type ZappNvmeComponentsSubsystem struct {

	// The name of the subsystem accessing the component. If neither the name nor the UUID is provided, the name defaults to &lt;application-name&gt;_&lt;component-name&gt;, whether that subsystem already exists or not.
	Name *string `json:"name,omitempty"`

	// The name of the host OS accessing the component. The default value is the host OS that is running the application.
	// Enum: [aix linux vmware windows]
	OsType *string `json:"os_type,omitempty"`

	// The UUID of an existing subsystem to be granted access to the component.
	UUID *string `json:"uuid,omitempty"`

	// zapp nvme components subsystem inline hosts
	ZappNvmeComponentsSubsystemInlineHosts []*ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem `json:"hosts,omitempty"`
}

// Validate validates this zapp nvme components subsystem
func (m *ZappNvmeComponentsSubsystem) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateZappNvmeComponentsSubsystemInlineHosts(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var zappNvmeComponentsSubsystemTypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","linux","vmware","windows"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		zappNvmeComponentsSubsystemTypeOsTypePropEnum = append(zappNvmeComponentsSubsystemTypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// zapp_nvme_components_subsystem
	// ZappNvmeComponentsSubsystem
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ZappNvmeComponentsSubsystemOsTypeAix captures enum value "aix"
	ZappNvmeComponentsSubsystemOsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// zapp_nvme_components_subsystem
	// ZappNvmeComponentsSubsystem
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ZappNvmeComponentsSubsystemOsTypeLinux captures enum value "linux"
	ZappNvmeComponentsSubsystemOsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// zapp_nvme_components_subsystem
	// ZappNvmeComponentsSubsystem
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ZappNvmeComponentsSubsystemOsTypeVmware captures enum value "vmware"
	ZappNvmeComponentsSubsystemOsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// zapp_nvme_components_subsystem
	// ZappNvmeComponentsSubsystem
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ZappNvmeComponentsSubsystemOsTypeWindows captures enum value "windows"
	ZappNvmeComponentsSubsystemOsTypeWindows string = "windows"
)

// prop value enum
func (m *ZappNvmeComponentsSubsystem) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, zappNvmeComponentsSubsystemTypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ZappNvmeComponentsSubsystem) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

func (m *ZappNvmeComponentsSubsystem) validateZappNvmeComponentsSubsystemInlineHosts(formats strfmt.Registry) error {
	if swag.IsZero(m.ZappNvmeComponentsSubsystemInlineHosts) { // not required
		return nil
	}

	for i := 0; i < len(m.ZappNvmeComponentsSubsystemInlineHosts); i++ {
		if swag.IsZero(m.ZappNvmeComponentsSubsystemInlineHosts[i]) { // not required
			continue
		}

		if m.ZappNvmeComponentsSubsystemInlineHosts[i] != nil {
			if err := m.ZappNvmeComponentsSubsystemInlineHosts[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("hosts" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this zapp nvme components subsystem based on the context it is used
func (m *ZappNvmeComponentsSubsystem) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateZappNvmeComponentsSubsystemInlineHosts(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ZappNvmeComponentsSubsystem) contextValidateZappNvmeComponentsSubsystemInlineHosts(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ZappNvmeComponentsSubsystemInlineHosts); i++ {

		if m.ZappNvmeComponentsSubsystemInlineHosts[i] != nil {
			if err := m.ZappNvmeComponentsSubsystemInlineHosts[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("hosts" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ZappNvmeComponentsSubsystem) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ZappNvmeComponentsSubsystem) UnmarshalBinary(b []byte) error {
	var res ZappNvmeComponentsSubsystem
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem zapp nvme components subsystem inline hosts inline array item
//
// swagger:model zapp_nvme_components_subsystem_inline_hosts_inline_array_item
type ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem struct {

	// The host NQN.
	Nqn *string `json:"nqn,omitempty"`
}

// Validate validates this zapp nvme components subsystem inline hosts inline array item
func (m *ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this zapp nvme components subsystem inline hosts inline array item based on context it is used
func (m *ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem) UnmarshalBinary(b []byte) error {
	var res ZappNvmeComponentsSubsystemInlineHostsInlineArrayItem
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
