// /*
// Copyright The Kubernetes Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// */

// Code generated by client-gen. DO NOT EDIT.
package azclient

import (
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/availabilitysetclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/deploymentclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/diskclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/interfaceclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/ipgroupclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/loadbalancerclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/managedclusterclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/privateendpointclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/privatelinkserviceclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/privatezoneclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/publicipaddressclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/publicipprefixclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/registryclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/resourcegroupclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/routetableclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/securitygroupclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/snapshotclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/sshpublickeyresourceclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/subnetclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/virtualmachineclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/virtualmachinescalesetclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/virtualmachinescalesetvmclient"
	"sigs.k8s.io/cloud-provider-azure/pkg/azclient/virtualnetworkclient"
)

type ClientFactory interface {
	GetAvailabilitySetClient() availabilitysetclient.Interface
	GetDeploymentClient() deploymentclient.Interface
	GetDiskClient() diskclient.Interface
	GetInterfaceClient() interfaceclient.Interface
	GetIPGroupClient() ipgroupclient.Interface
	GetLoadBalancerClient() loadbalancerclient.Interface
	GetManagedClusterClient() managedclusterclient.Interface
	GetPrivateEndpointClient() privateendpointclient.Interface
	GetPrivateLinkServiceClient() privatelinkserviceclient.Interface
	GetPrivateZoneClient() privatezoneclient.Interface
	GetPublicIPAddressClient() publicipaddressclient.Interface
	GetPublicIPPrefixClient() publicipprefixclient.Interface
	GetRegistryClient() registryclient.Interface
	GetResourceGroupClient() resourcegroupclient.Interface
	GetRouteTableClient() routetableclient.Interface
	GetSecurityGroupClient() securitygroupclient.Interface
	GetSnapshotClient() snapshotclient.Interface
	GetSSHPublicKeyResourceClient() sshpublickeyresourceclient.Interface
	GetSubnetClient() subnetclient.Interface
	GetVirtualMachineClient() virtualmachineclient.Interface
	GetVirtualMachineScaleSetClient() virtualmachinescalesetclient.Interface
	GetVirtualMachineScaleSetVMClient() virtualmachinescalesetvmclient.Interface
	GetVirtualNetworkClient() virtualnetworkclient.Interface
}
