// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewConsistencyGroupGetParams creates a new ConsistencyGroupGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewConsistencyGroupGetParams() *ConsistencyGroupGetParams {
	return &ConsistencyGroupGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewConsistencyGroupGetParamsWithTimeout creates a new ConsistencyGroupGetParams object
// with the ability to set a timeout on a request.
func NewConsistencyGroupGetParamsWithTimeout(timeout time.Duration) *ConsistencyGroupGetParams {
	return &ConsistencyGroupGetParams{
		timeout: timeout,
	}
}

// NewConsistencyGroupGetParamsWithContext creates a new ConsistencyGroupGetParams object
// with the ability to set a context for a request.
func NewConsistencyGroupGetParamsWithContext(ctx context.Context) *ConsistencyGroupGetParams {
	return &ConsistencyGroupGetParams{
		Context: ctx,
	}
}

// NewConsistencyGroupGetParamsWithHTTPClient creates a new ConsistencyGroupGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewConsistencyGroupGetParamsWithHTTPClient(client *http.Client) *ConsistencyGroupGetParams {
	return &ConsistencyGroupGetParams{
		HTTPClient: client,
	}
}

/*
ConsistencyGroupGetParams contains all the parameters to send to the API endpoint

	for the consistency group get operation.

	Typically these are written to a http.Request.
*/
type ConsistencyGroupGetParams struct {

	/* ApplicationComponentType.

	   Filter by application.component_type
	*/
	ApplicationComponentType *string

	/* ApplicationType.

	   Filter by application.type
	*/
	ApplicationType *string

	/* CloneGuaranteeType.

	   Filter by clone.guarantee.type
	*/
	CloneGuaranteeType *string

	/* CloneParentConsistencyGroupName.

	   Filter by clone.parent_consistency_group.name
	*/
	CloneParentConsistencyGroupName *string

	/* CloneParentConsistencyGroupUUID.

	   Filter by clone.parent_consistency_group.uuid
	*/
	CloneParentConsistencyGroupUUID *string

	/* CloneParentSnapshotName.

	   Filter by clone.parent_snapshot.name
	*/
	CloneParentSnapshotName *string

	/* CloneSplitInitiated.

	   Filter by clone.split_initiated
	*/
	CloneSplitInitiated *bool

	/* CloneVolumePrefix.

	   Filter by clone.volume.prefix
	*/
	CloneVolumePrefix *string

	/* CloneVolumeSuffix.

	   Filter by clone.volume.suffix
	*/
	CloneVolumeSuffix *string

	/* ConsistencyGroupsApplicationComponentType.

	   Filter by consistency_groups.application.component_type
	*/
	ConsistencyGroupsApplicationComponentType *string

	/* ConsistencyGroupsApplicationType.

	   Filter by consistency_groups.application.type
	*/
	ConsistencyGroupsApplicationType *string

	/* ConsistencyGroupsLunsComment.

	   Filter by consistency_groups.luns.comment
	*/
	ConsistencyGroupsLunsComment *string

	/* ConsistencyGroupsLunsCreateTime.

	   Filter by consistency_groups.luns.create_time
	*/
	ConsistencyGroupsLunsCreateTime *string

	/* ConsistencyGroupsLunsEnabled.

	   Filter by consistency_groups.luns.enabled
	*/
	ConsistencyGroupsLunsEnabled *bool

	/* ConsistencyGroupsLunsLunMapsIgroupComment.

	   Filter by consistency_groups.luns.lun_maps.igroup.comment
	*/
	ConsistencyGroupsLunsLunMapsIgroupComment *string

	/* ConsistencyGroupsLunsLunMapsIgroupIgroupsName.

	   Filter by consistency_groups.luns.lun_maps.igroup.igroups.name
	*/
	ConsistencyGroupsLunsLunMapsIgroupIgroupsName *string

	/* ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID.

	   Filter by consistency_groups.luns.lun_maps.igroup.igroups.uuid
	*/
	ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID *string

	/* ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment.

	   Filter by consistency_groups.luns.lun_maps.igroup.initiators.comment
	*/
	ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment *string

	/* ConsistencyGroupsLunsLunMapsIgroupInitiatorsName.

	   Filter by consistency_groups.luns.lun_maps.igroup.initiators.name
	*/
	ConsistencyGroupsLunsLunMapsIgroupInitiatorsName *string

	/* ConsistencyGroupsLunsLunMapsIgroupName.

	   Filter by consistency_groups.luns.lun_maps.igroup.name
	*/
	ConsistencyGroupsLunsLunMapsIgroupName *string

	/* ConsistencyGroupsLunsLunMapsIgroupOsType.

	   Filter by consistency_groups.luns.lun_maps.igroup.os_type
	*/
	ConsistencyGroupsLunsLunMapsIgroupOsType *string

	/* ConsistencyGroupsLunsLunMapsIgroupProtocol.

	   Filter by consistency_groups.luns.lun_maps.igroup.protocol
	*/
	ConsistencyGroupsLunsLunMapsIgroupProtocol *string

	/* ConsistencyGroupsLunsLunMapsIgroupUUID.

	   Filter by consistency_groups.luns.lun_maps.igroup.uuid
	*/
	ConsistencyGroupsLunsLunMapsIgroupUUID *string

	/* ConsistencyGroupsLunsLunMapsLogicalUnitNumber.

	   Filter by consistency_groups.luns.lun_maps.logical_unit_number
	*/
	ConsistencyGroupsLunsLunMapsLogicalUnitNumber *int64

	/* ConsistencyGroupsLunsName.

	   Filter by consistency_groups.luns.name
	*/
	ConsistencyGroupsLunsName *string

	/* ConsistencyGroupsLunsOsType.

	   Filter by consistency_groups.luns.os_type
	*/
	ConsistencyGroupsLunsOsType *string

	/* ConsistencyGroupsLunsQosPolicyMaxThroughputIops.

	   Filter by consistency_groups.luns.qos.policy.max_throughput_iops
	*/
	ConsistencyGroupsLunsQosPolicyMaxThroughputIops *int64

	/* ConsistencyGroupsLunsQosPolicyMaxThroughputMbps.

	   Filter by consistency_groups.luns.qos.policy.max_throughput_mbps
	*/
	ConsistencyGroupsLunsQosPolicyMaxThroughputMbps *int64

	/* ConsistencyGroupsLunsQosPolicyMinThroughputIops.

	   Filter by consistency_groups.luns.qos.policy.min_throughput_iops
	*/
	ConsistencyGroupsLunsQosPolicyMinThroughputIops *int64

	/* ConsistencyGroupsLunsQosPolicyMinThroughputMbps.

	   Filter by consistency_groups.luns.qos.policy.min_throughput_mbps
	*/
	ConsistencyGroupsLunsQosPolicyMinThroughputMbps *int64

	/* ConsistencyGroupsLunsQosPolicyName.

	   Filter by consistency_groups.luns.qos.policy.name
	*/
	ConsistencyGroupsLunsQosPolicyName *string

	/* ConsistencyGroupsLunsQosPolicyUUID.

	   Filter by consistency_groups.luns.qos.policy.uuid
	*/
	ConsistencyGroupsLunsQosPolicyUUID *string

	/* ConsistencyGroupsLunsSerialNumber.

	   Filter by consistency_groups.luns.serial_number
	*/
	ConsistencyGroupsLunsSerialNumber *string

	/* ConsistencyGroupsLunsSpaceGuaranteeRequested.

	   Filter by consistency_groups.luns.space.guarantee.requested
	*/
	ConsistencyGroupsLunsSpaceGuaranteeRequested *bool

	/* ConsistencyGroupsLunsSpaceGuaranteeReserved.

	   Filter by consistency_groups.luns.space.guarantee.reserved
	*/
	ConsistencyGroupsLunsSpaceGuaranteeReserved *bool

	/* ConsistencyGroupsLunsSpaceSize.

	   Filter by consistency_groups.luns.space.size
	*/
	ConsistencyGroupsLunsSpaceSize *int64

	/* ConsistencyGroupsLunsSpaceUsed.

	   Filter by consistency_groups.luns.space.used
	*/
	ConsistencyGroupsLunsSpaceUsed *int64

	/* ConsistencyGroupsLunsUUID.

	   Filter by consistency_groups.luns.uuid
	*/
	ConsistencyGroupsLunsUUID *string

	/* ConsistencyGroupsName.

	   Filter by consistency_groups.name
	*/
	ConsistencyGroupsName *string

	/* ConsistencyGroupsNamespacesAutoDelete.

	   Filter by consistency_groups.namespaces.auto_delete
	*/
	ConsistencyGroupsNamespacesAutoDelete *bool

	/* ConsistencyGroupsNamespacesComment.

	   Filter by consistency_groups.namespaces.comment
	*/
	ConsistencyGroupsNamespacesComment *string

	/* ConsistencyGroupsNamespacesCreateTime.

	   Filter by consistency_groups.namespaces.create_time
	*/
	ConsistencyGroupsNamespacesCreateTime *string

	/* ConsistencyGroupsNamespacesEnabled.

	   Filter by consistency_groups.namespaces.enabled
	*/
	ConsistencyGroupsNamespacesEnabled *bool

	/* ConsistencyGroupsNamespacesName.

	   Filter by consistency_groups.namespaces.name
	*/
	ConsistencyGroupsNamespacesName *string

	/* ConsistencyGroupsNamespacesOsType.

	   Filter by consistency_groups.namespaces.os_type
	*/
	ConsistencyGroupsNamespacesOsType *string

	/* ConsistencyGroupsNamespacesSpaceBlockSize.

	   Filter by consistency_groups.namespaces.space.block_size
	*/
	ConsistencyGroupsNamespacesSpaceBlockSize *int64

	/* ConsistencyGroupsNamespacesSpaceGuaranteeRequested.

	   Filter by consistency_groups.namespaces.space.guarantee.requested
	*/
	ConsistencyGroupsNamespacesSpaceGuaranteeRequested *bool

	/* ConsistencyGroupsNamespacesSpaceGuaranteeReserved.

	   Filter by consistency_groups.namespaces.space.guarantee.reserved
	*/
	ConsistencyGroupsNamespacesSpaceGuaranteeReserved *bool

	/* ConsistencyGroupsNamespacesSpaceSize.

	   Filter by consistency_groups.namespaces.space.size
	*/
	ConsistencyGroupsNamespacesSpaceSize *int64

	/* ConsistencyGroupsNamespacesSpaceUsed.

	   Filter by consistency_groups.namespaces.space.used
	*/
	ConsistencyGroupsNamespacesSpaceUsed *int64

	/* ConsistencyGroupsNamespacesStatusContainerState.

	   Filter by consistency_groups.namespaces.status.container_state
	*/
	ConsistencyGroupsNamespacesStatusContainerState *string

	/* ConsistencyGroupsNamespacesStatusMapped.

	   Filter by consistency_groups.namespaces.status.mapped
	*/
	ConsistencyGroupsNamespacesStatusMapped *bool

	/* ConsistencyGroupsNamespacesStatusReadOnly.

	   Filter by consistency_groups.namespaces.status.read_only
	*/
	ConsistencyGroupsNamespacesStatusReadOnly *bool

	/* ConsistencyGroupsNamespacesStatusState.

	   Filter by consistency_groups.namespaces.status.state
	*/
	ConsistencyGroupsNamespacesStatusState *string

	/* ConsistencyGroupsNamespacesSubsystemMapAnagrpid.

	   Filter by consistency_groups.namespaces.subsystem_map.anagrpid
	*/
	ConsistencyGroupsNamespacesSubsystemMapAnagrpid *string

	/* ConsistencyGroupsNamespacesSubsystemMapNsid.

	   Filter by consistency_groups.namespaces.subsystem_map.nsid
	*/
	ConsistencyGroupsNamespacesSubsystemMapNsid *string

	/* ConsistencyGroupsNamespacesSubsystemMapSubsystemComment.

	   Filter by consistency_groups.namespaces.subsystem_map.subsystem.comment
	*/
	ConsistencyGroupsNamespacesSubsystemMapSubsystemComment *string

	/* ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn.

	   Filter by consistency_groups.namespaces.subsystem_map.subsystem.hosts.nqn
	*/
	ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn *string

	/* ConsistencyGroupsNamespacesSubsystemMapSubsystemName.

	   Filter by consistency_groups.namespaces.subsystem_map.subsystem.name
	*/
	ConsistencyGroupsNamespacesSubsystemMapSubsystemName *string

	/* ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType.

	   Filter by consistency_groups.namespaces.subsystem_map.subsystem.os_type
	*/
	ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType *string

	/* ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID.

	   Filter by consistency_groups.namespaces.subsystem_map.subsystem.uuid
	*/
	ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID *string

	/* ConsistencyGroupsNamespacesUUID.

	   Filter by consistency_groups.namespaces.uuid
	*/
	ConsistencyGroupsNamespacesUUID *string

	/* ConsistencyGroupsParentConsistencyGroupName.

	   Filter by consistency_groups.parent_consistency_group.name
	*/
	ConsistencyGroupsParentConsistencyGroupName *string

	/* ConsistencyGroupsParentConsistencyGroupUUID.

	   Filter by consistency_groups.parent_consistency_group.uuid
	*/
	ConsistencyGroupsParentConsistencyGroupUUID *string

	/* ConsistencyGroupsQosPolicyMaxThroughputIops.

	   Filter by consistency_groups.qos.policy.max_throughput_iops
	*/
	ConsistencyGroupsQosPolicyMaxThroughputIops *int64

	/* ConsistencyGroupsQosPolicyMaxThroughputMbps.

	   Filter by consistency_groups.qos.policy.max_throughput_mbps
	*/
	ConsistencyGroupsQosPolicyMaxThroughputMbps *int64

	/* ConsistencyGroupsQosPolicyMinThroughputIops.

	   Filter by consistency_groups.qos.policy.min_throughput_iops
	*/
	ConsistencyGroupsQosPolicyMinThroughputIops *int64

	/* ConsistencyGroupsQosPolicyMinThroughputMbps.

	   Filter by consistency_groups.qos.policy.min_throughput_mbps
	*/
	ConsistencyGroupsQosPolicyMinThroughputMbps *int64

	/* ConsistencyGroupsQosPolicyName.

	   Filter by consistency_groups.qos.policy.name
	*/
	ConsistencyGroupsQosPolicyName *string

	/* ConsistencyGroupsQosPolicyUUID.

	   Filter by consistency_groups.qos.policy.uuid
	*/
	ConsistencyGroupsQosPolicyUUID *string

	/* ConsistencyGroupsSnapshotPolicyName.

	   Filter by consistency_groups.snapshot_policy.name
	*/
	ConsistencyGroupsSnapshotPolicyName *string

	/* ConsistencyGroupsSnapshotPolicyUUID.

	   Filter by consistency_groups.snapshot_policy.uuid
	*/
	ConsistencyGroupsSnapshotPolicyUUID *string

	/* ConsistencyGroupsSpaceAvailable.

	   Filter by consistency_groups.space.available
	*/
	ConsistencyGroupsSpaceAvailable *int64

	/* ConsistencyGroupsSpaceSize.

	   Filter by consistency_groups.space.size
	*/
	ConsistencyGroupsSpaceSize *int64

	/* ConsistencyGroupsSpaceUsed.

	   Filter by consistency_groups.space.used
	*/
	ConsistencyGroupsSpaceUsed *int64

	/* ConsistencyGroupsSvmName.

	   Filter by consistency_groups.svm.name
	*/
	ConsistencyGroupsSvmName *string

	/* ConsistencyGroupsSvmUUID.

	   Filter by consistency_groups.svm.uuid
	*/
	ConsistencyGroupsSvmUUID *string

	/* ConsistencyGroupsTieringPolicy.

	   Filter by consistency_groups.tiering.policy
	*/
	ConsistencyGroupsTieringPolicy *string

	/* ConsistencyGroupsUUID.

	   Filter by consistency_groups.uuid
	*/
	ConsistencyGroupsUUID *string

	/* ConsistencyGroupsVolumesComment.

	   Filter by consistency_groups.volumes.comment
	*/
	ConsistencyGroupsVolumesComment *string

	/* ConsistencyGroupsVolumesLanguage.

	   Filter by consistency_groups.volumes.language
	*/
	ConsistencyGroupsVolumesLanguage *string

	/* ConsistencyGroupsVolumesName.

	   Filter by consistency_groups.volumes.name
	*/
	ConsistencyGroupsVolumesName *string

	/* ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration.

	   Filter by consistency_groups.volumes.nas.cifs.shares.access_based_enumeration
	*/
	ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration *bool

	/* ConsistencyGroupsVolumesNasCifsSharesAclsPermission.

	   Filter by consistency_groups.volumes.nas.cifs.shares.acls.permission
	*/
	ConsistencyGroupsVolumesNasCifsSharesAclsPermission *string

	/* ConsistencyGroupsVolumesNasCifsSharesAclsType.

	   Filter by consistency_groups.volumes.nas.cifs.shares.acls.type
	*/
	ConsistencyGroupsVolumesNasCifsSharesAclsType *string

	/* ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup.

	   Filter by consistency_groups.volumes.nas.cifs.shares.acls.user_or_group
	*/
	ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup *string

	/* ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess.

	   Filter by consistency_groups.volumes.nas.cifs.shares.allow_unencrypted_access
	*/
	ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess *bool

	/* ConsistencyGroupsVolumesNasCifsSharesChangeNotify.

	   Filter by consistency_groups.volumes.nas.cifs.shares.change_notify
	*/
	ConsistencyGroupsVolumesNasCifsSharesChangeNotify *bool

	/* ConsistencyGroupsVolumesNasCifsSharesComment.

	   Filter by consistency_groups.volumes.nas.cifs.shares.comment
	*/
	ConsistencyGroupsVolumesNasCifsSharesComment *string

	/* ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable.

	   Filter by consistency_groups.volumes.nas.cifs.shares.continuously_available
	*/
	ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable *bool

	/* ConsistencyGroupsVolumesNasCifsSharesDirUmask.

	   Filter by consistency_groups.volumes.nas.cifs.shares.dir_umask
	*/
	ConsistencyGroupsVolumesNasCifsSharesDirUmask *int64

	/* ConsistencyGroupsVolumesNasCifsSharesEncryption.

	   Filter by consistency_groups.volumes.nas.cifs.shares.encryption
	*/
	ConsistencyGroupsVolumesNasCifsSharesEncryption *bool

	/* ConsistencyGroupsVolumesNasCifsSharesFileUmask.

	   Filter by consistency_groups.volumes.nas.cifs.shares.file_umask
	*/
	ConsistencyGroupsVolumesNasCifsSharesFileUmask *int64

	/* ConsistencyGroupsVolumesNasCifsSharesHomeDirectory.

	   Filter by consistency_groups.volumes.nas.cifs.shares.home_directory
	*/
	ConsistencyGroupsVolumesNasCifsSharesHomeDirectory *bool

	/* ConsistencyGroupsVolumesNasCifsSharesName.

	   Filter by consistency_groups.volumes.nas.cifs.shares.name
	*/
	ConsistencyGroupsVolumesNasCifsSharesName *string

	/* ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching.

	   Filter by consistency_groups.volumes.nas.cifs.shares.namespace_caching
	*/
	ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching *bool

	/* ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity.

	   Filter by consistency_groups.volumes.nas.cifs.shares.no_strict_security
	*/
	ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity *bool

	/* ConsistencyGroupsVolumesNasCifsSharesOfflineFiles.

	   Filter by consistency_groups.volumes.nas.cifs.shares.offline_files
	*/
	ConsistencyGroupsVolumesNasCifsSharesOfflineFiles *string

	/* ConsistencyGroupsVolumesNasCifsSharesOplocks.

	   Filter by consistency_groups.volumes.nas.cifs.shares.oplocks
	*/
	ConsistencyGroupsVolumesNasCifsSharesOplocks *bool

	/* ConsistencyGroupsVolumesNasCifsSharesShowSnapshot.

	   Filter by consistency_groups.volumes.nas.cifs.shares.show_snapshot
	*/
	ConsistencyGroupsVolumesNasCifsSharesShowSnapshot *bool

	/* ConsistencyGroupsVolumesNasCifsSharesUnixSymlink.

	   Filter by consistency_groups.volumes.nas.cifs.shares.unix_symlink
	*/
	ConsistencyGroupsVolumesNasCifsSharesUnixSymlink *string

	/* ConsistencyGroupsVolumesNasCifsSharesVscanProfile.

	   Filter by consistency_groups.volumes.nas.cifs.shares.vscan_profile
	*/
	ConsistencyGroupsVolumesNasCifsSharesVscanProfile *string

	/* ConsistencyGroupsVolumesNasExportPolicyName.

	   Filter by consistency_groups.volumes.nas.export_policy.name
	*/
	ConsistencyGroupsVolumesNasExportPolicyName *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.allow_device_creation
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation *bool

	/* ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.allow_suid
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid *bool

	/* ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.anonymous_user
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesChownMode.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.chown_mode
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesChownMode *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.clients.match
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesIndex.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.index
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesIndex *int64

	/* ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.ntfs_unix_security
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesProtocols.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.protocols
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesProtocols *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesRoRule.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.ro_rule
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesRoRule *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesRwRule.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.rw_rule
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesRwRule *string

	/* ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser.

	   Filter by consistency_groups.volumes.nas.export_policy.rules.superuser
	*/
	ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser *string

	/* ConsistencyGroupsVolumesNasExportPolicyUUID.

	   Filter by consistency_groups.volumes.nas.export_policy.uuid
	*/
	ConsistencyGroupsVolumesNasExportPolicyUUID *string

	/* ConsistencyGroupsVolumesNasGid.

	   Filter by consistency_groups.volumes.nas.gid
	*/
	ConsistencyGroupsVolumesNasGid *int64

	/* ConsistencyGroupsVolumesNasJunctionParentName.

	   Filter by consistency_groups.volumes.nas.junction_parent.name
	*/
	ConsistencyGroupsVolumesNasJunctionParentName *string

	/* ConsistencyGroupsVolumesNasJunctionParentUUID.

	   Filter by consistency_groups.volumes.nas.junction_parent.uuid
	*/
	ConsistencyGroupsVolumesNasJunctionParentUUID *string

	/* ConsistencyGroupsVolumesNasPath.

	   Filter by consistency_groups.volumes.nas.path
	*/
	ConsistencyGroupsVolumesNasPath *string

	/* ConsistencyGroupsVolumesNasSecurityStyle.

	   Filter by consistency_groups.volumes.nas.security_style
	*/
	ConsistencyGroupsVolumesNasSecurityStyle *string

	/* ConsistencyGroupsVolumesNasUID.

	   Filter by consistency_groups.volumes.nas.uid
	*/
	ConsistencyGroupsVolumesNasUID *int64

	/* ConsistencyGroupsVolumesNasUnixPermissions.

	   Filter by consistency_groups.volumes.nas.unix_permissions
	*/
	ConsistencyGroupsVolumesNasUnixPermissions *int64

	/* ConsistencyGroupsVolumesQosPolicyMaxThroughputIops.

	   Filter by consistency_groups.volumes.qos.policy.max_throughput_iops
	*/
	ConsistencyGroupsVolumesQosPolicyMaxThroughputIops *int64

	/* ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps.

	   Filter by consistency_groups.volumes.qos.policy.max_throughput_mbps
	*/
	ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps *int64

	/* ConsistencyGroupsVolumesQosPolicyMinThroughputIops.

	   Filter by consistency_groups.volumes.qos.policy.min_throughput_iops
	*/
	ConsistencyGroupsVolumesQosPolicyMinThroughputIops *int64

	/* ConsistencyGroupsVolumesQosPolicyMinThroughputMbps.

	   Filter by consistency_groups.volumes.qos.policy.min_throughput_mbps
	*/
	ConsistencyGroupsVolumesQosPolicyMinThroughputMbps *int64

	/* ConsistencyGroupsVolumesQosPolicyName.

	   Filter by consistency_groups.volumes.qos.policy.name
	*/
	ConsistencyGroupsVolumesQosPolicyName *string

	/* ConsistencyGroupsVolumesQosPolicyUUID.

	   Filter by consistency_groups.volumes.qos.policy.uuid
	*/
	ConsistencyGroupsVolumesQosPolicyUUID *string

	/* ConsistencyGroupsVolumesSnapshotPolicyName.

	   Filter by consistency_groups.volumes.snapshot_policy.name
	*/
	ConsistencyGroupsVolumesSnapshotPolicyName *string

	/* ConsistencyGroupsVolumesSnapshotPolicyUUID.

	   Filter by consistency_groups.volumes.snapshot_policy.uuid
	*/
	ConsistencyGroupsVolumesSnapshotPolicyUUID *string

	/* ConsistencyGroupsVolumesSpaceAvailable.

	   Filter by consistency_groups.volumes.space.available
	*/
	ConsistencyGroupsVolumesSpaceAvailable *int64

	/* ConsistencyGroupsVolumesSpaceSize.

	   Filter by consistency_groups.volumes.space.size
	*/
	ConsistencyGroupsVolumesSpaceSize *int64

	/* ConsistencyGroupsVolumesSpaceUsed.

	   Filter by consistency_groups.volumes.space.used
	*/
	ConsistencyGroupsVolumesSpaceUsed *int64

	/* ConsistencyGroupsVolumesTieringPolicy.

	   Filter by consistency_groups.volumes.tiering.policy
	*/
	ConsistencyGroupsVolumesTieringPolicy *string

	/* ConsistencyGroupsVolumesUUID.

	   Filter by consistency_groups.volumes.uuid
	*/
	ConsistencyGroupsVolumesUUID *string

	/* Fields.

	   Specify the fields to return.
	*/
	Fields []string

	/* LunsComment.

	   Filter by luns.comment
	*/
	LunsComment *string

	/* LunsCreateTime.

	   Filter by luns.create_time
	*/
	LunsCreateTime *string

	/* LunsEnabled.

	   Filter by luns.enabled
	*/
	LunsEnabled *bool

	/* LunsLunMapsIgroupComment.

	   Filter by luns.lun_maps.igroup.comment
	*/
	LunsLunMapsIgroupComment *string

	/* LunsLunMapsIgroupIgroupsName.

	   Filter by luns.lun_maps.igroup.igroups.name
	*/
	LunsLunMapsIgroupIgroupsName *string

	/* LunsLunMapsIgroupIgroupsUUID.

	   Filter by luns.lun_maps.igroup.igroups.uuid
	*/
	LunsLunMapsIgroupIgroupsUUID *string

	/* LunsLunMapsIgroupInitiatorsComment.

	   Filter by luns.lun_maps.igroup.initiators.comment
	*/
	LunsLunMapsIgroupInitiatorsComment *string

	/* LunsLunMapsIgroupInitiatorsName.

	   Filter by luns.lun_maps.igroup.initiators.name
	*/
	LunsLunMapsIgroupInitiatorsName *string

	/* LunsLunMapsIgroupName.

	   Filter by luns.lun_maps.igroup.name
	*/
	LunsLunMapsIgroupName *string

	/* LunsLunMapsIgroupOsType.

	   Filter by luns.lun_maps.igroup.os_type
	*/
	LunsLunMapsIgroupOsType *string

	/* LunsLunMapsIgroupProtocol.

	   Filter by luns.lun_maps.igroup.protocol
	*/
	LunsLunMapsIgroupProtocol *string

	/* LunsLunMapsIgroupUUID.

	   Filter by luns.lun_maps.igroup.uuid
	*/
	LunsLunMapsIgroupUUID *string

	/* LunsLunMapsLogicalUnitNumber.

	   Filter by luns.lun_maps.logical_unit_number
	*/
	LunsLunMapsLogicalUnitNumber *int64

	/* LunsName.

	   Filter by luns.name
	*/
	LunsName *string

	/* LunsOsType.

	   Filter by luns.os_type
	*/
	LunsOsType *string

	/* LunsQosPolicyMaxThroughputIops.

	   Filter by luns.qos.policy.max_throughput_iops
	*/
	LunsQosPolicyMaxThroughputIops *int64

	/* LunsQosPolicyMaxThroughputMbps.

	   Filter by luns.qos.policy.max_throughput_mbps
	*/
	LunsQosPolicyMaxThroughputMbps *int64

	/* LunsQosPolicyMinThroughputIops.

	   Filter by luns.qos.policy.min_throughput_iops
	*/
	LunsQosPolicyMinThroughputIops *int64

	/* LunsQosPolicyMinThroughputMbps.

	   Filter by luns.qos.policy.min_throughput_mbps
	*/
	LunsQosPolicyMinThroughputMbps *int64

	/* LunsQosPolicyName.

	   Filter by luns.qos.policy.name
	*/
	LunsQosPolicyName *string

	/* LunsQosPolicyUUID.

	   Filter by luns.qos.policy.uuid
	*/
	LunsQosPolicyUUID *string

	/* LunsSerialNumber.

	   Filter by luns.serial_number
	*/
	LunsSerialNumber *string

	/* LunsSpaceGuaranteeRequested.

	   Filter by luns.space.guarantee.requested
	*/
	LunsSpaceGuaranteeRequested *bool

	/* LunsSpaceGuaranteeReserved.

	   Filter by luns.space.guarantee.reserved
	*/
	LunsSpaceGuaranteeReserved *bool

	/* LunsSpaceSize.

	   Filter by luns.space.size
	*/
	LunsSpaceSize *int64

	/* LunsSpaceUsed.

	   Filter by luns.space.used
	*/
	LunsSpaceUsed *int64

	/* LunsUUID.

	   Filter by luns.uuid
	*/
	LunsUUID *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecords *int64

	/* Name.

	   Filter by name
	*/
	Name *string

	/* NamespacesAutoDelete.

	   Filter by namespaces.auto_delete
	*/
	NamespacesAutoDelete *bool

	/* NamespacesComment.

	   Filter by namespaces.comment
	*/
	NamespacesComment *string

	/* NamespacesCreateTime.

	   Filter by namespaces.create_time
	*/
	NamespacesCreateTime *string

	/* NamespacesEnabled.

	   Filter by namespaces.enabled
	*/
	NamespacesEnabled *bool

	/* NamespacesName.

	   Filter by namespaces.name
	*/
	NamespacesName *string

	/* NamespacesOsType.

	   Filter by namespaces.os_type
	*/
	NamespacesOsType *string

	/* NamespacesSpaceBlockSize.

	   Filter by namespaces.space.block_size
	*/
	NamespacesSpaceBlockSize *int64

	/* NamespacesSpaceGuaranteeRequested.

	   Filter by namespaces.space.guarantee.requested
	*/
	NamespacesSpaceGuaranteeRequested *bool

	/* NamespacesSpaceGuaranteeReserved.

	   Filter by namespaces.space.guarantee.reserved
	*/
	NamespacesSpaceGuaranteeReserved *bool

	/* NamespacesSpaceSize.

	   Filter by namespaces.space.size
	*/
	NamespacesSpaceSize *int64

	/* NamespacesSpaceUsed.

	   Filter by namespaces.space.used
	*/
	NamespacesSpaceUsed *int64

	/* NamespacesStatusContainerState.

	   Filter by namespaces.status.container_state
	*/
	NamespacesStatusContainerState *string

	/* NamespacesStatusMapped.

	   Filter by namespaces.status.mapped
	*/
	NamespacesStatusMapped *bool

	/* NamespacesStatusReadOnly.

	   Filter by namespaces.status.read_only
	*/
	NamespacesStatusReadOnly *bool

	/* NamespacesStatusState.

	   Filter by namespaces.status.state
	*/
	NamespacesStatusState *string

	/* NamespacesSubsystemMapAnagrpid.

	   Filter by namespaces.subsystem_map.anagrpid
	*/
	NamespacesSubsystemMapAnagrpid *string

	/* NamespacesSubsystemMapNsid.

	   Filter by namespaces.subsystem_map.nsid
	*/
	NamespacesSubsystemMapNsid *string

	/* NamespacesSubsystemMapSubsystemComment.

	   Filter by namespaces.subsystem_map.subsystem.comment
	*/
	NamespacesSubsystemMapSubsystemComment *string

	/* NamespacesSubsystemMapSubsystemHostsNqn.

	   Filter by namespaces.subsystem_map.subsystem.hosts.nqn
	*/
	NamespacesSubsystemMapSubsystemHostsNqn *string

	/* NamespacesSubsystemMapSubsystemName.

	   Filter by namespaces.subsystem_map.subsystem.name
	*/
	NamespacesSubsystemMapSubsystemName *string

	/* NamespacesSubsystemMapSubsystemOsType.

	   Filter by namespaces.subsystem_map.subsystem.os_type
	*/
	NamespacesSubsystemMapSubsystemOsType *string

	/* NamespacesSubsystemMapSubsystemUUID.

	   Filter by namespaces.subsystem_map.subsystem.uuid
	*/
	NamespacesSubsystemMapSubsystemUUID *string

	/* NamespacesUUID.

	   Filter by namespaces.uuid
	*/
	NamespacesUUID *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderBy []string

	/* ParentConsistencyGroupName.

	   Filter by parent_consistency_group.name
	*/
	ParentConsistencyGroupName *string

	/* ParentConsistencyGroupUUID.

	   Filter by parent_consistency_group.uuid
	*/
	ParentConsistencyGroupUUID *string

	/* QosPolicyMaxThroughputIops.

	   Filter by qos.policy.max_throughput_iops
	*/
	QosPolicyMaxThroughputIops *int64

	/* QosPolicyMaxThroughputMbps.

	   Filter by qos.policy.max_throughput_mbps
	*/
	QosPolicyMaxThroughputMbps *int64

	/* QosPolicyMinThroughputIops.

	   Filter by qos.policy.min_throughput_iops
	*/
	QosPolicyMinThroughputIops *int64

	/* QosPolicyMinThroughputMbps.

	   Filter by qos.policy.min_throughput_mbps
	*/
	QosPolicyMinThroughputMbps *int64

	/* QosPolicyName.

	   Filter by qos.policy.name
	*/
	QosPolicyName *string

	/* QosPolicyUUID.

	   Filter by qos.policy.uuid
	*/
	QosPolicyUUID *string

	/* Replicated.

	   Filter by replicated
	*/
	Replicated *bool

	/* ReplicationSource.

	   Filter by replication_source
	*/
	ReplicationSource *bool

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecords *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeout *int64

	/* SnapshotPolicyName.

	   Filter by snapshot_policy.name
	*/
	SnapshotPolicyName *string

	/* SnapshotPolicyUUID.

	   Filter by snapshot_policy.uuid
	*/
	SnapshotPolicyUUID *string

	/* SpaceAvailable.

	   Filter by space.available
	*/
	SpaceAvailable *int64

	/* SpaceSize.

	   Filter by space.size
	*/
	SpaceSize *int64

	/* SpaceUsed.

	   Filter by space.used
	*/
	SpaceUsed *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SvmName *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SvmUUID *string

	/* TieringPolicy.

	   Filter by tiering.policy
	*/
	TieringPolicy *string

	/* UUID.

	   The unique identifier of the group to retrieve.

	*/
	UUID string

	/* VolumesComment.

	   Filter by volumes.comment
	*/
	VolumesComment *string

	/* VolumesLanguage.

	   Filter by volumes.language
	*/
	VolumesLanguage *string

	/* VolumesName.

	   Filter by volumes.name
	*/
	VolumesName *string

	/* VolumesNasCifsSharesAccessBasedEnumeration.

	   Filter by volumes.nas.cifs.shares.access_based_enumeration
	*/
	VolumesNasCifsSharesAccessBasedEnumeration *bool

	/* VolumesNasCifsSharesAclsPermission.

	   Filter by volumes.nas.cifs.shares.acls.permission
	*/
	VolumesNasCifsSharesAclsPermission *string

	/* VolumesNasCifsSharesAclsType.

	   Filter by volumes.nas.cifs.shares.acls.type
	*/
	VolumesNasCifsSharesAclsType *string

	/* VolumesNasCifsSharesAclsUserOrGroup.

	   Filter by volumes.nas.cifs.shares.acls.user_or_group
	*/
	VolumesNasCifsSharesAclsUserOrGroup *string

	/* VolumesNasCifsSharesAllowUnencryptedAccess.

	   Filter by volumes.nas.cifs.shares.allow_unencrypted_access
	*/
	VolumesNasCifsSharesAllowUnencryptedAccess *bool

	/* VolumesNasCifsSharesChangeNotify.

	   Filter by volumes.nas.cifs.shares.change_notify
	*/
	VolumesNasCifsSharesChangeNotify *bool

	/* VolumesNasCifsSharesComment.

	   Filter by volumes.nas.cifs.shares.comment
	*/
	VolumesNasCifsSharesComment *string

	/* VolumesNasCifsSharesContinuouslyAvailable.

	   Filter by volumes.nas.cifs.shares.continuously_available
	*/
	VolumesNasCifsSharesContinuouslyAvailable *bool

	/* VolumesNasCifsSharesDirUmask.

	   Filter by volumes.nas.cifs.shares.dir_umask
	*/
	VolumesNasCifsSharesDirUmask *int64

	/* VolumesNasCifsSharesEncryption.

	   Filter by volumes.nas.cifs.shares.encryption
	*/
	VolumesNasCifsSharesEncryption *bool

	/* VolumesNasCifsSharesFileUmask.

	   Filter by volumes.nas.cifs.shares.file_umask
	*/
	VolumesNasCifsSharesFileUmask *int64

	/* VolumesNasCifsSharesHomeDirectory.

	   Filter by volumes.nas.cifs.shares.home_directory
	*/
	VolumesNasCifsSharesHomeDirectory *bool

	/* VolumesNasCifsSharesName.

	   Filter by volumes.nas.cifs.shares.name
	*/
	VolumesNasCifsSharesName *string

	/* VolumesNasCifsSharesNamespaceCaching.

	   Filter by volumes.nas.cifs.shares.namespace_caching
	*/
	VolumesNasCifsSharesNamespaceCaching *bool

	/* VolumesNasCifsSharesNoStrictSecurity.

	   Filter by volumes.nas.cifs.shares.no_strict_security
	*/
	VolumesNasCifsSharesNoStrictSecurity *bool

	/* VolumesNasCifsSharesOfflineFiles.

	   Filter by volumes.nas.cifs.shares.offline_files
	*/
	VolumesNasCifsSharesOfflineFiles *string

	/* VolumesNasCifsSharesOplocks.

	   Filter by volumes.nas.cifs.shares.oplocks
	*/
	VolumesNasCifsSharesOplocks *bool

	/* VolumesNasCifsSharesShowSnapshot.

	   Filter by volumes.nas.cifs.shares.show_snapshot
	*/
	VolumesNasCifsSharesShowSnapshot *bool

	/* VolumesNasCifsSharesUnixSymlink.

	   Filter by volumes.nas.cifs.shares.unix_symlink
	*/
	VolumesNasCifsSharesUnixSymlink *string

	/* VolumesNasCifsSharesVscanProfile.

	   Filter by volumes.nas.cifs.shares.vscan_profile
	*/
	VolumesNasCifsSharesVscanProfile *string

	/* VolumesNasExportPolicyName.

	   Filter by volumes.nas.export_policy.name
	*/
	VolumesNasExportPolicyName *string

	/* VolumesNasExportPolicyRulesAllowDeviceCreation.

	   Filter by volumes.nas.export_policy.rules.allow_device_creation
	*/
	VolumesNasExportPolicyRulesAllowDeviceCreation *bool

	/* VolumesNasExportPolicyRulesAllowSuid.

	   Filter by volumes.nas.export_policy.rules.allow_suid
	*/
	VolumesNasExportPolicyRulesAllowSuid *bool

	/* VolumesNasExportPolicyRulesAnonymousUser.

	   Filter by volumes.nas.export_policy.rules.anonymous_user
	*/
	VolumesNasExportPolicyRulesAnonymousUser *string

	/* VolumesNasExportPolicyRulesChownMode.

	   Filter by volumes.nas.export_policy.rules.chown_mode
	*/
	VolumesNasExportPolicyRulesChownMode *string

	/* VolumesNasExportPolicyRulesClientsMatch.

	   Filter by volumes.nas.export_policy.rules.clients.match
	*/
	VolumesNasExportPolicyRulesClientsMatch *string

	/* VolumesNasExportPolicyRulesIndex.

	   Filter by volumes.nas.export_policy.rules.index
	*/
	VolumesNasExportPolicyRulesIndex *int64

	/* VolumesNasExportPolicyRulesNtfsUnixSecurity.

	   Filter by volumes.nas.export_policy.rules.ntfs_unix_security
	*/
	VolumesNasExportPolicyRulesNtfsUnixSecurity *string

	/* VolumesNasExportPolicyRulesProtocols.

	   Filter by volumes.nas.export_policy.rules.protocols
	*/
	VolumesNasExportPolicyRulesProtocols *string

	/* VolumesNasExportPolicyRulesRoRule.

	   Filter by volumes.nas.export_policy.rules.ro_rule
	*/
	VolumesNasExportPolicyRulesRoRule *string

	/* VolumesNasExportPolicyRulesRwRule.

	   Filter by volumes.nas.export_policy.rules.rw_rule
	*/
	VolumesNasExportPolicyRulesRwRule *string

	/* VolumesNasExportPolicyRulesSuperuser.

	   Filter by volumes.nas.export_policy.rules.superuser
	*/
	VolumesNasExportPolicyRulesSuperuser *string

	/* VolumesNasExportPolicyUUID.

	   Filter by volumes.nas.export_policy.uuid
	*/
	VolumesNasExportPolicyUUID *string

	/* VolumesNasGid.

	   Filter by volumes.nas.gid
	*/
	VolumesNasGid *int64

	/* VolumesNasJunctionParentName.

	   Filter by volumes.nas.junction_parent.name
	*/
	VolumesNasJunctionParentName *string

	/* VolumesNasJunctionParentUUID.

	   Filter by volumes.nas.junction_parent.uuid
	*/
	VolumesNasJunctionParentUUID *string

	/* VolumesNasPath.

	   Filter by volumes.nas.path
	*/
	VolumesNasPath *string

	/* VolumesNasSecurityStyle.

	   Filter by volumes.nas.security_style
	*/
	VolumesNasSecurityStyle *string

	/* VolumesNasUID.

	   Filter by volumes.nas.uid
	*/
	VolumesNasUID *int64

	/* VolumesNasUnixPermissions.

	   Filter by volumes.nas.unix_permissions
	*/
	VolumesNasUnixPermissions *int64

	/* VolumesQosPolicyMaxThroughputIops.

	   Filter by volumes.qos.policy.max_throughput_iops
	*/
	VolumesQosPolicyMaxThroughputIops *int64

	/* VolumesQosPolicyMaxThroughputMbps.

	   Filter by volumes.qos.policy.max_throughput_mbps
	*/
	VolumesQosPolicyMaxThroughputMbps *int64

	/* VolumesQosPolicyMinThroughputIops.

	   Filter by volumes.qos.policy.min_throughput_iops
	*/
	VolumesQosPolicyMinThroughputIops *int64

	/* VolumesQosPolicyMinThroughputMbps.

	   Filter by volumes.qos.policy.min_throughput_mbps
	*/
	VolumesQosPolicyMinThroughputMbps *int64

	/* VolumesQosPolicyName.

	   Filter by volumes.qos.policy.name
	*/
	VolumesQosPolicyName *string

	/* VolumesQosPolicyUUID.

	   Filter by volumes.qos.policy.uuid
	*/
	VolumesQosPolicyUUID *string

	/* VolumesSnapshotPolicyName.

	   Filter by volumes.snapshot_policy.name
	*/
	VolumesSnapshotPolicyName *string

	/* VolumesSnapshotPolicyUUID.

	   Filter by volumes.snapshot_policy.uuid
	*/
	VolumesSnapshotPolicyUUID *string

	/* VolumesSpaceAvailable.

	   Filter by volumes.space.available
	*/
	VolumesSpaceAvailable *int64

	/* VolumesSpaceSize.

	   Filter by volumes.space.size
	*/
	VolumesSpaceSize *int64

	/* VolumesSpaceUsed.

	   Filter by volumes.space.used
	*/
	VolumesSpaceUsed *int64

	/* VolumesTieringPolicy.

	   Filter by volumes.tiering.policy
	*/
	VolumesTieringPolicy *string

	/* VolumesUUID.

	   Filter by volumes.uuid
	*/
	VolumesUUID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the consistency group get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConsistencyGroupGetParams) WithDefaults() *ConsistencyGroupGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the consistency group get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ConsistencyGroupGetParams) SetDefaults() {
	var (
		returnRecordsDefault = bool(true)

		returnTimeoutDefault = int64(15)
	)

	val := ConsistencyGroupGetParams{
		ReturnRecords: &returnRecordsDefault,
		ReturnTimeout: &returnTimeoutDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the consistency group get params
func (o *ConsistencyGroupGetParams) WithTimeout(timeout time.Duration) *ConsistencyGroupGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the consistency group get params
func (o *ConsistencyGroupGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the consistency group get params
func (o *ConsistencyGroupGetParams) WithContext(ctx context.Context) *ConsistencyGroupGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the consistency group get params
func (o *ConsistencyGroupGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the consistency group get params
func (o *ConsistencyGroupGetParams) WithHTTPClient(client *http.Client) *ConsistencyGroupGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the consistency group get params
func (o *ConsistencyGroupGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationComponentType adds the applicationComponentType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithApplicationComponentType(applicationComponentType *string) *ConsistencyGroupGetParams {
	o.SetApplicationComponentType(applicationComponentType)
	return o
}

// SetApplicationComponentType adds the applicationComponentType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetApplicationComponentType(applicationComponentType *string) {
	o.ApplicationComponentType = applicationComponentType
}

// WithApplicationType adds the applicationType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithApplicationType(applicationType *string) *ConsistencyGroupGetParams {
	o.SetApplicationType(applicationType)
	return o
}

// SetApplicationType adds the applicationType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetApplicationType(applicationType *string) {
	o.ApplicationType = applicationType
}

// WithCloneGuaranteeType adds the cloneGuaranteeType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneGuaranteeType(cloneGuaranteeType *string) *ConsistencyGroupGetParams {
	o.SetCloneGuaranteeType(cloneGuaranteeType)
	return o
}

// SetCloneGuaranteeType adds the cloneGuaranteeType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneGuaranteeType(cloneGuaranteeType *string) {
	o.CloneGuaranteeType = cloneGuaranteeType
}

// WithCloneParentConsistencyGroupName adds the cloneParentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneParentConsistencyGroupName(cloneParentConsistencyGroupName *string) *ConsistencyGroupGetParams {
	o.SetCloneParentConsistencyGroupName(cloneParentConsistencyGroupName)
	return o
}

// SetCloneParentConsistencyGroupName adds the cloneParentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneParentConsistencyGroupName(cloneParentConsistencyGroupName *string) {
	o.CloneParentConsistencyGroupName = cloneParentConsistencyGroupName
}

// WithCloneParentConsistencyGroupUUID adds the cloneParentConsistencyGroupUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneParentConsistencyGroupUUID(cloneParentConsistencyGroupUUID *string) *ConsistencyGroupGetParams {
	o.SetCloneParentConsistencyGroupUUID(cloneParentConsistencyGroupUUID)
	return o
}

// SetCloneParentConsistencyGroupUUID adds the cloneParentConsistencyGroupUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneParentConsistencyGroupUUID(cloneParentConsistencyGroupUUID *string) {
	o.CloneParentConsistencyGroupUUID = cloneParentConsistencyGroupUUID
}

// WithCloneParentSnapshotName adds the cloneParentSnapshotName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneParentSnapshotName(cloneParentSnapshotName *string) *ConsistencyGroupGetParams {
	o.SetCloneParentSnapshotName(cloneParentSnapshotName)
	return o
}

// SetCloneParentSnapshotName adds the cloneParentSnapshotName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneParentSnapshotName(cloneParentSnapshotName *string) {
	o.CloneParentSnapshotName = cloneParentSnapshotName
}

// WithCloneSplitInitiated adds the cloneSplitInitiated to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneSplitInitiated(cloneSplitInitiated *bool) *ConsistencyGroupGetParams {
	o.SetCloneSplitInitiated(cloneSplitInitiated)
	return o
}

// SetCloneSplitInitiated adds the cloneSplitInitiated to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneSplitInitiated(cloneSplitInitiated *bool) {
	o.CloneSplitInitiated = cloneSplitInitiated
}

// WithCloneVolumePrefix adds the cloneVolumePrefix to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneVolumePrefix(cloneVolumePrefix *string) *ConsistencyGroupGetParams {
	o.SetCloneVolumePrefix(cloneVolumePrefix)
	return o
}

// SetCloneVolumePrefix adds the cloneVolumePrefix to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneVolumePrefix(cloneVolumePrefix *string) {
	o.CloneVolumePrefix = cloneVolumePrefix
}

// WithCloneVolumeSuffix adds the cloneVolumeSuffix to the consistency group get params
func (o *ConsistencyGroupGetParams) WithCloneVolumeSuffix(cloneVolumeSuffix *string) *ConsistencyGroupGetParams {
	o.SetCloneVolumeSuffix(cloneVolumeSuffix)
	return o
}

// SetCloneVolumeSuffix adds the cloneVolumeSuffix to the consistency group get params
func (o *ConsistencyGroupGetParams) SetCloneVolumeSuffix(cloneVolumeSuffix *string) {
	o.CloneVolumeSuffix = cloneVolumeSuffix
}

// WithConsistencyGroupsApplicationComponentType adds the consistencyGroupsApplicationComponentType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsApplicationComponentType(consistencyGroupsApplicationComponentType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsApplicationComponentType(consistencyGroupsApplicationComponentType)
	return o
}

// SetConsistencyGroupsApplicationComponentType adds the consistencyGroupsApplicationComponentType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsApplicationComponentType(consistencyGroupsApplicationComponentType *string) {
	o.ConsistencyGroupsApplicationComponentType = consistencyGroupsApplicationComponentType
}

// WithConsistencyGroupsApplicationType adds the consistencyGroupsApplicationType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsApplicationType(consistencyGroupsApplicationType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsApplicationType(consistencyGroupsApplicationType)
	return o
}

// SetConsistencyGroupsApplicationType adds the consistencyGroupsApplicationType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsApplicationType(consistencyGroupsApplicationType *string) {
	o.ConsistencyGroupsApplicationType = consistencyGroupsApplicationType
}

// WithConsistencyGroupsLunsComment adds the consistencyGroupsLunsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsComment(consistencyGroupsLunsComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsComment(consistencyGroupsLunsComment)
	return o
}

// SetConsistencyGroupsLunsComment adds the consistencyGroupsLunsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsComment(consistencyGroupsLunsComment *string) {
	o.ConsistencyGroupsLunsComment = consistencyGroupsLunsComment
}

// WithConsistencyGroupsLunsCreateTime adds the consistencyGroupsLunsCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsCreateTime(consistencyGroupsLunsCreateTime *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsCreateTime(consistencyGroupsLunsCreateTime)
	return o
}

// SetConsistencyGroupsLunsCreateTime adds the consistencyGroupsLunsCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsCreateTime(consistencyGroupsLunsCreateTime *string) {
	o.ConsistencyGroupsLunsCreateTime = consistencyGroupsLunsCreateTime
}

// WithConsistencyGroupsLunsEnabled adds the consistencyGroupsLunsEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsEnabled(consistencyGroupsLunsEnabled *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsEnabled(consistencyGroupsLunsEnabled)
	return o
}

// SetConsistencyGroupsLunsEnabled adds the consistencyGroupsLunsEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsEnabled(consistencyGroupsLunsEnabled *bool) {
	o.ConsistencyGroupsLunsEnabled = consistencyGroupsLunsEnabled
}

// WithConsistencyGroupsLunsLunMapsIgroupComment adds the consistencyGroupsLunsLunMapsIgroupComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupComment(consistencyGroupsLunsLunMapsIgroupComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupComment(consistencyGroupsLunsLunMapsIgroupComment)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupComment adds the consistencyGroupsLunsLunMapsIgroupComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupComment(consistencyGroupsLunsLunMapsIgroupComment *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupComment = consistencyGroupsLunsLunMapsIgroupComment
}

// WithConsistencyGroupsLunsLunMapsIgroupIgroupsName adds the consistencyGroupsLunsLunMapsIgroupIgroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupIgroupsName(consistencyGroupsLunsLunMapsIgroupIgroupsName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupIgroupsName(consistencyGroupsLunsLunMapsIgroupIgroupsName)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupIgroupsName adds the consistencyGroupsLunsLunMapsIgroupIgroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupIgroupsName(consistencyGroupsLunsLunMapsIgroupIgroupsName *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupIgroupsName = consistencyGroupsLunsLunMapsIgroupIgroupsName
}

// WithConsistencyGroupsLunsLunMapsIgroupIgroupsUUID adds the consistencyGroupsLunsLunMapsIgroupIgroupsUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupIgroupsUUID(consistencyGroupsLunsLunMapsIgroupIgroupsUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupIgroupsUUID(consistencyGroupsLunsLunMapsIgroupIgroupsUUID)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupIgroupsUUID adds the consistencyGroupsLunsLunMapsIgroupIgroupsUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupIgroupsUUID(consistencyGroupsLunsLunMapsIgroupIgroupsUUID *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID = consistencyGroupsLunsLunMapsIgroupIgroupsUUID
}

// WithConsistencyGroupsLunsLunMapsIgroupInitiatorsComment adds the consistencyGroupsLunsLunMapsIgroupInitiatorsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupInitiatorsComment(consistencyGroupsLunsLunMapsIgroupInitiatorsComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupInitiatorsComment(consistencyGroupsLunsLunMapsIgroupInitiatorsComment)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupInitiatorsComment adds the consistencyGroupsLunsLunMapsIgroupInitiatorsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupInitiatorsComment(consistencyGroupsLunsLunMapsIgroupInitiatorsComment *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment = consistencyGroupsLunsLunMapsIgroupInitiatorsComment
}

// WithConsistencyGroupsLunsLunMapsIgroupInitiatorsName adds the consistencyGroupsLunsLunMapsIgroupInitiatorsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupInitiatorsName(consistencyGroupsLunsLunMapsIgroupInitiatorsName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupInitiatorsName(consistencyGroupsLunsLunMapsIgroupInitiatorsName)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupInitiatorsName adds the consistencyGroupsLunsLunMapsIgroupInitiatorsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupInitiatorsName(consistencyGroupsLunsLunMapsIgroupInitiatorsName *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsName = consistencyGroupsLunsLunMapsIgroupInitiatorsName
}

// WithConsistencyGroupsLunsLunMapsIgroupName adds the consistencyGroupsLunsLunMapsIgroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupName(consistencyGroupsLunsLunMapsIgroupName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupName(consistencyGroupsLunsLunMapsIgroupName)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupName adds the consistencyGroupsLunsLunMapsIgroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupName(consistencyGroupsLunsLunMapsIgroupName *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupName = consistencyGroupsLunsLunMapsIgroupName
}

// WithConsistencyGroupsLunsLunMapsIgroupOsType adds the consistencyGroupsLunsLunMapsIgroupOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupOsType(consistencyGroupsLunsLunMapsIgroupOsType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupOsType(consistencyGroupsLunsLunMapsIgroupOsType)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupOsType adds the consistencyGroupsLunsLunMapsIgroupOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupOsType(consistencyGroupsLunsLunMapsIgroupOsType *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupOsType = consistencyGroupsLunsLunMapsIgroupOsType
}

// WithConsistencyGroupsLunsLunMapsIgroupProtocol adds the consistencyGroupsLunsLunMapsIgroupProtocol to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupProtocol(consistencyGroupsLunsLunMapsIgroupProtocol *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupProtocol(consistencyGroupsLunsLunMapsIgroupProtocol)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupProtocol adds the consistencyGroupsLunsLunMapsIgroupProtocol to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupProtocol(consistencyGroupsLunsLunMapsIgroupProtocol *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupProtocol = consistencyGroupsLunsLunMapsIgroupProtocol
}

// WithConsistencyGroupsLunsLunMapsIgroupUUID adds the consistencyGroupsLunsLunMapsIgroupUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsIgroupUUID(consistencyGroupsLunsLunMapsIgroupUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsIgroupUUID(consistencyGroupsLunsLunMapsIgroupUUID)
	return o
}

// SetConsistencyGroupsLunsLunMapsIgroupUUID adds the consistencyGroupsLunsLunMapsIgroupUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsIgroupUUID(consistencyGroupsLunsLunMapsIgroupUUID *string) {
	o.ConsistencyGroupsLunsLunMapsIgroupUUID = consistencyGroupsLunsLunMapsIgroupUUID
}

// WithConsistencyGroupsLunsLunMapsLogicalUnitNumber adds the consistencyGroupsLunsLunMapsLogicalUnitNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsLunMapsLogicalUnitNumber(consistencyGroupsLunsLunMapsLogicalUnitNumber *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsLunMapsLogicalUnitNumber(consistencyGroupsLunsLunMapsLogicalUnitNumber)
	return o
}

// SetConsistencyGroupsLunsLunMapsLogicalUnitNumber adds the consistencyGroupsLunsLunMapsLogicalUnitNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsLunMapsLogicalUnitNumber(consistencyGroupsLunsLunMapsLogicalUnitNumber *int64) {
	o.ConsistencyGroupsLunsLunMapsLogicalUnitNumber = consistencyGroupsLunsLunMapsLogicalUnitNumber
}

// WithConsistencyGroupsLunsName adds the consistencyGroupsLunsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsName(consistencyGroupsLunsName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsName(consistencyGroupsLunsName)
	return o
}

// SetConsistencyGroupsLunsName adds the consistencyGroupsLunsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsName(consistencyGroupsLunsName *string) {
	o.ConsistencyGroupsLunsName = consistencyGroupsLunsName
}

// WithConsistencyGroupsLunsOsType adds the consistencyGroupsLunsOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsOsType(consistencyGroupsLunsOsType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsOsType(consistencyGroupsLunsOsType)
	return o
}

// SetConsistencyGroupsLunsOsType adds the consistencyGroupsLunsOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsOsType(consistencyGroupsLunsOsType *string) {
	o.ConsistencyGroupsLunsOsType = consistencyGroupsLunsOsType
}

// WithConsistencyGroupsLunsQosPolicyMaxThroughputIops adds the consistencyGroupsLunsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyMaxThroughputIops(consistencyGroupsLunsQosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyMaxThroughputIops(consistencyGroupsLunsQosPolicyMaxThroughputIops)
	return o
}

// SetConsistencyGroupsLunsQosPolicyMaxThroughputIops adds the consistencyGroupsLunsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyMaxThroughputIops(consistencyGroupsLunsQosPolicyMaxThroughputIops *int64) {
	o.ConsistencyGroupsLunsQosPolicyMaxThroughputIops = consistencyGroupsLunsQosPolicyMaxThroughputIops
}

// WithConsistencyGroupsLunsQosPolicyMaxThroughputMbps adds the consistencyGroupsLunsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyMaxThroughputMbps(consistencyGroupsLunsQosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyMaxThroughputMbps(consistencyGroupsLunsQosPolicyMaxThroughputMbps)
	return o
}

// SetConsistencyGroupsLunsQosPolicyMaxThroughputMbps adds the consistencyGroupsLunsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyMaxThroughputMbps(consistencyGroupsLunsQosPolicyMaxThroughputMbps *int64) {
	o.ConsistencyGroupsLunsQosPolicyMaxThroughputMbps = consistencyGroupsLunsQosPolicyMaxThroughputMbps
}

// WithConsistencyGroupsLunsQosPolicyMinThroughputIops adds the consistencyGroupsLunsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyMinThroughputIops(consistencyGroupsLunsQosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyMinThroughputIops(consistencyGroupsLunsQosPolicyMinThroughputIops)
	return o
}

// SetConsistencyGroupsLunsQosPolicyMinThroughputIops adds the consistencyGroupsLunsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyMinThroughputIops(consistencyGroupsLunsQosPolicyMinThroughputIops *int64) {
	o.ConsistencyGroupsLunsQosPolicyMinThroughputIops = consistencyGroupsLunsQosPolicyMinThroughputIops
}

// WithConsistencyGroupsLunsQosPolicyMinThroughputMbps adds the consistencyGroupsLunsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyMinThroughputMbps(consistencyGroupsLunsQosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyMinThroughputMbps(consistencyGroupsLunsQosPolicyMinThroughputMbps)
	return o
}

// SetConsistencyGroupsLunsQosPolicyMinThroughputMbps adds the consistencyGroupsLunsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyMinThroughputMbps(consistencyGroupsLunsQosPolicyMinThroughputMbps *int64) {
	o.ConsistencyGroupsLunsQosPolicyMinThroughputMbps = consistencyGroupsLunsQosPolicyMinThroughputMbps
}

// WithConsistencyGroupsLunsQosPolicyName adds the consistencyGroupsLunsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyName(consistencyGroupsLunsQosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyName(consistencyGroupsLunsQosPolicyName)
	return o
}

// SetConsistencyGroupsLunsQosPolicyName adds the consistencyGroupsLunsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyName(consistencyGroupsLunsQosPolicyName *string) {
	o.ConsistencyGroupsLunsQosPolicyName = consistencyGroupsLunsQosPolicyName
}

// WithConsistencyGroupsLunsQosPolicyUUID adds the consistencyGroupsLunsQosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsQosPolicyUUID(consistencyGroupsLunsQosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsQosPolicyUUID(consistencyGroupsLunsQosPolicyUUID)
	return o
}

// SetConsistencyGroupsLunsQosPolicyUUID adds the consistencyGroupsLunsQosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsQosPolicyUUID(consistencyGroupsLunsQosPolicyUUID *string) {
	o.ConsistencyGroupsLunsQosPolicyUUID = consistencyGroupsLunsQosPolicyUUID
}

// WithConsistencyGroupsLunsSerialNumber adds the consistencyGroupsLunsSerialNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsSerialNumber(consistencyGroupsLunsSerialNumber *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsSerialNumber(consistencyGroupsLunsSerialNumber)
	return o
}

// SetConsistencyGroupsLunsSerialNumber adds the consistencyGroupsLunsSerialNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsSerialNumber(consistencyGroupsLunsSerialNumber *string) {
	o.ConsistencyGroupsLunsSerialNumber = consistencyGroupsLunsSerialNumber
}

// WithConsistencyGroupsLunsSpaceGuaranteeRequested adds the consistencyGroupsLunsSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsSpaceGuaranteeRequested(consistencyGroupsLunsSpaceGuaranteeRequested *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsSpaceGuaranteeRequested(consistencyGroupsLunsSpaceGuaranteeRequested)
	return o
}

// SetConsistencyGroupsLunsSpaceGuaranteeRequested adds the consistencyGroupsLunsSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsSpaceGuaranteeRequested(consistencyGroupsLunsSpaceGuaranteeRequested *bool) {
	o.ConsistencyGroupsLunsSpaceGuaranteeRequested = consistencyGroupsLunsSpaceGuaranteeRequested
}

// WithConsistencyGroupsLunsSpaceGuaranteeReserved adds the consistencyGroupsLunsSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsSpaceGuaranteeReserved(consistencyGroupsLunsSpaceGuaranteeReserved *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsSpaceGuaranteeReserved(consistencyGroupsLunsSpaceGuaranteeReserved)
	return o
}

// SetConsistencyGroupsLunsSpaceGuaranteeReserved adds the consistencyGroupsLunsSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsSpaceGuaranteeReserved(consistencyGroupsLunsSpaceGuaranteeReserved *bool) {
	o.ConsistencyGroupsLunsSpaceGuaranteeReserved = consistencyGroupsLunsSpaceGuaranteeReserved
}

// WithConsistencyGroupsLunsSpaceSize adds the consistencyGroupsLunsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsSpaceSize(consistencyGroupsLunsSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsSpaceSize(consistencyGroupsLunsSpaceSize)
	return o
}

// SetConsistencyGroupsLunsSpaceSize adds the consistencyGroupsLunsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsSpaceSize(consistencyGroupsLunsSpaceSize *int64) {
	o.ConsistencyGroupsLunsSpaceSize = consistencyGroupsLunsSpaceSize
}

// WithConsistencyGroupsLunsSpaceUsed adds the consistencyGroupsLunsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsSpaceUsed(consistencyGroupsLunsSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsSpaceUsed(consistencyGroupsLunsSpaceUsed)
	return o
}

// SetConsistencyGroupsLunsSpaceUsed adds the consistencyGroupsLunsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsSpaceUsed(consistencyGroupsLunsSpaceUsed *int64) {
	o.ConsistencyGroupsLunsSpaceUsed = consistencyGroupsLunsSpaceUsed
}

// WithConsistencyGroupsLunsUUID adds the consistencyGroupsLunsUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsLunsUUID(consistencyGroupsLunsUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsLunsUUID(consistencyGroupsLunsUUID)
	return o
}

// SetConsistencyGroupsLunsUUID adds the consistencyGroupsLunsUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsLunsUUID(consistencyGroupsLunsUUID *string) {
	o.ConsistencyGroupsLunsUUID = consistencyGroupsLunsUUID
}

// WithConsistencyGroupsName adds the consistencyGroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsName(consistencyGroupsName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsName(consistencyGroupsName)
	return o
}

// SetConsistencyGroupsName adds the consistencyGroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsName(consistencyGroupsName *string) {
	o.ConsistencyGroupsName = consistencyGroupsName
}

// WithConsistencyGroupsNamespacesAutoDelete adds the consistencyGroupsNamespacesAutoDelete to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesAutoDelete(consistencyGroupsNamespacesAutoDelete *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesAutoDelete(consistencyGroupsNamespacesAutoDelete)
	return o
}

// SetConsistencyGroupsNamespacesAutoDelete adds the consistencyGroupsNamespacesAutoDelete to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesAutoDelete(consistencyGroupsNamespacesAutoDelete *bool) {
	o.ConsistencyGroupsNamespacesAutoDelete = consistencyGroupsNamespacesAutoDelete
}

// WithConsistencyGroupsNamespacesComment adds the consistencyGroupsNamespacesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesComment(consistencyGroupsNamespacesComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesComment(consistencyGroupsNamespacesComment)
	return o
}

// SetConsistencyGroupsNamespacesComment adds the consistencyGroupsNamespacesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesComment(consistencyGroupsNamespacesComment *string) {
	o.ConsistencyGroupsNamespacesComment = consistencyGroupsNamespacesComment
}

// WithConsistencyGroupsNamespacesCreateTime adds the consistencyGroupsNamespacesCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesCreateTime(consistencyGroupsNamespacesCreateTime *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesCreateTime(consistencyGroupsNamespacesCreateTime)
	return o
}

// SetConsistencyGroupsNamespacesCreateTime adds the consistencyGroupsNamespacesCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesCreateTime(consistencyGroupsNamespacesCreateTime *string) {
	o.ConsistencyGroupsNamespacesCreateTime = consistencyGroupsNamespacesCreateTime
}

// WithConsistencyGroupsNamespacesEnabled adds the consistencyGroupsNamespacesEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesEnabled(consistencyGroupsNamespacesEnabled *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesEnabled(consistencyGroupsNamespacesEnabled)
	return o
}

// SetConsistencyGroupsNamespacesEnabled adds the consistencyGroupsNamespacesEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesEnabled(consistencyGroupsNamespacesEnabled *bool) {
	o.ConsistencyGroupsNamespacesEnabled = consistencyGroupsNamespacesEnabled
}

// WithConsistencyGroupsNamespacesName adds the consistencyGroupsNamespacesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesName(consistencyGroupsNamespacesName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesName(consistencyGroupsNamespacesName)
	return o
}

// SetConsistencyGroupsNamespacesName adds the consistencyGroupsNamespacesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesName(consistencyGroupsNamespacesName *string) {
	o.ConsistencyGroupsNamespacesName = consistencyGroupsNamespacesName
}

// WithConsistencyGroupsNamespacesOsType adds the consistencyGroupsNamespacesOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesOsType(consistencyGroupsNamespacesOsType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesOsType(consistencyGroupsNamespacesOsType)
	return o
}

// SetConsistencyGroupsNamespacesOsType adds the consistencyGroupsNamespacesOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesOsType(consistencyGroupsNamespacesOsType *string) {
	o.ConsistencyGroupsNamespacesOsType = consistencyGroupsNamespacesOsType
}

// WithConsistencyGroupsNamespacesSpaceBlockSize adds the consistencyGroupsNamespacesSpaceBlockSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSpaceBlockSize(consistencyGroupsNamespacesSpaceBlockSize *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSpaceBlockSize(consistencyGroupsNamespacesSpaceBlockSize)
	return o
}

// SetConsistencyGroupsNamespacesSpaceBlockSize adds the consistencyGroupsNamespacesSpaceBlockSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSpaceBlockSize(consistencyGroupsNamespacesSpaceBlockSize *int64) {
	o.ConsistencyGroupsNamespacesSpaceBlockSize = consistencyGroupsNamespacesSpaceBlockSize
}

// WithConsistencyGroupsNamespacesSpaceGuaranteeRequested adds the consistencyGroupsNamespacesSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSpaceGuaranteeRequested(consistencyGroupsNamespacesSpaceGuaranteeRequested *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSpaceGuaranteeRequested(consistencyGroupsNamespacesSpaceGuaranteeRequested)
	return o
}

// SetConsistencyGroupsNamespacesSpaceGuaranteeRequested adds the consistencyGroupsNamespacesSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSpaceGuaranteeRequested(consistencyGroupsNamespacesSpaceGuaranteeRequested *bool) {
	o.ConsistencyGroupsNamespacesSpaceGuaranteeRequested = consistencyGroupsNamespacesSpaceGuaranteeRequested
}

// WithConsistencyGroupsNamespacesSpaceGuaranteeReserved adds the consistencyGroupsNamespacesSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSpaceGuaranteeReserved(consistencyGroupsNamespacesSpaceGuaranteeReserved *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSpaceGuaranteeReserved(consistencyGroupsNamespacesSpaceGuaranteeReserved)
	return o
}

// SetConsistencyGroupsNamespacesSpaceGuaranteeReserved adds the consistencyGroupsNamespacesSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSpaceGuaranteeReserved(consistencyGroupsNamespacesSpaceGuaranteeReserved *bool) {
	o.ConsistencyGroupsNamespacesSpaceGuaranteeReserved = consistencyGroupsNamespacesSpaceGuaranteeReserved
}

// WithConsistencyGroupsNamespacesSpaceSize adds the consistencyGroupsNamespacesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSpaceSize(consistencyGroupsNamespacesSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSpaceSize(consistencyGroupsNamespacesSpaceSize)
	return o
}

// SetConsistencyGroupsNamespacesSpaceSize adds the consistencyGroupsNamespacesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSpaceSize(consistencyGroupsNamespacesSpaceSize *int64) {
	o.ConsistencyGroupsNamespacesSpaceSize = consistencyGroupsNamespacesSpaceSize
}

// WithConsistencyGroupsNamespacesSpaceUsed adds the consistencyGroupsNamespacesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSpaceUsed(consistencyGroupsNamespacesSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSpaceUsed(consistencyGroupsNamespacesSpaceUsed)
	return o
}

// SetConsistencyGroupsNamespacesSpaceUsed adds the consistencyGroupsNamespacesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSpaceUsed(consistencyGroupsNamespacesSpaceUsed *int64) {
	o.ConsistencyGroupsNamespacesSpaceUsed = consistencyGroupsNamespacesSpaceUsed
}

// WithConsistencyGroupsNamespacesStatusContainerState adds the consistencyGroupsNamespacesStatusContainerState to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesStatusContainerState(consistencyGroupsNamespacesStatusContainerState *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesStatusContainerState(consistencyGroupsNamespacesStatusContainerState)
	return o
}

// SetConsistencyGroupsNamespacesStatusContainerState adds the consistencyGroupsNamespacesStatusContainerState to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesStatusContainerState(consistencyGroupsNamespacesStatusContainerState *string) {
	o.ConsistencyGroupsNamespacesStatusContainerState = consistencyGroupsNamespacesStatusContainerState
}

// WithConsistencyGroupsNamespacesStatusMapped adds the consistencyGroupsNamespacesStatusMapped to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesStatusMapped(consistencyGroupsNamespacesStatusMapped *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesStatusMapped(consistencyGroupsNamespacesStatusMapped)
	return o
}

// SetConsistencyGroupsNamespacesStatusMapped adds the consistencyGroupsNamespacesStatusMapped to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesStatusMapped(consistencyGroupsNamespacesStatusMapped *bool) {
	o.ConsistencyGroupsNamespacesStatusMapped = consistencyGroupsNamespacesStatusMapped
}

// WithConsistencyGroupsNamespacesStatusReadOnly adds the consistencyGroupsNamespacesStatusReadOnly to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesStatusReadOnly(consistencyGroupsNamespacesStatusReadOnly *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesStatusReadOnly(consistencyGroupsNamespacesStatusReadOnly)
	return o
}

// SetConsistencyGroupsNamespacesStatusReadOnly adds the consistencyGroupsNamespacesStatusReadOnly to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesStatusReadOnly(consistencyGroupsNamespacesStatusReadOnly *bool) {
	o.ConsistencyGroupsNamespacesStatusReadOnly = consistencyGroupsNamespacesStatusReadOnly
}

// WithConsistencyGroupsNamespacesStatusState adds the consistencyGroupsNamespacesStatusState to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesStatusState(consistencyGroupsNamespacesStatusState *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesStatusState(consistencyGroupsNamespacesStatusState)
	return o
}

// SetConsistencyGroupsNamespacesStatusState adds the consistencyGroupsNamespacesStatusState to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesStatusState(consistencyGroupsNamespacesStatusState *string) {
	o.ConsistencyGroupsNamespacesStatusState = consistencyGroupsNamespacesStatusState
}

// WithConsistencyGroupsNamespacesSubsystemMapAnagrpid adds the consistencyGroupsNamespacesSubsystemMapAnagrpid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapAnagrpid(consistencyGroupsNamespacesSubsystemMapAnagrpid *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapAnagrpid(consistencyGroupsNamespacesSubsystemMapAnagrpid)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapAnagrpid adds the consistencyGroupsNamespacesSubsystemMapAnagrpid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapAnagrpid(consistencyGroupsNamespacesSubsystemMapAnagrpid *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapAnagrpid = consistencyGroupsNamespacesSubsystemMapAnagrpid
}

// WithConsistencyGroupsNamespacesSubsystemMapNsid adds the consistencyGroupsNamespacesSubsystemMapNsid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapNsid(consistencyGroupsNamespacesSubsystemMapNsid *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapNsid(consistencyGroupsNamespacesSubsystemMapNsid)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapNsid adds the consistencyGroupsNamespacesSubsystemMapNsid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapNsid(consistencyGroupsNamespacesSubsystemMapNsid *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapNsid = consistencyGroupsNamespacesSubsystemMapNsid
}

// WithConsistencyGroupsNamespacesSubsystemMapSubsystemComment adds the consistencyGroupsNamespacesSubsystemMapSubsystemComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapSubsystemComment(consistencyGroupsNamespacesSubsystemMapSubsystemComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapSubsystemComment(consistencyGroupsNamespacesSubsystemMapSubsystemComment)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapSubsystemComment adds the consistencyGroupsNamespacesSubsystemMapSubsystemComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapSubsystemComment(consistencyGroupsNamespacesSubsystemMapSubsystemComment *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapSubsystemComment = consistencyGroupsNamespacesSubsystemMapSubsystemComment
}

// WithConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn adds the consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn(consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn(consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn adds the consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn(consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn = consistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn
}

// WithConsistencyGroupsNamespacesSubsystemMapSubsystemName adds the consistencyGroupsNamespacesSubsystemMapSubsystemName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapSubsystemName(consistencyGroupsNamespacesSubsystemMapSubsystemName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapSubsystemName(consistencyGroupsNamespacesSubsystemMapSubsystemName)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapSubsystemName adds the consistencyGroupsNamespacesSubsystemMapSubsystemName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapSubsystemName(consistencyGroupsNamespacesSubsystemMapSubsystemName *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapSubsystemName = consistencyGroupsNamespacesSubsystemMapSubsystemName
}

// WithConsistencyGroupsNamespacesSubsystemMapSubsystemOsType adds the consistencyGroupsNamespacesSubsystemMapSubsystemOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapSubsystemOsType(consistencyGroupsNamespacesSubsystemMapSubsystemOsType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapSubsystemOsType(consistencyGroupsNamespacesSubsystemMapSubsystemOsType)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapSubsystemOsType adds the consistencyGroupsNamespacesSubsystemMapSubsystemOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapSubsystemOsType(consistencyGroupsNamespacesSubsystemMapSubsystemOsType *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType = consistencyGroupsNamespacesSubsystemMapSubsystemOsType
}

// WithConsistencyGroupsNamespacesSubsystemMapSubsystemUUID adds the consistencyGroupsNamespacesSubsystemMapSubsystemUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesSubsystemMapSubsystemUUID(consistencyGroupsNamespacesSubsystemMapSubsystemUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesSubsystemMapSubsystemUUID(consistencyGroupsNamespacesSubsystemMapSubsystemUUID)
	return o
}

// SetConsistencyGroupsNamespacesSubsystemMapSubsystemUUID adds the consistencyGroupsNamespacesSubsystemMapSubsystemUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesSubsystemMapSubsystemUUID(consistencyGroupsNamespacesSubsystemMapSubsystemUUID *string) {
	o.ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID = consistencyGroupsNamespacesSubsystemMapSubsystemUUID
}

// WithConsistencyGroupsNamespacesUUID adds the consistencyGroupsNamespacesUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsNamespacesUUID(consistencyGroupsNamespacesUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsNamespacesUUID(consistencyGroupsNamespacesUUID)
	return o
}

// SetConsistencyGroupsNamespacesUUID adds the consistencyGroupsNamespacesUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsNamespacesUUID(consistencyGroupsNamespacesUUID *string) {
	o.ConsistencyGroupsNamespacesUUID = consistencyGroupsNamespacesUUID
}

// WithConsistencyGroupsParentConsistencyGroupName adds the consistencyGroupsParentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsParentConsistencyGroupName(consistencyGroupsParentConsistencyGroupName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsParentConsistencyGroupName(consistencyGroupsParentConsistencyGroupName)
	return o
}

// SetConsistencyGroupsParentConsistencyGroupName adds the consistencyGroupsParentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsParentConsistencyGroupName(consistencyGroupsParentConsistencyGroupName *string) {
	o.ConsistencyGroupsParentConsistencyGroupName = consistencyGroupsParentConsistencyGroupName
}

// WithConsistencyGroupsParentConsistencyGroupUUID adds the consistencyGroupsParentConsistencyGroupUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsParentConsistencyGroupUUID(consistencyGroupsParentConsistencyGroupUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsParentConsistencyGroupUUID(consistencyGroupsParentConsistencyGroupUUID)
	return o
}

// SetConsistencyGroupsParentConsistencyGroupUUID adds the consistencyGroupsParentConsistencyGroupUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsParentConsistencyGroupUUID(consistencyGroupsParentConsistencyGroupUUID *string) {
	o.ConsistencyGroupsParentConsistencyGroupUUID = consistencyGroupsParentConsistencyGroupUUID
}

// WithConsistencyGroupsQosPolicyMaxThroughputIops adds the consistencyGroupsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyMaxThroughputIops(consistencyGroupsQosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyMaxThroughputIops(consistencyGroupsQosPolicyMaxThroughputIops)
	return o
}

// SetConsistencyGroupsQosPolicyMaxThroughputIops adds the consistencyGroupsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyMaxThroughputIops(consistencyGroupsQosPolicyMaxThroughputIops *int64) {
	o.ConsistencyGroupsQosPolicyMaxThroughputIops = consistencyGroupsQosPolicyMaxThroughputIops
}

// WithConsistencyGroupsQosPolicyMaxThroughputMbps adds the consistencyGroupsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyMaxThroughputMbps(consistencyGroupsQosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyMaxThroughputMbps(consistencyGroupsQosPolicyMaxThroughputMbps)
	return o
}

// SetConsistencyGroupsQosPolicyMaxThroughputMbps adds the consistencyGroupsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyMaxThroughputMbps(consistencyGroupsQosPolicyMaxThroughputMbps *int64) {
	o.ConsistencyGroupsQosPolicyMaxThroughputMbps = consistencyGroupsQosPolicyMaxThroughputMbps
}

// WithConsistencyGroupsQosPolicyMinThroughputIops adds the consistencyGroupsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyMinThroughputIops(consistencyGroupsQosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyMinThroughputIops(consistencyGroupsQosPolicyMinThroughputIops)
	return o
}

// SetConsistencyGroupsQosPolicyMinThroughputIops adds the consistencyGroupsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyMinThroughputIops(consistencyGroupsQosPolicyMinThroughputIops *int64) {
	o.ConsistencyGroupsQosPolicyMinThroughputIops = consistencyGroupsQosPolicyMinThroughputIops
}

// WithConsistencyGroupsQosPolicyMinThroughputMbps adds the consistencyGroupsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyMinThroughputMbps(consistencyGroupsQosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyMinThroughputMbps(consistencyGroupsQosPolicyMinThroughputMbps)
	return o
}

// SetConsistencyGroupsQosPolicyMinThroughputMbps adds the consistencyGroupsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyMinThroughputMbps(consistencyGroupsQosPolicyMinThroughputMbps *int64) {
	o.ConsistencyGroupsQosPolicyMinThroughputMbps = consistencyGroupsQosPolicyMinThroughputMbps
}

// WithConsistencyGroupsQosPolicyName adds the consistencyGroupsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyName(consistencyGroupsQosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyName(consistencyGroupsQosPolicyName)
	return o
}

// SetConsistencyGroupsQosPolicyName adds the consistencyGroupsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyName(consistencyGroupsQosPolicyName *string) {
	o.ConsistencyGroupsQosPolicyName = consistencyGroupsQosPolicyName
}

// WithConsistencyGroupsQosPolicyUUID adds the consistencyGroupsQosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsQosPolicyUUID(consistencyGroupsQosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsQosPolicyUUID(consistencyGroupsQosPolicyUUID)
	return o
}

// SetConsistencyGroupsQosPolicyUUID adds the consistencyGroupsQosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsQosPolicyUUID(consistencyGroupsQosPolicyUUID *string) {
	o.ConsistencyGroupsQosPolicyUUID = consistencyGroupsQosPolicyUUID
}

// WithConsistencyGroupsSnapshotPolicyName adds the consistencyGroupsSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSnapshotPolicyName(consistencyGroupsSnapshotPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSnapshotPolicyName(consistencyGroupsSnapshotPolicyName)
	return o
}

// SetConsistencyGroupsSnapshotPolicyName adds the consistencyGroupsSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSnapshotPolicyName(consistencyGroupsSnapshotPolicyName *string) {
	o.ConsistencyGroupsSnapshotPolicyName = consistencyGroupsSnapshotPolicyName
}

// WithConsistencyGroupsSnapshotPolicyUUID adds the consistencyGroupsSnapshotPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSnapshotPolicyUUID(consistencyGroupsSnapshotPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSnapshotPolicyUUID(consistencyGroupsSnapshotPolicyUUID)
	return o
}

// SetConsistencyGroupsSnapshotPolicyUUID adds the consistencyGroupsSnapshotPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSnapshotPolicyUUID(consistencyGroupsSnapshotPolicyUUID *string) {
	o.ConsistencyGroupsSnapshotPolicyUUID = consistencyGroupsSnapshotPolicyUUID
}

// WithConsistencyGroupsSpaceAvailable adds the consistencyGroupsSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSpaceAvailable(consistencyGroupsSpaceAvailable *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSpaceAvailable(consistencyGroupsSpaceAvailable)
	return o
}

// SetConsistencyGroupsSpaceAvailable adds the consistencyGroupsSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSpaceAvailable(consistencyGroupsSpaceAvailable *int64) {
	o.ConsistencyGroupsSpaceAvailable = consistencyGroupsSpaceAvailable
}

// WithConsistencyGroupsSpaceSize adds the consistencyGroupsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSpaceSize(consistencyGroupsSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSpaceSize(consistencyGroupsSpaceSize)
	return o
}

// SetConsistencyGroupsSpaceSize adds the consistencyGroupsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSpaceSize(consistencyGroupsSpaceSize *int64) {
	o.ConsistencyGroupsSpaceSize = consistencyGroupsSpaceSize
}

// WithConsistencyGroupsSpaceUsed adds the consistencyGroupsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSpaceUsed(consistencyGroupsSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSpaceUsed(consistencyGroupsSpaceUsed)
	return o
}

// SetConsistencyGroupsSpaceUsed adds the consistencyGroupsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSpaceUsed(consistencyGroupsSpaceUsed *int64) {
	o.ConsistencyGroupsSpaceUsed = consistencyGroupsSpaceUsed
}

// WithConsistencyGroupsSvmName adds the consistencyGroupsSvmName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSvmName(consistencyGroupsSvmName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSvmName(consistencyGroupsSvmName)
	return o
}

// SetConsistencyGroupsSvmName adds the consistencyGroupsSvmName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSvmName(consistencyGroupsSvmName *string) {
	o.ConsistencyGroupsSvmName = consistencyGroupsSvmName
}

// WithConsistencyGroupsSvmUUID adds the consistencyGroupsSvmUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsSvmUUID(consistencyGroupsSvmUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsSvmUUID(consistencyGroupsSvmUUID)
	return o
}

// SetConsistencyGroupsSvmUUID adds the consistencyGroupsSvmUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsSvmUUID(consistencyGroupsSvmUUID *string) {
	o.ConsistencyGroupsSvmUUID = consistencyGroupsSvmUUID
}

// WithConsistencyGroupsTieringPolicy adds the consistencyGroupsTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsTieringPolicy(consistencyGroupsTieringPolicy *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsTieringPolicy(consistencyGroupsTieringPolicy)
	return o
}

// SetConsistencyGroupsTieringPolicy adds the consistencyGroupsTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsTieringPolicy(consistencyGroupsTieringPolicy *string) {
	o.ConsistencyGroupsTieringPolicy = consistencyGroupsTieringPolicy
}

// WithConsistencyGroupsUUID adds the consistencyGroupsUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsUUID(consistencyGroupsUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsUUID(consistencyGroupsUUID)
	return o
}

// SetConsistencyGroupsUUID adds the consistencyGroupsUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsUUID(consistencyGroupsUUID *string) {
	o.ConsistencyGroupsUUID = consistencyGroupsUUID
}

// WithConsistencyGroupsVolumesComment adds the consistencyGroupsVolumesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesComment(consistencyGroupsVolumesComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesComment(consistencyGroupsVolumesComment)
	return o
}

// SetConsistencyGroupsVolumesComment adds the consistencyGroupsVolumesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesComment(consistencyGroupsVolumesComment *string) {
	o.ConsistencyGroupsVolumesComment = consistencyGroupsVolumesComment
}

// WithConsistencyGroupsVolumesLanguage adds the consistencyGroupsVolumesLanguage to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesLanguage(consistencyGroupsVolumesLanguage *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesLanguage(consistencyGroupsVolumesLanguage)
	return o
}

// SetConsistencyGroupsVolumesLanguage adds the consistencyGroupsVolumesLanguage to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesLanguage(consistencyGroupsVolumesLanguage *string) {
	o.ConsistencyGroupsVolumesLanguage = consistencyGroupsVolumesLanguage
}

// WithConsistencyGroupsVolumesName adds the consistencyGroupsVolumesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesName(consistencyGroupsVolumesName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesName(consistencyGroupsVolumesName)
	return o
}

// SetConsistencyGroupsVolumesName adds the consistencyGroupsVolumesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesName(consistencyGroupsVolumesName *string) {
	o.ConsistencyGroupsVolumesName = consistencyGroupsVolumesName
}

// WithConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration adds the consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration(consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration(consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration adds the consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration(consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration = consistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration
}

// WithConsistencyGroupsVolumesNasCifsSharesAclsPermission adds the consistencyGroupsVolumesNasCifsSharesAclsPermission to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesAclsPermission(consistencyGroupsVolumesNasCifsSharesAclsPermission *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesAclsPermission(consistencyGroupsVolumesNasCifsSharesAclsPermission)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesAclsPermission adds the consistencyGroupsVolumesNasCifsSharesAclsPermission to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesAclsPermission(consistencyGroupsVolumesNasCifsSharesAclsPermission *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesAclsPermission = consistencyGroupsVolumesNasCifsSharesAclsPermission
}

// WithConsistencyGroupsVolumesNasCifsSharesAclsType adds the consistencyGroupsVolumesNasCifsSharesAclsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesAclsType(consistencyGroupsVolumesNasCifsSharesAclsType *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesAclsType(consistencyGroupsVolumesNasCifsSharesAclsType)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesAclsType adds the consistencyGroupsVolumesNasCifsSharesAclsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesAclsType(consistencyGroupsVolumesNasCifsSharesAclsType *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesAclsType = consistencyGroupsVolumesNasCifsSharesAclsType
}

// WithConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup adds the consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup(consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup(consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup adds the consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup(consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup = consistencyGroupsVolumesNasCifsSharesAclsUserOrGroup
}

// WithConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess adds the consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess(consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess(consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess adds the consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess(consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess = consistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess
}

// WithConsistencyGroupsVolumesNasCifsSharesChangeNotify adds the consistencyGroupsVolumesNasCifsSharesChangeNotify to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesChangeNotify(consistencyGroupsVolumesNasCifsSharesChangeNotify *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesChangeNotify(consistencyGroupsVolumesNasCifsSharesChangeNotify)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesChangeNotify adds the consistencyGroupsVolumesNasCifsSharesChangeNotify to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesChangeNotify(consistencyGroupsVolumesNasCifsSharesChangeNotify *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesChangeNotify = consistencyGroupsVolumesNasCifsSharesChangeNotify
}

// WithConsistencyGroupsVolumesNasCifsSharesComment adds the consistencyGroupsVolumesNasCifsSharesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesComment(consistencyGroupsVolumesNasCifsSharesComment *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesComment(consistencyGroupsVolumesNasCifsSharesComment)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesComment adds the consistencyGroupsVolumesNasCifsSharesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesComment(consistencyGroupsVolumesNasCifsSharesComment *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesComment = consistencyGroupsVolumesNasCifsSharesComment
}

// WithConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable adds the consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable(consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable(consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable adds the consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable(consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable = consistencyGroupsVolumesNasCifsSharesContinuouslyAvailable
}

// WithConsistencyGroupsVolumesNasCifsSharesDirUmask adds the consistencyGroupsVolumesNasCifsSharesDirUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesDirUmask(consistencyGroupsVolumesNasCifsSharesDirUmask *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesDirUmask(consistencyGroupsVolumesNasCifsSharesDirUmask)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesDirUmask adds the consistencyGroupsVolumesNasCifsSharesDirUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesDirUmask(consistencyGroupsVolumesNasCifsSharesDirUmask *int64) {
	o.ConsistencyGroupsVolumesNasCifsSharesDirUmask = consistencyGroupsVolumesNasCifsSharesDirUmask
}

// WithConsistencyGroupsVolumesNasCifsSharesEncryption adds the consistencyGroupsVolumesNasCifsSharesEncryption to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesEncryption(consistencyGroupsVolumesNasCifsSharesEncryption *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesEncryption(consistencyGroupsVolumesNasCifsSharesEncryption)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesEncryption adds the consistencyGroupsVolumesNasCifsSharesEncryption to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesEncryption(consistencyGroupsVolumesNasCifsSharesEncryption *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesEncryption = consistencyGroupsVolumesNasCifsSharesEncryption
}

// WithConsistencyGroupsVolumesNasCifsSharesFileUmask adds the consistencyGroupsVolumesNasCifsSharesFileUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesFileUmask(consistencyGroupsVolumesNasCifsSharesFileUmask *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesFileUmask(consistencyGroupsVolumesNasCifsSharesFileUmask)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesFileUmask adds the consistencyGroupsVolumesNasCifsSharesFileUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesFileUmask(consistencyGroupsVolumesNasCifsSharesFileUmask *int64) {
	o.ConsistencyGroupsVolumesNasCifsSharesFileUmask = consistencyGroupsVolumesNasCifsSharesFileUmask
}

// WithConsistencyGroupsVolumesNasCifsSharesHomeDirectory adds the consistencyGroupsVolumesNasCifsSharesHomeDirectory to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesHomeDirectory(consistencyGroupsVolumesNasCifsSharesHomeDirectory *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesHomeDirectory(consistencyGroupsVolumesNasCifsSharesHomeDirectory)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesHomeDirectory adds the consistencyGroupsVolumesNasCifsSharesHomeDirectory to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesHomeDirectory(consistencyGroupsVolumesNasCifsSharesHomeDirectory *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesHomeDirectory = consistencyGroupsVolumesNasCifsSharesHomeDirectory
}

// WithConsistencyGroupsVolumesNasCifsSharesName adds the consistencyGroupsVolumesNasCifsSharesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesName(consistencyGroupsVolumesNasCifsSharesName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesName(consistencyGroupsVolumesNasCifsSharesName)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesName adds the consistencyGroupsVolumesNasCifsSharesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesName(consistencyGroupsVolumesNasCifsSharesName *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesName = consistencyGroupsVolumesNasCifsSharesName
}

// WithConsistencyGroupsVolumesNasCifsSharesNamespaceCaching adds the consistencyGroupsVolumesNasCifsSharesNamespaceCaching to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesNamespaceCaching(consistencyGroupsVolumesNasCifsSharesNamespaceCaching *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesNamespaceCaching(consistencyGroupsVolumesNasCifsSharesNamespaceCaching)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesNamespaceCaching adds the consistencyGroupsVolumesNasCifsSharesNamespaceCaching to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesNamespaceCaching(consistencyGroupsVolumesNasCifsSharesNamespaceCaching *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching = consistencyGroupsVolumesNasCifsSharesNamespaceCaching
}

// WithConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity adds the consistencyGroupsVolumesNasCifsSharesNoStrictSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity(consistencyGroupsVolumesNasCifsSharesNoStrictSecurity *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity(consistencyGroupsVolumesNasCifsSharesNoStrictSecurity)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity adds the consistencyGroupsVolumesNasCifsSharesNoStrictSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity(consistencyGroupsVolumesNasCifsSharesNoStrictSecurity *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity = consistencyGroupsVolumesNasCifsSharesNoStrictSecurity
}

// WithConsistencyGroupsVolumesNasCifsSharesOfflineFiles adds the consistencyGroupsVolumesNasCifsSharesOfflineFiles to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesOfflineFiles(consistencyGroupsVolumesNasCifsSharesOfflineFiles *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesOfflineFiles(consistencyGroupsVolumesNasCifsSharesOfflineFiles)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesOfflineFiles adds the consistencyGroupsVolumesNasCifsSharesOfflineFiles to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesOfflineFiles(consistencyGroupsVolumesNasCifsSharesOfflineFiles *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesOfflineFiles = consistencyGroupsVolumesNasCifsSharesOfflineFiles
}

// WithConsistencyGroupsVolumesNasCifsSharesOplocks adds the consistencyGroupsVolumesNasCifsSharesOplocks to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesOplocks(consistencyGroupsVolumesNasCifsSharesOplocks *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesOplocks(consistencyGroupsVolumesNasCifsSharesOplocks)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesOplocks adds the consistencyGroupsVolumesNasCifsSharesOplocks to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesOplocks(consistencyGroupsVolumesNasCifsSharesOplocks *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesOplocks = consistencyGroupsVolumesNasCifsSharesOplocks
}

// WithConsistencyGroupsVolumesNasCifsSharesShowSnapshot adds the consistencyGroupsVolumesNasCifsSharesShowSnapshot to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesShowSnapshot(consistencyGroupsVolumesNasCifsSharesShowSnapshot *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesShowSnapshot(consistencyGroupsVolumesNasCifsSharesShowSnapshot)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesShowSnapshot adds the consistencyGroupsVolumesNasCifsSharesShowSnapshot to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesShowSnapshot(consistencyGroupsVolumesNasCifsSharesShowSnapshot *bool) {
	o.ConsistencyGroupsVolumesNasCifsSharesShowSnapshot = consistencyGroupsVolumesNasCifsSharesShowSnapshot
}

// WithConsistencyGroupsVolumesNasCifsSharesUnixSymlink adds the consistencyGroupsVolumesNasCifsSharesUnixSymlink to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesUnixSymlink(consistencyGroupsVolumesNasCifsSharesUnixSymlink *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesUnixSymlink(consistencyGroupsVolumesNasCifsSharesUnixSymlink)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesUnixSymlink adds the consistencyGroupsVolumesNasCifsSharesUnixSymlink to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesUnixSymlink(consistencyGroupsVolumesNasCifsSharesUnixSymlink *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesUnixSymlink = consistencyGroupsVolumesNasCifsSharesUnixSymlink
}

// WithConsistencyGroupsVolumesNasCifsSharesVscanProfile adds the consistencyGroupsVolumesNasCifsSharesVscanProfile to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasCifsSharesVscanProfile(consistencyGroupsVolumesNasCifsSharesVscanProfile *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasCifsSharesVscanProfile(consistencyGroupsVolumesNasCifsSharesVscanProfile)
	return o
}

// SetConsistencyGroupsVolumesNasCifsSharesVscanProfile adds the consistencyGroupsVolumesNasCifsSharesVscanProfile to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasCifsSharesVscanProfile(consistencyGroupsVolumesNasCifsSharesVscanProfile *string) {
	o.ConsistencyGroupsVolumesNasCifsSharesVscanProfile = consistencyGroupsVolumesNasCifsSharesVscanProfile
}

// WithConsistencyGroupsVolumesNasExportPolicyName adds the consistencyGroupsVolumesNasExportPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyName(consistencyGroupsVolumesNasExportPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyName(consistencyGroupsVolumesNasExportPolicyName)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyName adds the consistencyGroupsVolumesNasExportPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyName(consistencyGroupsVolumesNasExportPolicyName *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyName = consistencyGroupsVolumesNasExportPolicyName
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation adds the consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation(consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation(consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation adds the consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation(consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation *bool) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation = consistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid adds the consistencyGroupsVolumesNasExportPolicyRulesAllowSuid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid(consistencyGroupsVolumesNasExportPolicyRulesAllowSuid *bool) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid(consistencyGroupsVolumesNasExportPolicyRulesAllowSuid)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid adds the consistencyGroupsVolumesNasExportPolicyRulesAllowSuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid(consistencyGroupsVolumesNasExportPolicyRulesAllowSuid *bool) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid = consistencyGroupsVolumesNasExportPolicyRulesAllowSuid
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser adds the consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser(consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser(consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser adds the consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser(consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser = consistencyGroupsVolumesNasExportPolicyRulesAnonymousUser
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesChownMode adds the consistencyGroupsVolumesNasExportPolicyRulesChownMode to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesChownMode(consistencyGroupsVolumesNasExportPolicyRulesChownMode *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesChownMode(consistencyGroupsVolumesNasExportPolicyRulesChownMode)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesChownMode adds the consistencyGroupsVolumesNasExportPolicyRulesChownMode to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesChownMode(consistencyGroupsVolumesNasExportPolicyRulesChownMode *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesChownMode = consistencyGroupsVolumesNasExportPolicyRulesChownMode
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch adds the consistencyGroupsVolumesNasExportPolicyRulesClientsMatch to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch(consistencyGroupsVolumesNasExportPolicyRulesClientsMatch *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch(consistencyGroupsVolumesNasExportPolicyRulesClientsMatch)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch adds the consistencyGroupsVolumesNasExportPolicyRulesClientsMatch to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch(consistencyGroupsVolumesNasExportPolicyRulesClientsMatch *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch = consistencyGroupsVolumesNasExportPolicyRulesClientsMatch
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesIndex adds the consistencyGroupsVolumesNasExportPolicyRulesIndex to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesIndex(consistencyGroupsVolumesNasExportPolicyRulesIndex *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesIndex(consistencyGroupsVolumesNasExportPolicyRulesIndex)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesIndex adds the consistencyGroupsVolumesNasExportPolicyRulesIndex to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesIndex(consistencyGroupsVolumesNasExportPolicyRulesIndex *int64) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesIndex = consistencyGroupsVolumesNasExportPolicyRulesIndex
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity adds the consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity(consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity(consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity adds the consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity(consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity = consistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesProtocols adds the consistencyGroupsVolumesNasExportPolicyRulesProtocols to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesProtocols(consistencyGroupsVolumesNasExportPolicyRulesProtocols *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesProtocols(consistencyGroupsVolumesNasExportPolicyRulesProtocols)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesProtocols adds the consistencyGroupsVolumesNasExportPolicyRulesProtocols to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesProtocols(consistencyGroupsVolumesNasExportPolicyRulesProtocols *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesProtocols = consistencyGroupsVolumesNasExportPolicyRulesProtocols
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesRoRule adds the consistencyGroupsVolumesNasExportPolicyRulesRoRule to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesRoRule(consistencyGroupsVolumesNasExportPolicyRulesRoRule *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesRoRule(consistencyGroupsVolumesNasExportPolicyRulesRoRule)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesRoRule adds the consistencyGroupsVolumesNasExportPolicyRulesRoRule to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesRoRule(consistencyGroupsVolumesNasExportPolicyRulesRoRule *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesRoRule = consistencyGroupsVolumesNasExportPolicyRulesRoRule
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesRwRule adds the consistencyGroupsVolumesNasExportPolicyRulesRwRule to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesRwRule(consistencyGroupsVolumesNasExportPolicyRulesRwRule *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesRwRule(consistencyGroupsVolumesNasExportPolicyRulesRwRule)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesRwRule adds the consistencyGroupsVolumesNasExportPolicyRulesRwRule to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesRwRule(consistencyGroupsVolumesNasExportPolicyRulesRwRule *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesRwRule = consistencyGroupsVolumesNasExportPolicyRulesRwRule
}

// WithConsistencyGroupsVolumesNasExportPolicyRulesSuperuser adds the consistencyGroupsVolumesNasExportPolicyRulesSuperuser to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyRulesSuperuser(consistencyGroupsVolumesNasExportPolicyRulesSuperuser *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyRulesSuperuser(consistencyGroupsVolumesNasExportPolicyRulesSuperuser)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyRulesSuperuser adds the consistencyGroupsVolumesNasExportPolicyRulesSuperuser to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyRulesSuperuser(consistencyGroupsVolumesNasExportPolicyRulesSuperuser *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser = consistencyGroupsVolumesNasExportPolicyRulesSuperuser
}

// WithConsistencyGroupsVolumesNasExportPolicyUUID adds the consistencyGroupsVolumesNasExportPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasExportPolicyUUID(consistencyGroupsVolumesNasExportPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasExportPolicyUUID(consistencyGroupsVolumesNasExportPolicyUUID)
	return o
}

// SetConsistencyGroupsVolumesNasExportPolicyUUID adds the consistencyGroupsVolumesNasExportPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasExportPolicyUUID(consistencyGroupsVolumesNasExportPolicyUUID *string) {
	o.ConsistencyGroupsVolumesNasExportPolicyUUID = consistencyGroupsVolumesNasExportPolicyUUID
}

// WithConsistencyGroupsVolumesNasGid adds the consistencyGroupsVolumesNasGid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasGid(consistencyGroupsVolumesNasGid *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasGid(consistencyGroupsVolumesNasGid)
	return o
}

// SetConsistencyGroupsVolumesNasGid adds the consistencyGroupsVolumesNasGid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasGid(consistencyGroupsVolumesNasGid *int64) {
	o.ConsistencyGroupsVolumesNasGid = consistencyGroupsVolumesNasGid
}

// WithConsistencyGroupsVolumesNasJunctionParentName adds the consistencyGroupsVolumesNasJunctionParentName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasJunctionParentName(consistencyGroupsVolumesNasJunctionParentName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasJunctionParentName(consistencyGroupsVolumesNasJunctionParentName)
	return o
}

// SetConsistencyGroupsVolumesNasJunctionParentName adds the consistencyGroupsVolumesNasJunctionParentName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasJunctionParentName(consistencyGroupsVolumesNasJunctionParentName *string) {
	o.ConsistencyGroupsVolumesNasJunctionParentName = consistencyGroupsVolumesNasJunctionParentName
}

// WithConsistencyGroupsVolumesNasJunctionParentUUID adds the consistencyGroupsVolumesNasJunctionParentUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasJunctionParentUUID(consistencyGroupsVolumesNasJunctionParentUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasJunctionParentUUID(consistencyGroupsVolumesNasJunctionParentUUID)
	return o
}

// SetConsistencyGroupsVolumesNasJunctionParentUUID adds the consistencyGroupsVolumesNasJunctionParentUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasJunctionParentUUID(consistencyGroupsVolumesNasJunctionParentUUID *string) {
	o.ConsistencyGroupsVolumesNasJunctionParentUUID = consistencyGroupsVolumesNasJunctionParentUUID
}

// WithConsistencyGroupsVolumesNasPath adds the consistencyGroupsVolumesNasPath to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasPath(consistencyGroupsVolumesNasPath *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasPath(consistencyGroupsVolumesNasPath)
	return o
}

// SetConsistencyGroupsVolumesNasPath adds the consistencyGroupsVolumesNasPath to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasPath(consistencyGroupsVolumesNasPath *string) {
	o.ConsistencyGroupsVolumesNasPath = consistencyGroupsVolumesNasPath
}

// WithConsistencyGroupsVolumesNasSecurityStyle adds the consistencyGroupsVolumesNasSecurityStyle to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasSecurityStyle(consistencyGroupsVolumesNasSecurityStyle *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasSecurityStyle(consistencyGroupsVolumesNasSecurityStyle)
	return o
}

// SetConsistencyGroupsVolumesNasSecurityStyle adds the consistencyGroupsVolumesNasSecurityStyle to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasSecurityStyle(consistencyGroupsVolumesNasSecurityStyle *string) {
	o.ConsistencyGroupsVolumesNasSecurityStyle = consistencyGroupsVolumesNasSecurityStyle
}

// WithConsistencyGroupsVolumesNasUID adds the consistencyGroupsVolumesNasUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasUID(consistencyGroupsVolumesNasUID *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasUID(consistencyGroupsVolumesNasUID)
	return o
}

// SetConsistencyGroupsVolumesNasUID adds the consistencyGroupsVolumesNasUid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasUID(consistencyGroupsVolumesNasUID *int64) {
	o.ConsistencyGroupsVolumesNasUID = consistencyGroupsVolumesNasUID
}

// WithConsistencyGroupsVolumesNasUnixPermissions adds the consistencyGroupsVolumesNasUnixPermissions to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesNasUnixPermissions(consistencyGroupsVolumesNasUnixPermissions *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesNasUnixPermissions(consistencyGroupsVolumesNasUnixPermissions)
	return o
}

// SetConsistencyGroupsVolumesNasUnixPermissions adds the consistencyGroupsVolumesNasUnixPermissions to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesNasUnixPermissions(consistencyGroupsVolumesNasUnixPermissions *int64) {
	o.ConsistencyGroupsVolumesNasUnixPermissions = consistencyGroupsVolumesNasUnixPermissions
}

// WithConsistencyGroupsVolumesQosPolicyMaxThroughputIops adds the consistencyGroupsVolumesQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyMaxThroughputIops(consistencyGroupsVolumesQosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyMaxThroughputIops(consistencyGroupsVolumesQosPolicyMaxThroughputIops)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyMaxThroughputIops adds the consistencyGroupsVolumesQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyMaxThroughputIops(consistencyGroupsVolumesQosPolicyMaxThroughputIops *int64) {
	o.ConsistencyGroupsVolumesQosPolicyMaxThroughputIops = consistencyGroupsVolumesQosPolicyMaxThroughputIops
}

// WithConsistencyGroupsVolumesQosPolicyMaxThroughputMbps adds the consistencyGroupsVolumesQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyMaxThroughputMbps(consistencyGroupsVolumesQosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyMaxThroughputMbps(consistencyGroupsVolumesQosPolicyMaxThroughputMbps)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyMaxThroughputMbps adds the consistencyGroupsVolumesQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyMaxThroughputMbps(consistencyGroupsVolumesQosPolicyMaxThroughputMbps *int64) {
	o.ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps = consistencyGroupsVolumesQosPolicyMaxThroughputMbps
}

// WithConsistencyGroupsVolumesQosPolicyMinThroughputIops adds the consistencyGroupsVolumesQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyMinThroughputIops(consistencyGroupsVolumesQosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyMinThroughputIops(consistencyGroupsVolumesQosPolicyMinThroughputIops)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyMinThroughputIops adds the consistencyGroupsVolumesQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyMinThroughputIops(consistencyGroupsVolumesQosPolicyMinThroughputIops *int64) {
	o.ConsistencyGroupsVolumesQosPolicyMinThroughputIops = consistencyGroupsVolumesQosPolicyMinThroughputIops
}

// WithConsistencyGroupsVolumesQosPolicyMinThroughputMbps adds the consistencyGroupsVolumesQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyMinThroughputMbps(consistencyGroupsVolumesQosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyMinThroughputMbps(consistencyGroupsVolumesQosPolicyMinThroughputMbps)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyMinThroughputMbps adds the consistencyGroupsVolumesQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyMinThroughputMbps(consistencyGroupsVolumesQosPolicyMinThroughputMbps *int64) {
	o.ConsistencyGroupsVolumesQosPolicyMinThroughputMbps = consistencyGroupsVolumesQosPolicyMinThroughputMbps
}

// WithConsistencyGroupsVolumesQosPolicyName adds the consistencyGroupsVolumesQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyName(consistencyGroupsVolumesQosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyName(consistencyGroupsVolumesQosPolicyName)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyName adds the consistencyGroupsVolumesQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyName(consistencyGroupsVolumesQosPolicyName *string) {
	o.ConsistencyGroupsVolumesQosPolicyName = consistencyGroupsVolumesQosPolicyName
}

// WithConsistencyGroupsVolumesQosPolicyUUID adds the consistencyGroupsVolumesQosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesQosPolicyUUID(consistencyGroupsVolumesQosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesQosPolicyUUID(consistencyGroupsVolumesQosPolicyUUID)
	return o
}

// SetConsistencyGroupsVolumesQosPolicyUUID adds the consistencyGroupsVolumesQosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesQosPolicyUUID(consistencyGroupsVolumesQosPolicyUUID *string) {
	o.ConsistencyGroupsVolumesQosPolicyUUID = consistencyGroupsVolumesQosPolicyUUID
}

// WithConsistencyGroupsVolumesSnapshotPolicyName adds the consistencyGroupsVolumesSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesSnapshotPolicyName(consistencyGroupsVolumesSnapshotPolicyName *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesSnapshotPolicyName(consistencyGroupsVolumesSnapshotPolicyName)
	return o
}

// SetConsistencyGroupsVolumesSnapshotPolicyName adds the consistencyGroupsVolumesSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesSnapshotPolicyName(consistencyGroupsVolumesSnapshotPolicyName *string) {
	o.ConsistencyGroupsVolumesSnapshotPolicyName = consistencyGroupsVolumesSnapshotPolicyName
}

// WithConsistencyGroupsVolumesSnapshotPolicyUUID adds the consistencyGroupsVolumesSnapshotPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesSnapshotPolicyUUID(consistencyGroupsVolumesSnapshotPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesSnapshotPolicyUUID(consistencyGroupsVolumesSnapshotPolicyUUID)
	return o
}

// SetConsistencyGroupsVolumesSnapshotPolicyUUID adds the consistencyGroupsVolumesSnapshotPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesSnapshotPolicyUUID(consistencyGroupsVolumesSnapshotPolicyUUID *string) {
	o.ConsistencyGroupsVolumesSnapshotPolicyUUID = consistencyGroupsVolumesSnapshotPolicyUUID
}

// WithConsistencyGroupsVolumesSpaceAvailable adds the consistencyGroupsVolumesSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesSpaceAvailable(consistencyGroupsVolumesSpaceAvailable *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesSpaceAvailable(consistencyGroupsVolumesSpaceAvailable)
	return o
}

// SetConsistencyGroupsVolumesSpaceAvailable adds the consistencyGroupsVolumesSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesSpaceAvailable(consistencyGroupsVolumesSpaceAvailable *int64) {
	o.ConsistencyGroupsVolumesSpaceAvailable = consistencyGroupsVolumesSpaceAvailable
}

// WithConsistencyGroupsVolumesSpaceSize adds the consistencyGroupsVolumesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesSpaceSize(consistencyGroupsVolumesSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesSpaceSize(consistencyGroupsVolumesSpaceSize)
	return o
}

// SetConsistencyGroupsVolumesSpaceSize adds the consistencyGroupsVolumesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesSpaceSize(consistencyGroupsVolumesSpaceSize *int64) {
	o.ConsistencyGroupsVolumesSpaceSize = consistencyGroupsVolumesSpaceSize
}

// WithConsistencyGroupsVolumesSpaceUsed adds the consistencyGroupsVolumesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesSpaceUsed(consistencyGroupsVolumesSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesSpaceUsed(consistencyGroupsVolumesSpaceUsed)
	return o
}

// SetConsistencyGroupsVolumesSpaceUsed adds the consistencyGroupsVolumesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesSpaceUsed(consistencyGroupsVolumesSpaceUsed *int64) {
	o.ConsistencyGroupsVolumesSpaceUsed = consistencyGroupsVolumesSpaceUsed
}

// WithConsistencyGroupsVolumesTieringPolicy adds the consistencyGroupsVolumesTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesTieringPolicy(consistencyGroupsVolumesTieringPolicy *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesTieringPolicy(consistencyGroupsVolumesTieringPolicy)
	return o
}

// SetConsistencyGroupsVolumesTieringPolicy adds the consistencyGroupsVolumesTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesTieringPolicy(consistencyGroupsVolumesTieringPolicy *string) {
	o.ConsistencyGroupsVolumesTieringPolicy = consistencyGroupsVolumesTieringPolicy
}

// WithConsistencyGroupsVolumesUUID adds the consistencyGroupsVolumesUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithConsistencyGroupsVolumesUUID(consistencyGroupsVolumesUUID *string) *ConsistencyGroupGetParams {
	o.SetConsistencyGroupsVolumesUUID(consistencyGroupsVolumesUUID)
	return o
}

// SetConsistencyGroupsVolumesUUID adds the consistencyGroupsVolumesUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetConsistencyGroupsVolumesUUID(consistencyGroupsVolumesUUID *string) {
	o.ConsistencyGroupsVolumesUUID = consistencyGroupsVolumesUUID
}

// WithFields adds the fields to the consistency group get params
func (o *ConsistencyGroupGetParams) WithFields(fields []string) *ConsistencyGroupGetParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the consistency group get params
func (o *ConsistencyGroupGetParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithLunsComment adds the lunsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsComment(lunsComment *string) *ConsistencyGroupGetParams {
	o.SetLunsComment(lunsComment)
	return o
}

// SetLunsComment adds the lunsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsComment(lunsComment *string) {
	o.LunsComment = lunsComment
}

// WithLunsCreateTime adds the lunsCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsCreateTime(lunsCreateTime *string) *ConsistencyGroupGetParams {
	o.SetLunsCreateTime(lunsCreateTime)
	return o
}

// SetLunsCreateTime adds the lunsCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsCreateTime(lunsCreateTime *string) {
	o.LunsCreateTime = lunsCreateTime
}

// WithLunsEnabled adds the lunsEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsEnabled(lunsEnabled *bool) *ConsistencyGroupGetParams {
	o.SetLunsEnabled(lunsEnabled)
	return o
}

// SetLunsEnabled adds the lunsEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsEnabled(lunsEnabled *bool) {
	o.LunsEnabled = lunsEnabled
}

// WithLunsLunMapsIgroupComment adds the lunsLunMapsIgroupComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupComment(lunsLunMapsIgroupComment *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupComment(lunsLunMapsIgroupComment)
	return o
}

// SetLunsLunMapsIgroupComment adds the lunsLunMapsIgroupComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupComment(lunsLunMapsIgroupComment *string) {
	o.LunsLunMapsIgroupComment = lunsLunMapsIgroupComment
}

// WithLunsLunMapsIgroupIgroupsName adds the lunsLunMapsIgroupIgroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupIgroupsName(lunsLunMapsIgroupIgroupsName *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupIgroupsName(lunsLunMapsIgroupIgroupsName)
	return o
}

// SetLunsLunMapsIgroupIgroupsName adds the lunsLunMapsIgroupIgroupsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupIgroupsName(lunsLunMapsIgroupIgroupsName *string) {
	o.LunsLunMapsIgroupIgroupsName = lunsLunMapsIgroupIgroupsName
}

// WithLunsLunMapsIgroupIgroupsUUID adds the lunsLunMapsIgroupIgroupsUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupIgroupsUUID(lunsLunMapsIgroupIgroupsUUID *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupIgroupsUUID(lunsLunMapsIgroupIgroupsUUID)
	return o
}

// SetLunsLunMapsIgroupIgroupsUUID adds the lunsLunMapsIgroupIgroupsUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupIgroupsUUID(lunsLunMapsIgroupIgroupsUUID *string) {
	o.LunsLunMapsIgroupIgroupsUUID = lunsLunMapsIgroupIgroupsUUID
}

// WithLunsLunMapsIgroupInitiatorsComment adds the lunsLunMapsIgroupInitiatorsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupInitiatorsComment(lunsLunMapsIgroupInitiatorsComment *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupInitiatorsComment(lunsLunMapsIgroupInitiatorsComment)
	return o
}

// SetLunsLunMapsIgroupInitiatorsComment adds the lunsLunMapsIgroupInitiatorsComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupInitiatorsComment(lunsLunMapsIgroupInitiatorsComment *string) {
	o.LunsLunMapsIgroupInitiatorsComment = lunsLunMapsIgroupInitiatorsComment
}

// WithLunsLunMapsIgroupInitiatorsName adds the lunsLunMapsIgroupInitiatorsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupInitiatorsName(lunsLunMapsIgroupInitiatorsName *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupInitiatorsName(lunsLunMapsIgroupInitiatorsName)
	return o
}

// SetLunsLunMapsIgroupInitiatorsName adds the lunsLunMapsIgroupInitiatorsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupInitiatorsName(lunsLunMapsIgroupInitiatorsName *string) {
	o.LunsLunMapsIgroupInitiatorsName = lunsLunMapsIgroupInitiatorsName
}

// WithLunsLunMapsIgroupName adds the lunsLunMapsIgroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupName(lunsLunMapsIgroupName *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupName(lunsLunMapsIgroupName)
	return o
}

// SetLunsLunMapsIgroupName adds the lunsLunMapsIgroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupName(lunsLunMapsIgroupName *string) {
	o.LunsLunMapsIgroupName = lunsLunMapsIgroupName
}

// WithLunsLunMapsIgroupOsType adds the lunsLunMapsIgroupOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupOsType(lunsLunMapsIgroupOsType *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupOsType(lunsLunMapsIgroupOsType)
	return o
}

// SetLunsLunMapsIgroupOsType adds the lunsLunMapsIgroupOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupOsType(lunsLunMapsIgroupOsType *string) {
	o.LunsLunMapsIgroupOsType = lunsLunMapsIgroupOsType
}

// WithLunsLunMapsIgroupProtocol adds the lunsLunMapsIgroupProtocol to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupProtocol(lunsLunMapsIgroupProtocol *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupProtocol(lunsLunMapsIgroupProtocol)
	return o
}

// SetLunsLunMapsIgroupProtocol adds the lunsLunMapsIgroupProtocol to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupProtocol(lunsLunMapsIgroupProtocol *string) {
	o.LunsLunMapsIgroupProtocol = lunsLunMapsIgroupProtocol
}

// WithLunsLunMapsIgroupUUID adds the lunsLunMapsIgroupUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsIgroupUUID(lunsLunMapsIgroupUUID *string) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsIgroupUUID(lunsLunMapsIgroupUUID)
	return o
}

// SetLunsLunMapsIgroupUUID adds the lunsLunMapsIgroupUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsIgroupUUID(lunsLunMapsIgroupUUID *string) {
	o.LunsLunMapsIgroupUUID = lunsLunMapsIgroupUUID
}

// WithLunsLunMapsLogicalUnitNumber adds the lunsLunMapsLogicalUnitNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsLunMapsLogicalUnitNumber(lunsLunMapsLogicalUnitNumber *int64) *ConsistencyGroupGetParams {
	o.SetLunsLunMapsLogicalUnitNumber(lunsLunMapsLogicalUnitNumber)
	return o
}

// SetLunsLunMapsLogicalUnitNumber adds the lunsLunMapsLogicalUnitNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsLunMapsLogicalUnitNumber(lunsLunMapsLogicalUnitNumber *int64) {
	o.LunsLunMapsLogicalUnitNumber = lunsLunMapsLogicalUnitNumber
}

// WithLunsName adds the lunsName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsName(lunsName *string) *ConsistencyGroupGetParams {
	o.SetLunsName(lunsName)
	return o
}

// SetLunsName adds the lunsName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsName(lunsName *string) {
	o.LunsName = lunsName
}

// WithLunsOsType adds the lunsOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsOsType(lunsOsType *string) *ConsistencyGroupGetParams {
	o.SetLunsOsType(lunsOsType)
	return o
}

// SetLunsOsType adds the lunsOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsOsType(lunsOsType *string) {
	o.LunsOsType = lunsOsType
}

// WithLunsQosPolicyMaxThroughputIops adds the lunsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyMaxThroughputIops(lunsQosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyMaxThroughputIops(lunsQosPolicyMaxThroughputIops)
	return o
}

// SetLunsQosPolicyMaxThroughputIops adds the lunsQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyMaxThroughputIops(lunsQosPolicyMaxThroughputIops *int64) {
	o.LunsQosPolicyMaxThroughputIops = lunsQosPolicyMaxThroughputIops
}

// WithLunsQosPolicyMaxThroughputMbps adds the lunsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyMaxThroughputMbps(lunsQosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyMaxThroughputMbps(lunsQosPolicyMaxThroughputMbps)
	return o
}

// SetLunsQosPolicyMaxThroughputMbps adds the lunsQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyMaxThroughputMbps(lunsQosPolicyMaxThroughputMbps *int64) {
	o.LunsQosPolicyMaxThroughputMbps = lunsQosPolicyMaxThroughputMbps
}

// WithLunsQosPolicyMinThroughputIops adds the lunsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyMinThroughputIops(lunsQosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyMinThroughputIops(lunsQosPolicyMinThroughputIops)
	return o
}

// SetLunsQosPolicyMinThroughputIops adds the lunsQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyMinThroughputIops(lunsQosPolicyMinThroughputIops *int64) {
	o.LunsQosPolicyMinThroughputIops = lunsQosPolicyMinThroughputIops
}

// WithLunsQosPolicyMinThroughputMbps adds the lunsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyMinThroughputMbps(lunsQosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyMinThroughputMbps(lunsQosPolicyMinThroughputMbps)
	return o
}

// SetLunsQosPolicyMinThroughputMbps adds the lunsQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyMinThroughputMbps(lunsQosPolicyMinThroughputMbps *int64) {
	o.LunsQosPolicyMinThroughputMbps = lunsQosPolicyMinThroughputMbps
}

// WithLunsQosPolicyName adds the lunsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyName(lunsQosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyName(lunsQosPolicyName)
	return o
}

// SetLunsQosPolicyName adds the lunsQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyName(lunsQosPolicyName *string) {
	o.LunsQosPolicyName = lunsQosPolicyName
}

// WithLunsQosPolicyUUID adds the lunsQosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsQosPolicyUUID(lunsQosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetLunsQosPolicyUUID(lunsQosPolicyUUID)
	return o
}

// SetLunsQosPolicyUUID adds the lunsQosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsQosPolicyUUID(lunsQosPolicyUUID *string) {
	o.LunsQosPolicyUUID = lunsQosPolicyUUID
}

// WithLunsSerialNumber adds the lunsSerialNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsSerialNumber(lunsSerialNumber *string) *ConsistencyGroupGetParams {
	o.SetLunsSerialNumber(lunsSerialNumber)
	return o
}

// SetLunsSerialNumber adds the lunsSerialNumber to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsSerialNumber(lunsSerialNumber *string) {
	o.LunsSerialNumber = lunsSerialNumber
}

// WithLunsSpaceGuaranteeRequested adds the lunsSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsSpaceGuaranteeRequested(lunsSpaceGuaranteeRequested *bool) *ConsistencyGroupGetParams {
	o.SetLunsSpaceGuaranteeRequested(lunsSpaceGuaranteeRequested)
	return o
}

// SetLunsSpaceGuaranteeRequested adds the lunsSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsSpaceGuaranteeRequested(lunsSpaceGuaranteeRequested *bool) {
	o.LunsSpaceGuaranteeRequested = lunsSpaceGuaranteeRequested
}

// WithLunsSpaceGuaranteeReserved adds the lunsSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsSpaceGuaranteeReserved(lunsSpaceGuaranteeReserved *bool) *ConsistencyGroupGetParams {
	o.SetLunsSpaceGuaranteeReserved(lunsSpaceGuaranteeReserved)
	return o
}

// SetLunsSpaceGuaranteeReserved adds the lunsSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsSpaceGuaranteeReserved(lunsSpaceGuaranteeReserved *bool) {
	o.LunsSpaceGuaranteeReserved = lunsSpaceGuaranteeReserved
}

// WithLunsSpaceSize adds the lunsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsSpaceSize(lunsSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetLunsSpaceSize(lunsSpaceSize)
	return o
}

// SetLunsSpaceSize adds the lunsSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsSpaceSize(lunsSpaceSize *int64) {
	o.LunsSpaceSize = lunsSpaceSize
}

// WithLunsSpaceUsed adds the lunsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsSpaceUsed(lunsSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetLunsSpaceUsed(lunsSpaceUsed)
	return o
}

// SetLunsSpaceUsed adds the lunsSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsSpaceUsed(lunsSpaceUsed *int64) {
	o.LunsSpaceUsed = lunsSpaceUsed
}

// WithLunsUUID adds the lunsUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithLunsUUID(lunsUUID *string) *ConsistencyGroupGetParams {
	o.SetLunsUUID(lunsUUID)
	return o
}

// SetLunsUUID adds the lunsUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetLunsUUID(lunsUUID *string) {
	o.LunsUUID = lunsUUID
}

// WithMaxRecords adds the maxRecords to the consistency group get params
func (o *ConsistencyGroupGetParams) WithMaxRecords(maxRecords *int64) *ConsistencyGroupGetParams {
	o.SetMaxRecords(maxRecords)
	return o
}

// SetMaxRecords adds the maxRecords to the consistency group get params
func (o *ConsistencyGroupGetParams) SetMaxRecords(maxRecords *int64) {
	o.MaxRecords = maxRecords
}

// WithName adds the name to the consistency group get params
func (o *ConsistencyGroupGetParams) WithName(name *string) *ConsistencyGroupGetParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the consistency group get params
func (o *ConsistencyGroupGetParams) SetName(name *string) {
	o.Name = name
}

// WithNamespacesAutoDelete adds the namespacesAutoDelete to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesAutoDelete(namespacesAutoDelete *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesAutoDelete(namespacesAutoDelete)
	return o
}

// SetNamespacesAutoDelete adds the namespacesAutoDelete to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesAutoDelete(namespacesAutoDelete *bool) {
	o.NamespacesAutoDelete = namespacesAutoDelete
}

// WithNamespacesComment adds the namespacesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesComment(namespacesComment *string) *ConsistencyGroupGetParams {
	o.SetNamespacesComment(namespacesComment)
	return o
}

// SetNamespacesComment adds the namespacesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesComment(namespacesComment *string) {
	o.NamespacesComment = namespacesComment
}

// WithNamespacesCreateTime adds the namespacesCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesCreateTime(namespacesCreateTime *string) *ConsistencyGroupGetParams {
	o.SetNamespacesCreateTime(namespacesCreateTime)
	return o
}

// SetNamespacesCreateTime adds the namespacesCreateTime to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesCreateTime(namespacesCreateTime *string) {
	o.NamespacesCreateTime = namespacesCreateTime
}

// WithNamespacesEnabled adds the namespacesEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesEnabled(namespacesEnabled *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesEnabled(namespacesEnabled)
	return o
}

// SetNamespacesEnabled adds the namespacesEnabled to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesEnabled(namespacesEnabled *bool) {
	o.NamespacesEnabled = namespacesEnabled
}

// WithNamespacesName adds the namespacesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesName(namespacesName *string) *ConsistencyGroupGetParams {
	o.SetNamespacesName(namespacesName)
	return o
}

// SetNamespacesName adds the namespacesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesName(namespacesName *string) {
	o.NamespacesName = namespacesName
}

// WithNamespacesOsType adds the namespacesOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesOsType(namespacesOsType *string) *ConsistencyGroupGetParams {
	o.SetNamespacesOsType(namespacesOsType)
	return o
}

// SetNamespacesOsType adds the namespacesOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesOsType(namespacesOsType *string) {
	o.NamespacesOsType = namespacesOsType
}

// WithNamespacesSpaceBlockSize adds the namespacesSpaceBlockSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSpaceBlockSize(namespacesSpaceBlockSize *int64) *ConsistencyGroupGetParams {
	o.SetNamespacesSpaceBlockSize(namespacesSpaceBlockSize)
	return o
}

// SetNamespacesSpaceBlockSize adds the namespacesSpaceBlockSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSpaceBlockSize(namespacesSpaceBlockSize *int64) {
	o.NamespacesSpaceBlockSize = namespacesSpaceBlockSize
}

// WithNamespacesSpaceGuaranteeRequested adds the namespacesSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSpaceGuaranteeRequested(namespacesSpaceGuaranteeRequested *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesSpaceGuaranteeRequested(namespacesSpaceGuaranteeRequested)
	return o
}

// SetNamespacesSpaceGuaranteeRequested adds the namespacesSpaceGuaranteeRequested to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSpaceGuaranteeRequested(namespacesSpaceGuaranteeRequested *bool) {
	o.NamespacesSpaceGuaranteeRequested = namespacesSpaceGuaranteeRequested
}

// WithNamespacesSpaceGuaranteeReserved adds the namespacesSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSpaceGuaranteeReserved(namespacesSpaceGuaranteeReserved *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesSpaceGuaranteeReserved(namespacesSpaceGuaranteeReserved)
	return o
}

// SetNamespacesSpaceGuaranteeReserved adds the namespacesSpaceGuaranteeReserved to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSpaceGuaranteeReserved(namespacesSpaceGuaranteeReserved *bool) {
	o.NamespacesSpaceGuaranteeReserved = namespacesSpaceGuaranteeReserved
}

// WithNamespacesSpaceSize adds the namespacesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSpaceSize(namespacesSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetNamespacesSpaceSize(namespacesSpaceSize)
	return o
}

// SetNamespacesSpaceSize adds the namespacesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSpaceSize(namespacesSpaceSize *int64) {
	o.NamespacesSpaceSize = namespacesSpaceSize
}

// WithNamespacesSpaceUsed adds the namespacesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSpaceUsed(namespacesSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetNamespacesSpaceUsed(namespacesSpaceUsed)
	return o
}

// SetNamespacesSpaceUsed adds the namespacesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSpaceUsed(namespacesSpaceUsed *int64) {
	o.NamespacesSpaceUsed = namespacesSpaceUsed
}

// WithNamespacesStatusContainerState adds the namespacesStatusContainerState to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesStatusContainerState(namespacesStatusContainerState *string) *ConsistencyGroupGetParams {
	o.SetNamespacesStatusContainerState(namespacesStatusContainerState)
	return o
}

// SetNamespacesStatusContainerState adds the namespacesStatusContainerState to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesStatusContainerState(namespacesStatusContainerState *string) {
	o.NamespacesStatusContainerState = namespacesStatusContainerState
}

// WithNamespacesStatusMapped adds the namespacesStatusMapped to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesStatusMapped(namespacesStatusMapped *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesStatusMapped(namespacesStatusMapped)
	return o
}

// SetNamespacesStatusMapped adds the namespacesStatusMapped to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesStatusMapped(namespacesStatusMapped *bool) {
	o.NamespacesStatusMapped = namespacesStatusMapped
}

// WithNamespacesStatusReadOnly adds the namespacesStatusReadOnly to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesStatusReadOnly(namespacesStatusReadOnly *bool) *ConsistencyGroupGetParams {
	o.SetNamespacesStatusReadOnly(namespacesStatusReadOnly)
	return o
}

// SetNamespacesStatusReadOnly adds the namespacesStatusReadOnly to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesStatusReadOnly(namespacesStatusReadOnly *bool) {
	o.NamespacesStatusReadOnly = namespacesStatusReadOnly
}

// WithNamespacesStatusState adds the namespacesStatusState to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesStatusState(namespacesStatusState *string) *ConsistencyGroupGetParams {
	o.SetNamespacesStatusState(namespacesStatusState)
	return o
}

// SetNamespacesStatusState adds the namespacesStatusState to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesStatusState(namespacesStatusState *string) {
	o.NamespacesStatusState = namespacesStatusState
}

// WithNamespacesSubsystemMapAnagrpid adds the namespacesSubsystemMapAnagrpid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapAnagrpid(namespacesSubsystemMapAnagrpid *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapAnagrpid(namespacesSubsystemMapAnagrpid)
	return o
}

// SetNamespacesSubsystemMapAnagrpid adds the namespacesSubsystemMapAnagrpid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapAnagrpid(namespacesSubsystemMapAnagrpid *string) {
	o.NamespacesSubsystemMapAnagrpid = namespacesSubsystemMapAnagrpid
}

// WithNamespacesSubsystemMapNsid adds the namespacesSubsystemMapNsid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapNsid(namespacesSubsystemMapNsid *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapNsid(namespacesSubsystemMapNsid)
	return o
}

// SetNamespacesSubsystemMapNsid adds the namespacesSubsystemMapNsid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapNsid(namespacesSubsystemMapNsid *string) {
	o.NamespacesSubsystemMapNsid = namespacesSubsystemMapNsid
}

// WithNamespacesSubsystemMapSubsystemComment adds the namespacesSubsystemMapSubsystemComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapSubsystemComment(namespacesSubsystemMapSubsystemComment *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapSubsystemComment(namespacesSubsystemMapSubsystemComment)
	return o
}

// SetNamespacesSubsystemMapSubsystemComment adds the namespacesSubsystemMapSubsystemComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapSubsystemComment(namespacesSubsystemMapSubsystemComment *string) {
	o.NamespacesSubsystemMapSubsystemComment = namespacesSubsystemMapSubsystemComment
}

// WithNamespacesSubsystemMapSubsystemHostsNqn adds the namespacesSubsystemMapSubsystemHostsNqn to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapSubsystemHostsNqn(namespacesSubsystemMapSubsystemHostsNqn *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapSubsystemHostsNqn(namespacesSubsystemMapSubsystemHostsNqn)
	return o
}

// SetNamespacesSubsystemMapSubsystemHostsNqn adds the namespacesSubsystemMapSubsystemHostsNqn to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapSubsystemHostsNqn(namespacesSubsystemMapSubsystemHostsNqn *string) {
	o.NamespacesSubsystemMapSubsystemHostsNqn = namespacesSubsystemMapSubsystemHostsNqn
}

// WithNamespacesSubsystemMapSubsystemName adds the namespacesSubsystemMapSubsystemName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapSubsystemName(namespacesSubsystemMapSubsystemName *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapSubsystemName(namespacesSubsystemMapSubsystemName)
	return o
}

// SetNamespacesSubsystemMapSubsystemName adds the namespacesSubsystemMapSubsystemName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapSubsystemName(namespacesSubsystemMapSubsystemName *string) {
	o.NamespacesSubsystemMapSubsystemName = namespacesSubsystemMapSubsystemName
}

// WithNamespacesSubsystemMapSubsystemOsType adds the namespacesSubsystemMapSubsystemOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapSubsystemOsType(namespacesSubsystemMapSubsystemOsType *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapSubsystemOsType(namespacesSubsystemMapSubsystemOsType)
	return o
}

// SetNamespacesSubsystemMapSubsystemOsType adds the namespacesSubsystemMapSubsystemOsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapSubsystemOsType(namespacesSubsystemMapSubsystemOsType *string) {
	o.NamespacesSubsystemMapSubsystemOsType = namespacesSubsystemMapSubsystemOsType
}

// WithNamespacesSubsystemMapSubsystemUUID adds the namespacesSubsystemMapSubsystemUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesSubsystemMapSubsystemUUID(namespacesSubsystemMapSubsystemUUID *string) *ConsistencyGroupGetParams {
	o.SetNamespacesSubsystemMapSubsystemUUID(namespacesSubsystemMapSubsystemUUID)
	return o
}

// SetNamespacesSubsystemMapSubsystemUUID adds the namespacesSubsystemMapSubsystemUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesSubsystemMapSubsystemUUID(namespacesSubsystemMapSubsystemUUID *string) {
	o.NamespacesSubsystemMapSubsystemUUID = namespacesSubsystemMapSubsystemUUID
}

// WithNamespacesUUID adds the namespacesUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithNamespacesUUID(namespacesUUID *string) *ConsistencyGroupGetParams {
	o.SetNamespacesUUID(namespacesUUID)
	return o
}

// SetNamespacesUUID adds the namespacesUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetNamespacesUUID(namespacesUUID *string) {
	o.NamespacesUUID = namespacesUUID
}

// WithOrderBy adds the orderBy to the consistency group get params
func (o *ConsistencyGroupGetParams) WithOrderBy(orderBy []string) *ConsistencyGroupGetParams {
	o.SetOrderBy(orderBy)
	return o
}

// SetOrderBy adds the orderBy to the consistency group get params
func (o *ConsistencyGroupGetParams) SetOrderBy(orderBy []string) {
	o.OrderBy = orderBy
}

// WithParentConsistencyGroupName adds the parentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithParentConsistencyGroupName(parentConsistencyGroupName *string) *ConsistencyGroupGetParams {
	o.SetParentConsistencyGroupName(parentConsistencyGroupName)
	return o
}

// SetParentConsistencyGroupName adds the parentConsistencyGroupName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetParentConsistencyGroupName(parentConsistencyGroupName *string) {
	o.ParentConsistencyGroupName = parentConsistencyGroupName
}

// WithParentConsistencyGroupUUID adds the parentConsistencyGroupUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithParentConsistencyGroupUUID(parentConsistencyGroupUUID *string) *ConsistencyGroupGetParams {
	o.SetParentConsistencyGroupUUID(parentConsistencyGroupUUID)
	return o
}

// SetParentConsistencyGroupUUID adds the parentConsistencyGroupUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetParentConsistencyGroupUUID(parentConsistencyGroupUUID *string) {
	o.ParentConsistencyGroupUUID = parentConsistencyGroupUUID
}

// WithQosPolicyMaxThroughputIops adds the qosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops)
	return o
}

// SetQosPolicyMaxThroughputIops adds the qosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyMaxThroughputIops(qosPolicyMaxThroughputIops *int64) {
	o.QosPolicyMaxThroughputIops = qosPolicyMaxThroughputIops
}

// WithQosPolicyMaxThroughputMbps adds the qosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps)
	return o
}

// SetQosPolicyMaxThroughputMbps adds the qosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyMaxThroughputMbps(qosPolicyMaxThroughputMbps *int64) {
	o.QosPolicyMaxThroughputMbps = qosPolicyMaxThroughputMbps
}

// WithQosPolicyMinThroughputIops adds the qosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyMinThroughputIops(qosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetQosPolicyMinThroughputIops(qosPolicyMinThroughputIops)
	return o
}

// SetQosPolicyMinThroughputIops adds the qosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyMinThroughputIops(qosPolicyMinThroughputIops *int64) {
	o.QosPolicyMinThroughputIops = qosPolicyMinThroughputIops
}

// WithQosPolicyMinThroughputMbps adds the qosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyMinThroughputMbps(qosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetQosPolicyMinThroughputMbps(qosPolicyMinThroughputMbps)
	return o
}

// SetQosPolicyMinThroughputMbps adds the qosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyMinThroughputMbps(qosPolicyMinThroughputMbps *int64) {
	o.QosPolicyMinThroughputMbps = qosPolicyMinThroughputMbps
}

// WithQosPolicyName adds the qosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyName(qosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetQosPolicyName(qosPolicyName)
	return o
}

// SetQosPolicyName adds the qosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyName(qosPolicyName *string) {
	o.QosPolicyName = qosPolicyName
}

// WithQosPolicyUUID adds the qosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithQosPolicyUUID(qosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetQosPolicyUUID(qosPolicyUUID)
	return o
}

// SetQosPolicyUUID adds the qosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetQosPolicyUUID(qosPolicyUUID *string) {
	o.QosPolicyUUID = qosPolicyUUID
}

// WithReplicated adds the replicated to the consistency group get params
func (o *ConsistencyGroupGetParams) WithReplicated(replicated *bool) *ConsistencyGroupGetParams {
	o.SetReplicated(replicated)
	return o
}

// SetReplicated adds the replicated to the consistency group get params
func (o *ConsistencyGroupGetParams) SetReplicated(replicated *bool) {
	o.Replicated = replicated
}

// WithReplicationSource adds the replicationSource to the consistency group get params
func (o *ConsistencyGroupGetParams) WithReplicationSource(replicationSource *bool) *ConsistencyGroupGetParams {
	o.SetReplicationSource(replicationSource)
	return o
}

// SetReplicationSource adds the replicationSource to the consistency group get params
func (o *ConsistencyGroupGetParams) SetReplicationSource(replicationSource *bool) {
	o.ReplicationSource = replicationSource
}

// WithReturnRecords adds the returnRecords to the consistency group get params
func (o *ConsistencyGroupGetParams) WithReturnRecords(returnRecords *bool) *ConsistencyGroupGetParams {
	o.SetReturnRecords(returnRecords)
	return o
}

// SetReturnRecords adds the returnRecords to the consistency group get params
func (o *ConsistencyGroupGetParams) SetReturnRecords(returnRecords *bool) {
	o.ReturnRecords = returnRecords
}

// WithReturnTimeout adds the returnTimeout to the consistency group get params
func (o *ConsistencyGroupGetParams) WithReturnTimeout(returnTimeout *int64) *ConsistencyGroupGetParams {
	o.SetReturnTimeout(returnTimeout)
	return o
}

// SetReturnTimeout adds the returnTimeout to the consistency group get params
func (o *ConsistencyGroupGetParams) SetReturnTimeout(returnTimeout *int64) {
	o.ReturnTimeout = returnTimeout
}

// WithSnapshotPolicyName adds the snapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSnapshotPolicyName(snapshotPolicyName *string) *ConsistencyGroupGetParams {
	o.SetSnapshotPolicyName(snapshotPolicyName)
	return o
}

// SetSnapshotPolicyName adds the snapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSnapshotPolicyName(snapshotPolicyName *string) {
	o.SnapshotPolicyName = snapshotPolicyName
}

// WithSnapshotPolicyUUID adds the snapshotPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSnapshotPolicyUUID(snapshotPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetSnapshotPolicyUUID(snapshotPolicyUUID)
	return o
}

// SetSnapshotPolicyUUID adds the snapshotPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSnapshotPolicyUUID(snapshotPolicyUUID *string) {
	o.SnapshotPolicyUUID = snapshotPolicyUUID
}

// WithSpaceAvailable adds the spaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSpaceAvailable(spaceAvailable *int64) *ConsistencyGroupGetParams {
	o.SetSpaceAvailable(spaceAvailable)
	return o
}

// SetSpaceAvailable adds the spaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSpaceAvailable(spaceAvailable *int64) {
	o.SpaceAvailable = spaceAvailable
}

// WithSpaceSize adds the spaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSpaceSize(spaceSize *int64) *ConsistencyGroupGetParams {
	o.SetSpaceSize(spaceSize)
	return o
}

// SetSpaceSize adds the spaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSpaceSize(spaceSize *int64) {
	o.SpaceSize = spaceSize
}

// WithSpaceUsed adds the spaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSpaceUsed(spaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetSpaceUsed(spaceUsed)
	return o
}

// SetSpaceUsed adds the spaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSpaceUsed(spaceUsed *int64) {
	o.SpaceUsed = spaceUsed
}

// WithSvmName adds the svmName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSvmName(svmName *string) *ConsistencyGroupGetParams {
	o.SetSvmName(svmName)
	return o
}

// SetSvmName adds the svmName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSvmName(svmName *string) {
	o.SvmName = svmName
}

// WithSvmUUID adds the svmUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithSvmUUID(svmUUID *string) *ConsistencyGroupGetParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetSvmUUID(svmUUID *string) {
	o.SvmUUID = svmUUID
}

// WithTieringPolicy adds the tieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) WithTieringPolicy(tieringPolicy *string) *ConsistencyGroupGetParams {
	o.SetTieringPolicy(tieringPolicy)
	return o
}

// SetTieringPolicy adds the tieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) SetTieringPolicy(tieringPolicy *string) {
	o.TieringPolicy = tieringPolicy
}

// WithUUID adds the uuid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithUUID(uuid string) *ConsistencyGroupGetParams {
	o.SetUUID(uuid)
	return o
}

// SetUUID adds the uuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetUUID(uuid string) {
	o.UUID = uuid
}

// WithVolumesComment adds the volumesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesComment(volumesComment *string) *ConsistencyGroupGetParams {
	o.SetVolumesComment(volumesComment)
	return o
}

// SetVolumesComment adds the volumesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesComment(volumesComment *string) {
	o.VolumesComment = volumesComment
}

// WithVolumesLanguage adds the volumesLanguage to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesLanguage(volumesLanguage *string) *ConsistencyGroupGetParams {
	o.SetVolumesLanguage(volumesLanguage)
	return o
}

// SetVolumesLanguage adds the volumesLanguage to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesLanguage(volumesLanguage *string) {
	o.VolumesLanguage = volumesLanguage
}

// WithVolumesName adds the volumesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesName(volumesName *string) *ConsistencyGroupGetParams {
	o.SetVolumesName(volumesName)
	return o
}

// SetVolumesName adds the volumesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesName(volumesName *string) {
	o.VolumesName = volumesName
}

// WithVolumesNasCifsSharesAccessBasedEnumeration adds the volumesNasCifsSharesAccessBasedEnumeration to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesAccessBasedEnumeration(volumesNasCifsSharesAccessBasedEnumeration *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesAccessBasedEnumeration(volumesNasCifsSharesAccessBasedEnumeration)
	return o
}

// SetVolumesNasCifsSharesAccessBasedEnumeration adds the volumesNasCifsSharesAccessBasedEnumeration to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesAccessBasedEnumeration(volumesNasCifsSharesAccessBasedEnumeration *bool) {
	o.VolumesNasCifsSharesAccessBasedEnumeration = volumesNasCifsSharesAccessBasedEnumeration
}

// WithVolumesNasCifsSharesAclsPermission adds the volumesNasCifsSharesAclsPermission to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesAclsPermission(volumesNasCifsSharesAclsPermission *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesAclsPermission(volumesNasCifsSharesAclsPermission)
	return o
}

// SetVolumesNasCifsSharesAclsPermission adds the volumesNasCifsSharesAclsPermission to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesAclsPermission(volumesNasCifsSharesAclsPermission *string) {
	o.VolumesNasCifsSharesAclsPermission = volumesNasCifsSharesAclsPermission
}

// WithVolumesNasCifsSharesAclsType adds the volumesNasCifsSharesAclsType to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesAclsType(volumesNasCifsSharesAclsType *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesAclsType(volumesNasCifsSharesAclsType)
	return o
}

// SetVolumesNasCifsSharesAclsType adds the volumesNasCifsSharesAclsType to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesAclsType(volumesNasCifsSharesAclsType *string) {
	o.VolumesNasCifsSharesAclsType = volumesNasCifsSharesAclsType
}

// WithVolumesNasCifsSharesAclsUserOrGroup adds the volumesNasCifsSharesAclsUserOrGroup to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesAclsUserOrGroup(volumesNasCifsSharesAclsUserOrGroup *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesAclsUserOrGroup(volumesNasCifsSharesAclsUserOrGroup)
	return o
}

// SetVolumesNasCifsSharesAclsUserOrGroup adds the volumesNasCifsSharesAclsUserOrGroup to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesAclsUserOrGroup(volumesNasCifsSharesAclsUserOrGroup *string) {
	o.VolumesNasCifsSharesAclsUserOrGroup = volumesNasCifsSharesAclsUserOrGroup
}

// WithVolumesNasCifsSharesAllowUnencryptedAccess adds the volumesNasCifsSharesAllowUnencryptedAccess to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesAllowUnencryptedAccess(volumesNasCifsSharesAllowUnencryptedAccess *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesAllowUnencryptedAccess(volumesNasCifsSharesAllowUnencryptedAccess)
	return o
}

// SetVolumesNasCifsSharesAllowUnencryptedAccess adds the volumesNasCifsSharesAllowUnencryptedAccess to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesAllowUnencryptedAccess(volumesNasCifsSharesAllowUnencryptedAccess *bool) {
	o.VolumesNasCifsSharesAllowUnencryptedAccess = volumesNasCifsSharesAllowUnencryptedAccess
}

// WithVolumesNasCifsSharesChangeNotify adds the volumesNasCifsSharesChangeNotify to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesChangeNotify(volumesNasCifsSharesChangeNotify *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesChangeNotify(volumesNasCifsSharesChangeNotify)
	return o
}

// SetVolumesNasCifsSharesChangeNotify adds the volumesNasCifsSharesChangeNotify to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesChangeNotify(volumesNasCifsSharesChangeNotify *bool) {
	o.VolumesNasCifsSharesChangeNotify = volumesNasCifsSharesChangeNotify
}

// WithVolumesNasCifsSharesComment adds the volumesNasCifsSharesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesComment(volumesNasCifsSharesComment *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesComment(volumesNasCifsSharesComment)
	return o
}

// SetVolumesNasCifsSharesComment adds the volumesNasCifsSharesComment to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesComment(volumesNasCifsSharesComment *string) {
	o.VolumesNasCifsSharesComment = volumesNasCifsSharesComment
}

// WithVolumesNasCifsSharesContinuouslyAvailable adds the volumesNasCifsSharesContinuouslyAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesContinuouslyAvailable(volumesNasCifsSharesContinuouslyAvailable *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesContinuouslyAvailable(volumesNasCifsSharesContinuouslyAvailable)
	return o
}

// SetVolumesNasCifsSharesContinuouslyAvailable adds the volumesNasCifsSharesContinuouslyAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesContinuouslyAvailable(volumesNasCifsSharesContinuouslyAvailable *bool) {
	o.VolumesNasCifsSharesContinuouslyAvailable = volumesNasCifsSharesContinuouslyAvailable
}

// WithVolumesNasCifsSharesDirUmask adds the volumesNasCifsSharesDirUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesDirUmask(volumesNasCifsSharesDirUmask *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesDirUmask(volumesNasCifsSharesDirUmask)
	return o
}

// SetVolumesNasCifsSharesDirUmask adds the volumesNasCifsSharesDirUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesDirUmask(volumesNasCifsSharesDirUmask *int64) {
	o.VolumesNasCifsSharesDirUmask = volumesNasCifsSharesDirUmask
}

// WithVolumesNasCifsSharesEncryption adds the volumesNasCifsSharesEncryption to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesEncryption(volumesNasCifsSharesEncryption *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesEncryption(volumesNasCifsSharesEncryption)
	return o
}

// SetVolumesNasCifsSharesEncryption adds the volumesNasCifsSharesEncryption to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesEncryption(volumesNasCifsSharesEncryption *bool) {
	o.VolumesNasCifsSharesEncryption = volumesNasCifsSharesEncryption
}

// WithVolumesNasCifsSharesFileUmask adds the volumesNasCifsSharesFileUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesFileUmask(volumesNasCifsSharesFileUmask *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesFileUmask(volumesNasCifsSharesFileUmask)
	return o
}

// SetVolumesNasCifsSharesFileUmask adds the volumesNasCifsSharesFileUmask to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesFileUmask(volumesNasCifsSharesFileUmask *int64) {
	o.VolumesNasCifsSharesFileUmask = volumesNasCifsSharesFileUmask
}

// WithVolumesNasCifsSharesHomeDirectory adds the volumesNasCifsSharesHomeDirectory to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesHomeDirectory(volumesNasCifsSharesHomeDirectory *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesHomeDirectory(volumesNasCifsSharesHomeDirectory)
	return o
}

// SetVolumesNasCifsSharesHomeDirectory adds the volumesNasCifsSharesHomeDirectory to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesHomeDirectory(volumesNasCifsSharesHomeDirectory *bool) {
	o.VolumesNasCifsSharesHomeDirectory = volumesNasCifsSharesHomeDirectory
}

// WithVolumesNasCifsSharesName adds the volumesNasCifsSharesName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesName(volumesNasCifsSharesName *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesName(volumesNasCifsSharesName)
	return o
}

// SetVolumesNasCifsSharesName adds the volumesNasCifsSharesName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesName(volumesNasCifsSharesName *string) {
	o.VolumesNasCifsSharesName = volumesNasCifsSharesName
}

// WithVolumesNasCifsSharesNamespaceCaching adds the volumesNasCifsSharesNamespaceCaching to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesNamespaceCaching(volumesNasCifsSharesNamespaceCaching *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesNamespaceCaching(volumesNasCifsSharesNamespaceCaching)
	return o
}

// SetVolumesNasCifsSharesNamespaceCaching adds the volumesNasCifsSharesNamespaceCaching to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesNamespaceCaching(volumesNasCifsSharesNamespaceCaching *bool) {
	o.VolumesNasCifsSharesNamespaceCaching = volumesNasCifsSharesNamespaceCaching
}

// WithVolumesNasCifsSharesNoStrictSecurity adds the volumesNasCifsSharesNoStrictSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesNoStrictSecurity(volumesNasCifsSharesNoStrictSecurity *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesNoStrictSecurity(volumesNasCifsSharesNoStrictSecurity)
	return o
}

// SetVolumesNasCifsSharesNoStrictSecurity adds the volumesNasCifsSharesNoStrictSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesNoStrictSecurity(volumesNasCifsSharesNoStrictSecurity *bool) {
	o.VolumesNasCifsSharesNoStrictSecurity = volumesNasCifsSharesNoStrictSecurity
}

// WithVolumesNasCifsSharesOfflineFiles adds the volumesNasCifsSharesOfflineFiles to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesOfflineFiles(volumesNasCifsSharesOfflineFiles *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesOfflineFiles(volumesNasCifsSharesOfflineFiles)
	return o
}

// SetVolumesNasCifsSharesOfflineFiles adds the volumesNasCifsSharesOfflineFiles to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesOfflineFiles(volumesNasCifsSharesOfflineFiles *string) {
	o.VolumesNasCifsSharesOfflineFiles = volumesNasCifsSharesOfflineFiles
}

// WithVolumesNasCifsSharesOplocks adds the volumesNasCifsSharesOplocks to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesOplocks(volumesNasCifsSharesOplocks *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesOplocks(volumesNasCifsSharesOplocks)
	return o
}

// SetVolumesNasCifsSharesOplocks adds the volumesNasCifsSharesOplocks to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesOplocks(volumesNasCifsSharesOplocks *bool) {
	o.VolumesNasCifsSharesOplocks = volumesNasCifsSharesOplocks
}

// WithVolumesNasCifsSharesShowSnapshot adds the volumesNasCifsSharesShowSnapshot to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesShowSnapshot(volumesNasCifsSharesShowSnapshot *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesShowSnapshot(volumesNasCifsSharesShowSnapshot)
	return o
}

// SetVolumesNasCifsSharesShowSnapshot adds the volumesNasCifsSharesShowSnapshot to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesShowSnapshot(volumesNasCifsSharesShowSnapshot *bool) {
	o.VolumesNasCifsSharesShowSnapshot = volumesNasCifsSharesShowSnapshot
}

// WithVolumesNasCifsSharesUnixSymlink adds the volumesNasCifsSharesUnixSymlink to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesUnixSymlink(volumesNasCifsSharesUnixSymlink *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesUnixSymlink(volumesNasCifsSharesUnixSymlink)
	return o
}

// SetVolumesNasCifsSharesUnixSymlink adds the volumesNasCifsSharesUnixSymlink to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesUnixSymlink(volumesNasCifsSharesUnixSymlink *string) {
	o.VolumesNasCifsSharesUnixSymlink = volumesNasCifsSharesUnixSymlink
}

// WithVolumesNasCifsSharesVscanProfile adds the volumesNasCifsSharesVscanProfile to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasCifsSharesVscanProfile(volumesNasCifsSharesVscanProfile *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasCifsSharesVscanProfile(volumesNasCifsSharesVscanProfile)
	return o
}

// SetVolumesNasCifsSharesVscanProfile adds the volumesNasCifsSharesVscanProfile to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasCifsSharesVscanProfile(volumesNasCifsSharesVscanProfile *string) {
	o.VolumesNasCifsSharesVscanProfile = volumesNasCifsSharesVscanProfile
}

// WithVolumesNasExportPolicyName adds the volumesNasExportPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyName(volumesNasExportPolicyName *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyName(volumesNasExportPolicyName)
	return o
}

// SetVolumesNasExportPolicyName adds the volumesNasExportPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyName(volumesNasExportPolicyName *string) {
	o.VolumesNasExportPolicyName = volumesNasExportPolicyName
}

// WithVolumesNasExportPolicyRulesAllowDeviceCreation adds the volumesNasExportPolicyRulesAllowDeviceCreation to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesAllowDeviceCreation(volumesNasExportPolicyRulesAllowDeviceCreation *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesAllowDeviceCreation(volumesNasExportPolicyRulesAllowDeviceCreation)
	return o
}

// SetVolumesNasExportPolicyRulesAllowDeviceCreation adds the volumesNasExportPolicyRulesAllowDeviceCreation to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesAllowDeviceCreation(volumesNasExportPolicyRulesAllowDeviceCreation *bool) {
	o.VolumesNasExportPolicyRulesAllowDeviceCreation = volumesNasExportPolicyRulesAllowDeviceCreation
}

// WithVolumesNasExportPolicyRulesAllowSuid adds the volumesNasExportPolicyRulesAllowSuid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesAllowSuid(volumesNasExportPolicyRulesAllowSuid *bool) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesAllowSuid(volumesNasExportPolicyRulesAllowSuid)
	return o
}

// SetVolumesNasExportPolicyRulesAllowSuid adds the volumesNasExportPolicyRulesAllowSuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesAllowSuid(volumesNasExportPolicyRulesAllowSuid *bool) {
	o.VolumesNasExportPolicyRulesAllowSuid = volumesNasExportPolicyRulesAllowSuid
}

// WithVolumesNasExportPolicyRulesAnonymousUser adds the volumesNasExportPolicyRulesAnonymousUser to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesAnonymousUser(volumesNasExportPolicyRulesAnonymousUser *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesAnonymousUser(volumesNasExportPolicyRulesAnonymousUser)
	return o
}

// SetVolumesNasExportPolicyRulesAnonymousUser adds the volumesNasExportPolicyRulesAnonymousUser to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesAnonymousUser(volumesNasExportPolicyRulesAnonymousUser *string) {
	o.VolumesNasExportPolicyRulesAnonymousUser = volumesNasExportPolicyRulesAnonymousUser
}

// WithVolumesNasExportPolicyRulesChownMode adds the volumesNasExportPolicyRulesChownMode to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesChownMode(volumesNasExportPolicyRulesChownMode *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesChownMode(volumesNasExportPolicyRulesChownMode)
	return o
}

// SetVolumesNasExportPolicyRulesChownMode adds the volumesNasExportPolicyRulesChownMode to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesChownMode(volumesNasExportPolicyRulesChownMode *string) {
	o.VolumesNasExportPolicyRulesChownMode = volumesNasExportPolicyRulesChownMode
}

// WithVolumesNasExportPolicyRulesClientsMatch adds the volumesNasExportPolicyRulesClientsMatch to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesClientsMatch(volumesNasExportPolicyRulesClientsMatch *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesClientsMatch(volumesNasExportPolicyRulesClientsMatch)
	return o
}

// SetVolumesNasExportPolicyRulesClientsMatch adds the volumesNasExportPolicyRulesClientsMatch to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesClientsMatch(volumesNasExportPolicyRulesClientsMatch *string) {
	o.VolumesNasExportPolicyRulesClientsMatch = volumesNasExportPolicyRulesClientsMatch
}

// WithVolumesNasExportPolicyRulesIndex adds the volumesNasExportPolicyRulesIndex to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesIndex(volumesNasExportPolicyRulesIndex *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesIndex(volumesNasExportPolicyRulesIndex)
	return o
}

// SetVolumesNasExportPolicyRulesIndex adds the volumesNasExportPolicyRulesIndex to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesIndex(volumesNasExportPolicyRulesIndex *int64) {
	o.VolumesNasExportPolicyRulesIndex = volumesNasExportPolicyRulesIndex
}

// WithVolumesNasExportPolicyRulesNtfsUnixSecurity adds the volumesNasExportPolicyRulesNtfsUnixSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesNtfsUnixSecurity(volumesNasExportPolicyRulesNtfsUnixSecurity *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesNtfsUnixSecurity(volumesNasExportPolicyRulesNtfsUnixSecurity)
	return o
}

// SetVolumesNasExportPolicyRulesNtfsUnixSecurity adds the volumesNasExportPolicyRulesNtfsUnixSecurity to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesNtfsUnixSecurity(volumesNasExportPolicyRulesNtfsUnixSecurity *string) {
	o.VolumesNasExportPolicyRulesNtfsUnixSecurity = volumesNasExportPolicyRulesNtfsUnixSecurity
}

// WithVolumesNasExportPolicyRulesProtocols adds the volumesNasExportPolicyRulesProtocols to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesProtocols(volumesNasExportPolicyRulesProtocols *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesProtocols(volumesNasExportPolicyRulesProtocols)
	return o
}

// SetVolumesNasExportPolicyRulesProtocols adds the volumesNasExportPolicyRulesProtocols to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesProtocols(volumesNasExportPolicyRulesProtocols *string) {
	o.VolumesNasExportPolicyRulesProtocols = volumesNasExportPolicyRulesProtocols
}

// WithVolumesNasExportPolicyRulesRoRule adds the volumesNasExportPolicyRulesRoRule to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesRoRule(volumesNasExportPolicyRulesRoRule *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesRoRule(volumesNasExportPolicyRulesRoRule)
	return o
}

// SetVolumesNasExportPolicyRulesRoRule adds the volumesNasExportPolicyRulesRoRule to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesRoRule(volumesNasExportPolicyRulesRoRule *string) {
	o.VolumesNasExportPolicyRulesRoRule = volumesNasExportPolicyRulesRoRule
}

// WithVolumesNasExportPolicyRulesRwRule adds the volumesNasExportPolicyRulesRwRule to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesRwRule(volumesNasExportPolicyRulesRwRule *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesRwRule(volumesNasExportPolicyRulesRwRule)
	return o
}

// SetVolumesNasExportPolicyRulesRwRule adds the volumesNasExportPolicyRulesRwRule to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesRwRule(volumesNasExportPolicyRulesRwRule *string) {
	o.VolumesNasExportPolicyRulesRwRule = volumesNasExportPolicyRulesRwRule
}

// WithVolumesNasExportPolicyRulesSuperuser adds the volumesNasExportPolicyRulesSuperuser to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyRulesSuperuser(volumesNasExportPolicyRulesSuperuser *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyRulesSuperuser(volumesNasExportPolicyRulesSuperuser)
	return o
}

// SetVolumesNasExportPolicyRulesSuperuser adds the volumesNasExportPolicyRulesSuperuser to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyRulesSuperuser(volumesNasExportPolicyRulesSuperuser *string) {
	o.VolumesNasExportPolicyRulesSuperuser = volumesNasExportPolicyRulesSuperuser
}

// WithVolumesNasExportPolicyUUID adds the volumesNasExportPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasExportPolicyUUID(volumesNasExportPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasExportPolicyUUID(volumesNasExportPolicyUUID)
	return o
}

// SetVolumesNasExportPolicyUUID adds the volumesNasExportPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasExportPolicyUUID(volumesNasExportPolicyUUID *string) {
	o.VolumesNasExportPolicyUUID = volumesNasExportPolicyUUID
}

// WithVolumesNasGid adds the volumesNasGid to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasGid(volumesNasGid *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasGid(volumesNasGid)
	return o
}

// SetVolumesNasGid adds the volumesNasGid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasGid(volumesNasGid *int64) {
	o.VolumesNasGid = volumesNasGid
}

// WithVolumesNasJunctionParentName adds the volumesNasJunctionParentName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasJunctionParentName(volumesNasJunctionParentName *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasJunctionParentName(volumesNasJunctionParentName)
	return o
}

// SetVolumesNasJunctionParentName adds the volumesNasJunctionParentName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasJunctionParentName(volumesNasJunctionParentName *string) {
	o.VolumesNasJunctionParentName = volumesNasJunctionParentName
}

// WithVolumesNasJunctionParentUUID adds the volumesNasJunctionParentUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasJunctionParentUUID(volumesNasJunctionParentUUID *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasJunctionParentUUID(volumesNasJunctionParentUUID)
	return o
}

// SetVolumesNasJunctionParentUUID adds the volumesNasJunctionParentUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasJunctionParentUUID(volumesNasJunctionParentUUID *string) {
	o.VolumesNasJunctionParentUUID = volumesNasJunctionParentUUID
}

// WithVolumesNasPath adds the volumesNasPath to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasPath(volumesNasPath *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasPath(volumesNasPath)
	return o
}

// SetVolumesNasPath adds the volumesNasPath to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasPath(volumesNasPath *string) {
	o.VolumesNasPath = volumesNasPath
}

// WithVolumesNasSecurityStyle adds the volumesNasSecurityStyle to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasSecurityStyle(volumesNasSecurityStyle *string) *ConsistencyGroupGetParams {
	o.SetVolumesNasSecurityStyle(volumesNasSecurityStyle)
	return o
}

// SetVolumesNasSecurityStyle adds the volumesNasSecurityStyle to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasSecurityStyle(volumesNasSecurityStyle *string) {
	o.VolumesNasSecurityStyle = volumesNasSecurityStyle
}

// WithVolumesNasUID adds the volumesNasUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasUID(volumesNasUID *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasUID(volumesNasUID)
	return o
}

// SetVolumesNasUID adds the volumesNasUid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasUID(volumesNasUID *int64) {
	o.VolumesNasUID = volumesNasUID
}

// WithVolumesNasUnixPermissions adds the volumesNasUnixPermissions to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesNasUnixPermissions(volumesNasUnixPermissions *int64) *ConsistencyGroupGetParams {
	o.SetVolumesNasUnixPermissions(volumesNasUnixPermissions)
	return o
}

// SetVolumesNasUnixPermissions adds the volumesNasUnixPermissions to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesNasUnixPermissions(volumesNasUnixPermissions *int64) {
	o.VolumesNasUnixPermissions = volumesNasUnixPermissions
}

// WithVolumesQosPolicyMaxThroughputIops adds the volumesQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyMaxThroughputIops(volumesQosPolicyMaxThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyMaxThroughputIops(volumesQosPolicyMaxThroughputIops)
	return o
}

// SetVolumesQosPolicyMaxThroughputIops adds the volumesQosPolicyMaxThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyMaxThroughputIops(volumesQosPolicyMaxThroughputIops *int64) {
	o.VolumesQosPolicyMaxThroughputIops = volumesQosPolicyMaxThroughputIops
}

// WithVolumesQosPolicyMaxThroughputMbps adds the volumesQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyMaxThroughputMbps(volumesQosPolicyMaxThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyMaxThroughputMbps(volumesQosPolicyMaxThroughputMbps)
	return o
}

// SetVolumesQosPolicyMaxThroughputMbps adds the volumesQosPolicyMaxThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyMaxThroughputMbps(volumesQosPolicyMaxThroughputMbps *int64) {
	o.VolumesQosPolicyMaxThroughputMbps = volumesQosPolicyMaxThroughputMbps
}

// WithVolumesQosPolicyMinThroughputIops adds the volumesQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyMinThroughputIops(volumesQosPolicyMinThroughputIops *int64) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyMinThroughputIops(volumesQosPolicyMinThroughputIops)
	return o
}

// SetVolumesQosPolicyMinThroughputIops adds the volumesQosPolicyMinThroughputIops to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyMinThroughputIops(volumesQosPolicyMinThroughputIops *int64) {
	o.VolumesQosPolicyMinThroughputIops = volumesQosPolicyMinThroughputIops
}

// WithVolumesQosPolicyMinThroughputMbps adds the volumesQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyMinThroughputMbps(volumesQosPolicyMinThroughputMbps *int64) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyMinThroughputMbps(volumesQosPolicyMinThroughputMbps)
	return o
}

// SetVolumesQosPolicyMinThroughputMbps adds the volumesQosPolicyMinThroughputMbps to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyMinThroughputMbps(volumesQosPolicyMinThroughputMbps *int64) {
	o.VolumesQosPolicyMinThroughputMbps = volumesQosPolicyMinThroughputMbps
}

// WithVolumesQosPolicyName adds the volumesQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyName(volumesQosPolicyName *string) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyName(volumesQosPolicyName)
	return o
}

// SetVolumesQosPolicyName adds the volumesQosPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyName(volumesQosPolicyName *string) {
	o.VolumesQosPolicyName = volumesQosPolicyName
}

// WithVolumesQosPolicyUUID adds the volumesQosPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesQosPolicyUUID(volumesQosPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetVolumesQosPolicyUUID(volumesQosPolicyUUID)
	return o
}

// SetVolumesQosPolicyUUID adds the volumesQosPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesQosPolicyUUID(volumesQosPolicyUUID *string) {
	o.VolumesQosPolicyUUID = volumesQosPolicyUUID
}

// WithVolumesSnapshotPolicyName adds the volumesSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesSnapshotPolicyName(volumesSnapshotPolicyName *string) *ConsistencyGroupGetParams {
	o.SetVolumesSnapshotPolicyName(volumesSnapshotPolicyName)
	return o
}

// SetVolumesSnapshotPolicyName adds the volumesSnapshotPolicyName to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesSnapshotPolicyName(volumesSnapshotPolicyName *string) {
	o.VolumesSnapshotPolicyName = volumesSnapshotPolicyName
}

// WithVolumesSnapshotPolicyUUID adds the volumesSnapshotPolicyUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesSnapshotPolicyUUID(volumesSnapshotPolicyUUID *string) *ConsistencyGroupGetParams {
	o.SetVolumesSnapshotPolicyUUID(volumesSnapshotPolicyUUID)
	return o
}

// SetVolumesSnapshotPolicyUUID adds the volumesSnapshotPolicyUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesSnapshotPolicyUUID(volumesSnapshotPolicyUUID *string) {
	o.VolumesSnapshotPolicyUUID = volumesSnapshotPolicyUUID
}

// WithVolumesSpaceAvailable adds the volumesSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesSpaceAvailable(volumesSpaceAvailable *int64) *ConsistencyGroupGetParams {
	o.SetVolumesSpaceAvailable(volumesSpaceAvailable)
	return o
}

// SetVolumesSpaceAvailable adds the volumesSpaceAvailable to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesSpaceAvailable(volumesSpaceAvailable *int64) {
	o.VolumesSpaceAvailable = volumesSpaceAvailable
}

// WithVolumesSpaceSize adds the volumesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesSpaceSize(volumesSpaceSize *int64) *ConsistencyGroupGetParams {
	o.SetVolumesSpaceSize(volumesSpaceSize)
	return o
}

// SetVolumesSpaceSize adds the volumesSpaceSize to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesSpaceSize(volumesSpaceSize *int64) {
	o.VolumesSpaceSize = volumesSpaceSize
}

// WithVolumesSpaceUsed adds the volumesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesSpaceUsed(volumesSpaceUsed *int64) *ConsistencyGroupGetParams {
	o.SetVolumesSpaceUsed(volumesSpaceUsed)
	return o
}

// SetVolumesSpaceUsed adds the volumesSpaceUsed to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesSpaceUsed(volumesSpaceUsed *int64) {
	o.VolumesSpaceUsed = volumesSpaceUsed
}

// WithVolumesTieringPolicy adds the volumesTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesTieringPolicy(volumesTieringPolicy *string) *ConsistencyGroupGetParams {
	o.SetVolumesTieringPolicy(volumesTieringPolicy)
	return o
}

// SetVolumesTieringPolicy adds the volumesTieringPolicy to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesTieringPolicy(volumesTieringPolicy *string) {
	o.VolumesTieringPolicy = volumesTieringPolicy
}

// WithVolumesUUID adds the volumesUUID to the consistency group get params
func (o *ConsistencyGroupGetParams) WithVolumesUUID(volumesUUID *string) *ConsistencyGroupGetParams {
	o.SetVolumesUUID(volumesUUID)
	return o
}

// SetVolumesUUID adds the volumesUuid to the consistency group get params
func (o *ConsistencyGroupGetParams) SetVolumesUUID(volumesUUID *string) {
	o.VolumesUUID = volumesUUID
}

// WriteToRequest writes these params to a swagger request
func (o *ConsistencyGroupGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ApplicationComponentType != nil {

		// query param application.component_type
		var qrApplicationComponentType string

		if o.ApplicationComponentType != nil {
			qrApplicationComponentType = *o.ApplicationComponentType
		}
		qApplicationComponentType := qrApplicationComponentType
		if qApplicationComponentType != "" {

			if err := r.SetQueryParam("application.component_type", qApplicationComponentType); err != nil {
				return err
			}
		}
	}

	if o.ApplicationType != nil {

		// query param application.type
		var qrApplicationType string

		if o.ApplicationType != nil {
			qrApplicationType = *o.ApplicationType
		}
		qApplicationType := qrApplicationType
		if qApplicationType != "" {

			if err := r.SetQueryParam("application.type", qApplicationType); err != nil {
				return err
			}
		}
	}

	if o.CloneGuaranteeType != nil {

		// query param clone.guarantee.type
		var qrCloneGuaranteeType string

		if o.CloneGuaranteeType != nil {
			qrCloneGuaranteeType = *o.CloneGuaranteeType
		}
		qCloneGuaranteeType := qrCloneGuaranteeType
		if qCloneGuaranteeType != "" {

			if err := r.SetQueryParam("clone.guarantee.type", qCloneGuaranteeType); err != nil {
				return err
			}
		}
	}

	if o.CloneParentConsistencyGroupName != nil {

		// query param clone.parent_consistency_group.name
		var qrCloneParentConsistencyGroupName string

		if o.CloneParentConsistencyGroupName != nil {
			qrCloneParentConsistencyGroupName = *o.CloneParentConsistencyGroupName
		}
		qCloneParentConsistencyGroupName := qrCloneParentConsistencyGroupName
		if qCloneParentConsistencyGroupName != "" {

			if err := r.SetQueryParam("clone.parent_consistency_group.name", qCloneParentConsistencyGroupName); err != nil {
				return err
			}
		}
	}

	if o.CloneParentConsistencyGroupUUID != nil {

		// query param clone.parent_consistency_group.uuid
		var qrCloneParentConsistencyGroupUUID string

		if o.CloneParentConsistencyGroupUUID != nil {
			qrCloneParentConsistencyGroupUUID = *o.CloneParentConsistencyGroupUUID
		}
		qCloneParentConsistencyGroupUUID := qrCloneParentConsistencyGroupUUID
		if qCloneParentConsistencyGroupUUID != "" {

			if err := r.SetQueryParam("clone.parent_consistency_group.uuid", qCloneParentConsistencyGroupUUID); err != nil {
				return err
			}
		}
	}

	if o.CloneParentSnapshotName != nil {

		// query param clone.parent_snapshot.name
		var qrCloneParentSnapshotName string

		if o.CloneParentSnapshotName != nil {
			qrCloneParentSnapshotName = *o.CloneParentSnapshotName
		}
		qCloneParentSnapshotName := qrCloneParentSnapshotName
		if qCloneParentSnapshotName != "" {

			if err := r.SetQueryParam("clone.parent_snapshot.name", qCloneParentSnapshotName); err != nil {
				return err
			}
		}
	}

	if o.CloneSplitInitiated != nil {

		// query param clone.split_initiated
		var qrCloneSplitInitiated bool

		if o.CloneSplitInitiated != nil {
			qrCloneSplitInitiated = *o.CloneSplitInitiated
		}
		qCloneSplitInitiated := swag.FormatBool(qrCloneSplitInitiated)
		if qCloneSplitInitiated != "" {

			if err := r.SetQueryParam("clone.split_initiated", qCloneSplitInitiated); err != nil {
				return err
			}
		}
	}

	if o.CloneVolumePrefix != nil {

		// query param clone.volume.prefix
		var qrCloneVolumePrefix string

		if o.CloneVolumePrefix != nil {
			qrCloneVolumePrefix = *o.CloneVolumePrefix
		}
		qCloneVolumePrefix := qrCloneVolumePrefix
		if qCloneVolumePrefix != "" {

			if err := r.SetQueryParam("clone.volume.prefix", qCloneVolumePrefix); err != nil {
				return err
			}
		}
	}

	if o.CloneVolumeSuffix != nil {

		// query param clone.volume.suffix
		var qrCloneVolumeSuffix string

		if o.CloneVolumeSuffix != nil {
			qrCloneVolumeSuffix = *o.CloneVolumeSuffix
		}
		qCloneVolumeSuffix := qrCloneVolumeSuffix
		if qCloneVolumeSuffix != "" {

			if err := r.SetQueryParam("clone.volume.suffix", qCloneVolumeSuffix); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsApplicationComponentType != nil {

		// query param consistency_groups.application.component_type
		var qrConsistencyGroupsApplicationComponentType string

		if o.ConsistencyGroupsApplicationComponentType != nil {
			qrConsistencyGroupsApplicationComponentType = *o.ConsistencyGroupsApplicationComponentType
		}
		qConsistencyGroupsApplicationComponentType := qrConsistencyGroupsApplicationComponentType
		if qConsistencyGroupsApplicationComponentType != "" {

			if err := r.SetQueryParam("consistency_groups.application.component_type", qConsistencyGroupsApplicationComponentType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsApplicationType != nil {

		// query param consistency_groups.application.type
		var qrConsistencyGroupsApplicationType string

		if o.ConsistencyGroupsApplicationType != nil {
			qrConsistencyGroupsApplicationType = *o.ConsistencyGroupsApplicationType
		}
		qConsistencyGroupsApplicationType := qrConsistencyGroupsApplicationType
		if qConsistencyGroupsApplicationType != "" {

			if err := r.SetQueryParam("consistency_groups.application.type", qConsistencyGroupsApplicationType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsComment != nil {

		// query param consistency_groups.luns.comment
		var qrConsistencyGroupsLunsComment string

		if o.ConsistencyGroupsLunsComment != nil {
			qrConsistencyGroupsLunsComment = *o.ConsistencyGroupsLunsComment
		}
		qConsistencyGroupsLunsComment := qrConsistencyGroupsLunsComment
		if qConsistencyGroupsLunsComment != "" {

			if err := r.SetQueryParam("consistency_groups.luns.comment", qConsistencyGroupsLunsComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsCreateTime != nil {

		// query param consistency_groups.luns.create_time
		var qrConsistencyGroupsLunsCreateTime string

		if o.ConsistencyGroupsLunsCreateTime != nil {
			qrConsistencyGroupsLunsCreateTime = *o.ConsistencyGroupsLunsCreateTime
		}
		qConsistencyGroupsLunsCreateTime := qrConsistencyGroupsLunsCreateTime
		if qConsistencyGroupsLunsCreateTime != "" {

			if err := r.SetQueryParam("consistency_groups.luns.create_time", qConsistencyGroupsLunsCreateTime); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsEnabled != nil {

		// query param consistency_groups.luns.enabled
		var qrConsistencyGroupsLunsEnabled bool

		if o.ConsistencyGroupsLunsEnabled != nil {
			qrConsistencyGroupsLunsEnabled = *o.ConsistencyGroupsLunsEnabled
		}
		qConsistencyGroupsLunsEnabled := swag.FormatBool(qrConsistencyGroupsLunsEnabled)
		if qConsistencyGroupsLunsEnabled != "" {

			if err := r.SetQueryParam("consistency_groups.luns.enabled", qConsistencyGroupsLunsEnabled); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupComment != nil {

		// query param consistency_groups.luns.lun_maps.igroup.comment
		var qrConsistencyGroupsLunsLunMapsIgroupComment string

		if o.ConsistencyGroupsLunsLunMapsIgroupComment != nil {
			qrConsistencyGroupsLunsLunMapsIgroupComment = *o.ConsistencyGroupsLunsLunMapsIgroupComment
		}
		qConsistencyGroupsLunsLunMapsIgroupComment := qrConsistencyGroupsLunsLunMapsIgroupComment
		if qConsistencyGroupsLunsLunMapsIgroupComment != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.comment", qConsistencyGroupsLunsLunMapsIgroupComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupIgroupsName != nil {

		// query param consistency_groups.luns.lun_maps.igroup.igroups.name
		var qrConsistencyGroupsLunsLunMapsIgroupIgroupsName string

		if o.ConsistencyGroupsLunsLunMapsIgroupIgroupsName != nil {
			qrConsistencyGroupsLunsLunMapsIgroupIgroupsName = *o.ConsistencyGroupsLunsLunMapsIgroupIgroupsName
		}
		qConsistencyGroupsLunsLunMapsIgroupIgroupsName := qrConsistencyGroupsLunsLunMapsIgroupIgroupsName
		if qConsistencyGroupsLunsLunMapsIgroupIgroupsName != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.igroups.name", qConsistencyGroupsLunsLunMapsIgroupIgroupsName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID != nil {

		// query param consistency_groups.luns.lun_maps.igroup.igroups.uuid
		var qrConsistencyGroupsLunsLunMapsIgroupIgroupsUUID string

		if o.ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID != nil {
			qrConsistencyGroupsLunsLunMapsIgroupIgroupsUUID = *o.ConsistencyGroupsLunsLunMapsIgroupIgroupsUUID
		}
		qConsistencyGroupsLunsLunMapsIgroupIgroupsUUID := qrConsistencyGroupsLunsLunMapsIgroupIgroupsUUID
		if qConsistencyGroupsLunsLunMapsIgroupIgroupsUUID != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.igroups.uuid", qConsistencyGroupsLunsLunMapsIgroupIgroupsUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment != nil {

		// query param consistency_groups.luns.lun_maps.igroup.initiators.comment
		var qrConsistencyGroupsLunsLunMapsIgroupInitiatorsComment string

		if o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment != nil {
			qrConsistencyGroupsLunsLunMapsIgroupInitiatorsComment = *o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsComment
		}
		qConsistencyGroupsLunsLunMapsIgroupInitiatorsComment := qrConsistencyGroupsLunsLunMapsIgroupInitiatorsComment
		if qConsistencyGroupsLunsLunMapsIgroupInitiatorsComment != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.initiators.comment", qConsistencyGroupsLunsLunMapsIgroupInitiatorsComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsName != nil {

		// query param consistency_groups.luns.lun_maps.igroup.initiators.name
		var qrConsistencyGroupsLunsLunMapsIgroupInitiatorsName string

		if o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsName != nil {
			qrConsistencyGroupsLunsLunMapsIgroupInitiatorsName = *o.ConsistencyGroupsLunsLunMapsIgroupInitiatorsName
		}
		qConsistencyGroupsLunsLunMapsIgroupInitiatorsName := qrConsistencyGroupsLunsLunMapsIgroupInitiatorsName
		if qConsistencyGroupsLunsLunMapsIgroupInitiatorsName != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.initiators.name", qConsistencyGroupsLunsLunMapsIgroupInitiatorsName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupName != nil {

		// query param consistency_groups.luns.lun_maps.igroup.name
		var qrConsistencyGroupsLunsLunMapsIgroupName string

		if o.ConsistencyGroupsLunsLunMapsIgroupName != nil {
			qrConsistencyGroupsLunsLunMapsIgroupName = *o.ConsistencyGroupsLunsLunMapsIgroupName
		}
		qConsistencyGroupsLunsLunMapsIgroupName := qrConsistencyGroupsLunsLunMapsIgroupName
		if qConsistencyGroupsLunsLunMapsIgroupName != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.name", qConsistencyGroupsLunsLunMapsIgroupName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupOsType != nil {

		// query param consistency_groups.luns.lun_maps.igroup.os_type
		var qrConsistencyGroupsLunsLunMapsIgroupOsType string

		if o.ConsistencyGroupsLunsLunMapsIgroupOsType != nil {
			qrConsistencyGroupsLunsLunMapsIgroupOsType = *o.ConsistencyGroupsLunsLunMapsIgroupOsType
		}
		qConsistencyGroupsLunsLunMapsIgroupOsType := qrConsistencyGroupsLunsLunMapsIgroupOsType
		if qConsistencyGroupsLunsLunMapsIgroupOsType != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.os_type", qConsistencyGroupsLunsLunMapsIgroupOsType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupProtocol != nil {

		// query param consistency_groups.luns.lun_maps.igroup.protocol
		var qrConsistencyGroupsLunsLunMapsIgroupProtocol string

		if o.ConsistencyGroupsLunsLunMapsIgroupProtocol != nil {
			qrConsistencyGroupsLunsLunMapsIgroupProtocol = *o.ConsistencyGroupsLunsLunMapsIgroupProtocol
		}
		qConsistencyGroupsLunsLunMapsIgroupProtocol := qrConsistencyGroupsLunsLunMapsIgroupProtocol
		if qConsistencyGroupsLunsLunMapsIgroupProtocol != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.protocol", qConsistencyGroupsLunsLunMapsIgroupProtocol); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsIgroupUUID != nil {

		// query param consistency_groups.luns.lun_maps.igroup.uuid
		var qrConsistencyGroupsLunsLunMapsIgroupUUID string

		if o.ConsistencyGroupsLunsLunMapsIgroupUUID != nil {
			qrConsistencyGroupsLunsLunMapsIgroupUUID = *o.ConsistencyGroupsLunsLunMapsIgroupUUID
		}
		qConsistencyGroupsLunsLunMapsIgroupUUID := qrConsistencyGroupsLunsLunMapsIgroupUUID
		if qConsistencyGroupsLunsLunMapsIgroupUUID != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.igroup.uuid", qConsistencyGroupsLunsLunMapsIgroupUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsLunMapsLogicalUnitNumber != nil {

		// query param consistency_groups.luns.lun_maps.logical_unit_number
		var qrConsistencyGroupsLunsLunMapsLogicalUnitNumber int64

		if o.ConsistencyGroupsLunsLunMapsLogicalUnitNumber != nil {
			qrConsistencyGroupsLunsLunMapsLogicalUnitNumber = *o.ConsistencyGroupsLunsLunMapsLogicalUnitNumber
		}
		qConsistencyGroupsLunsLunMapsLogicalUnitNumber := swag.FormatInt64(qrConsistencyGroupsLunsLunMapsLogicalUnitNumber)
		if qConsistencyGroupsLunsLunMapsLogicalUnitNumber != "" {

			if err := r.SetQueryParam("consistency_groups.luns.lun_maps.logical_unit_number", qConsistencyGroupsLunsLunMapsLogicalUnitNumber); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsName != nil {

		// query param consistency_groups.luns.name
		var qrConsistencyGroupsLunsName string

		if o.ConsistencyGroupsLunsName != nil {
			qrConsistencyGroupsLunsName = *o.ConsistencyGroupsLunsName
		}
		qConsistencyGroupsLunsName := qrConsistencyGroupsLunsName
		if qConsistencyGroupsLunsName != "" {

			if err := r.SetQueryParam("consistency_groups.luns.name", qConsistencyGroupsLunsName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsOsType != nil {

		// query param consistency_groups.luns.os_type
		var qrConsistencyGroupsLunsOsType string

		if o.ConsistencyGroupsLunsOsType != nil {
			qrConsistencyGroupsLunsOsType = *o.ConsistencyGroupsLunsOsType
		}
		qConsistencyGroupsLunsOsType := qrConsistencyGroupsLunsOsType
		if qConsistencyGroupsLunsOsType != "" {

			if err := r.SetQueryParam("consistency_groups.luns.os_type", qConsistencyGroupsLunsOsType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyMaxThroughputIops != nil {

		// query param consistency_groups.luns.qos.policy.max_throughput_iops
		var qrConsistencyGroupsLunsQosPolicyMaxThroughputIops int64

		if o.ConsistencyGroupsLunsQosPolicyMaxThroughputIops != nil {
			qrConsistencyGroupsLunsQosPolicyMaxThroughputIops = *o.ConsistencyGroupsLunsQosPolicyMaxThroughputIops
		}
		qConsistencyGroupsLunsQosPolicyMaxThroughputIops := swag.FormatInt64(qrConsistencyGroupsLunsQosPolicyMaxThroughputIops)
		if qConsistencyGroupsLunsQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.max_throughput_iops", qConsistencyGroupsLunsQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyMaxThroughputMbps != nil {

		// query param consistency_groups.luns.qos.policy.max_throughput_mbps
		var qrConsistencyGroupsLunsQosPolicyMaxThroughputMbps int64

		if o.ConsistencyGroupsLunsQosPolicyMaxThroughputMbps != nil {
			qrConsistencyGroupsLunsQosPolicyMaxThroughputMbps = *o.ConsistencyGroupsLunsQosPolicyMaxThroughputMbps
		}
		qConsistencyGroupsLunsQosPolicyMaxThroughputMbps := swag.FormatInt64(qrConsistencyGroupsLunsQosPolicyMaxThroughputMbps)
		if qConsistencyGroupsLunsQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.max_throughput_mbps", qConsistencyGroupsLunsQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyMinThroughputIops != nil {

		// query param consistency_groups.luns.qos.policy.min_throughput_iops
		var qrConsistencyGroupsLunsQosPolicyMinThroughputIops int64

		if o.ConsistencyGroupsLunsQosPolicyMinThroughputIops != nil {
			qrConsistencyGroupsLunsQosPolicyMinThroughputIops = *o.ConsistencyGroupsLunsQosPolicyMinThroughputIops
		}
		qConsistencyGroupsLunsQosPolicyMinThroughputIops := swag.FormatInt64(qrConsistencyGroupsLunsQosPolicyMinThroughputIops)
		if qConsistencyGroupsLunsQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.min_throughput_iops", qConsistencyGroupsLunsQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyMinThroughputMbps != nil {

		// query param consistency_groups.luns.qos.policy.min_throughput_mbps
		var qrConsistencyGroupsLunsQosPolicyMinThroughputMbps int64

		if o.ConsistencyGroupsLunsQosPolicyMinThroughputMbps != nil {
			qrConsistencyGroupsLunsQosPolicyMinThroughputMbps = *o.ConsistencyGroupsLunsQosPolicyMinThroughputMbps
		}
		qConsistencyGroupsLunsQosPolicyMinThroughputMbps := swag.FormatInt64(qrConsistencyGroupsLunsQosPolicyMinThroughputMbps)
		if qConsistencyGroupsLunsQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.min_throughput_mbps", qConsistencyGroupsLunsQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyName != nil {

		// query param consistency_groups.luns.qos.policy.name
		var qrConsistencyGroupsLunsQosPolicyName string

		if o.ConsistencyGroupsLunsQosPolicyName != nil {
			qrConsistencyGroupsLunsQosPolicyName = *o.ConsistencyGroupsLunsQosPolicyName
		}
		qConsistencyGroupsLunsQosPolicyName := qrConsistencyGroupsLunsQosPolicyName
		if qConsistencyGroupsLunsQosPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.name", qConsistencyGroupsLunsQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsQosPolicyUUID != nil {

		// query param consistency_groups.luns.qos.policy.uuid
		var qrConsistencyGroupsLunsQosPolicyUUID string

		if o.ConsistencyGroupsLunsQosPolicyUUID != nil {
			qrConsistencyGroupsLunsQosPolicyUUID = *o.ConsistencyGroupsLunsQosPolicyUUID
		}
		qConsistencyGroupsLunsQosPolicyUUID := qrConsistencyGroupsLunsQosPolicyUUID
		if qConsistencyGroupsLunsQosPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.luns.qos.policy.uuid", qConsistencyGroupsLunsQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsSerialNumber != nil {

		// query param consistency_groups.luns.serial_number
		var qrConsistencyGroupsLunsSerialNumber string

		if o.ConsistencyGroupsLunsSerialNumber != nil {
			qrConsistencyGroupsLunsSerialNumber = *o.ConsistencyGroupsLunsSerialNumber
		}
		qConsistencyGroupsLunsSerialNumber := qrConsistencyGroupsLunsSerialNumber
		if qConsistencyGroupsLunsSerialNumber != "" {

			if err := r.SetQueryParam("consistency_groups.luns.serial_number", qConsistencyGroupsLunsSerialNumber); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsSpaceGuaranteeRequested != nil {

		// query param consistency_groups.luns.space.guarantee.requested
		var qrConsistencyGroupsLunsSpaceGuaranteeRequested bool

		if o.ConsistencyGroupsLunsSpaceGuaranteeRequested != nil {
			qrConsistencyGroupsLunsSpaceGuaranteeRequested = *o.ConsistencyGroupsLunsSpaceGuaranteeRequested
		}
		qConsistencyGroupsLunsSpaceGuaranteeRequested := swag.FormatBool(qrConsistencyGroupsLunsSpaceGuaranteeRequested)
		if qConsistencyGroupsLunsSpaceGuaranteeRequested != "" {

			if err := r.SetQueryParam("consistency_groups.luns.space.guarantee.requested", qConsistencyGroupsLunsSpaceGuaranteeRequested); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsSpaceGuaranteeReserved != nil {

		// query param consistency_groups.luns.space.guarantee.reserved
		var qrConsistencyGroupsLunsSpaceGuaranteeReserved bool

		if o.ConsistencyGroupsLunsSpaceGuaranteeReserved != nil {
			qrConsistencyGroupsLunsSpaceGuaranteeReserved = *o.ConsistencyGroupsLunsSpaceGuaranteeReserved
		}
		qConsistencyGroupsLunsSpaceGuaranteeReserved := swag.FormatBool(qrConsistencyGroupsLunsSpaceGuaranteeReserved)
		if qConsistencyGroupsLunsSpaceGuaranteeReserved != "" {

			if err := r.SetQueryParam("consistency_groups.luns.space.guarantee.reserved", qConsistencyGroupsLunsSpaceGuaranteeReserved); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsSpaceSize != nil {

		// query param consistency_groups.luns.space.size
		var qrConsistencyGroupsLunsSpaceSize int64

		if o.ConsistencyGroupsLunsSpaceSize != nil {
			qrConsistencyGroupsLunsSpaceSize = *o.ConsistencyGroupsLunsSpaceSize
		}
		qConsistencyGroupsLunsSpaceSize := swag.FormatInt64(qrConsistencyGroupsLunsSpaceSize)
		if qConsistencyGroupsLunsSpaceSize != "" {

			if err := r.SetQueryParam("consistency_groups.luns.space.size", qConsistencyGroupsLunsSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsSpaceUsed != nil {

		// query param consistency_groups.luns.space.used
		var qrConsistencyGroupsLunsSpaceUsed int64

		if o.ConsistencyGroupsLunsSpaceUsed != nil {
			qrConsistencyGroupsLunsSpaceUsed = *o.ConsistencyGroupsLunsSpaceUsed
		}
		qConsistencyGroupsLunsSpaceUsed := swag.FormatInt64(qrConsistencyGroupsLunsSpaceUsed)
		if qConsistencyGroupsLunsSpaceUsed != "" {

			if err := r.SetQueryParam("consistency_groups.luns.space.used", qConsistencyGroupsLunsSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsLunsUUID != nil {

		// query param consistency_groups.luns.uuid
		var qrConsistencyGroupsLunsUUID string

		if o.ConsistencyGroupsLunsUUID != nil {
			qrConsistencyGroupsLunsUUID = *o.ConsistencyGroupsLunsUUID
		}
		qConsistencyGroupsLunsUUID := qrConsistencyGroupsLunsUUID
		if qConsistencyGroupsLunsUUID != "" {

			if err := r.SetQueryParam("consistency_groups.luns.uuid", qConsistencyGroupsLunsUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsName != nil {

		// query param consistency_groups.name
		var qrConsistencyGroupsName string

		if o.ConsistencyGroupsName != nil {
			qrConsistencyGroupsName = *o.ConsistencyGroupsName
		}
		qConsistencyGroupsName := qrConsistencyGroupsName
		if qConsistencyGroupsName != "" {

			if err := r.SetQueryParam("consistency_groups.name", qConsistencyGroupsName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesAutoDelete != nil {

		// query param consistency_groups.namespaces.auto_delete
		var qrConsistencyGroupsNamespacesAutoDelete bool

		if o.ConsistencyGroupsNamespacesAutoDelete != nil {
			qrConsistencyGroupsNamespacesAutoDelete = *o.ConsistencyGroupsNamespacesAutoDelete
		}
		qConsistencyGroupsNamespacesAutoDelete := swag.FormatBool(qrConsistencyGroupsNamespacesAutoDelete)
		if qConsistencyGroupsNamespacesAutoDelete != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.auto_delete", qConsistencyGroupsNamespacesAutoDelete); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesComment != nil {

		// query param consistency_groups.namespaces.comment
		var qrConsistencyGroupsNamespacesComment string

		if o.ConsistencyGroupsNamespacesComment != nil {
			qrConsistencyGroupsNamespacesComment = *o.ConsistencyGroupsNamespacesComment
		}
		qConsistencyGroupsNamespacesComment := qrConsistencyGroupsNamespacesComment
		if qConsistencyGroupsNamespacesComment != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.comment", qConsistencyGroupsNamespacesComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesCreateTime != nil {

		// query param consistency_groups.namespaces.create_time
		var qrConsistencyGroupsNamespacesCreateTime string

		if o.ConsistencyGroupsNamespacesCreateTime != nil {
			qrConsistencyGroupsNamespacesCreateTime = *o.ConsistencyGroupsNamespacesCreateTime
		}
		qConsistencyGroupsNamespacesCreateTime := qrConsistencyGroupsNamespacesCreateTime
		if qConsistencyGroupsNamespacesCreateTime != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.create_time", qConsistencyGroupsNamespacesCreateTime); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesEnabled != nil {

		// query param consistency_groups.namespaces.enabled
		var qrConsistencyGroupsNamespacesEnabled bool

		if o.ConsistencyGroupsNamespacesEnabled != nil {
			qrConsistencyGroupsNamespacesEnabled = *o.ConsistencyGroupsNamespacesEnabled
		}
		qConsistencyGroupsNamespacesEnabled := swag.FormatBool(qrConsistencyGroupsNamespacesEnabled)
		if qConsistencyGroupsNamespacesEnabled != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.enabled", qConsistencyGroupsNamespacesEnabled); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesName != nil {

		// query param consistency_groups.namespaces.name
		var qrConsistencyGroupsNamespacesName string

		if o.ConsistencyGroupsNamespacesName != nil {
			qrConsistencyGroupsNamespacesName = *o.ConsistencyGroupsNamespacesName
		}
		qConsistencyGroupsNamespacesName := qrConsistencyGroupsNamespacesName
		if qConsistencyGroupsNamespacesName != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.name", qConsistencyGroupsNamespacesName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesOsType != nil {

		// query param consistency_groups.namespaces.os_type
		var qrConsistencyGroupsNamespacesOsType string

		if o.ConsistencyGroupsNamespacesOsType != nil {
			qrConsistencyGroupsNamespacesOsType = *o.ConsistencyGroupsNamespacesOsType
		}
		qConsistencyGroupsNamespacesOsType := qrConsistencyGroupsNamespacesOsType
		if qConsistencyGroupsNamespacesOsType != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.os_type", qConsistencyGroupsNamespacesOsType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSpaceBlockSize != nil {

		// query param consistency_groups.namespaces.space.block_size
		var qrConsistencyGroupsNamespacesSpaceBlockSize int64

		if o.ConsistencyGroupsNamespacesSpaceBlockSize != nil {
			qrConsistencyGroupsNamespacesSpaceBlockSize = *o.ConsistencyGroupsNamespacesSpaceBlockSize
		}
		qConsistencyGroupsNamespacesSpaceBlockSize := swag.FormatInt64(qrConsistencyGroupsNamespacesSpaceBlockSize)
		if qConsistencyGroupsNamespacesSpaceBlockSize != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.space.block_size", qConsistencyGroupsNamespacesSpaceBlockSize); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSpaceGuaranteeRequested != nil {

		// query param consistency_groups.namespaces.space.guarantee.requested
		var qrConsistencyGroupsNamespacesSpaceGuaranteeRequested bool

		if o.ConsistencyGroupsNamespacesSpaceGuaranteeRequested != nil {
			qrConsistencyGroupsNamespacesSpaceGuaranteeRequested = *o.ConsistencyGroupsNamespacesSpaceGuaranteeRequested
		}
		qConsistencyGroupsNamespacesSpaceGuaranteeRequested := swag.FormatBool(qrConsistencyGroupsNamespacesSpaceGuaranteeRequested)
		if qConsistencyGroupsNamespacesSpaceGuaranteeRequested != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.space.guarantee.requested", qConsistencyGroupsNamespacesSpaceGuaranteeRequested); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSpaceGuaranteeReserved != nil {

		// query param consistency_groups.namespaces.space.guarantee.reserved
		var qrConsistencyGroupsNamespacesSpaceGuaranteeReserved bool

		if o.ConsistencyGroupsNamespacesSpaceGuaranteeReserved != nil {
			qrConsistencyGroupsNamespacesSpaceGuaranteeReserved = *o.ConsistencyGroupsNamespacesSpaceGuaranteeReserved
		}
		qConsistencyGroupsNamespacesSpaceGuaranteeReserved := swag.FormatBool(qrConsistencyGroupsNamespacesSpaceGuaranteeReserved)
		if qConsistencyGroupsNamespacesSpaceGuaranteeReserved != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.space.guarantee.reserved", qConsistencyGroupsNamespacesSpaceGuaranteeReserved); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSpaceSize != nil {

		// query param consistency_groups.namespaces.space.size
		var qrConsistencyGroupsNamespacesSpaceSize int64

		if o.ConsistencyGroupsNamespacesSpaceSize != nil {
			qrConsistencyGroupsNamespacesSpaceSize = *o.ConsistencyGroupsNamespacesSpaceSize
		}
		qConsistencyGroupsNamespacesSpaceSize := swag.FormatInt64(qrConsistencyGroupsNamespacesSpaceSize)
		if qConsistencyGroupsNamespacesSpaceSize != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.space.size", qConsistencyGroupsNamespacesSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSpaceUsed != nil {

		// query param consistency_groups.namespaces.space.used
		var qrConsistencyGroupsNamespacesSpaceUsed int64

		if o.ConsistencyGroupsNamespacesSpaceUsed != nil {
			qrConsistencyGroupsNamespacesSpaceUsed = *o.ConsistencyGroupsNamespacesSpaceUsed
		}
		qConsistencyGroupsNamespacesSpaceUsed := swag.FormatInt64(qrConsistencyGroupsNamespacesSpaceUsed)
		if qConsistencyGroupsNamespacesSpaceUsed != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.space.used", qConsistencyGroupsNamespacesSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesStatusContainerState != nil {

		// query param consistency_groups.namespaces.status.container_state
		var qrConsistencyGroupsNamespacesStatusContainerState string

		if o.ConsistencyGroupsNamespacesStatusContainerState != nil {
			qrConsistencyGroupsNamespacesStatusContainerState = *o.ConsistencyGroupsNamespacesStatusContainerState
		}
		qConsistencyGroupsNamespacesStatusContainerState := qrConsistencyGroupsNamespacesStatusContainerState
		if qConsistencyGroupsNamespacesStatusContainerState != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.status.container_state", qConsistencyGroupsNamespacesStatusContainerState); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesStatusMapped != nil {

		// query param consistency_groups.namespaces.status.mapped
		var qrConsistencyGroupsNamespacesStatusMapped bool

		if o.ConsistencyGroupsNamespacesStatusMapped != nil {
			qrConsistencyGroupsNamespacesStatusMapped = *o.ConsistencyGroupsNamespacesStatusMapped
		}
		qConsistencyGroupsNamespacesStatusMapped := swag.FormatBool(qrConsistencyGroupsNamespacesStatusMapped)
		if qConsistencyGroupsNamespacesStatusMapped != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.status.mapped", qConsistencyGroupsNamespacesStatusMapped); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesStatusReadOnly != nil {

		// query param consistency_groups.namespaces.status.read_only
		var qrConsistencyGroupsNamespacesStatusReadOnly bool

		if o.ConsistencyGroupsNamespacesStatusReadOnly != nil {
			qrConsistencyGroupsNamespacesStatusReadOnly = *o.ConsistencyGroupsNamespacesStatusReadOnly
		}
		qConsistencyGroupsNamespacesStatusReadOnly := swag.FormatBool(qrConsistencyGroupsNamespacesStatusReadOnly)
		if qConsistencyGroupsNamespacesStatusReadOnly != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.status.read_only", qConsistencyGroupsNamespacesStatusReadOnly); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesStatusState != nil {

		// query param consistency_groups.namespaces.status.state
		var qrConsistencyGroupsNamespacesStatusState string

		if o.ConsistencyGroupsNamespacesStatusState != nil {
			qrConsistencyGroupsNamespacesStatusState = *o.ConsistencyGroupsNamespacesStatusState
		}
		qConsistencyGroupsNamespacesStatusState := qrConsistencyGroupsNamespacesStatusState
		if qConsistencyGroupsNamespacesStatusState != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.status.state", qConsistencyGroupsNamespacesStatusState); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapAnagrpid != nil {

		// query param consistency_groups.namespaces.subsystem_map.anagrpid
		var qrConsistencyGroupsNamespacesSubsystemMapAnagrpid string

		if o.ConsistencyGroupsNamespacesSubsystemMapAnagrpid != nil {
			qrConsistencyGroupsNamespacesSubsystemMapAnagrpid = *o.ConsistencyGroupsNamespacesSubsystemMapAnagrpid
		}
		qConsistencyGroupsNamespacesSubsystemMapAnagrpid := qrConsistencyGroupsNamespacesSubsystemMapAnagrpid
		if qConsistencyGroupsNamespacesSubsystemMapAnagrpid != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.anagrpid", qConsistencyGroupsNamespacesSubsystemMapAnagrpid); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapNsid != nil {

		// query param consistency_groups.namespaces.subsystem_map.nsid
		var qrConsistencyGroupsNamespacesSubsystemMapNsid string

		if o.ConsistencyGroupsNamespacesSubsystemMapNsid != nil {
			qrConsistencyGroupsNamespacesSubsystemMapNsid = *o.ConsistencyGroupsNamespacesSubsystemMapNsid
		}
		qConsistencyGroupsNamespacesSubsystemMapNsid := qrConsistencyGroupsNamespacesSubsystemMapNsid
		if qConsistencyGroupsNamespacesSubsystemMapNsid != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.nsid", qConsistencyGroupsNamespacesSubsystemMapNsid); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemComment != nil {

		// query param consistency_groups.namespaces.subsystem_map.subsystem.comment
		var qrConsistencyGroupsNamespacesSubsystemMapSubsystemComment string

		if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemComment != nil {
			qrConsistencyGroupsNamespacesSubsystemMapSubsystemComment = *o.ConsistencyGroupsNamespacesSubsystemMapSubsystemComment
		}
		qConsistencyGroupsNamespacesSubsystemMapSubsystemComment := qrConsistencyGroupsNamespacesSubsystemMapSubsystemComment
		if qConsistencyGroupsNamespacesSubsystemMapSubsystemComment != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.subsystem.comment", qConsistencyGroupsNamespacesSubsystemMapSubsystemComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn != nil {

		// query param consistency_groups.namespaces.subsystem_map.subsystem.hosts.nqn
		var qrConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn string

		if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn != nil {
			qrConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn = *o.ConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn
		}
		qConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn := qrConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn
		if qConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.subsystem.hosts.nqn", qConsistencyGroupsNamespacesSubsystemMapSubsystemHostsNqn); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemName != nil {

		// query param consistency_groups.namespaces.subsystem_map.subsystem.name
		var qrConsistencyGroupsNamespacesSubsystemMapSubsystemName string

		if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemName != nil {
			qrConsistencyGroupsNamespacesSubsystemMapSubsystemName = *o.ConsistencyGroupsNamespacesSubsystemMapSubsystemName
		}
		qConsistencyGroupsNamespacesSubsystemMapSubsystemName := qrConsistencyGroupsNamespacesSubsystemMapSubsystemName
		if qConsistencyGroupsNamespacesSubsystemMapSubsystemName != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.subsystem.name", qConsistencyGroupsNamespacesSubsystemMapSubsystemName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType != nil {

		// query param consistency_groups.namespaces.subsystem_map.subsystem.os_type
		var qrConsistencyGroupsNamespacesSubsystemMapSubsystemOsType string

		if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType != nil {
			qrConsistencyGroupsNamespacesSubsystemMapSubsystemOsType = *o.ConsistencyGroupsNamespacesSubsystemMapSubsystemOsType
		}
		qConsistencyGroupsNamespacesSubsystemMapSubsystemOsType := qrConsistencyGroupsNamespacesSubsystemMapSubsystemOsType
		if qConsistencyGroupsNamespacesSubsystemMapSubsystemOsType != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.subsystem.os_type", qConsistencyGroupsNamespacesSubsystemMapSubsystemOsType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID != nil {

		// query param consistency_groups.namespaces.subsystem_map.subsystem.uuid
		var qrConsistencyGroupsNamespacesSubsystemMapSubsystemUUID string

		if o.ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID != nil {
			qrConsistencyGroupsNamespacesSubsystemMapSubsystemUUID = *o.ConsistencyGroupsNamespacesSubsystemMapSubsystemUUID
		}
		qConsistencyGroupsNamespacesSubsystemMapSubsystemUUID := qrConsistencyGroupsNamespacesSubsystemMapSubsystemUUID
		if qConsistencyGroupsNamespacesSubsystemMapSubsystemUUID != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.subsystem_map.subsystem.uuid", qConsistencyGroupsNamespacesSubsystemMapSubsystemUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsNamespacesUUID != nil {

		// query param consistency_groups.namespaces.uuid
		var qrConsistencyGroupsNamespacesUUID string

		if o.ConsistencyGroupsNamespacesUUID != nil {
			qrConsistencyGroupsNamespacesUUID = *o.ConsistencyGroupsNamespacesUUID
		}
		qConsistencyGroupsNamespacesUUID := qrConsistencyGroupsNamespacesUUID
		if qConsistencyGroupsNamespacesUUID != "" {

			if err := r.SetQueryParam("consistency_groups.namespaces.uuid", qConsistencyGroupsNamespacesUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsParentConsistencyGroupName != nil {

		// query param consistency_groups.parent_consistency_group.name
		var qrConsistencyGroupsParentConsistencyGroupName string

		if o.ConsistencyGroupsParentConsistencyGroupName != nil {
			qrConsistencyGroupsParentConsistencyGroupName = *o.ConsistencyGroupsParentConsistencyGroupName
		}
		qConsistencyGroupsParentConsistencyGroupName := qrConsistencyGroupsParentConsistencyGroupName
		if qConsistencyGroupsParentConsistencyGroupName != "" {

			if err := r.SetQueryParam("consistency_groups.parent_consistency_group.name", qConsistencyGroupsParentConsistencyGroupName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsParentConsistencyGroupUUID != nil {

		// query param consistency_groups.parent_consistency_group.uuid
		var qrConsistencyGroupsParentConsistencyGroupUUID string

		if o.ConsistencyGroupsParentConsistencyGroupUUID != nil {
			qrConsistencyGroupsParentConsistencyGroupUUID = *o.ConsistencyGroupsParentConsistencyGroupUUID
		}
		qConsistencyGroupsParentConsistencyGroupUUID := qrConsistencyGroupsParentConsistencyGroupUUID
		if qConsistencyGroupsParentConsistencyGroupUUID != "" {

			if err := r.SetQueryParam("consistency_groups.parent_consistency_group.uuid", qConsistencyGroupsParentConsistencyGroupUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyMaxThroughputIops != nil {

		// query param consistency_groups.qos.policy.max_throughput_iops
		var qrConsistencyGroupsQosPolicyMaxThroughputIops int64

		if o.ConsistencyGroupsQosPolicyMaxThroughputIops != nil {
			qrConsistencyGroupsQosPolicyMaxThroughputIops = *o.ConsistencyGroupsQosPolicyMaxThroughputIops
		}
		qConsistencyGroupsQosPolicyMaxThroughputIops := swag.FormatInt64(qrConsistencyGroupsQosPolicyMaxThroughputIops)
		if qConsistencyGroupsQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.max_throughput_iops", qConsistencyGroupsQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyMaxThroughputMbps != nil {

		// query param consistency_groups.qos.policy.max_throughput_mbps
		var qrConsistencyGroupsQosPolicyMaxThroughputMbps int64

		if o.ConsistencyGroupsQosPolicyMaxThroughputMbps != nil {
			qrConsistencyGroupsQosPolicyMaxThroughputMbps = *o.ConsistencyGroupsQosPolicyMaxThroughputMbps
		}
		qConsistencyGroupsQosPolicyMaxThroughputMbps := swag.FormatInt64(qrConsistencyGroupsQosPolicyMaxThroughputMbps)
		if qConsistencyGroupsQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.max_throughput_mbps", qConsistencyGroupsQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyMinThroughputIops != nil {

		// query param consistency_groups.qos.policy.min_throughput_iops
		var qrConsistencyGroupsQosPolicyMinThroughputIops int64

		if o.ConsistencyGroupsQosPolicyMinThroughputIops != nil {
			qrConsistencyGroupsQosPolicyMinThroughputIops = *o.ConsistencyGroupsQosPolicyMinThroughputIops
		}
		qConsistencyGroupsQosPolicyMinThroughputIops := swag.FormatInt64(qrConsistencyGroupsQosPolicyMinThroughputIops)
		if qConsistencyGroupsQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.min_throughput_iops", qConsistencyGroupsQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyMinThroughputMbps != nil {

		// query param consistency_groups.qos.policy.min_throughput_mbps
		var qrConsistencyGroupsQosPolicyMinThroughputMbps int64

		if o.ConsistencyGroupsQosPolicyMinThroughputMbps != nil {
			qrConsistencyGroupsQosPolicyMinThroughputMbps = *o.ConsistencyGroupsQosPolicyMinThroughputMbps
		}
		qConsistencyGroupsQosPolicyMinThroughputMbps := swag.FormatInt64(qrConsistencyGroupsQosPolicyMinThroughputMbps)
		if qConsistencyGroupsQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.min_throughput_mbps", qConsistencyGroupsQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyName != nil {

		// query param consistency_groups.qos.policy.name
		var qrConsistencyGroupsQosPolicyName string

		if o.ConsistencyGroupsQosPolicyName != nil {
			qrConsistencyGroupsQosPolicyName = *o.ConsistencyGroupsQosPolicyName
		}
		qConsistencyGroupsQosPolicyName := qrConsistencyGroupsQosPolicyName
		if qConsistencyGroupsQosPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.name", qConsistencyGroupsQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsQosPolicyUUID != nil {

		// query param consistency_groups.qos.policy.uuid
		var qrConsistencyGroupsQosPolicyUUID string

		if o.ConsistencyGroupsQosPolicyUUID != nil {
			qrConsistencyGroupsQosPolicyUUID = *o.ConsistencyGroupsQosPolicyUUID
		}
		qConsistencyGroupsQosPolicyUUID := qrConsistencyGroupsQosPolicyUUID
		if qConsistencyGroupsQosPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.qos.policy.uuid", qConsistencyGroupsQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSnapshotPolicyName != nil {

		// query param consistency_groups.snapshot_policy.name
		var qrConsistencyGroupsSnapshotPolicyName string

		if o.ConsistencyGroupsSnapshotPolicyName != nil {
			qrConsistencyGroupsSnapshotPolicyName = *o.ConsistencyGroupsSnapshotPolicyName
		}
		qConsistencyGroupsSnapshotPolicyName := qrConsistencyGroupsSnapshotPolicyName
		if qConsistencyGroupsSnapshotPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.snapshot_policy.name", qConsistencyGroupsSnapshotPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSnapshotPolicyUUID != nil {

		// query param consistency_groups.snapshot_policy.uuid
		var qrConsistencyGroupsSnapshotPolicyUUID string

		if o.ConsistencyGroupsSnapshotPolicyUUID != nil {
			qrConsistencyGroupsSnapshotPolicyUUID = *o.ConsistencyGroupsSnapshotPolicyUUID
		}
		qConsistencyGroupsSnapshotPolicyUUID := qrConsistencyGroupsSnapshotPolicyUUID
		if qConsistencyGroupsSnapshotPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.snapshot_policy.uuid", qConsistencyGroupsSnapshotPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSpaceAvailable != nil {

		// query param consistency_groups.space.available
		var qrConsistencyGroupsSpaceAvailable int64

		if o.ConsistencyGroupsSpaceAvailable != nil {
			qrConsistencyGroupsSpaceAvailable = *o.ConsistencyGroupsSpaceAvailable
		}
		qConsistencyGroupsSpaceAvailable := swag.FormatInt64(qrConsistencyGroupsSpaceAvailable)
		if qConsistencyGroupsSpaceAvailable != "" {

			if err := r.SetQueryParam("consistency_groups.space.available", qConsistencyGroupsSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSpaceSize != nil {

		// query param consistency_groups.space.size
		var qrConsistencyGroupsSpaceSize int64

		if o.ConsistencyGroupsSpaceSize != nil {
			qrConsistencyGroupsSpaceSize = *o.ConsistencyGroupsSpaceSize
		}
		qConsistencyGroupsSpaceSize := swag.FormatInt64(qrConsistencyGroupsSpaceSize)
		if qConsistencyGroupsSpaceSize != "" {

			if err := r.SetQueryParam("consistency_groups.space.size", qConsistencyGroupsSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSpaceUsed != nil {

		// query param consistency_groups.space.used
		var qrConsistencyGroupsSpaceUsed int64

		if o.ConsistencyGroupsSpaceUsed != nil {
			qrConsistencyGroupsSpaceUsed = *o.ConsistencyGroupsSpaceUsed
		}
		qConsistencyGroupsSpaceUsed := swag.FormatInt64(qrConsistencyGroupsSpaceUsed)
		if qConsistencyGroupsSpaceUsed != "" {

			if err := r.SetQueryParam("consistency_groups.space.used", qConsistencyGroupsSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSvmName != nil {

		// query param consistency_groups.svm.name
		var qrConsistencyGroupsSvmName string

		if o.ConsistencyGroupsSvmName != nil {
			qrConsistencyGroupsSvmName = *o.ConsistencyGroupsSvmName
		}
		qConsistencyGroupsSvmName := qrConsistencyGroupsSvmName
		if qConsistencyGroupsSvmName != "" {

			if err := r.SetQueryParam("consistency_groups.svm.name", qConsistencyGroupsSvmName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsSvmUUID != nil {

		// query param consistency_groups.svm.uuid
		var qrConsistencyGroupsSvmUUID string

		if o.ConsistencyGroupsSvmUUID != nil {
			qrConsistencyGroupsSvmUUID = *o.ConsistencyGroupsSvmUUID
		}
		qConsistencyGroupsSvmUUID := qrConsistencyGroupsSvmUUID
		if qConsistencyGroupsSvmUUID != "" {

			if err := r.SetQueryParam("consistency_groups.svm.uuid", qConsistencyGroupsSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsTieringPolicy != nil {

		// query param consistency_groups.tiering.policy
		var qrConsistencyGroupsTieringPolicy string

		if o.ConsistencyGroupsTieringPolicy != nil {
			qrConsistencyGroupsTieringPolicy = *o.ConsistencyGroupsTieringPolicy
		}
		qConsistencyGroupsTieringPolicy := qrConsistencyGroupsTieringPolicy
		if qConsistencyGroupsTieringPolicy != "" {

			if err := r.SetQueryParam("consistency_groups.tiering.policy", qConsistencyGroupsTieringPolicy); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsUUID != nil {

		// query param consistency_groups.uuid
		var qrConsistencyGroupsUUID string

		if o.ConsistencyGroupsUUID != nil {
			qrConsistencyGroupsUUID = *o.ConsistencyGroupsUUID
		}
		qConsistencyGroupsUUID := qrConsistencyGroupsUUID
		if qConsistencyGroupsUUID != "" {

			if err := r.SetQueryParam("consistency_groups.uuid", qConsistencyGroupsUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesComment != nil {

		// query param consistency_groups.volumes.comment
		var qrConsistencyGroupsVolumesComment string

		if o.ConsistencyGroupsVolumesComment != nil {
			qrConsistencyGroupsVolumesComment = *o.ConsistencyGroupsVolumesComment
		}
		qConsistencyGroupsVolumesComment := qrConsistencyGroupsVolumesComment
		if qConsistencyGroupsVolumesComment != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.comment", qConsistencyGroupsVolumesComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesLanguage != nil {

		// query param consistency_groups.volumes.language
		var qrConsistencyGroupsVolumesLanguage string

		if o.ConsistencyGroupsVolumesLanguage != nil {
			qrConsistencyGroupsVolumesLanguage = *o.ConsistencyGroupsVolumesLanguage
		}
		qConsistencyGroupsVolumesLanguage := qrConsistencyGroupsVolumesLanguage
		if qConsistencyGroupsVolumesLanguage != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.language", qConsistencyGroupsVolumesLanguage); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesName != nil {

		// query param consistency_groups.volumes.name
		var qrConsistencyGroupsVolumesName string

		if o.ConsistencyGroupsVolumesName != nil {
			qrConsistencyGroupsVolumesName = *o.ConsistencyGroupsVolumesName
		}
		qConsistencyGroupsVolumesName := qrConsistencyGroupsVolumesName
		if qConsistencyGroupsVolumesName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.name", qConsistencyGroupsVolumesName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.access_based_enumeration
		var qrConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration bool

		if o.ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration != nil {
			qrConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration = *o.ConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration
		}
		qConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration)
		if qConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.access_based_enumeration", qConsistencyGroupsVolumesNasCifsSharesAccessBasedEnumeration); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesAclsPermission != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.acls.permission
		var qrConsistencyGroupsVolumesNasCifsSharesAclsPermission string

		if o.ConsistencyGroupsVolumesNasCifsSharesAclsPermission != nil {
			qrConsistencyGroupsVolumesNasCifsSharesAclsPermission = *o.ConsistencyGroupsVolumesNasCifsSharesAclsPermission
		}
		qConsistencyGroupsVolumesNasCifsSharesAclsPermission := qrConsistencyGroupsVolumesNasCifsSharesAclsPermission
		if qConsistencyGroupsVolumesNasCifsSharesAclsPermission != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.acls.permission", qConsistencyGroupsVolumesNasCifsSharesAclsPermission); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesAclsType != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.acls.type
		var qrConsistencyGroupsVolumesNasCifsSharesAclsType string

		if o.ConsistencyGroupsVolumesNasCifsSharesAclsType != nil {
			qrConsistencyGroupsVolumesNasCifsSharesAclsType = *o.ConsistencyGroupsVolumesNasCifsSharesAclsType
		}
		qConsistencyGroupsVolumesNasCifsSharesAclsType := qrConsistencyGroupsVolumesNasCifsSharesAclsType
		if qConsistencyGroupsVolumesNasCifsSharesAclsType != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.acls.type", qConsistencyGroupsVolumesNasCifsSharesAclsType); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.acls.user_or_group
		var qrConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup string

		if o.ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup != nil {
			qrConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup = *o.ConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup
		}
		qConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup := qrConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup
		if qConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.acls.user_or_group", qConsistencyGroupsVolumesNasCifsSharesAclsUserOrGroup); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.allow_unencrypted_access
		var qrConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess bool

		if o.ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess != nil {
			qrConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess = *o.ConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess
		}
		qConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess)
		if qConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.allow_unencrypted_access", qConsistencyGroupsVolumesNasCifsSharesAllowUnencryptedAccess); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesChangeNotify != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.change_notify
		var qrConsistencyGroupsVolumesNasCifsSharesChangeNotify bool

		if o.ConsistencyGroupsVolumesNasCifsSharesChangeNotify != nil {
			qrConsistencyGroupsVolumesNasCifsSharesChangeNotify = *o.ConsistencyGroupsVolumesNasCifsSharesChangeNotify
		}
		qConsistencyGroupsVolumesNasCifsSharesChangeNotify := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesChangeNotify)
		if qConsistencyGroupsVolumesNasCifsSharesChangeNotify != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.change_notify", qConsistencyGroupsVolumesNasCifsSharesChangeNotify); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesComment != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.comment
		var qrConsistencyGroupsVolumesNasCifsSharesComment string

		if o.ConsistencyGroupsVolumesNasCifsSharesComment != nil {
			qrConsistencyGroupsVolumesNasCifsSharesComment = *o.ConsistencyGroupsVolumesNasCifsSharesComment
		}
		qConsistencyGroupsVolumesNasCifsSharesComment := qrConsistencyGroupsVolumesNasCifsSharesComment
		if qConsistencyGroupsVolumesNasCifsSharesComment != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.comment", qConsistencyGroupsVolumesNasCifsSharesComment); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.continuously_available
		var qrConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable bool

		if o.ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable != nil {
			qrConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable = *o.ConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable
		}
		qConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable)
		if qConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.continuously_available", qConsistencyGroupsVolumesNasCifsSharesContinuouslyAvailable); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesDirUmask != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.dir_umask
		var qrConsistencyGroupsVolumesNasCifsSharesDirUmask int64

		if o.ConsistencyGroupsVolumesNasCifsSharesDirUmask != nil {
			qrConsistencyGroupsVolumesNasCifsSharesDirUmask = *o.ConsistencyGroupsVolumesNasCifsSharesDirUmask
		}
		qConsistencyGroupsVolumesNasCifsSharesDirUmask := swag.FormatInt64(qrConsistencyGroupsVolumesNasCifsSharesDirUmask)
		if qConsistencyGroupsVolumesNasCifsSharesDirUmask != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.dir_umask", qConsistencyGroupsVolumesNasCifsSharesDirUmask); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesEncryption != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.encryption
		var qrConsistencyGroupsVolumesNasCifsSharesEncryption bool

		if o.ConsistencyGroupsVolumesNasCifsSharesEncryption != nil {
			qrConsistencyGroupsVolumesNasCifsSharesEncryption = *o.ConsistencyGroupsVolumesNasCifsSharesEncryption
		}
		qConsistencyGroupsVolumesNasCifsSharesEncryption := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesEncryption)
		if qConsistencyGroupsVolumesNasCifsSharesEncryption != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.encryption", qConsistencyGroupsVolumesNasCifsSharesEncryption); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesFileUmask != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.file_umask
		var qrConsistencyGroupsVolumesNasCifsSharesFileUmask int64

		if o.ConsistencyGroupsVolumesNasCifsSharesFileUmask != nil {
			qrConsistencyGroupsVolumesNasCifsSharesFileUmask = *o.ConsistencyGroupsVolumesNasCifsSharesFileUmask
		}
		qConsistencyGroupsVolumesNasCifsSharesFileUmask := swag.FormatInt64(qrConsistencyGroupsVolumesNasCifsSharesFileUmask)
		if qConsistencyGroupsVolumesNasCifsSharesFileUmask != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.file_umask", qConsistencyGroupsVolumesNasCifsSharesFileUmask); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesHomeDirectory != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.home_directory
		var qrConsistencyGroupsVolumesNasCifsSharesHomeDirectory bool

		if o.ConsistencyGroupsVolumesNasCifsSharesHomeDirectory != nil {
			qrConsistencyGroupsVolumesNasCifsSharesHomeDirectory = *o.ConsistencyGroupsVolumesNasCifsSharesHomeDirectory
		}
		qConsistencyGroupsVolumesNasCifsSharesHomeDirectory := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesHomeDirectory)
		if qConsistencyGroupsVolumesNasCifsSharesHomeDirectory != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.home_directory", qConsistencyGroupsVolumesNasCifsSharesHomeDirectory); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesName != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.name
		var qrConsistencyGroupsVolumesNasCifsSharesName string

		if o.ConsistencyGroupsVolumesNasCifsSharesName != nil {
			qrConsistencyGroupsVolumesNasCifsSharesName = *o.ConsistencyGroupsVolumesNasCifsSharesName
		}
		qConsistencyGroupsVolumesNasCifsSharesName := qrConsistencyGroupsVolumesNasCifsSharesName
		if qConsistencyGroupsVolumesNasCifsSharesName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.name", qConsistencyGroupsVolumesNasCifsSharesName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.namespace_caching
		var qrConsistencyGroupsVolumesNasCifsSharesNamespaceCaching bool

		if o.ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching != nil {
			qrConsistencyGroupsVolumesNasCifsSharesNamespaceCaching = *o.ConsistencyGroupsVolumesNasCifsSharesNamespaceCaching
		}
		qConsistencyGroupsVolumesNasCifsSharesNamespaceCaching := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesNamespaceCaching)
		if qConsistencyGroupsVolumesNasCifsSharesNamespaceCaching != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.namespace_caching", qConsistencyGroupsVolumesNasCifsSharesNamespaceCaching); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.no_strict_security
		var qrConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity bool

		if o.ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity != nil {
			qrConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity = *o.ConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity
		}
		qConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity)
		if qConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.no_strict_security", qConsistencyGroupsVolumesNasCifsSharesNoStrictSecurity); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesOfflineFiles != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.offline_files
		var qrConsistencyGroupsVolumesNasCifsSharesOfflineFiles string

		if o.ConsistencyGroupsVolumesNasCifsSharesOfflineFiles != nil {
			qrConsistencyGroupsVolumesNasCifsSharesOfflineFiles = *o.ConsistencyGroupsVolumesNasCifsSharesOfflineFiles
		}
		qConsistencyGroupsVolumesNasCifsSharesOfflineFiles := qrConsistencyGroupsVolumesNasCifsSharesOfflineFiles
		if qConsistencyGroupsVolumesNasCifsSharesOfflineFiles != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.offline_files", qConsistencyGroupsVolumesNasCifsSharesOfflineFiles); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesOplocks != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.oplocks
		var qrConsistencyGroupsVolumesNasCifsSharesOplocks bool

		if o.ConsistencyGroupsVolumesNasCifsSharesOplocks != nil {
			qrConsistencyGroupsVolumesNasCifsSharesOplocks = *o.ConsistencyGroupsVolumesNasCifsSharesOplocks
		}
		qConsistencyGroupsVolumesNasCifsSharesOplocks := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesOplocks)
		if qConsistencyGroupsVolumesNasCifsSharesOplocks != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.oplocks", qConsistencyGroupsVolumesNasCifsSharesOplocks); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesShowSnapshot != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.show_snapshot
		var qrConsistencyGroupsVolumesNasCifsSharesShowSnapshot bool

		if o.ConsistencyGroupsVolumesNasCifsSharesShowSnapshot != nil {
			qrConsistencyGroupsVolumesNasCifsSharesShowSnapshot = *o.ConsistencyGroupsVolumesNasCifsSharesShowSnapshot
		}
		qConsistencyGroupsVolumesNasCifsSharesShowSnapshot := swag.FormatBool(qrConsistencyGroupsVolumesNasCifsSharesShowSnapshot)
		if qConsistencyGroupsVolumesNasCifsSharesShowSnapshot != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.show_snapshot", qConsistencyGroupsVolumesNasCifsSharesShowSnapshot); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesUnixSymlink != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.unix_symlink
		var qrConsistencyGroupsVolumesNasCifsSharesUnixSymlink string

		if o.ConsistencyGroupsVolumesNasCifsSharesUnixSymlink != nil {
			qrConsistencyGroupsVolumesNasCifsSharesUnixSymlink = *o.ConsistencyGroupsVolumesNasCifsSharesUnixSymlink
		}
		qConsistencyGroupsVolumesNasCifsSharesUnixSymlink := qrConsistencyGroupsVolumesNasCifsSharesUnixSymlink
		if qConsistencyGroupsVolumesNasCifsSharesUnixSymlink != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.unix_symlink", qConsistencyGroupsVolumesNasCifsSharesUnixSymlink); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasCifsSharesVscanProfile != nil {

		// query param consistency_groups.volumes.nas.cifs.shares.vscan_profile
		var qrConsistencyGroupsVolumesNasCifsSharesVscanProfile string

		if o.ConsistencyGroupsVolumesNasCifsSharesVscanProfile != nil {
			qrConsistencyGroupsVolumesNasCifsSharesVscanProfile = *o.ConsistencyGroupsVolumesNasCifsSharesVscanProfile
		}
		qConsistencyGroupsVolumesNasCifsSharesVscanProfile := qrConsistencyGroupsVolumesNasCifsSharesVscanProfile
		if qConsistencyGroupsVolumesNasCifsSharesVscanProfile != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.cifs.shares.vscan_profile", qConsistencyGroupsVolumesNasCifsSharesVscanProfile); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyName != nil {

		// query param consistency_groups.volumes.nas.export_policy.name
		var qrConsistencyGroupsVolumesNasExportPolicyName string

		if o.ConsistencyGroupsVolumesNasExportPolicyName != nil {
			qrConsistencyGroupsVolumesNasExportPolicyName = *o.ConsistencyGroupsVolumesNasExportPolicyName
		}
		qConsistencyGroupsVolumesNasExportPolicyName := qrConsistencyGroupsVolumesNasExportPolicyName
		if qConsistencyGroupsVolumesNasExportPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.name", qConsistencyGroupsVolumesNasExportPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.allow_device_creation
		var qrConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation bool

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation = *o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation := swag.FormatBool(qrConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation)
		if qConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.allow_device_creation", qConsistencyGroupsVolumesNasExportPolicyRulesAllowDeviceCreation); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.allow_suid
		var qrConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid bool

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid = *o.ConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid := swag.FormatBool(qrConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid)
		if qConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.allow_suid", qConsistencyGroupsVolumesNasExportPolicyRulesAllowSuid); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.anonymous_user
		var qrConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser = *o.ConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser := qrConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser
		if qConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.anonymous_user", qConsistencyGroupsVolumesNasExportPolicyRulesAnonymousUser); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesChownMode != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.chown_mode
		var qrConsistencyGroupsVolumesNasExportPolicyRulesChownMode string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesChownMode != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesChownMode = *o.ConsistencyGroupsVolumesNasExportPolicyRulesChownMode
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesChownMode := qrConsistencyGroupsVolumesNasExportPolicyRulesChownMode
		if qConsistencyGroupsVolumesNasExportPolicyRulesChownMode != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.chown_mode", qConsistencyGroupsVolumesNasExportPolicyRulesChownMode); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.clients.match
		var qrConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch = *o.ConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch := qrConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch
		if qConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.clients.match", qConsistencyGroupsVolumesNasExportPolicyRulesClientsMatch); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesIndex != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.index
		var qrConsistencyGroupsVolumesNasExportPolicyRulesIndex int64

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesIndex != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesIndex = *o.ConsistencyGroupsVolumesNasExportPolicyRulesIndex
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesIndex := swag.FormatInt64(qrConsistencyGroupsVolumesNasExportPolicyRulesIndex)
		if qConsistencyGroupsVolumesNasExportPolicyRulesIndex != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.index", qConsistencyGroupsVolumesNasExportPolicyRulesIndex); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.ntfs_unix_security
		var qrConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity = *o.ConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity := qrConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity
		if qConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.ntfs_unix_security", qConsistencyGroupsVolumesNasExportPolicyRulesNtfsUnixSecurity); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesProtocols != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.protocols
		var qrConsistencyGroupsVolumesNasExportPolicyRulesProtocols string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesProtocols != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesProtocols = *o.ConsistencyGroupsVolumesNasExportPolicyRulesProtocols
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesProtocols := qrConsistencyGroupsVolumesNasExportPolicyRulesProtocols
		if qConsistencyGroupsVolumesNasExportPolicyRulesProtocols != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.protocols", qConsistencyGroupsVolumesNasExportPolicyRulesProtocols); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesRoRule != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.ro_rule
		var qrConsistencyGroupsVolumesNasExportPolicyRulesRoRule string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesRoRule != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesRoRule = *o.ConsistencyGroupsVolumesNasExportPolicyRulesRoRule
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesRoRule := qrConsistencyGroupsVolumesNasExportPolicyRulesRoRule
		if qConsistencyGroupsVolumesNasExportPolicyRulesRoRule != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.ro_rule", qConsistencyGroupsVolumesNasExportPolicyRulesRoRule); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesRwRule != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.rw_rule
		var qrConsistencyGroupsVolumesNasExportPolicyRulesRwRule string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesRwRule != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesRwRule = *o.ConsistencyGroupsVolumesNasExportPolicyRulesRwRule
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesRwRule := qrConsistencyGroupsVolumesNasExportPolicyRulesRwRule
		if qConsistencyGroupsVolumesNasExportPolicyRulesRwRule != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.rw_rule", qConsistencyGroupsVolumesNasExportPolicyRulesRwRule); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser != nil {

		// query param consistency_groups.volumes.nas.export_policy.rules.superuser
		var qrConsistencyGroupsVolumesNasExportPolicyRulesSuperuser string

		if o.ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser != nil {
			qrConsistencyGroupsVolumesNasExportPolicyRulesSuperuser = *o.ConsistencyGroupsVolumesNasExportPolicyRulesSuperuser
		}
		qConsistencyGroupsVolumesNasExportPolicyRulesSuperuser := qrConsistencyGroupsVolumesNasExportPolicyRulesSuperuser
		if qConsistencyGroupsVolumesNasExportPolicyRulesSuperuser != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.rules.superuser", qConsistencyGroupsVolumesNasExportPolicyRulesSuperuser); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasExportPolicyUUID != nil {

		// query param consistency_groups.volumes.nas.export_policy.uuid
		var qrConsistencyGroupsVolumesNasExportPolicyUUID string

		if o.ConsistencyGroupsVolumesNasExportPolicyUUID != nil {
			qrConsistencyGroupsVolumesNasExportPolicyUUID = *o.ConsistencyGroupsVolumesNasExportPolicyUUID
		}
		qConsistencyGroupsVolumesNasExportPolicyUUID := qrConsistencyGroupsVolumesNasExportPolicyUUID
		if qConsistencyGroupsVolumesNasExportPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.export_policy.uuid", qConsistencyGroupsVolumesNasExportPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasGid != nil {

		// query param consistency_groups.volumes.nas.gid
		var qrConsistencyGroupsVolumesNasGid int64

		if o.ConsistencyGroupsVolumesNasGid != nil {
			qrConsistencyGroupsVolumesNasGid = *o.ConsistencyGroupsVolumesNasGid
		}
		qConsistencyGroupsVolumesNasGid := swag.FormatInt64(qrConsistencyGroupsVolumesNasGid)
		if qConsistencyGroupsVolumesNasGid != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.gid", qConsistencyGroupsVolumesNasGid); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasJunctionParentName != nil {

		// query param consistency_groups.volumes.nas.junction_parent.name
		var qrConsistencyGroupsVolumesNasJunctionParentName string

		if o.ConsistencyGroupsVolumesNasJunctionParentName != nil {
			qrConsistencyGroupsVolumesNasJunctionParentName = *o.ConsistencyGroupsVolumesNasJunctionParentName
		}
		qConsistencyGroupsVolumesNasJunctionParentName := qrConsistencyGroupsVolumesNasJunctionParentName
		if qConsistencyGroupsVolumesNasJunctionParentName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.junction_parent.name", qConsistencyGroupsVolumesNasJunctionParentName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasJunctionParentUUID != nil {

		// query param consistency_groups.volumes.nas.junction_parent.uuid
		var qrConsistencyGroupsVolumesNasJunctionParentUUID string

		if o.ConsistencyGroupsVolumesNasJunctionParentUUID != nil {
			qrConsistencyGroupsVolumesNasJunctionParentUUID = *o.ConsistencyGroupsVolumesNasJunctionParentUUID
		}
		qConsistencyGroupsVolumesNasJunctionParentUUID := qrConsistencyGroupsVolumesNasJunctionParentUUID
		if qConsistencyGroupsVolumesNasJunctionParentUUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.junction_parent.uuid", qConsistencyGroupsVolumesNasJunctionParentUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasPath != nil {

		// query param consistency_groups.volumes.nas.path
		var qrConsistencyGroupsVolumesNasPath string

		if o.ConsistencyGroupsVolumesNasPath != nil {
			qrConsistencyGroupsVolumesNasPath = *o.ConsistencyGroupsVolumesNasPath
		}
		qConsistencyGroupsVolumesNasPath := qrConsistencyGroupsVolumesNasPath
		if qConsistencyGroupsVolumesNasPath != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.path", qConsistencyGroupsVolumesNasPath); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasSecurityStyle != nil {

		// query param consistency_groups.volumes.nas.security_style
		var qrConsistencyGroupsVolumesNasSecurityStyle string

		if o.ConsistencyGroupsVolumesNasSecurityStyle != nil {
			qrConsistencyGroupsVolumesNasSecurityStyle = *o.ConsistencyGroupsVolumesNasSecurityStyle
		}
		qConsistencyGroupsVolumesNasSecurityStyle := qrConsistencyGroupsVolumesNasSecurityStyle
		if qConsistencyGroupsVolumesNasSecurityStyle != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.security_style", qConsistencyGroupsVolumesNasSecurityStyle); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasUID != nil {

		// query param consistency_groups.volumes.nas.uid
		var qrConsistencyGroupsVolumesNasUID int64

		if o.ConsistencyGroupsVolumesNasUID != nil {
			qrConsistencyGroupsVolumesNasUID = *o.ConsistencyGroupsVolumesNasUID
		}
		qConsistencyGroupsVolumesNasUID := swag.FormatInt64(qrConsistencyGroupsVolumesNasUID)
		if qConsistencyGroupsVolumesNasUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.uid", qConsistencyGroupsVolumesNasUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesNasUnixPermissions != nil {

		// query param consistency_groups.volumes.nas.unix_permissions
		var qrConsistencyGroupsVolumesNasUnixPermissions int64

		if o.ConsistencyGroupsVolumesNasUnixPermissions != nil {
			qrConsistencyGroupsVolumesNasUnixPermissions = *o.ConsistencyGroupsVolumesNasUnixPermissions
		}
		qConsistencyGroupsVolumesNasUnixPermissions := swag.FormatInt64(qrConsistencyGroupsVolumesNasUnixPermissions)
		if qConsistencyGroupsVolumesNasUnixPermissions != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.nas.unix_permissions", qConsistencyGroupsVolumesNasUnixPermissions); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyMaxThroughputIops != nil {

		// query param consistency_groups.volumes.qos.policy.max_throughput_iops
		var qrConsistencyGroupsVolumesQosPolicyMaxThroughputIops int64

		if o.ConsistencyGroupsVolumesQosPolicyMaxThroughputIops != nil {
			qrConsistencyGroupsVolumesQosPolicyMaxThroughputIops = *o.ConsistencyGroupsVolumesQosPolicyMaxThroughputIops
		}
		qConsistencyGroupsVolumesQosPolicyMaxThroughputIops := swag.FormatInt64(qrConsistencyGroupsVolumesQosPolicyMaxThroughputIops)
		if qConsistencyGroupsVolumesQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.max_throughput_iops", qConsistencyGroupsVolumesQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps != nil {

		// query param consistency_groups.volumes.qos.policy.max_throughput_mbps
		var qrConsistencyGroupsVolumesQosPolicyMaxThroughputMbps int64

		if o.ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps != nil {
			qrConsistencyGroupsVolumesQosPolicyMaxThroughputMbps = *o.ConsistencyGroupsVolumesQosPolicyMaxThroughputMbps
		}
		qConsistencyGroupsVolumesQosPolicyMaxThroughputMbps := swag.FormatInt64(qrConsistencyGroupsVolumesQosPolicyMaxThroughputMbps)
		if qConsistencyGroupsVolumesQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.max_throughput_mbps", qConsistencyGroupsVolumesQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyMinThroughputIops != nil {

		// query param consistency_groups.volumes.qos.policy.min_throughput_iops
		var qrConsistencyGroupsVolumesQosPolicyMinThroughputIops int64

		if o.ConsistencyGroupsVolumesQosPolicyMinThroughputIops != nil {
			qrConsistencyGroupsVolumesQosPolicyMinThroughputIops = *o.ConsistencyGroupsVolumesQosPolicyMinThroughputIops
		}
		qConsistencyGroupsVolumesQosPolicyMinThroughputIops := swag.FormatInt64(qrConsistencyGroupsVolumesQosPolicyMinThroughputIops)
		if qConsistencyGroupsVolumesQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.min_throughput_iops", qConsistencyGroupsVolumesQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyMinThroughputMbps != nil {

		// query param consistency_groups.volumes.qos.policy.min_throughput_mbps
		var qrConsistencyGroupsVolumesQosPolicyMinThroughputMbps int64

		if o.ConsistencyGroupsVolumesQosPolicyMinThroughputMbps != nil {
			qrConsistencyGroupsVolumesQosPolicyMinThroughputMbps = *o.ConsistencyGroupsVolumesQosPolicyMinThroughputMbps
		}
		qConsistencyGroupsVolumesQosPolicyMinThroughputMbps := swag.FormatInt64(qrConsistencyGroupsVolumesQosPolicyMinThroughputMbps)
		if qConsistencyGroupsVolumesQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.min_throughput_mbps", qConsistencyGroupsVolumesQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyName != nil {

		// query param consistency_groups.volumes.qos.policy.name
		var qrConsistencyGroupsVolumesQosPolicyName string

		if o.ConsistencyGroupsVolumesQosPolicyName != nil {
			qrConsistencyGroupsVolumesQosPolicyName = *o.ConsistencyGroupsVolumesQosPolicyName
		}
		qConsistencyGroupsVolumesQosPolicyName := qrConsistencyGroupsVolumesQosPolicyName
		if qConsistencyGroupsVolumesQosPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.name", qConsistencyGroupsVolumesQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesQosPolicyUUID != nil {

		// query param consistency_groups.volumes.qos.policy.uuid
		var qrConsistencyGroupsVolumesQosPolicyUUID string

		if o.ConsistencyGroupsVolumesQosPolicyUUID != nil {
			qrConsistencyGroupsVolumesQosPolicyUUID = *o.ConsistencyGroupsVolumesQosPolicyUUID
		}
		qConsistencyGroupsVolumesQosPolicyUUID := qrConsistencyGroupsVolumesQosPolicyUUID
		if qConsistencyGroupsVolumesQosPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.qos.policy.uuid", qConsistencyGroupsVolumesQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesSnapshotPolicyName != nil {

		// query param consistency_groups.volumes.snapshot_policy.name
		var qrConsistencyGroupsVolumesSnapshotPolicyName string

		if o.ConsistencyGroupsVolumesSnapshotPolicyName != nil {
			qrConsistencyGroupsVolumesSnapshotPolicyName = *o.ConsistencyGroupsVolumesSnapshotPolicyName
		}
		qConsistencyGroupsVolumesSnapshotPolicyName := qrConsistencyGroupsVolumesSnapshotPolicyName
		if qConsistencyGroupsVolumesSnapshotPolicyName != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.snapshot_policy.name", qConsistencyGroupsVolumesSnapshotPolicyName); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesSnapshotPolicyUUID != nil {

		// query param consistency_groups.volumes.snapshot_policy.uuid
		var qrConsistencyGroupsVolumesSnapshotPolicyUUID string

		if o.ConsistencyGroupsVolumesSnapshotPolicyUUID != nil {
			qrConsistencyGroupsVolumesSnapshotPolicyUUID = *o.ConsistencyGroupsVolumesSnapshotPolicyUUID
		}
		qConsistencyGroupsVolumesSnapshotPolicyUUID := qrConsistencyGroupsVolumesSnapshotPolicyUUID
		if qConsistencyGroupsVolumesSnapshotPolicyUUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.snapshot_policy.uuid", qConsistencyGroupsVolumesSnapshotPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesSpaceAvailable != nil {

		// query param consistency_groups.volumes.space.available
		var qrConsistencyGroupsVolumesSpaceAvailable int64

		if o.ConsistencyGroupsVolumesSpaceAvailable != nil {
			qrConsistencyGroupsVolumesSpaceAvailable = *o.ConsistencyGroupsVolumesSpaceAvailable
		}
		qConsistencyGroupsVolumesSpaceAvailable := swag.FormatInt64(qrConsistencyGroupsVolumesSpaceAvailable)
		if qConsistencyGroupsVolumesSpaceAvailable != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.space.available", qConsistencyGroupsVolumesSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesSpaceSize != nil {

		// query param consistency_groups.volumes.space.size
		var qrConsistencyGroupsVolumesSpaceSize int64

		if o.ConsistencyGroupsVolumesSpaceSize != nil {
			qrConsistencyGroupsVolumesSpaceSize = *o.ConsistencyGroupsVolumesSpaceSize
		}
		qConsistencyGroupsVolumesSpaceSize := swag.FormatInt64(qrConsistencyGroupsVolumesSpaceSize)
		if qConsistencyGroupsVolumesSpaceSize != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.space.size", qConsistencyGroupsVolumesSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesSpaceUsed != nil {

		// query param consistency_groups.volumes.space.used
		var qrConsistencyGroupsVolumesSpaceUsed int64

		if o.ConsistencyGroupsVolumesSpaceUsed != nil {
			qrConsistencyGroupsVolumesSpaceUsed = *o.ConsistencyGroupsVolumesSpaceUsed
		}
		qConsistencyGroupsVolumesSpaceUsed := swag.FormatInt64(qrConsistencyGroupsVolumesSpaceUsed)
		if qConsistencyGroupsVolumesSpaceUsed != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.space.used", qConsistencyGroupsVolumesSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesTieringPolicy != nil {

		// query param consistency_groups.volumes.tiering.policy
		var qrConsistencyGroupsVolumesTieringPolicy string

		if o.ConsistencyGroupsVolumesTieringPolicy != nil {
			qrConsistencyGroupsVolumesTieringPolicy = *o.ConsistencyGroupsVolumesTieringPolicy
		}
		qConsistencyGroupsVolumesTieringPolicy := qrConsistencyGroupsVolumesTieringPolicy
		if qConsistencyGroupsVolumesTieringPolicy != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.tiering.policy", qConsistencyGroupsVolumesTieringPolicy); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyGroupsVolumesUUID != nil {

		// query param consistency_groups.volumes.uuid
		var qrConsistencyGroupsVolumesUUID string

		if o.ConsistencyGroupsVolumesUUID != nil {
			qrConsistencyGroupsVolumesUUID = *o.ConsistencyGroupsVolumesUUID
		}
		qConsistencyGroupsVolumesUUID := qrConsistencyGroupsVolumesUUID
		if qConsistencyGroupsVolumesUUID != "" {

			if err := r.SetQueryParam("consistency_groups.volumes.uuid", qConsistencyGroupsVolumesUUID); err != nil {
				return err
			}
		}
	}

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LunsComment != nil {

		// query param luns.comment
		var qrLunsComment string

		if o.LunsComment != nil {
			qrLunsComment = *o.LunsComment
		}
		qLunsComment := qrLunsComment
		if qLunsComment != "" {

			if err := r.SetQueryParam("luns.comment", qLunsComment); err != nil {
				return err
			}
		}
	}

	if o.LunsCreateTime != nil {

		// query param luns.create_time
		var qrLunsCreateTime string

		if o.LunsCreateTime != nil {
			qrLunsCreateTime = *o.LunsCreateTime
		}
		qLunsCreateTime := qrLunsCreateTime
		if qLunsCreateTime != "" {

			if err := r.SetQueryParam("luns.create_time", qLunsCreateTime); err != nil {
				return err
			}
		}
	}

	if o.LunsEnabled != nil {

		// query param luns.enabled
		var qrLunsEnabled bool

		if o.LunsEnabled != nil {
			qrLunsEnabled = *o.LunsEnabled
		}
		qLunsEnabled := swag.FormatBool(qrLunsEnabled)
		if qLunsEnabled != "" {

			if err := r.SetQueryParam("luns.enabled", qLunsEnabled); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupComment != nil {

		// query param luns.lun_maps.igroup.comment
		var qrLunsLunMapsIgroupComment string

		if o.LunsLunMapsIgroupComment != nil {
			qrLunsLunMapsIgroupComment = *o.LunsLunMapsIgroupComment
		}
		qLunsLunMapsIgroupComment := qrLunsLunMapsIgroupComment
		if qLunsLunMapsIgroupComment != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.comment", qLunsLunMapsIgroupComment); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupIgroupsName != nil {

		// query param luns.lun_maps.igroup.igroups.name
		var qrLunsLunMapsIgroupIgroupsName string

		if o.LunsLunMapsIgroupIgroupsName != nil {
			qrLunsLunMapsIgroupIgroupsName = *o.LunsLunMapsIgroupIgroupsName
		}
		qLunsLunMapsIgroupIgroupsName := qrLunsLunMapsIgroupIgroupsName
		if qLunsLunMapsIgroupIgroupsName != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.igroups.name", qLunsLunMapsIgroupIgroupsName); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupIgroupsUUID != nil {

		// query param luns.lun_maps.igroup.igroups.uuid
		var qrLunsLunMapsIgroupIgroupsUUID string

		if o.LunsLunMapsIgroupIgroupsUUID != nil {
			qrLunsLunMapsIgroupIgroupsUUID = *o.LunsLunMapsIgroupIgroupsUUID
		}
		qLunsLunMapsIgroupIgroupsUUID := qrLunsLunMapsIgroupIgroupsUUID
		if qLunsLunMapsIgroupIgroupsUUID != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.igroups.uuid", qLunsLunMapsIgroupIgroupsUUID); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupInitiatorsComment != nil {

		// query param luns.lun_maps.igroup.initiators.comment
		var qrLunsLunMapsIgroupInitiatorsComment string

		if o.LunsLunMapsIgroupInitiatorsComment != nil {
			qrLunsLunMapsIgroupInitiatorsComment = *o.LunsLunMapsIgroupInitiatorsComment
		}
		qLunsLunMapsIgroupInitiatorsComment := qrLunsLunMapsIgroupInitiatorsComment
		if qLunsLunMapsIgroupInitiatorsComment != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.initiators.comment", qLunsLunMapsIgroupInitiatorsComment); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupInitiatorsName != nil {

		// query param luns.lun_maps.igroup.initiators.name
		var qrLunsLunMapsIgroupInitiatorsName string

		if o.LunsLunMapsIgroupInitiatorsName != nil {
			qrLunsLunMapsIgroupInitiatorsName = *o.LunsLunMapsIgroupInitiatorsName
		}
		qLunsLunMapsIgroupInitiatorsName := qrLunsLunMapsIgroupInitiatorsName
		if qLunsLunMapsIgroupInitiatorsName != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.initiators.name", qLunsLunMapsIgroupInitiatorsName); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupName != nil {

		// query param luns.lun_maps.igroup.name
		var qrLunsLunMapsIgroupName string

		if o.LunsLunMapsIgroupName != nil {
			qrLunsLunMapsIgroupName = *o.LunsLunMapsIgroupName
		}
		qLunsLunMapsIgroupName := qrLunsLunMapsIgroupName
		if qLunsLunMapsIgroupName != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.name", qLunsLunMapsIgroupName); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupOsType != nil {

		// query param luns.lun_maps.igroup.os_type
		var qrLunsLunMapsIgroupOsType string

		if o.LunsLunMapsIgroupOsType != nil {
			qrLunsLunMapsIgroupOsType = *o.LunsLunMapsIgroupOsType
		}
		qLunsLunMapsIgroupOsType := qrLunsLunMapsIgroupOsType
		if qLunsLunMapsIgroupOsType != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.os_type", qLunsLunMapsIgroupOsType); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupProtocol != nil {

		// query param luns.lun_maps.igroup.protocol
		var qrLunsLunMapsIgroupProtocol string

		if o.LunsLunMapsIgroupProtocol != nil {
			qrLunsLunMapsIgroupProtocol = *o.LunsLunMapsIgroupProtocol
		}
		qLunsLunMapsIgroupProtocol := qrLunsLunMapsIgroupProtocol
		if qLunsLunMapsIgroupProtocol != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.protocol", qLunsLunMapsIgroupProtocol); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsIgroupUUID != nil {

		// query param luns.lun_maps.igroup.uuid
		var qrLunsLunMapsIgroupUUID string

		if o.LunsLunMapsIgroupUUID != nil {
			qrLunsLunMapsIgroupUUID = *o.LunsLunMapsIgroupUUID
		}
		qLunsLunMapsIgroupUUID := qrLunsLunMapsIgroupUUID
		if qLunsLunMapsIgroupUUID != "" {

			if err := r.SetQueryParam("luns.lun_maps.igroup.uuid", qLunsLunMapsIgroupUUID); err != nil {
				return err
			}
		}
	}

	if o.LunsLunMapsLogicalUnitNumber != nil {

		// query param luns.lun_maps.logical_unit_number
		var qrLunsLunMapsLogicalUnitNumber int64

		if o.LunsLunMapsLogicalUnitNumber != nil {
			qrLunsLunMapsLogicalUnitNumber = *o.LunsLunMapsLogicalUnitNumber
		}
		qLunsLunMapsLogicalUnitNumber := swag.FormatInt64(qrLunsLunMapsLogicalUnitNumber)
		if qLunsLunMapsLogicalUnitNumber != "" {

			if err := r.SetQueryParam("luns.lun_maps.logical_unit_number", qLunsLunMapsLogicalUnitNumber); err != nil {
				return err
			}
		}
	}

	if o.LunsName != nil {

		// query param luns.name
		var qrLunsName string

		if o.LunsName != nil {
			qrLunsName = *o.LunsName
		}
		qLunsName := qrLunsName
		if qLunsName != "" {

			if err := r.SetQueryParam("luns.name", qLunsName); err != nil {
				return err
			}
		}
	}

	if o.LunsOsType != nil {

		// query param luns.os_type
		var qrLunsOsType string

		if o.LunsOsType != nil {
			qrLunsOsType = *o.LunsOsType
		}
		qLunsOsType := qrLunsOsType
		if qLunsOsType != "" {

			if err := r.SetQueryParam("luns.os_type", qLunsOsType); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyMaxThroughputIops != nil {

		// query param luns.qos.policy.max_throughput_iops
		var qrLunsQosPolicyMaxThroughputIops int64

		if o.LunsQosPolicyMaxThroughputIops != nil {
			qrLunsQosPolicyMaxThroughputIops = *o.LunsQosPolicyMaxThroughputIops
		}
		qLunsQosPolicyMaxThroughputIops := swag.FormatInt64(qrLunsQosPolicyMaxThroughputIops)
		if qLunsQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("luns.qos.policy.max_throughput_iops", qLunsQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyMaxThroughputMbps != nil {

		// query param luns.qos.policy.max_throughput_mbps
		var qrLunsQosPolicyMaxThroughputMbps int64

		if o.LunsQosPolicyMaxThroughputMbps != nil {
			qrLunsQosPolicyMaxThroughputMbps = *o.LunsQosPolicyMaxThroughputMbps
		}
		qLunsQosPolicyMaxThroughputMbps := swag.FormatInt64(qrLunsQosPolicyMaxThroughputMbps)
		if qLunsQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("luns.qos.policy.max_throughput_mbps", qLunsQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyMinThroughputIops != nil {

		// query param luns.qos.policy.min_throughput_iops
		var qrLunsQosPolicyMinThroughputIops int64

		if o.LunsQosPolicyMinThroughputIops != nil {
			qrLunsQosPolicyMinThroughputIops = *o.LunsQosPolicyMinThroughputIops
		}
		qLunsQosPolicyMinThroughputIops := swag.FormatInt64(qrLunsQosPolicyMinThroughputIops)
		if qLunsQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("luns.qos.policy.min_throughput_iops", qLunsQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyMinThroughputMbps != nil {

		// query param luns.qos.policy.min_throughput_mbps
		var qrLunsQosPolicyMinThroughputMbps int64

		if o.LunsQosPolicyMinThroughputMbps != nil {
			qrLunsQosPolicyMinThroughputMbps = *o.LunsQosPolicyMinThroughputMbps
		}
		qLunsQosPolicyMinThroughputMbps := swag.FormatInt64(qrLunsQosPolicyMinThroughputMbps)
		if qLunsQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("luns.qos.policy.min_throughput_mbps", qLunsQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyName != nil {

		// query param luns.qos.policy.name
		var qrLunsQosPolicyName string

		if o.LunsQosPolicyName != nil {
			qrLunsQosPolicyName = *o.LunsQosPolicyName
		}
		qLunsQosPolicyName := qrLunsQosPolicyName
		if qLunsQosPolicyName != "" {

			if err := r.SetQueryParam("luns.qos.policy.name", qLunsQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.LunsQosPolicyUUID != nil {

		// query param luns.qos.policy.uuid
		var qrLunsQosPolicyUUID string

		if o.LunsQosPolicyUUID != nil {
			qrLunsQosPolicyUUID = *o.LunsQosPolicyUUID
		}
		qLunsQosPolicyUUID := qrLunsQosPolicyUUID
		if qLunsQosPolicyUUID != "" {

			if err := r.SetQueryParam("luns.qos.policy.uuid", qLunsQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.LunsSerialNumber != nil {

		// query param luns.serial_number
		var qrLunsSerialNumber string

		if o.LunsSerialNumber != nil {
			qrLunsSerialNumber = *o.LunsSerialNumber
		}
		qLunsSerialNumber := qrLunsSerialNumber
		if qLunsSerialNumber != "" {

			if err := r.SetQueryParam("luns.serial_number", qLunsSerialNumber); err != nil {
				return err
			}
		}
	}

	if o.LunsSpaceGuaranteeRequested != nil {

		// query param luns.space.guarantee.requested
		var qrLunsSpaceGuaranteeRequested bool

		if o.LunsSpaceGuaranteeRequested != nil {
			qrLunsSpaceGuaranteeRequested = *o.LunsSpaceGuaranteeRequested
		}
		qLunsSpaceGuaranteeRequested := swag.FormatBool(qrLunsSpaceGuaranteeRequested)
		if qLunsSpaceGuaranteeRequested != "" {

			if err := r.SetQueryParam("luns.space.guarantee.requested", qLunsSpaceGuaranteeRequested); err != nil {
				return err
			}
		}
	}

	if o.LunsSpaceGuaranteeReserved != nil {

		// query param luns.space.guarantee.reserved
		var qrLunsSpaceGuaranteeReserved bool

		if o.LunsSpaceGuaranteeReserved != nil {
			qrLunsSpaceGuaranteeReserved = *o.LunsSpaceGuaranteeReserved
		}
		qLunsSpaceGuaranteeReserved := swag.FormatBool(qrLunsSpaceGuaranteeReserved)
		if qLunsSpaceGuaranteeReserved != "" {

			if err := r.SetQueryParam("luns.space.guarantee.reserved", qLunsSpaceGuaranteeReserved); err != nil {
				return err
			}
		}
	}

	if o.LunsSpaceSize != nil {

		// query param luns.space.size
		var qrLunsSpaceSize int64

		if o.LunsSpaceSize != nil {
			qrLunsSpaceSize = *o.LunsSpaceSize
		}
		qLunsSpaceSize := swag.FormatInt64(qrLunsSpaceSize)
		if qLunsSpaceSize != "" {

			if err := r.SetQueryParam("luns.space.size", qLunsSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.LunsSpaceUsed != nil {

		// query param luns.space.used
		var qrLunsSpaceUsed int64

		if o.LunsSpaceUsed != nil {
			qrLunsSpaceUsed = *o.LunsSpaceUsed
		}
		qLunsSpaceUsed := swag.FormatInt64(qrLunsSpaceUsed)
		if qLunsSpaceUsed != "" {

			if err := r.SetQueryParam("luns.space.used", qLunsSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.LunsUUID != nil {

		// query param luns.uuid
		var qrLunsUUID string

		if o.LunsUUID != nil {
			qrLunsUUID = *o.LunsUUID
		}
		qLunsUUID := qrLunsUUID
		if qLunsUUID != "" {

			if err := r.SetQueryParam("luns.uuid", qLunsUUID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecords != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecords != nil {
			qrMaxRecords = *o.MaxRecords
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.Name != nil {

		// query param name
		var qrName string

		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NamespacesAutoDelete != nil {

		// query param namespaces.auto_delete
		var qrNamespacesAutoDelete bool

		if o.NamespacesAutoDelete != nil {
			qrNamespacesAutoDelete = *o.NamespacesAutoDelete
		}
		qNamespacesAutoDelete := swag.FormatBool(qrNamespacesAutoDelete)
		if qNamespacesAutoDelete != "" {

			if err := r.SetQueryParam("namespaces.auto_delete", qNamespacesAutoDelete); err != nil {
				return err
			}
		}
	}

	if o.NamespacesComment != nil {

		// query param namespaces.comment
		var qrNamespacesComment string

		if o.NamespacesComment != nil {
			qrNamespacesComment = *o.NamespacesComment
		}
		qNamespacesComment := qrNamespacesComment
		if qNamespacesComment != "" {

			if err := r.SetQueryParam("namespaces.comment", qNamespacesComment); err != nil {
				return err
			}
		}
	}

	if o.NamespacesCreateTime != nil {

		// query param namespaces.create_time
		var qrNamespacesCreateTime string

		if o.NamespacesCreateTime != nil {
			qrNamespacesCreateTime = *o.NamespacesCreateTime
		}
		qNamespacesCreateTime := qrNamespacesCreateTime
		if qNamespacesCreateTime != "" {

			if err := r.SetQueryParam("namespaces.create_time", qNamespacesCreateTime); err != nil {
				return err
			}
		}
	}

	if o.NamespacesEnabled != nil {

		// query param namespaces.enabled
		var qrNamespacesEnabled bool

		if o.NamespacesEnabled != nil {
			qrNamespacesEnabled = *o.NamespacesEnabled
		}
		qNamespacesEnabled := swag.FormatBool(qrNamespacesEnabled)
		if qNamespacesEnabled != "" {

			if err := r.SetQueryParam("namespaces.enabled", qNamespacesEnabled); err != nil {
				return err
			}
		}
	}

	if o.NamespacesName != nil {

		// query param namespaces.name
		var qrNamespacesName string

		if o.NamespacesName != nil {
			qrNamespacesName = *o.NamespacesName
		}
		qNamespacesName := qrNamespacesName
		if qNamespacesName != "" {

			if err := r.SetQueryParam("namespaces.name", qNamespacesName); err != nil {
				return err
			}
		}
	}

	if o.NamespacesOsType != nil {

		// query param namespaces.os_type
		var qrNamespacesOsType string

		if o.NamespacesOsType != nil {
			qrNamespacesOsType = *o.NamespacesOsType
		}
		qNamespacesOsType := qrNamespacesOsType
		if qNamespacesOsType != "" {

			if err := r.SetQueryParam("namespaces.os_type", qNamespacesOsType); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSpaceBlockSize != nil {

		// query param namespaces.space.block_size
		var qrNamespacesSpaceBlockSize int64

		if o.NamespacesSpaceBlockSize != nil {
			qrNamespacesSpaceBlockSize = *o.NamespacesSpaceBlockSize
		}
		qNamespacesSpaceBlockSize := swag.FormatInt64(qrNamespacesSpaceBlockSize)
		if qNamespacesSpaceBlockSize != "" {

			if err := r.SetQueryParam("namespaces.space.block_size", qNamespacesSpaceBlockSize); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSpaceGuaranteeRequested != nil {

		// query param namespaces.space.guarantee.requested
		var qrNamespacesSpaceGuaranteeRequested bool

		if o.NamespacesSpaceGuaranteeRequested != nil {
			qrNamespacesSpaceGuaranteeRequested = *o.NamespacesSpaceGuaranteeRequested
		}
		qNamespacesSpaceGuaranteeRequested := swag.FormatBool(qrNamespacesSpaceGuaranteeRequested)
		if qNamespacesSpaceGuaranteeRequested != "" {

			if err := r.SetQueryParam("namespaces.space.guarantee.requested", qNamespacesSpaceGuaranteeRequested); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSpaceGuaranteeReserved != nil {

		// query param namespaces.space.guarantee.reserved
		var qrNamespacesSpaceGuaranteeReserved bool

		if o.NamespacesSpaceGuaranteeReserved != nil {
			qrNamespacesSpaceGuaranteeReserved = *o.NamespacesSpaceGuaranteeReserved
		}
		qNamespacesSpaceGuaranteeReserved := swag.FormatBool(qrNamespacesSpaceGuaranteeReserved)
		if qNamespacesSpaceGuaranteeReserved != "" {

			if err := r.SetQueryParam("namespaces.space.guarantee.reserved", qNamespacesSpaceGuaranteeReserved); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSpaceSize != nil {

		// query param namespaces.space.size
		var qrNamespacesSpaceSize int64

		if o.NamespacesSpaceSize != nil {
			qrNamespacesSpaceSize = *o.NamespacesSpaceSize
		}
		qNamespacesSpaceSize := swag.FormatInt64(qrNamespacesSpaceSize)
		if qNamespacesSpaceSize != "" {

			if err := r.SetQueryParam("namespaces.space.size", qNamespacesSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSpaceUsed != nil {

		// query param namespaces.space.used
		var qrNamespacesSpaceUsed int64

		if o.NamespacesSpaceUsed != nil {
			qrNamespacesSpaceUsed = *o.NamespacesSpaceUsed
		}
		qNamespacesSpaceUsed := swag.FormatInt64(qrNamespacesSpaceUsed)
		if qNamespacesSpaceUsed != "" {

			if err := r.SetQueryParam("namespaces.space.used", qNamespacesSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.NamespacesStatusContainerState != nil {

		// query param namespaces.status.container_state
		var qrNamespacesStatusContainerState string

		if o.NamespacesStatusContainerState != nil {
			qrNamespacesStatusContainerState = *o.NamespacesStatusContainerState
		}
		qNamespacesStatusContainerState := qrNamespacesStatusContainerState
		if qNamespacesStatusContainerState != "" {

			if err := r.SetQueryParam("namespaces.status.container_state", qNamespacesStatusContainerState); err != nil {
				return err
			}
		}
	}

	if o.NamespacesStatusMapped != nil {

		// query param namespaces.status.mapped
		var qrNamespacesStatusMapped bool

		if o.NamespacesStatusMapped != nil {
			qrNamespacesStatusMapped = *o.NamespacesStatusMapped
		}
		qNamespacesStatusMapped := swag.FormatBool(qrNamespacesStatusMapped)
		if qNamespacesStatusMapped != "" {

			if err := r.SetQueryParam("namespaces.status.mapped", qNamespacesStatusMapped); err != nil {
				return err
			}
		}
	}

	if o.NamespacesStatusReadOnly != nil {

		// query param namespaces.status.read_only
		var qrNamespacesStatusReadOnly bool

		if o.NamespacesStatusReadOnly != nil {
			qrNamespacesStatusReadOnly = *o.NamespacesStatusReadOnly
		}
		qNamespacesStatusReadOnly := swag.FormatBool(qrNamespacesStatusReadOnly)
		if qNamespacesStatusReadOnly != "" {

			if err := r.SetQueryParam("namespaces.status.read_only", qNamespacesStatusReadOnly); err != nil {
				return err
			}
		}
	}

	if o.NamespacesStatusState != nil {

		// query param namespaces.status.state
		var qrNamespacesStatusState string

		if o.NamespacesStatusState != nil {
			qrNamespacesStatusState = *o.NamespacesStatusState
		}
		qNamespacesStatusState := qrNamespacesStatusState
		if qNamespacesStatusState != "" {

			if err := r.SetQueryParam("namespaces.status.state", qNamespacesStatusState); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapAnagrpid != nil {

		// query param namespaces.subsystem_map.anagrpid
		var qrNamespacesSubsystemMapAnagrpid string

		if o.NamespacesSubsystemMapAnagrpid != nil {
			qrNamespacesSubsystemMapAnagrpid = *o.NamespacesSubsystemMapAnagrpid
		}
		qNamespacesSubsystemMapAnagrpid := qrNamespacesSubsystemMapAnagrpid
		if qNamespacesSubsystemMapAnagrpid != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.anagrpid", qNamespacesSubsystemMapAnagrpid); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapNsid != nil {

		// query param namespaces.subsystem_map.nsid
		var qrNamespacesSubsystemMapNsid string

		if o.NamespacesSubsystemMapNsid != nil {
			qrNamespacesSubsystemMapNsid = *o.NamespacesSubsystemMapNsid
		}
		qNamespacesSubsystemMapNsid := qrNamespacesSubsystemMapNsid
		if qNamespacesSubsystemMapNsid != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.nsid", qNamespacesSubsystemMapNsid); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapSubsystemComment != nil {

		// query param namespaces.subsystem_map.subsystem.comment
		var qrNamespacesSubsystemMapSubsystemComment string

		if o.NamespacesSubsystemMapSubsystemComment != nil {
			qrNamespacesSubsystemMapSubsystemComment = *o.NamespacesSubsystemMapSubsystemComment
		}
		qNamespacesSubsystemMapSubsystemComment := qrNamespacesSubsystemMapSubsystemComment
		if qNamespacesSubsystemMapSubsystemComment != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.subsystem.comment", qNamespacesSubsystemMapSubsystemComment); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapSubsystemHostsNqn != nil {

		// query param namespaces.subsystem_map.subsystem.hosts.nqn
		var qrNamespacesSubsystemMapSubsystemHostsNqn string

		if o.NamespacesSubsystemMapSubsystemHostsNqn != nil {
			qrNamespacesSubsystemMapSubsystemHostsNqn = *o.NamespacesSubsystemMapSubsystemHostsNqn
		}
		qNamespacesSubsystemMapSubsystemHostsNqn := qrNamespacesSubsystemMapSubsystemHostsNqn
		if qNamespacesSubsystemMapSubsystemHostsNqn != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.subsystem.hosts.nqn", qNamespacesSubsystemMapSubsystemHostsNqn); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapSubsystemName != nil {

		// query param namespaces.subsystem_map.subsystem.name
		var qrNamespacesSubsystemMapSubsystemName string

		if o.NamespacesSubsystemMapSubsystemName != nil {
			qrNamespacesSubsystemMapSubsystemName = *o.NamespacesSubsystemMapSubsystemName
		}
		qNamespacesSubsystemMapSubsystemName := qrNamespacesSubsystemMapSubsystemName
		if qNamespacesSubsystemMapSubsystemName != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.subsystem.name", qNamespacesSubsystemMapSubsystemName); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapSubsystemOsType != nil {

		// query param namespaces.subsystem_map.subsystem.os_type
		var qrNamespacesSubsystemMapSubsystemOsType string

		if o.NamespacesSubsystemMapSubsystemOsType != nil {
			qrNamespacesSubsystemMapSubsystemOsType = *o.NamespacesSubsystemMapSubsystemOsType
		}
		qNamespacesSubsystemMapSubsystemOsType := qrNamespacesSubsystemMapSubsystemOsType
		if qNamespacesSubsystemMapSubsystemOsType != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.subsystem.os_type", qNamespacesSubsystemMapSubsystemOsType); err != nil {
				return err
			}
		}
	}

	if o.NamespacesSubsystemMapSubsystemUUID != nil {

		// query param namespaces.subsystem_map.subsystem.uuid
		var qrNamespacesSubsystemMapSubsystemUUID string

		if o.NamespacesSubsystemMapSubsystemUUID != nil {
			qrNamespacesSubsystemMapSubsystemUUID = *o.NamespacesSubsystemMapSubsystemUUID
		}
		qNamespacesSubsystemMapSubsystemUUID := qrNamespacesSubsystemMapSubsystemUUID
		if qNamespacesSubsystemMapSubsystemUUID != "" {

			if err := r.SetQueryParam("namespaces.subsystem_map.subsystem.uuid", qNamespacesSubsystemMapSubsystemUUID); err != nil {
				return err
			}
		}
	}

	if o.NamespacesUUID != nil {

		// query param namespaces.uuid
		var qrNamespacesUUID string

		if o.NamespacesUUID != nil {
			qrNamespacesUUID = *o.NamespacesUUID
		}
		qNamespacesUUID := qrNamespacesUUID
		if qNamespacesUUID != "" {

			if err := r.SetQueryParam("namespaces.uuid", qNamespacesUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderBy != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ParentConsistencyGroupName != nil {

		// query param parent_consistency_group.name
		var qrParentConsistencyGroupName string

		if o.ParentConsistencyGroupName != nil {
			qrParentConsistencyGroupName = *o.ParentConsistencyGroupName
		}
		qParentConsistencyGroupName := qrParentConsistencyGroupName
		if qParentConsistencyGroupName != "" {

			if err := r.SetQueryParam("parent_consistency_group.name", qParentConsistencyGroupName); err != nil {
				return err
			}
		}
	}

	if o.ParentConsistencyGroupUUID != nil {

		// query param parent_consistency_group.uuid
		var qrParentConsistencyGroupUUID string

		if o.ParentConsistencyGroupUUID != nil {
			qrParentConsistencyGroupUUID = *o.ParentConsistencyGroupUUID
		}
		qParentConsistencyGroupUUID := qrParentConsistencyGroupUUID
		if qParentConsistencyGroupUUID != "" {

			if err := r.SetQueryParam("parent_consistency_group.uuid", qParentConsistencyGroupUUID); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyMaxThroughputIops != nil {

		// query param qos.policy.max_throughput_iops
		var qrQosPolicyMaxThroughputIops int64

		if o.QosPolicyMaxThroughputIops != nil {
			qrQosPolicyMaxThroughputIops = *o.QosPolicyMaxThroughputIops
		}
		qQosPolicyMaxThroughputIops := swag.FormatInt64(qrQosPolicyMaxThroughputIops)
		if qQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("qos.policy.max_throughput_iops", qQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyMaxThroughputMbps != nil {

		// query param qos.policy.max_throughput_mbps
		var qrQosPolicyMaxThroughputMbps int64

		if o.QosPolicyMaxThroughputMbps != nil {
			qrQosPolicyMaxThroughputMbps = *o.QosPolicyMaxThroughputMbps
		}
		qQosPolicyMaxThroughputMbps := swag.FormatInt64(qrQosPolicyMaxThroughputMbps)
		if qQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("qos.policy.max_throughput_mbps", qQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyMinThroughputIops != nil {

		// query param qos.policy.min_throughput_iops
		var qrQosPolicyMinThroughputIops int64

		if o.QosPolicyMinThroughputIops != nil {
			qrQosPolicyMinThroughputIops = *o.QosPolicyMinThroughputIops
		}
		qQosPolicyMinThroughputIops := swag.FormatInt64(qrQosPolicyMinThroughputIops)
		if qQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("qos.policy.min_throughput_iops", qQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyMinThroughputMbps != nil {

		// query param qos.policy.min_throughput_mbps
		var qrQosPolicyMinThroughputMbps int64

		if o.QosPolicyMinThroughputMbps != nil {
			qrQosPolicyMinThroughputMbps = *o.QosPolicyMinThroughputMbps
		}
		qQosPolicyMinThroughputMbps := swag.FormatInt64(qrQosPolicyMinThroughputMbps)
		if qQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("qos.policy.min_throughput_mbps", qQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyName != nil {

		// query param qos.policy.name
		var qrQosPolicyName string

		if o.QosPolicyName != nil {
			qrQosPolicyName = *o.QosPolicyName
		}
		qQosPolicyName := qrQosPolicyName
		if qQosPolicyName != "" {

			if err := r.SetQueryParam("qos.policy.name", qQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.QosPolicyUUID != nil {

		// query param qos.policy.uuid
		var qrQosPolicyUUID string

		if o.QosPolicyUUID != nil {
			qrQosPolicyUUID = *o.QosPolicyUUID
		}
		qQosPolicyUUID := qrQosPolicyUUID
		if qQosPolicyUUID != "" {

			if err := r.SetQueryParam("qos.policy.uuid", qQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.Replicated != nil {

		// query param replicated
		var qrReplicated bool

		if o.Replicated != nil {
			qrReplicated = *o.Replicated
		}
		qReplicated := swag.FormatBool(qrReplicated)
		if qReplicated != "" {

			if err := r.SetQueryParam("replicated", qReplicated); err != nil {
				return err
			}
		}
	}

	if o.ReplicationSource != nil {

		// query param replication_source
		var qrReplicationSource bool

		if o.ReplicationSource != nil {
			qrReplicationSource = *o.ReplicationSource
		}
		qReplicationSource := swag.FormatBool(qrReplicationSource)
		if qReplicationSource != "" {

			if err := r.SetQueryParam("replication_source", qReplicationSource); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecords != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecords != nil {
			qrReturnRecords = *o.ReturnRecords
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeout != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeout != nil {
			qrReturnTimeout = *o.ReturnTimeout
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SnapshotPolicyName != nil {

		// query param snapshot_policy.name
		var qrSnapshotPolicyName string

		if o.SnapshotPolicyName != nil {
			qrSnapshotPolicyName = *o.SnapshotPolicyName
		}
		qSnapshotPolicyName := qrSnapshotPolicyName
		if qSnapshotPolicyName != "" {

			if err := r.SetQueryParam("snapshot_policy.name", qSnapshotPolicyName); err != nil {
				return err
			}
		}
	}

	if o.SnapshotPolicyUUID != nil {

		// query param snapshot_policy.uuid
		var qrSnapshotPolicyUUID string

		if o.SnapshotPolicyUUID != nil {
			qrSnapshotPolicyUUID = *o.SnapshotPolicyUUID
		}
		qSnapshotPolicyUUID := qrSnapshotPolicyUUID
		if qSnapshotPolicyUUID != "" {

			if err := r.SetQueryParam("snapshot_policy.uuid", qSnapshotPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.SpaceAvailable != nil {

		// query param space.available
		var qrSpaceAvailable int64

		if o.SpaceAvailable != nil {
			qrSpaceAvailable = *o.SpaceAvailable
		}
		qSpaceAvailable := swag.FormatInt64(qrSpaceAvailable)
		if qSpaceAvailable != "" {

			if err := r.SetQueryParam("space.available", qSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.SpaceSize != nil {

		// query param space.size
		var qrSpaceSize int64

		if o.SpaceSize != nil {
			qrSpaceSize = *o.SpaceSize
		}
		qSpaceSize := swag.FormatInt64(qrSpaceSize)
		if qSpaceSize != "" {

			if err := r.SetQueryParam("space.size", qSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.SpaceUsed != nil {

		// query param space.used
		var qrSpaceUsed int64

		if o.SpaceUsed != nil {
			qrSpaceUsed = *o.SpaceUsed
		}
		qSpaceUsed := swag.FormatInt64(qrSpaceUsed)
		if qSpaceUsed != "" {

			if err := r.SetQueryParam("space.used", qSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.SvmName != nil {

		// query param svm.name
		var qrSvmName string

		if o.SvmName != nil {
			qrSvmName = *o.SvmName
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SvmUUID != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SvmUUID != nil {
			qrSvmUUID = *o.SvmUUID
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.TieringPolicy != nil {

		// query param tiering.policy
		var qrTieringPolicy string

		if o.TieringPolicy != nil {
			qrTieringPolicy = *o.TieringPolicy
		}
		qTieringPolicy := qrTieringPolicy
		if qTieringPolicy != "" {

			if err := r.SetQueryParam("tiering.policy", qTieringPolicy); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUID); err != nil {
		return err
	}

	if o.VolumesComment != nil {

		// query param volumes.comment
		var qrVolumesComment string

		if o.VolumesComment != nil {
			qrVolumesComment = *o.VolumesComment
		}
		qVolumesComment := qrVolumesComment
		if qVolumesComment != "" {

			if err := r.SetQueryParam("volumes.comment", qVolumesComment); err != nil {
				return err
			}
		}
	}

	if o.VolumesLanguage != nil {

		// query param volumes.language
		var qrVolumesLanguage string

		if o.VolumesLanguage != nil {
			qrVolumesLanguage = *o.VolumesLanguage
		}
		qVolumesLanguage := qrVolumesLanguage
		if qVolumesLanguage != "" {

			if err := r.SetQueryParam("volumes.language", qVolumesLanguage); err != nil {
				return err
			}
		}
	}

	if o.VolumesName != nil {

		// query param volumes.name
		var qrVolumesName string

		if o.VolumesName != nil {
			qrVolumesName = *o.VolumesName
		}
		qVolumesName := qrVolumesName
		if qVolumesName != "" {

			if err := r.SetQueryParam("volumes.name", qVolumesName); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesAccessBasedEnumeration != nil {

		// query param volumes.nas.cifs.shares.access_based_enumeration
		var qrVolumesNasCifsSharesAccessBasedEnumeration bool

		if o.VolumesNasCifsSharesAccessBasedEnumeration != nil {
			qrVolumesNasCifsSharesAccessBasedEnumeration = *o.VolumesNasCifsSharesAccessBasedEnumeration
		}
		qVolumesNasCifsSharesAccessBasedEnumeration := swag.FormatBool(qrVolumesNasCifsSharesAccessBasedEnumeration)
		if qVolumesNasCifsSharesAccessBasedEnumeration != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.access_based_enumeration", qVolumesNasCifsSharesAccessBasedEnumeration); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesAclsPermission != nil {

		// query param volumes.nas.cifs.shares.acls.permission
		var qrVolumesNasCifsSharesAclsPermission string

		if o.VolumesNasCifsSharesAclsPermission != nil {
			qrVolumesNasCifsSharesAclsPermission = *o.VolumesNasCifsSharesAclsPermission
		}
		qVolumesNasCifsSharesAclsPermission := qrVolumesNasCifsSharesAclsPermission
		if qVolumesNasCifsSharesAclsPermission != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.acls.permission", qVolumesNasCifsSharesAclsPermission); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesAclsType != nil {

		// query param volumes.nas.cifs.shares.acls.type
		var qrVolumesNasCifsSharesAclsType string

		if o.VolumesNasCifsSharesAclsType != nil {
			qrVolumesNasCifsSharesAclsType = *o.VolumesNasCifsSharesAclsType
		}
		qVolumesNasCifsSharesAclsType := qrVolumesNasCifsSharesAclsType
		if qVolumesNasCifsSharesAclsType != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.acls.type", qVolumesNasCifsSharesAclsType); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesAclsUserOrGroup != nil {

		// query param volumes.nas.cifs.shares.acls.user_or_group
		var qrVolumesNasCifsSharesAclsUserOrGroup string

		if o.VolumesNasCifsSharesAclsUserOrGroup != nil {
			qrVolumesNasCifsSharesAclsUserOrGroup = *o.VolumesNasCifsSharesAclsUserOrGroup
		}
		qVolumesNasCifsSharesAclsUserOrGroup := qrVolumesNasCifsSharesAclsUserOrGroup
		if qVolumesNasCifsSharesAclsUserOrGroup != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.acls.user_or_group", qVolumesNasCifsSharesAclsUserOrGroup); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesAllowUnencryptedAccess != nil {

		// query param volumes.nas.cifs.shares.allow_unencrypted_access
		var qrVolumesNasCifsSharesAllowUnencryptedAccess bool

		if o.VolumesNasCifsSharesAllowUnencryptedAccess != nil {
			qrVolumesNasCifsSharesAllowUnencryptedAccess = *o.VolumesNasCifsSharesAllowUnencryptedAccess
		}
		qVolumesNasCifsSharesAllowUnencryptedAccess := swag.FormatBool(qrVolumesNasCifsSharesAllowUnencryptedAccess)
		if qVolumesNasCifsSharesAllowUnencryptedAccess != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.allow_unencrypted_access", qVolumesNasCifsSharesAllowUnencryptedAccess); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesChangeNotify != nil {

		// query param volumes.nas.cifs.shares.change_notify
		var qrVolumesNasCifsSharesChangeNotify bool

		if o.VolumesNasCifsSharesChangeNotify != nil {
			qrVolumesNasCifsSharesChangeNotify = *o.VolumesNasCifsSharesChangeNotify
		}
		qVolumesNasCifsSharesChangeNotify := swag.FormatBool(qrVolumesNasCifsSharesChangeNotify)
		if qVolumesNasCifsSharesChangeNotify != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.change_notify", qVolumesNasCifsSharesChangeNotify); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesComment != nil {

		// query param volumes.nas.cifs.shares.comment
		var qrVolumesNasCifsSharesComment string

		if o.VolumesNasCifsSharesComment != nil {
			qrVolumesNasCifsSharesComment = *o.VolumesNasCifsSharesComment
		}
		qVolumesNasCifsSharesComment := qrVolumesNasCifsSharesComment
		if qVolumesNasCifsSharesComment != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.comment", qVolumesNasCifsSharesComment); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesContinuouslyAvailable != nil {

		// query param volumes.nas.cifs.shares.continuously_available
		var qrVolumesNasCifsSharesContinuouslyAvailable bool

		if o.VolumesNasCifsSharesContinuouslyAvailable != nil {
			qrVolumesNasCifsSharesContinuouslyAvailable = *o.VolumesNasCifsSharesContinuouslyAvailable
		}
		qVolumesNasCifsSharesContinuouslyAvailable := swag.FormatBool(qrVolumesNasCifsSharesContinuouslyAvailable)
		if qVolumesNasCifsSharesContinuouslyAvailable != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.continuously_available", qVolumesNasCifsSharesContinuouslyAvailable); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesDirUmask != nil {

		// query param volumes.nas.cifs.shares.dir_umask
		var qrVolumesNasCifsSharesDirUmask int64

		if o.VolumesNasCifsSharesDirUmask != nil {
			qrVolumesNasCifsSharesDirUmask = *o.VolumesNasCifsSharesDirUmask
		}
		qVolumesNasCifsSharesDirUmask := swag.FormatInt64(qrVolumesNasCifsSharesDirUmask)
		if qVolumesNasCifsSharesDirUmask != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.dir_umask", qVolumesNasCifsSharesDirUmask); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesEncryption != nil {

		// query param volumes.nas.cifs.shares.encryption
		var qrVolumesNasCifsSharesEncryption bool

		if o.VolumesNasCifsSharesEncryption != nil {
			qrVolumesNasCifsSharesEncryption = *o.VolumesNasCifsSharesEncryption
		}
		qVolumesNasCifsSharesEncryption := swag.FormatBool(qrVolumesNasCifsSharesEncryption)
		if qVolumesNasCifsSharesEncryption != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.encryption", qVolumesNasCifsSharesEncryption); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesFileUmask != nil {

		// query param volumes.nas.cifs.shares.file_umask
		var qrVolumesNasCifsSharesFileUmask int64

		if o.VolumesNasCifsSharesFileUmask != nil {
			qrVolumesNasCifsSharesFileUmask = *o.VolumesNasCifsSharesFileUmask
		}
		qVolumesNasCifsSharesFileUmask := swag.FormatInt64(qrVolumesNasCifsSharesFileUmask)
		if qVolumesNasCifsSharesFileUmask != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.file_umask", qVolumesNasCifsSharesFileUmask); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesHomeDirectory != nil {

		// query param volumes.nas.cifs.shares.home_directory
		var qrVolumesNasCifsSharesHomeDirectory bool

		if o.VolumesNasCifsSharesHomeDirectory != nil {
			qrVolumesNasCifsSharesHomeDirectory = *o.VolumesNasCifsSharesHomeDirectory
		}
		qVolumesNasCifsSharesHomeDirectory := swag.FormatBool(qrVolumesNasCifsSharesHomeDirectory)
		if qVolumesNasCifsSharesHomeDirectory != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.home_directory", qVolumesNasCifsSharesHomeDirectory); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesName != nil {

		// query param volumes.nas.cifs.shares.name
		var qrVolumesNasCifsSharesName string

		if o.VolumesNasCifsSharesName != nil {
			qrVolumesNasCifsSharesName = *o.VolumesNasCifsSharesName
		}
		qVolumesNasCifsSharesName := qrVolumesNasCifsSharesName
		if qVolumesNasCifsSharesName != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.name", qVolumesNasCifsSharesName); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesNamespaceCaching != nil {

		// query param volumes.nas.cifs.shares.namespace_caching
		var qrVolumesNasCifsSharesNamespaceCaching bool

		if o.VolumesNasCifsSharesNamespaceCaching != nil {
			qrVolumesNasCifsSharesNamespaceCaching = *o.VolumesNasCifsSharesNamespaceCaching
		}
		qVolumesNasCifsSharesNamespaceCaching := swag.FormatBool(qrVolumesNasCifsSharesNamespaceCaching)
		if qVolumesNasCifsSharesNamespaceCaching != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.namespace_caching", qVolumesNasCifsSharesNamespaceCaching); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesNoStrictSecurity != nil {

		// query param volumes.nas.cifs.shares.no_strict_security
		var qrVolumesNasCifsSharesNoStrictSecurity bool

		if o.VolumesNasCifsSharesNoStrictSecurity != nil {
			qrVolumesNasCifsSharesNoStrictSecurity = *o.VolumesNasCifsSharesNoStrictSecurity
		}
		qVolumesNasCifsSharesNoStrictSecurity := swag.FormatBool(qrVolumesNasCifsSharesNoStrictSecurity)
		if qVolumesNasCifsSharesNoStrictSecurity != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.no_strict_security", qVolumesNasCifsSharesNoStrictSecurity); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesOfflineFiles != nil {

		// query param volumes.nas.cifs.shares.offline_files
		var qrVolumesNasCifsSharesOfflineFiles string

		if o.VolumesNasCifsSharesOfflineFiles != nil {
			qrVolumesNasCifsSharesOfflineFiles = *o.VolumesNasCifsSharesOfflineFiles
		}
		qVolumesNasCifsSharesOfflineFiles := qrVolumesNasCifsSharesOfflineFiles
		if qVolumesNasCifsSharesOfflineFiles != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.offline_files", qVolumesNasCifsSharesOfflineFiles); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesOplocks != nil {

		// query param volumes.nas.cifs.shares.oplocks
		var qrVolumesNasCifsSharesOplocks bool

		if o.VolumesNasCifsSharesOplocks != nil {
			qrVolumesNasCifsSharesOplocks = *o.VolumesNasCifsSharesOplocks
		}
		qVolumesNasCifsSharesOplocks := swag.FormatBool(qrVolumesNasCifsSharesOplocks)
		if qVolumesNasCifsSharesOplocks != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.oplocks", qVolumesNasCifsSharesOplocks); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesShowSnapshot != nil {

		// query param volumes.nas.cifs.shares.show_snapshot
		var qrVolumesNasCifsSharesShowSnapshot bool

		if o.VolumesNasCifsSharesShowSnapshot != nil {
			qrVolumesNasCifsSharesShowSnapshot = *o.VolumesNasCifsSharesShowSnapshot
		}
		qVolumesNasCifsSharesShowSnapshot := swag.FormatBool(qrVolumesNasCifsSharesShowSnapshot)
		if qVolumesNasCifsSharesShowSnapshot != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.show_snapshot", qVolumesNasCifsSharesShowSnapshot); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesUnixSymlink != nil {

		// query param volumes.nas.cifs.shares.unix_symlink
		var qrVolumesNasCifsSharesUnixSymlink string

		if o.VolumesNasCifsSharesUnixSymlink != nil {
			qrVolumesNasCifsSharesUnixSymlink = *o.VolumesNasCifsSharesUnixSymlink
		}
		qVolumesNasCifsSharesUnixSymlink := qrVolumesNasCifsSharesUnixSymlink
		if qVolumesNasCifsSharesUnixSymlink != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.unix_symlink", qVolumesNasCifsSharesUnixSymlink); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasCifsSharesVscanProfile != nil {

		// query param volumes.nas.cifs.shares.vscan_profile
		var qrVolumesNasCifsSharesVscanProfile string

		if o.VolumesNasCifsSharesVscanProfile != nil {
			qrVolumesNasCifsSharesVscanProfile = *o.VolumesNasCifsSharesVscanProfile
		}
		qVolumesNasCifsSharesVscanProfile := qrVolumesNasCifsSharesVscanProfile
		if qVolumesNasCifsSharesVscanProfile != "" {

			if err := r.SetQueryParam("volumes.nas.cifs.shares.vscan_profile", qVolumesNasCifsSharesVscanProfile); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyName != nil {

		// query param volumes.nas.export_policy.name
		var qrVolumesNasExportPolicyName string

		if o.VolumesNasExportPolicyName != nil {
			qrVolumesNasExportPolicyName = *o.VolumesNasExportPolicyName
		}
		qVolumesNasExportPolicyName := qrVolumesNasExportPolicyName
		if qVolumesNasExportPolicyName != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.name", qVolumesNasExportPolicyName); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesAllowDeviceCreation != nil {

		// query param volumes.nas.export_policy.rules.allow_device_creation
		var qrVolumesNasExportPolicyRulesAllowDeviceCreation bool

		if o.VolumesNasExportPolicyRulesAllowDeviceCreation != nil {
			qrVolumesNasExportPolicyRulesAllowDeviceCreation = *o.VolumesNasExportPolicyRulesAllowDeviceCreation
		}
		qVolumesNasExportPolicyRulesAllowDeviceCreation := swag.FormatBool(qrVolumesNasExportPolicyRulesAllowDeviceCreation)
		if qVolumesNasExportPolicyRulesAllowDeviceCreation != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.allow_device_creation", qVolumesNasExportPolicyRulesAllowDeviceCreation); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesAllowSuid != nil {

		// query param volumes.nas.export_policy.rules.allow_suid
		var qrVolumesNasExportPolicyRulesAllowSuid bool

		if o.VolumesNasExportPolicyRulesAllowSuid != nil {
			qrVolumesNasExportPolicyRulesAllowSuid = *o.VolumesNasExportPolicyRulesAllowSuid
		}
		qVolumesNasExportPolicyRulesAllowSuid := swag.FormatBool(qrVolumesNasExportPolicyRulesAllowSuid)
		if qVolumesNasExportPolicyRulesAllowSuid != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.allow_suid", qVolumesNasExportPolicyRulesAllowSuid); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesAnonymousUser != nil {

		// query param volumes.nas.export_policy.rules.anonymous_user
		var qrVolumesNasExportPolicyRulesAnonymousUser string

		if o.VolumesNasExportPolicyRulesAnonymousUser != nil {
			qrVolumesNasExportPolicyRulesAnonymousUser = *o.VolumesNasExportPolicyRulesAnonymousUser
		}
		qVolumesNasExportPolicyRulesAnonymousUser := qrVolumesNasExportPolicyRulesAnonymousUser
		if qVolumesNasExportPolicyRulesAnonymousUser != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.anonymous_user", qVolumesNasExportPolicyRulesAnonymousUser); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesChownMode != nil {

		// query param volumes.nas.export_policy.rules.chown_mode
		var qrVolumesNasExportPolicyRulesChownMode string

		if o.VolumesNasExportPolicyRulesChownMode != nil {
			qrVolumesNasExportPolicyRulesChownMode = *o.VolumesNasExportPolicyRulesChownMode
		}
		qVolumesNasExportPolicyRulesChownMode := qrVolumesNasExportPolicyRulesChownMode
		if qVolumesNasExportPolicyRulesChownMode != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.chown_mode", qVolumesNasExportPolicyRulesChownMode); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesClientsMatch != nil {

		// query param volumes.nas.export_policy.rules.clients.match
		var qrVolumesNasExportPolicyRulesClientsMatch string

		if o.VolumesNasExportPolicyRulesClientsMatch != nil {
			qrVolumesNasExportPolicyRulesClientsMatch = *o.VolumesNasExportPolicyRulesClientsMatch
		}
		qVolumesNasExportPolicyRulesClientsMatch := qrVolumesNasExportPolicyRulesClientsMatch
		if qVolumesNasExportPolicyRulesClientsMatch != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.clients.match", qVolumesNasExportPolicyRulesClientsMatch); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesIndex != nil {

		// query param volumes.nas.export_policy.rules.index
		var qrVolumesNasExportPolicyRulesIndex int64

		if o.VolumesNasExportPolicyRulesIndex != nil {
			qrVolumesNasExportPolicyRulesIndex = *o.VolumesNasExportPolicyRulesIndex
		}
		qVolumesNasExportPolicyRulesIndex := swag.FormatInt64(qrVolumesNasExportPolicyRulesIndex)
		if qVolumesNasExportPolicyRulesIndex != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.index", qVolumesNasExportPolicyRulesIndex); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesNtfsUnixSecurity != nil {

		// query param volumes.nas.export_policy.rules.ntfs_unix_security
		var qrVolumesNasExportPolicyRulesNtfsUnixSecurity string

		if o.VolumesNasExportPolicyRulesNtfsUnixSecurity != nil {
			qrVolumesNasExportPolicyRulesNtfsUnixSecurity = *o.VolumesNasExportPolicyRulesNtfsUnixSecurity
		}
		qVolumesNasExportPolicyRulesNtfsUnixSecurity := qrVolumesNasExportPolicyRulesNtfsUnixSecurity
		if qVolumesNasExportPolicyRulesNtfsUnixSecurity != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.ntfs_unix_security", qVolumesNasExportPolicyRulesNtfsUnixSecurity); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesProtocols != nil {

		// query param volumes.nas.export_policy.rules.protocols
		var qrVolumesNasExportPolicyRulesProtocols string

		if o.VolumesNasExportPolicyRulesProtocols != nil {
			qrVolumesNasExportPolicyRulesProtocols = *o.VolumesNasExportPolicyRulesProtocols
		}
		qVolumesNasExportPolicyRulesProtocols := qrVolumesNasExportPolicyRulesProtocols
		if qVolumesNasExportPolicyRulesProtocols != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.protocols", qVolumesNasExportPolicyRulesProtocols); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesRoRule != nil {

		// query param volumes.nas.export_policy.rules.ro_rule
		var qrVolumesNasExportPolicyRulesRoRule string

		if o.VolumesNasExportPolicyRulesRoRule != nil {
			qrVolumesNasExportPolicyRulesRoRule = *o.VolumesNasExportPolicyRulesRoRule
		}
		qVolumesNasExportPolicyRulesRoRule := qrVolumesNasExportPolicyRulesRoRule
		if qVolumesNasExportPolicyRulesRoRule != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.ro_rule", qVolumesNasExportPolicyRulesRoRule); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesRwRule != nil {

		// query param volumes.nas.export_policy.rules.rw_rule
		var qrVolumesNasExportPolicyRulesRwRule string

		if o.VolumesNasExportPolicyRulesRwRule != nil {
			qrVolumesNasExportPolicyRulesRwRule = *o.VolumesNasExportPolicyRulesRwRule
		}
		qVolumesNasExportPolicyRulesRwRule := qrVolumesNasExportPolicyRulesRwRule
		if qVolumesNasExportPolicyRulesRwRule != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.rw_rule", qVolumesNasExportPolicyRulesRwRule); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyRulesSuperuser != nil {

		// query param volumes.nas.export_policy.rules.superuser
		var qrVolumesNasExportPolicyRulesSuperuser string

		if o.VolumesNasExportPolicyRulesSuperuser != nil {
			qrVolumesNasExportPolicyRulesSuperuser = *o.VolumesNasExportPolicyRulesSuperuser
		}
		qVolumesNasExportPolicyRulesSuperuser := qrVolumesNasExportPolicyRulesSuperuser
		if qVolumesNasExportPolicyRulesSuperuser != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.rules.superuser", qVolumesNasExportPolicyRulesSuperuser); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasExportPolicyUUID != nil {

		// query param volumes.nas.export_policy.uuid
		var qrVolumesNasExportPolicyUUID string

		if o.VolumesNasExportPolicyUUID != nil {
			qrVolumesNasExportPolicyUUID = *o.VolumesNasExportPolicyUUID
		}
		qVolumesNasExportPolicyUUID := qrVolumesNasExportPolicyUUID
		if qVolumesNasExportPolicyUUID != "" {

			if err := r.SetQueryParam("volumes.nas.export_policy.uuid", qVolumesNasExportPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasGid != nil {

		// query param volumes.nas.gid
		var qrVolumesNasGid int64

		if o.VolumesNasGid != nil {
			qrVolumesNasGid = *o.VolumesNasGid
		}
		qVolumesNasGid := swag.FormatInt64(qrVolumesNasGid)
		if qVolumesNasGid != "" {

			if err := r.SetQueryParam("volumes.nas.gid", qVolumesNasGid); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasJunctionParentName != nil {

		// query param volumes.nas.junction_parent.name
		var qrVolumesNasJunctionParentName string

		if o.VolumesNasJunctionParentName != nil {
			qrVolumesNasJunctionParentName = *o.VolumesNasJunctionParentName
		}
		qVolumesNasJunctionParentName := qrVolumesNasJunctionParentName
		if qVolumesNasJunctionParentName != "" {

			if err := r.SetQueryParam("volumes.nas.junction_parent.name", qVolumesNasJunctionParentName); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasJunctionParentUUID != nil {

		// query param volumes.nas.junction_parent.uuid
		var qrVolumesNasJunctionParentUUID string

		if o.VolumesNasJunctionParentUUID != nil {
			qrVolumesNasJunctionParentUUID = *o.VolumesNasJunctionParentUUID
		}
		qVolumesNasJunctionParentUUID := qrVolumesNasJunctionParentUUID
		if qVolumesNasJunctionParentUUID != "" {

			if err := r.SetQueryParam("volumes.nas.junction_parent.uuid", qVolumesNasJunctionParentUUID); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasPath != nil {

		// query param volumes.nas.path
		var qrVolumesNasPath string

		if o.VolumesNasPath != nil {
			qrVolumesNasPath = *o.VolumesNasPath
		}
		qVolumesNasPath := qrVolumesNasPath
		if qVolumesNasPath != "" {

			if err := r.SetQueryParam("volumes.nas.path", qVolumesNasPath); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasSecurityStyle != nil {

		// query param volumes.nas.security_style
		var qrVolumesNasSecurityStyle string

		if o.VolumesNasSecurityStyle != nil {
			qrVolumesNasSecurityStyle = *o.VolumesNasSecurityStyle
		}
		qVolumesNasSecurityStyle := qrVolumesNasSecurityStyle
		if qVolumesNasSecurityStyle != "" {

			if err := r.SetQueryParam("volumes.nas.security_style", qVolumesNasSecurityStyle); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasUID != nil {

		// query param volumes.nas.uid
		var qrVolumesNasUID int64

		if o.VolumesNasUID != nil {
			qrVolumesNasUID = *o.VolumesNasUID
		}
		qVolumesNasUID := swag.FormatInt64(qrVolumesNasUID)
		if qVolumesNasUID != "" {

			if err := r.SetQueryParam("volumes.nas.uid", qVolumesNasUID); err != nil {
				return err
			}
		}
	}

	if o.VolumesNasUnixPermissions != nil {

		// query param volumes.nas.unix_permissions
		var qrVolumesNasUnixPermissions int64

		if o.VolumesNasUnixPermissions != nil {
			qrVolumesNasUnixPermissions = *o.VolumesNasUnixPermissions
		}
		qVolumesNasUnixPermissions := swag.FormatInt64(qrVolumesNasUnixPermissions)
		if qVolumesNasUnixPermissions != "" {

			if err := r.SetQueryParam("volumes.nas.unix_permissions", qVolumesNasUnixPermissions); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyMaxThroughputIops != nil {

		// query param volumes.qos.policy.max_throughput_iops
		var qrVolumesQosPolicyMaxThroughputIops int64

		if o.VolumesQosPolicyMaxThroughputIops != nil {
			qrVolumesQosPolicyMaxThroughputIops = *o.VolumesQosPolicyMaxThroughputIops
		}
		qVolumesQosPolicyMaxThroughputIops := swag.FormatInt64(qrVolumesQosPolicyMaxThroughputIops)
		if qVolumesQosPolicyMaxThroughputIops != "" {

			if err := r.SetQueryParam("volumes.qos.policy.max_throughput_iops", qVolumesQosPolicyMaxThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyMaxThroughputMbps != nil {

		// query param volumes.qos.policy.max_throughput_mbps
		var qrVolumesQosPolicyMaxThroughputMbps int64

		if o.VolumesQosPolicyMaxThroughputMbps != nil {
			qrVolumesQosPolicyMaxThroughputMbps = *o.VolumesQosPolicyMaxThroughputMbps
		}
		qVolumesQosPolicyMaxThroughputMbps := swag.FormatInt64(qrVolumesQosPolicyMaxThroughputMbps)
		if qVolumesQosPolicyMaxThroughputMbps != "" {

			if err := r.SetQueryParam("volumes.qos.policy.max_throughput_mbps", qVolumesQosPolicyMaxThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyMinThroughputIops != nil {

		// query param volumes.qos.policy.min_throughput_iops
		var qrVolumesQosPolicyMinThroughputIops int64

		if o.VolumesQosPolicyMinThroughputIops != nil {
			qrVolumesQosPolicyMinThroughputIops = *o.VolumesQosPolicyMinThroughputIops
		}
		qVolumesQosPolicyMinThroughputIops := swag.FormatInt64(qrVolumesQosPolicyMinThroughputIops)
		if qVolumesQosPolicyMinThroughputIops != "" {

			if err := r.SetQueryParam("volumes.qos.policy.min_throughput_iops", qVolumesQosPolicyMinThroughputIops); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyMinThroughputMbps != nil {

		// query param volumes.qos.policy.min_throughput_mbps
		var qrVolumesQosPolicyMinThroughputMbps int64

		if o.VolumesQosPolicyMinThroughputMbps != nil {
			qrVolumesQosPolicyMinThroughputMbps = *o.VolumesQosPolicyMinThroughputMbps
		}
		qVolumesQosPolicyMinThroughputMbps := swag.FormatInt64(qrVolumesQosPolicyMinThroughputMbps)
		if qVolumesQosPolicyMinThroughputMbps != "" {

			if err := r.SetQueryParam("volumes.qos.policy.min_throughput_mbps", qVolumesQosPolicyMinThroughputMbps); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyName != nil {

		// query param volumes.qos.policy.name
		var qrVolumesQosPolicyName string

		if o.VolumesQosPolicyName != nil {
			qrVolumesQosPolicyName = *o.VolumesQosPolicyName
		}
		qVolumesQosPolicyName := qrVolumesQosPolicyName
		if qVolumesQosPolicyName != "" {

			if err := r.SetQueryParam("volumes.qos.policy.name", qVolumesQosPolicyName); err != nil {
				return err
			}
		}
	}

	if o.VolumesQosPolicyUUID != nil {

		// query param volumes.qos.policy.uuid
		var qrVolumesQosPolicyUUID string

		if o.VolumesQosPolicyUUID != nil {
			qrVolumesQosPolicyUUID = *o.VolumesQosPolicyUUID
		}
		qVolumesQosPolicyUUID := qrVolumesQosPolicyUUID
		if qVolumesQosPolicyUUID != "" {

			if err := r.SetQueryParam("volumes.qos.policy.uuid", qVolumesQosPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.VolumesSnapshotPolicyName != nil {

		// query param volumes.snapshot_policy.name
		var qrVolumesSnapshotPolicyName string

		if o.VolumesSnapshotPolicyName != nil {
			qrVolumesSnapshotPolicyName = *o.VolumesSnapshotPolicyName
		}
		qVolumesSnapshotPolicyName := qrVolumesSnapshotPolicyName
		if qVolumesSnapshotPolicyName != "" {

			if err := r.SetQueryParam("volumes.snapshot_policy.name", qVolumesSnapshotPolicyName); err != nil {
				return err
			}
		}
	}

	if o.VolumesSnapshotPolicyUUID != nil {

		// query param volumes.snapshot_policy.uuid
		var qrVolumesSnapshotPolicyUUID string

		if o.VolumesSnapshotPolicyUUID != nil {
			qrVolumesSnapshotPolicyUUID = *o.VolumesSnapshotPolicyUUID
		}
		qVolumesSnapshotPolicyUUID := qrVolumesSnapshotPolicyUUID
		if qVolumesSnapshotPolicyUUID != "" {

			if err := r.SetQueryParam("volumes.snapshot_policy.uuid", qVolumesSnapshotPolicyUUID); err != nil {
				return err
			}
		}
	}

	if o.VolumesSpaceAvailable != nil {

		// query param volumes.space.available
		var qrVolumesSpaceAvailable int64

		if o.VolumesSpaceAvailable != nil {
			qrVolumesSpaceAvailable = *o.VolumesSpaceAvailable
		}
		qVolumesSpaceAvailable := swag.FormatInt64(qrVolumesSpaceAvailable)
		if qVolumesSpaceAvailable != "" {

			if err := r.SetQueryParam("volumes.space.available", qVolumesSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.VolumesSpaceSize != nil {

		// query param volumes.space.size
		var qrVolumesSpaceSize int64

		if o.VolumesSpaceSize != nil {
			qrVolumesSpaceSize = *o.VolumesSpaceSize
		}
		qVolumesSpaceSize := swag.FormatInt64(qrVolumesSpaceSize)
		if qVolumesSpaceSize != "" {

			if err := r.SetQueryParam("volumes.space.size", qVolumesSpaceSize); err != nil {
				return err
			}
		}
	}

	if o.VolumesSpaceUsed != nil {

		// query param volumes.space.used
		var qrVolumesSpaceUsed int64

		if o.VolumesSpaceUsed != nil {
			qrVolumesSpaceUsed = *o.VolumesSpaceUsed
		}
		qVolumesSpaceUsed := swag.FormatInt64(qrVolumesSpaceUsed)
		if qVolumesSpaceUsed != "" {

			if err := r.SetQueryParam("volumes.space.used", qVolumesSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.VolumesTieringPolicy != nil {

		// query param volumes.tiering.policy
		var qrVolumesTieringPolicy string

		if o.VolumesTieringPolicy != nil {
			qrVolumesTieringPolicy = *o.VolumesTieringPolicy
		}
		qVolumesTieringPolicy := qrVolumesTieringPolicy
		if qVolumesTieringPolicy != "" {

			if err := r.SetQueryParam("volumes.tiering.policy", qVolumesTieringPolicy); err != nil {
				return err
			}
		}
	}

	if o.VolumesUUID != nil {

		// query param volumes.uuid
		var qrVolumesUUID string

		if o.VolumesUUID != nil {
			qrVolumesUUID = *o.VolumesUUID
		}
		qVolumesUUID := qrVolumesUUID
		if qVolumesUUID != "" {

			if err := r.SetQueryParam("volumes.uuid", qVolumesUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamConsistencyGroupGet binds the parameter fields
func (o *ConsistencyGroupGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamConsistencyGroupGet binds the parameter order_by
func (o *ConsistencyGroupGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderBy

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
