// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ConsistencyGroupResponse consistency group response
//
// swagger:model consistency_group_response
type ConsistencyGroupResponse struct {

	// links
	Links *CollectionLinks `json:"_links,omitempty"`

	// consistency group response inline records
	ConsistencyGroupResponseInlineRecords []*ConsistencyGroupResponseInlineRecordsInlineArrayItem `json:"records,omitempty"`

	// Number of records.
	// Example: 1
	NumRecords *int64 `json:"num_records,omitempty"`
}

// Validate validates this consistency group response
func (m *ConsistencyGroupResponse) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateConsistencyGroupResponseInlineRecords(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponse) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponse) validateConsistencyGroupResponseInlineRecords(formats strfmt.Registry) error {
	if swag.IsZero(m.ConsistencyGroupResponseInlineRecords) { // not required
		return nil
	}

	for i := 0; i < len(m.ConsistencyGroupResponseInlineRecords); i++ {
		if swag.IsZero(m.ConsistencyGroupResponseInlineRecords[i]) { // not required
			continue
		}

		if m.ConsistencyGroupResponseInlineRecords[i] != nil {
			if err := m.ConsistencyGroupResponseInlineRecords[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("records" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response based on the context it is used
func (m *ConsistencyGroupResponse) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateConsistencyGroupResponseInlineRecords(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponse) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponse) contextValidateConsistencyGroupResponseInlineRecords(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ConsistencyGroupResponseInlineRecords); i++ {

		if m.ConsistencyGroupResponseInlineRecords[i] != nil {
			if err := m.ConsistencyGroupResponseInlineRecords[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("records" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponse) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponse) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponse
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItem consistency group response inline records inline array item
//
// swagger:model consistency_group_response_inline_records_inline_array_item
type ConsistencyGroupResponseInlineRecordsInlineArrayItem struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// application
	Application *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication `json:"application,omitempty"`

	// clone
	Clone *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone `json:"clone,omitempty"`

	// A consistency group is a mutually exclusive aggregation of volumes or other consistency groups. A consistency group can only be associated with one direct parent consistency group.
	//
	// Max Items: 5
	// Min Items: 0
	// Unique: true
	ConsistencyGroups []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0 `json:"consistency_groups"`

	// The LUNs array can be used to create or modify LUNs in a consistency group on a new or existing volume that is a member of the consistency group. LUNs are considered members of a consistency group if they are located on a volume that is a member of the consistency group.
	//
	// Max Items: 16
	// Min Items: 0
	// Unique: true
	Luns []*ConsistencyGroupResponseRecordsItems0LunsItems0 `json:"luns"`

	// Name of the consistency group. The consistency group name must be unique within an SVM.<br/>
	// If not provided and the consistency group contains only one volume, the name will be generated based on the volume name. If the consistency group contains more than one volume, the name is required.
	//
	Name *string `json:"name,omitempty"`

	// An NVMe namespace is a collection of addressable logical blocks presented to hosts connected to the SVM using the NVMe over Fabrics protocol.
	// In ONTAP, an NVMe namespace is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
	// An NVMe namespace is created to a specified size using thin or thick provisioning as determined by the volume on which it is created. NVMe namespaces support being cloned. An NVMe namespace cannot be renamed, resized, or moved to a different volume. NVMe namespaces do not support the assignment of a QoS policy for performance management, but a QoS policy can be assigned to the volume containing the namespace. See the NVMe namespace object model to learn more about each of the properties supported by the NVMe namespace REST API.<br/>
	// An NVMe namespace must be mapped to an NVMe subsystem to grant access to the subsystem's hosts. Hosts can then access the NVMe namespace and perform I/O using the NVMe over Fabrics protocol.
	//
	// Max Items: 16
	// Min Items: 0
	// Unique: true
	Namespaces []*ConsistencyGroupResponseRecordsItems0NamespacesItems0 `json:"namespaces"`

	// parent consistency group
	ParentConsistencyGroup *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup `json:"parent_consistency_group,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos `json:"qos,omitempty"`

	// Indicates whether or not replication has been enabled on this consistency group.
	//
	Replicated *bool `json:"replicated,omitempty"`

	// Indicates whether or not this consistency group is the source for replication.
	//
	ReplicationSource *bool `json:"replication_source,omitempty"`

	// restore to
	RestoreTo *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo `json:"restore_to,omitempty"`

	// The Snapshot copy policy of the consistency group.<br/>
	// This is the dedicated consistency group Snapshot copy policy, not an aggregation of the volume granular Snapshot copy policy.
	//
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// space
	Space *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace `json:"space,omitempty"`

	// svm
	Svm *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm `json:"svm,omitempty"`

	// tiering
	Tiering *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering `json:"tiering,omitempty"`

	// The unique identifier of the consistency group. The UUID is generated by ONTAP when the consistency group is created.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`

	// A consistency group is a mutually exclusive aggregation of volumes or other consistency groups. A volume can only be associated with one direct parent consistency group.<br/>
	// The volumes array can be used to create new volumes in the consistency group, add existing volumes to the consistency group, or modify existing volumes that are already members of the consistency group.<br/>
	// The total number of volumes across all child consistency groups contained in a consistency group is constrained by the same limit.
	//
	// Max Items: 80
	// Min Items: 0
	// Unique: true
	Volumes []*ConsistencyGroupResponseRecordsItems0VolumesItems0 `json:"volumes"`
}

// Validate validates this consistency group response inline records inline array item
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateApplication(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateClone(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateConsistencyGroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLuns(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNamespaces(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentConsistencyGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRestoreTo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVolumes(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateApplication(formats strfmt.Registry) error {
	if swag.IsZero(m.Application) { // not required
		return nil
	}

	if m.Application != nil {
		if err := m.Application.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("application")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateClone(formats strfmt.Registry) error {
	if swag.IsZero(m.Clone) { // not required
		return nil
	}

	if m.Clone != nil {
		if err := m.Clone.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateConsistencyGroups(formats strfmt.Registry) error {
	if swag.IsZero(m.ConsistencyGroups) { // not required
		return nil
	}

	iConsistencyGroupsSize := int64(len(m.ConsistencyGroups))

	if err := validate.MinItems("consistency_groups", "body", iConsistencyGroupsSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("consistency_groups", "body", iConsistencyGroupsSize, 5); err != nil {
		return err
	}

	if err := validate.UniqueItems("consistency_groups", "body", m.ConsistencyGroups); err != nil {
		return err
	}

	for i := 0; i < len(m.ConsistencyGroups); i++ {
		if swag.IsZero(m.ConsistencyGroups[i]) { // not required
			continue
		}

		if m.ConsistencyGroups[i] != nil {
			if err := m.ConsistencyGroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("consistency_groups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateLuns(formats strfmt.Registry) error {
	if swag.IsZero(m.Luns) { // not required
		return nil
	}

	iLunsSize := int64(len(m.Luns))

	if err := validate.MinItems("luns", "body", iLunsSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("luns", "body", iLunsSize, 16); err != nil {
		return err
	}

	if err := validate.UniqueItems("luns", "body", m.Luns); err != nil {
		return err
	}

	for i := 0; i < len(m.Luns); i++ {
		if swag.IsZero(m.Luns[i]) { // not required
			continue
		}

		if m.Luns[i] != nil {
			if err := m.Luns[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("luns" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateNamespaces(formats strfmt.Registry) error {
	if swag.IsZero(m.Namespaces) { // not required
		return nil
	}

	iNamespacesSize := int64(len(m.Namespaces))

	if err := validate.MinItems("namespaces", "body", iNamespacesSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("namespaces", "body", iNamespacesSize, 16); err != nil {
		return err
	}

	if err := validate.UniqueItems("namespaces", "body", m.Namespaces); err != nil {
		return err
	}

	for i := 0; i < len(m.Namespaces); i++ {
		if swag.IsZero(m.Namespaces[i]) { // not required
			continue
		}

		if m.Namespaces[i] != nil {
			if err := m.Namespaces[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("namespaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateParentConsistencyGroup(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentConsistencyGroup) { // not required
		return nil
	}

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateRestoreTo(formats strfmt.Registry) error {
	if swag.IsZero(m.RestoreTo) { // not required
		return nil
	}

	if m.RestoreTo != nil {
		if err := m.RestoreTo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateSnapshotPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateSvm(formats strfmt.Registry) error {
	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateTiering(formats strfmt.Registry) error {
	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) validateVolumes(formats strfmt.Registry) error {
	if swag.IsZero(m.Volumes) { // not required
		return nil
	}

	iVolumesSize := int64(len(m.Volumes))

	if err := validate.MinItems("volumes", "body", iVolumesSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("volumes", "body", iVolumesSize, 80); err != nil {
		return err
	}

	if err := validate.UniqueItems("volumes", "body", m.Volumes); err != nil {
		return err
	}

	for i := 0; i < len(m.Volumes); i++ {
		if swag.IsZero(m.Volumes[i]) { // not required
			continue
		}

		if m.Volumes[i] != nil {
			if err := m.Volumes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("volumes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateApplication(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateClone(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateConsistencyGroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLuns(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNamespaces(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentConsistencyGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRestoreTo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSnapshotPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSvm(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTiering(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVolumes(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateApplication(ctx context.Context, formats strfmt.Registry) error {

	if m.Application != nil {
		if err := m.Application.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("application")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateClone(ctx context.Context, formats strfmt.Registry) error {

	if m.Clone != nil {
		if err := m.Clone.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateConsistencyGroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ConsistencyGroups); i++ {

		if m.ConsistencyGroups[i] != nil {
			if err := m.ConsistencyGroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("consistency_groups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateLuns(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Luns); i++ {

		if m.Luns[i] != nil {
			if err := m.Luns[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("luns" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateNamespaces(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Namespaces); i++ {

		if m.Namespaces[i] != nil {
			if err := m.Namespaces[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("namespaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateParentConsistencyGroup(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateRestoreTo(ctx context.Context, formats strfmt.Registry) error {

	if m.RestoreTo != nil {
		if err := m.RestoreTo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateSnapshotPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateSvm(ctx context.Context, formats strfmt.Registry) error {

	if m.Svm != nil {
		if err := m.Svm.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateTiering(ctx context.Context, formats strfmt.Registry) error {

	if m.Tiering != nil {
		if err := m.Tiering.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) contextValidateVolumes(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Volumes); i++ {

		if m.Volumes[i] != nil {
			if err := m.Volumes[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("volumes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItem) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItem
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication consistency group response inline records inline array item inline application
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_application
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication struct {

	// Nested consistency group tag.
	// Enum: [data logs other]
	ComponentType *string `json:"component_type,omitempty"`

	// Top level consistency group tag.
	// Enum: [oracle other exchange sql_server sap_hana vmware mongodb db2 mysql sap_maxdb postgresql sap_ase_sybase]
	Type *string `json:"type,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline application
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComponentType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeComponentTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["data","logs","other"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeComponentTypePropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeComponentTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// component_type
	// ComponentType
	// data
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeData captures enum value "data"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeData string = "data"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// component_type
	// ComponentType
	// logs
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeLogs captures enum value "logs"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeLogs string = "logs"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// component_type
	// ComponentType
	// other
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeOther captures enum value "other"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationComponentTypeOther string = "other"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) validateComponentTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeComponentTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) validateComponentType(formats strfmt.Registry) error {
	if swag.IsZero(m.ComponentType) { // not required
		return nil
	}

	// value enum
	if err := m.validateComponentTypeEnum("application"+"."+"component_type", "body", *m.ComponentType); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["oracle","other","exchange","sql_server","sap_hana","vmware","mongodb","db2","mysql","sap_maxdb","postgresql","sap_ase_sybase"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeTypePropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// oracle
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeOracle captures enum value "oracle"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeOracle string = "oracle"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// other
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeOther captures enum value "other"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeOther string = "other"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// exchange
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeExchange captures enum value "exchange"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeExchange string = "exchange"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// sql_server
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSQLServer captures enum value "sql_server"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSQLServer string = "sql_server"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// sap_hana
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapHana captures enum value "sap_hana"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapHana string = "sap_hana"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// mongodb
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeMongodb captures enum value "mongodb"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeMongodb string = "mongodb"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// db2
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeDb2 captures enum value "db2"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeDb2 string = "db2"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// mysql
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeMysql captures enum value "mysql"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeMysql string = "mysql"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// sap_maxdb
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapMaxdb captures enum value "sap_maxdb"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapMaxdb string = "sap_maxdb"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// postgresql
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypePostgresql captures enum value "postgresql"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypePostgresql string = "postgresql"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_application
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	// type
	// Type
	// sap_ase_sybase
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapAseSybase captures enum value "sap_ase_sybase"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeSapAseSybase string = "sap_ase_sybase"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineApplicationTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("application"+"."+"type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline application based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineApplication
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone Creates a clone of an existing consistency group from the current contents or an existing Snapshot copy.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_clone
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone struct {

	// guarantee
	Guarantee *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee `json:"guarantee,omitempty"`

	// parent consistency group
	ParentConsistencyGroup *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup `json:"parent_consistency_group,omitempty"`

	// parent snapshot
	ParentSnapshot *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot `json:"parent_snapshot,omitempty"`

	// Splits volumes after cloning. Default is false.
	SplitInitiated *bool `json:"split_initiated,omitempty"`

	// volume
	Volume *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume `json:"volume,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline clone
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentConsistencyGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVolume(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) validateParentConsistencyGroup(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentConsistencyGroup) { // not required
		return nil
	}

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) validateParentSnapshot(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentSnapshot) { // not required
		return nil
	}

	if m.ParentSnapshot != nil {
		if err := m.ParentSnapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_snapshot")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) validateVolume(formats strfmt.Registry) error {
	if swag.IsZero(m.Volume) { // not required
		return nil
	}

	if m.Volume != nil {
		if err := m.Volume.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "volume")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline clone based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentConsistencyGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentSnapshot(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVolume(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) contextValidateParentConsistencyGroup(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) contextValidateParentSnapshot(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentSnapshot != nil {
		if err := m.ParentSnapshot.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_snapshot")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) contextValidateVolume(ctx context.Context, formats strfmt.Registry) error {

	if m.Volume != nil {
		if err := m.Volume.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "volume")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineClone
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee consistency group response inline records inline array item inline clone inline guarantee
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_clone_inline_guarantee
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee struct {

	// The type of space guarantee of this volume in the aggregate.
	// Enum: [volume none]
	Type *string `json:"type,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline clone inline guarantee
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["volume","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeTypePropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_clone_inline_guarantee
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee
	// type
	// Type
	// volume
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeVolume captures enum value "volume"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeVolume string = "volume"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_clone_inline_guarantee
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee
	// type
	// Type
	// none
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeNone captures enum value "none"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeNone string = "none"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuaranteeTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("clone"+"."+"guarantee"+"."+"type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline clone inline guarantee based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup Consistency group that is to be cloned.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_clone_inline_parent_consistency_group
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the consistency group.
	// Example: my_consistency_group
	Name *string `json:"name,omitempty"`

	// The unique identifier of the consistency group.
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline clone inline parent consistency group
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline clone inline parent consistency group based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentConsistencyGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot consistency group response inline records inline array item inline clone inline parent snapshot
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_clone_inline_parent_snapshot
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot struct {

	// Name of an existing Snapshot copy of a parent consistency group.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline clone inline parent snapshot
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline clone inline parent snapshot based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineParentSnapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume Volume name suffix/prefix for the cloned volumes.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_clone_inline_volume
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume struct {

	// Volume name prefix for cloned volumes.
	Prefix *string `json:"prefix,omitempty"`

	// Volume name suffix for cloned volumes.
	Suffix *string `json:"suffix,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline clone inline volume
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline clone inline volume based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineCloneInlineVolume
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0 consistency group response records items0 consistency groups items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0 struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// application
	Application *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application `json:"application,omitempty"`

	// The LUNs array can be used to create or modify LUNs in a consistency group on a new or existing volume that is a member of the consistency group. LUNs are considered members of a consistency group if they are located on a volume that is a member of the consistency group.
	//
	// Max Items: 16
	// Min Items: 0
	// Unique: true
	Luns []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0 `json:"luns"`

	// Name of the consistency group. The consistency group name must be unique within an SVM.<br/>
	// If not provided and the consistency group contains only one volume, the name will be generated based on the volume name. If the consistency group contains more than one volume, the name is required.
	//
	Name *string `json:"name,omitempty"`

	// An NVMe namespace is a collection of addressable logical blocks presented to hosts connected to the SVM using the NVMe over Fabrics protocol.
	// In ONTAP, an NVMe namespace is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
	// An NVMe namespace is created to a specified size using thin or thick provisioning as determined by the volume on which it is created. NVMe namespaces support being cloned. An NVMe namespace cannot be renamed, resized, or moved to a different volume. NVMe namespaces do not support the assignment of a QoS policy for performance management, but a QoS policy can be assigned to the volume containing the namespace. See the NVMe namespace object model to learn more about each of the properties supported by the NVMe namespace REST API.<br/>
	// An NVMe namespace must be mapped to an NVMe subsystem to grant access to the subsystem's hosts. Hosts can then access the NVMe namespace and perform I/O using the NVMe over Fabrics protocol.
	//
	// Max Items: 16
	// Min Items: 0
	// Unique: true
	Namespaces []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0 `json:"namespaces"`

	// parent consistency group
	ParentConsistencyGroup *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup `json:"parent_consistency_group,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos `json:"qos,omitempty"`

	// restore to
	RestoreTo *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo `json:"restore_to,omitempty"`

	// The Snapshot copy policy of the consistency group.<br/>
	// This is the dedicated consistency group Snapshot copy policy, not an aggregation of the volume granular Snapshot copy policy.
	//
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space `json:"space,omitempty"`

	// svm
	Svm *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm `json:"svm,omitempty"`

	// tiering
	Tiering *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering `json:"tiering,omitempty"`

	// The unique identifier of the consistency group. The UUID is generated by ONTAP when the consistency group is created.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`

	// A consistency group is a mutually exclusive aggregation of volumes or other consistency groups. A volume can only be associated with one direct parent consistency group.<br/>
	// The volumes array can be used to create new volumes in the consistency group, add existing volumes to the consistency group, or modify existing volumes that are already members of the consistency group.<br/>
	// The total number of volumes across all child consistency groups contained in a consistency group is constrained by the same limit.
	//
	// Max Items: 80
	// Min Items: 0
	// Unique: true
	Volumes []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0 `json:"volumes"`
}

// Validate validates this consistency group response records items0 consistency groups items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateApplication(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLuns(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNamespaces(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateParentConsistencyGroup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRestoreTo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVolumes(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateApplication(formats strfmt.Registry) error {
	if swag.IsZero(m.Application) { // not required
		return nil
	}

	if m.Application != nil {
		if err := m.Application.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("application")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateLuns(formats strfmt.Registry) error {
	if swag.IsZero(m.Luns) { // not required
		return nil
	}

	iLunsSize := int64(len(m.Luns))

	if err := validate.MinItems("luns", "body", iLunsSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("luns", "body", iLunsSize, 16); err != nil {
		return err
	}

	if err := validate.UniqueItems("luns", "body", m.Luns); err != nil {
		return err
	}

	for i := 0; i < len(m.Luns); i++ {
		if swag.IsZero(m.Luns[i]) { // not required
			continue
		}

		if m.Luns[i] != nil {
			if err := m.Luns[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("luns" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateNamespaces(formats strfmt.Registry) error {
	if swag.IsZero(m.Namespaces) { // not required
		return nil
	}

	iNamespacesSize := int64(len(m.Namespaces))

	if err := validate.MinItems("namespaces", "body", iNamespacesSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("namespaces", "body", iNamespacesSize, 16); err != nil {
		return err
	}

	if err := validate.UniqueItems("namespaces", "body", m.Namespaces); err != nil {
		return err
	}

	for i := 0; i < len(m.Namespaces); i++ {
		if swag.IsZero(m.Namespaces[i]) { // not required
			continue
		}

		if m.Namespaces[i] != nil {
			if err := m.Namespaces[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("namespaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateParentConsistencyGroup(formats strfmt.Registry) error {
	if swag.IsZero(m.ParentConsistencyGroup) { // not required
		return nil
	}

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateRestoreTo(formats strfmt.Registry) error {
	if swag.IsZero(m.RestoreTo) { // not required
		return nil
	}

	if m.RestoreTo != nil {
		if err := m.RestoreTo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateSnapshotPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateSvm(formats strfmt.Registry) error {
	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateTiering(formats strfmt.Registry) error {
	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) validateVolumes(formats strfmt.Registry) error {
	if swag.IsZero(m.Volumes) { // not required
		return nil
	}

	iVolumesSize := int64(len(m.Volumes))

	if err := validate.MinItems("volumes", "body", iVolumesSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("volumes", "body", iVolumesSize, 80); err != nil {
		return err
	}

	if err := validate.UniqueItems("volumes", "body", m.Volumes); err != nil {
		return err
	}

	for i := 0; i < len(m.Volumes); i++ {
		if swag.IsZero(m.Volumes[i]) { // not required
			continue
		}

		if m.Volumes[i] != nil {
			if err := m.Volumes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("volumes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateApplication(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLuns(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNamespaces(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateParentConsistencyGroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRestoreTo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSnapshotPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSvm(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTiering(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVolumes(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateApplication(ctx context.Context, formats strfmt.Registry) error {

	if m.Application != nil {
		if err := m.Application.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("application")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateLuns(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Luns); i++ {

		if m.Luns[i] != nil {
			if err := m.Luns[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("luns" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateNamespaces(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Namespaces); i++ {

		if m.Namespaces[i] != nil {
			if err := m.Namespaces[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("namespaces" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateParentConsistencyGroup(ctx context.Context, formats strfmt.Registry) error {

	if m.ParentConsistencyGroup != nil {
		if err := m.ParentConsistencyGroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateRestoreTo(ctx context.Context, formats strfmt.Registry) error {

	if m.RestoreTo != nil {
		if err := m.RestoreTo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateSnapshotPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateSvm(ctx context.Context, formats strfmt.Registry) error {

	if m.Svm != nil {
		if err := m.Svm.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateTiering(ctx context.Context, formats strfmt.Registry) error {

	if m.Tiering != nil {
		if err := m.Tiering.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) contextValidateVolumes(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Volumes); i++ {

		if m.Volumes[i] != nil {
			if err := m.Volumes[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("volumes" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application consistency group response records items0 consistency groups items0 application
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application struct {

	// Nested consistency group tag.
	// Enum: [data logs other]
	ComponentType *string `json:"component_type,omitempty"`

	// Top level consistency group tag.
	// Enum: [oracle other exchange sql_server sap_hana vmware mongodb db2 mysql sap_maxdb postgresql sap_ase_sybase]
	Type *string `json:"type,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 application
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComponentType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeComponentTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["data","logs","other"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeComponentTypePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeComponentTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// component_type
	// ComponentType
	// data
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeData captures enum value "data"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeData string = "data"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// component_type
	// ComponentType
	// logs
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeLogs captures enum value "logs"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeLogs string = "logs"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// component_type
	// ComponentType
	// other
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeOther captures enum value "other"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationComponentTypeOther string = "other"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) validateComponentTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeComponentTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) validateComponentType(formats strfmt.Registry) error {
	if swag.IsZero(m.ComponentType) { // not required
		return nil
	}

	// value enum
	if err := m.validateComponentTypeEnum("application"+"."+"component_type", "body", *m.ComponentType); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["oracle","other","exchange","sql_server","sap_hana","vmware","mongodb","db2","mysql","sap_maxdb","postgresql","sap_ase_sybase"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeTypePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// oracle
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeOracle captures enum value "oracle"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeOracle string = "oracle"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// other
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeOther captures enum value "other"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeOther string = "other"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// exchange
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeExchange captures enum value "exchange"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeExchange string = "exchange"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// sql_server
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSQLServer captures enum value "sql_server"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSQLServer string = "sql_server"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// sap_hana
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapHana captures enum value "sap_hana"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapHana string = "sap_hana"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// mongodb
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeMongodb captures enum value "mongodb"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeMongodb string = "mongodb"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// db2
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeDb2 captures enum value "db2"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeDb2 string = "db2"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// mysql
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeMysql captures enum value "mysql"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeMysql string = "mysql"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// sap_maxdb
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapMaxdb captures enum value "sap_maxdb"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapMaxdb string = "sap_maxdb"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// postgresql
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypePostgresql captures enum value "postgresql"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypePostgresql string = "postgresql"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	// type
	// Type
	// sap_ase_sybase
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapAseSybase captures enum value "sap_ase_sybase"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeSapAseSybase string = "sap_ase_sybase"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ApplicationTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("application"+"."+"type", "body", *m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 application based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Application
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0 A LUN is the logical representation of storage in a storage area network (SAN).<br/>
// In ONTAP, a LUN is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
// A LUN can be created to a specified size using thin or thick provisioning. A LUN can then be renamed, resized, cloned, and moved to a different volume. LUNs support the assignment of a quality of service (QoS) policy for performance management or a QoS policy can be assigned to the volume containing the LUN. See the LUN object model to learn more about each of the properties supported by the LUN REST API.<br/>
// A LUN must be mapped to an initiator group to grant access to the initiator group's initiators (client hosts). Initiators can then access the LUN and perform I/O over a Fibre Channel (FC) fabric using the Fibre Channel Protocol or a TCP/IP network using iSCSI.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0 struct {

	// clone
	Clone *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone `json:"clone,omitempty"`

	// A configurable comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// The time the LUN was created.
	// Example: 2018-06-04T19:00:00Z
	// Read Only: true
	// Format: date-time
	CreateTime *strfmt.DateTime `json:"create_time,omitempty"`

	// The enabled state of the LUN. LUNs can be disabled to prevent access to the LUN. Certain error conditions also cause the LUN to become disabled. If the LUN is disabled, you can consult the `state` property to determine if the LUN is administratively disabled (_offline_) or has become disabled as a result of an error. A LUN in an error condition can be brought online by setting the `enabled` property to _true_ or brought administratively offline by setting the `enabled` property to _false_. Upon creation, a LUN is enabled by default. Valid in PATCH.
	//
	Enabled *bool `json:"enabled,omitempty"`

	// An array of LUN maps.<br/>
	// A LUN map is an association between a LUN and an initiator group. When a LUN is mapped to an initiator group, the initiator group's initiators are granted access to the LUN. The relationship between a LUN and an initiator group is many LUNs to many initiator groups.
	//
	LunMaps []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0 `json:"lun_maps"`

	// The fully qualified path name of the LUN composed of the "/vol" prefix, the volume name, the qtree name (optional), and the base name of the LUN. Valid in POST and PATCH.
	//
	// Example: /vol/volume1/lun1
	Name *string `json:"name,omitempty"`

	// The operating system type of the LUN.<br/>
	// Required in POST when creating a LUN that is not a clone of another. Disallowed in POST when creating a LUN clone.
	//
	// Enum: [aix hpux hyper_v linux netware openvms solaris solaris_efi vmware windows windows_2008 windows_gpt xen]
	OsType *string `json:"os_type,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos `json:"qos,omitempty"`

	// The LUN serial number. The serial number is generated by ONTAP when the LUN is created.
	//
	// Read Only: true
	// Max Length: 12
	// Min Length: 12
	SerialNumber *string `json:"serial_number,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space `json:"space,omitempty"`

	// The unique identifier of the LUN.  The UUID is generated by ONTAP when the LUN is created.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateClone(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreateTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLunMaps(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSerialNumber(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateClone(formats strfmt.Registry) error {
	if swag.IsZero(m.Clone) { // not required
		return nil
	}

	if m.Clone != nil {
		if err := m.Clone.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateCreateTime(formats strfmt.Registry) error {
	if swag.IsZero(m.CreateTime) { // not required
		return nil
	}

	if err := validate.FormatOf("create_time", "body", "date-time", m.CreateTime.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateLunMaps(formats strfmt.Registry) error {
	if swag.IsZero(m.LunMaps) { // not required
		return nil
	}

	for i := 0; i < len(m.LunMaps); i++ {
		if swag.IsZero(m.LunMaps[i]) { // not required
			continue
		}

		if m.LunMaps[i] != nil {
			if err := m.LunMaps[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lun_maps" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0TypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","hpux","hyper_v","linux","netware","openvms","solaris","solaris_efi","vmware","windows","windows_2008","windows_gpt","xen"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0TypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0TypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// hpux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeHpux captures enum value "hpux"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeHpux string = "hpux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// hyper_v
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeHyperv captures enum value "hyper_v"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeHyperv string = "hyper_v"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// netware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeNetware captures enum value "netware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeNetware string = "netware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// openvms
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeOpenvms captures enum value "openvms"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeOpenvms string = "openvms"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// solaris
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeSolaris captures enum value "solaris"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeSolaris string = "solaris"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// solaris_efi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeSolarisEfi captures enum value "solaris_efi"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeSolarisEfi string = "solaris_efi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindows string = "windows"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// windows_2008
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindows2008 captures enum value "windows_2008"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindows2008 string = "windows_2008"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// windows_gpt
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindowsGpt captures enum value "windows_gpt"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeWindowsGpt string = "windows_gpt"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	// os_type
	// OsType
	// xen
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeXen captures enum value "xen"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0OsTypeXen string = "xen"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0TypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateSerialNumber(formats strfmt.Registry) error {
	if swag.IsZero(m.SerialNumber) { // not required
		return nil
	}

	if err := validate.MinLength("serial_number", "body", *m.SerialNumber, 12); err != nil {
		return err
	}

	if err := validate.MaxLength("serial_number", "body", *m.SerialNumber, 12); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateClone(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCreateTime(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLunMaps(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSerialNumber(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateClone(ctx context.Context, formats strfmt.Registry) error {

	if m.Clone != nil {
		if err := m.Clone.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateCreateTime(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "create_time", "body", m.CreateTime); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateLunMaps(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.LunMaps); i++ {

		if m.LunMaps[i] != nil {
			if err := m.LunMaps[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lun_maps" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateSerialNumber(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "serial_number", "body", m.SerialNumber); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone This sub-object is used in POST to create a new LUN as a clone of an existing LUN, or PATCH to overwrite an existing LUN as a clone of another. Setting a property in this sub-object indicates that a LUN clone is desired. Consider the following other properties when cloning a LUN: `auto_delete`, `qos_policy`, `space.guarantee.requested` and `space.scsi_thin_provisioning_support_enabled`.<br/>
// When used in a PATCH, the patched LUN's data is over-written as a clone of the source and the following properties are preserved from the patched LUN unless otherwise specified as part of the PATCH: `class`, `auto_delete`, `lun_maps`, `serial_number`, `status.state`, and `uuid`.<br/>
// Persistent reservations for the patched LUN are also preserved.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone struct {

	// source
	Source *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource `json:"source,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 clone
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSource(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) validateSource(formats strfmt.Registry) error {
	if swag.IsZero(m.Source) { // not required
		return nil
	}

	if m.Source != nil {
		if err := m.Source.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "source")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 clone based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSource(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) contextValidateSource(ctx context.Context, formats strfmt.Registry) error {

	if m.Source != nil {
		if err := m.Source.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "source")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Clone
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource The source LUN for a LUN clone operation. This can be specified using property `clone.source.uuid` or `clone.source.name`. If both properties are supplied, they must refer to the same LUN.<br/>
// Valid in POST to create a new LUN as a clone of the source.<br/>
// Valid in PATCH to overwrite an existing LUN's data as a clone of another.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource struct {

	// The fully qualified path name of the clone source LUN composed of a "/vol" prefix, the volume name, the (optional) qtree name, and base name of the LUN. Valid in POST and PATCH.
	//
	// Example: /vol/volume1/lun1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the clone source LUN. Valid in POST and PATCH.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 clone source
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 luns items0 clone source based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0CloneSource
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0 A LUN map is an association between a LUN and an initiator group.<br/>
// When a LUN is mapped to an initiator group, the initiator group's initiators are granted access to the LUN. The relationship between a LUN and an initiator group is many LUNs to many initiator groups.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0 struct {

	// igroup
	Igroup *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup `json:"igroup,omitempty"`

	// The logical unit number assigned to the LUN when mapped to the specified initiator group. The number is used to identify the LUN to initiators in the initiator group when communicating through the Fibre Channel Protocol or iSCSI. Optional in POST; if no value is provided, ONTAP assigns the lowest available value.
	//
	LogicalUnitNumber *int64 `json:"logical_unit_number,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 lun maps items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIgroup(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) validateIgroup(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroup) { // not required
		return nil
	}

	if m.Igroup != nil {
		if err := m.Igroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIgroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) contextValidateIgroup(ctx context.Context, formats strfmt.Registry) error {

	if m.Igroup != nil {
		if err := m.Igroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup The initiator group that directly owns the initiator, which is where modification of the initiator is supported. This property will only be populated when the initiator is a member of a nested initiator group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup struct {

	// A comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Separate igroup definitions to include in this igroup.
	//
	Igroups []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 `json:"igroups"`

	// The initiators that are members of the group.
	//
	Initiators []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 `json:"initiators"`

	// The name of the initiator group. Required in POST; optional in PATCH.
	//
	// Example: igroup1
	// Max Length: 96
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// The host operating system of the initiator group. All initiators in the group should be hosts of the same operating system. Required in POST; optional in PATCH.
	//
	// Enum: [aix hpux hyper_v linux netware openvms solaris vmware windows xen]
	OsType *string `json:"os_type,omitempty"`

	// The protocols supported by the initiator group. This restricts the type of initiators that can be added to the initiator group. Optional in POST; if not supplied, this defaults to _mixed_.<br/>
	// The protocol of an initiator group cannot be changed after creation of the group.
	//
	// Enum: [fcp iscsi mixed]
	Protocol *string `json:"protocol,omitempty"`

	// The unique identifier of the initiator group.
	//
	// Example: 4ea7a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIgroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInitiators(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProtocol(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("igroup"+"."+"comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("igroup"+"."+"comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateIgroups(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroups) { // not required
		return nil
	}

	for i := 0; i < len(m.Igroups); i++ {
		if swag.IsZero(m.Igroups[i]) { // not required
			continue
		}

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateInitiators(formats strfmt.Registry) error {
	if swag.IsZero(m.Initiators) { // not required
		return nil
	}

	for i := 0; i < len(m.Initiators); i++ {
		if swag.IsZero(m.Initiators[i]) { // not required
			continue
		}

		if m.Initiators[i] != nil {
			if err := m.Initiators[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "initiators" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("igroup"+"."+"name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("igroup"+"."+"name", "body", *m.Name, 96); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","hpux","hyper_v","linux","netware","openvms","solaris","vmware","windows","xen"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// hpux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeHpux captures enum value "hpux"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeHpux string = "hpux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// hyper_v
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeHyperv captures enum value "hyper_v"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeHyperv string = "hyper_v"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// netware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeNetware captures enum value "netware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeNetware string = "netware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// openvms
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeOpenvms captures enum value "openvms"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeOpenvms string = "openvms"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// solaris
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeSolaris captures enum value "solaris"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeSolaris string = "solaris"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeWindows string = "windows"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// xen
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeXen captures enum value "xen"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupOsTypeXen string = "xen"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("igroup"+"."+"os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fcp","iscsi","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// fcp
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolFcp captures enum value "fcp"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolFcp string = "fcp"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// iscsi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolIscsi captures enum value "iscsi"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolIscsi string = "iscsi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// mixed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolMixed captures enum value "mixed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupProtocolMixed string = "mixed"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateProtocolEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) validateProtocol(formats strfmt.Registry) error {
	if swag.IsZero(m.Protocol) { // not required
		return nil
	}

	// value enum
	if err := m.validateProtocolEnum("igroup"+"."+"protocol", "body", *m.Protocol); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIgroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInitiators(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) contextValidateIgroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Igroups); i++ {

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) contextValidateInitiators(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Initiators); i++ {

		if m.Initiators[i] != nil {
			if err := m.Initiators[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "initiators" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "igroup"+"."+"uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0Igroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup igroups items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the initiator group.
	//
	// Example: igroup1
	// Max Length: 96
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the initiator group.
	//
	// Example: 4ea7a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup igroups items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", *m.Name, 96); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup igroups items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 The initiators that are members of the initiator group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 struct {

	// A comment available for use by the administrator.
	//
	// Example: my comment
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Name of initiator that is a member of the initiator group.
	//
	// Example: iqn.1998-01.com.corp.iscsi:name1
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup initiators items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 luns items0 lun maps items0 igroup initiators items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 luns items0 provisioning options based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos consistency group response records items0 consistency groups items0 luns items0 qos
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos struct {

	// policy
	Policy *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 qos
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 qos based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Qos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy The QoS policy
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 qos policy
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 qos policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0QosPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space The storage space related properties of the LUN.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space struct {

	// guarantee
	Guarantee *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee `json:"guarantee,omitempty"`

	// The total provisioned size of the LUN. The LUN size can be increased but not reduced using the REST interface.
	// The maximum and minimum sizes listed here are the absolute maximum and absolute minimum sizes, in bytes. The actual minimum and maxiumum sizes vary depending on the ONTAP version, ONTAP platform, and the available space in the containing volume and aggregate.
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	// Example: 1073741824
	// Maximum: 1.40737488355328e+14
	// Minimum: 4096
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed by the main data stream of the LUN.<br/>
	// This value is the total space consumed in the volume by the LUN, including filesystem overhead, but excluding prefix and suffix streams. Due to internal filesystem overhead and the many ways SAN filesystems and applications utilize blocks within a LUN, this value does not necessarily reflect actual consumption/availability from the perspective of the filesystem or application. Without specific knowledge of how the LUN blocks are utilized outside of ONTAP, this property should not be used as an indicator for an out-of-space condition.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 space
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) validateSize(formats strfmt.Registry) error {
	if swag.IsZero(m.Size) { // not required
		return nil
	}

	if err := validate.MinimumInt("space"+"."+"size", "body", *m.Size, 4096, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("space"+"."+"size", "body", *m.Size, 1.40737488355328e+14, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 luns items0 space based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee Properties that request and report the space guarantee for the LUN.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee struct {

	// The requested space reservation policy for the LUN. If _true_, a space reservation is requested for the LUN; if _false_, the LUN is thin provisioned. Guaranteeing a space reservation request for a LUN requires that the volume in which the LUN resides is also space reserved and that the fractional reserve for the volume is 100%. Valid in POST and PATCH.
	//
	Requested *bool `json:"requested,omitempty"`

	// Reports if the LUN is space guaranteed.<br/>
	// If _true_, a space guarantee is requested and the containing volume and aggregate support the request. If _false_, a space guarantee is not requested or a space guarantee is requested and either the containing volume or aggregate do not support the request.
	//
	Reserved *bool `json:"reserved,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 luns items0 space guarantee
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 luns items0 space guarantee based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0LunsItems0SpaceGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0 An NVMe namespace is a collection of addressable logical blocks presented to hosts connected to the storage virtual machine using the NVMe over Fabrics protocol.<br/>
// In ONTAP, an NVMe namespace is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
// An NVMe namespace is created to a specified size using thin or thick provisioning as determined by the volume on which it is created. NVMe namespaces support being cloned. An NVMe namespace cannot be renamed, resized, or moved to a different volume. NVMe namespaces do not support the assignment of a QoS policy for performance management, but a QoS policy can be assigned to the volume containing the namespace. See the NVMe namespace object model to learn more about each of the properties supported by the NVMe namespace REST API.<br/>
// An NVMe namespace must be mapped to an NVMe subsystem to grant access to the subsystem's hosts. Hosts can then access the NVMe namespace and perform I/O using the NVMe over Fabrics protocol.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0 struct {

	// This property marks the NVMe namespace for auto deletion when the volume containing the namespace runs out of space. This is most commonly set on namespace clones.<br/>
	// When set to _true_, the NVMe namespace becomes eligible for automatic deletion when the volume runs out of space. Auto deletion only occurs when the volume containing the namespace is also configured for auto deletion and free space in the volume decreases below a particular threshold.<br/>
	// This property is optional in POST and PATCH. The default value for a new NVMe namespace is _false_.<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	AutoDelete *bool `json:"auto_delete,omitempty"`

	// A configurable comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// The time the NVMe namespace was created.
	// Example: 2018-06-04T19:00:00Z
	// Read Only: true
	// Format: date-time
	CreateTime *strfmt.DateTime `json:"create_time,omitempty"`

	// The enabled state of the NVMe namespace. Certain error conditions cause the namespace to become disabled. If the namespace is disabled, you can check the `state` property to determine what error disabled the namespace. An NVMe namespace is enabled automatically when it is created.
	//
	// Read Only: true
	Enabled *bool `json:"enabled,omitempty"`

	// The fully qualified path name of the NVMe namespace composed of a "/vol" prefix, the volume name, the (optional) qtree name and base name of the namespace. Valid in POST.<br/>
	// NVMe namespaces do not support rename, or movement between volumes.
	//
	// Example: /vol/volume1/qtree1/namespace1
	Name *string `json:"name,omitempty"`

	// The operating system type of the NVMe namespace.<br/>
	// Required in POST when creating an NVMe namespace that is not a clone of another. Disallowed in POST when creating a namespace clone.
	//
	// Enum: [aix linux vmware windows]
	OsType *string `json:"os_type,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space `json:"space,omitempty"`

	// status
	Status *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status `json:"status,omitempty"`

	// subsystem map
	SubsystemMap *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap `json:"subsystem_map,omitempty"`

	// The unique identifier of the NVMe namespace.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreateTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubsystemMap(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateCreateTime(formats strfmt.Registry) error {
	if swag.IsZero(m.CreateTime) { // not required
		return nil
	}

	if err := validate.FormatOf("create_time", "body", "date-time", m.CreateTime.String(), formats); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0TypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","linux","vmware","windows"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0TypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0TypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0OsTypeWindows string = "windows"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0TypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.Status) { // not required
		return nil
	}

	if m.Status != nil {
		if err := m.Status.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) validateSubsystemMap(formats strfmt.Registry) error {
	if swag.IsZero(m.SubsystemMap) { // not required
		return nil
	}

	if m.SubsystemMap != nil {
		if err := m.SubsystemMap.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 namespaces items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCreateTime(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateEnabled(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSubsystemMap(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateCreateTime(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "create_time", "body", m.CreateTime); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateEnabled(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "enabled", "body", m.Enabled); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateStatus(ctx context.Context, formats strfmt.Registry) error {

	if m.Status != nil {
		if err := m.Status.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateSubsystemMap(ctx context.Context, formats strfmt.Registry) error {

	if m.SubsystemMap != nil {
		if err := m.SubsystemMap.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 namespaces items0 provisioning options based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space The storage space related properties of the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space struct {

	// The size of blocks in the namespace, in bytes.<br/>
	// Valid in POST when creating an NVMe namespace that is not a clone of another. Disallowed in POST when creating a namespace clone.
	//  Valid in POST.
	//
	// Enum: [512 4096]
	BlockSize *int64 `json:"block_size,omitempty"`

	// guarantee
	Guarantee *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee `json:"guarantee,omitempty"`

	// The total provisioned size of the NVMe namespace. Valid in POST and PATCH. The NVMe namespace size can be increased but not reduced using the REST interface.<br/>
	// The maximum and minimum sizes listed here are the absolute maximum and absolute minimum sizes, in bytes. The maximum size is variable with respect to large NVMe namespace support in ONTAP. If large namespaces are supported, the maximum size is 128 TB (140737488355328 bytes) and if not supported, the maximum size is just under 16 TB (17557557870592 bytes). The minimum size supported is always 4096 bytes.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	// Example: 1073741824
	// Maximum: 1.40737488355328e+14
	// Minimum: 4096
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed by the main data stream of the NVMe namespace.<br/>
	// This value is the total space consumed in the volume by the NVMe namespace, including filesystem overhead, but excluding prefix and suffix streams. Due to internal filesystem overhead and the many ways NVMe filesystems and applications utilize blocks within a namespace, this value does not necessarily reflect actual consumption/availability from the perspective of the filesystem or application. Without specific knowledge of how the namespace blocks are utilized outside of ONTAP, this property should not be used as an indicator for an out-of-space condition.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0 space
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBlockSize(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceTypeBlockSizePropEnum []interface{}

func init() {
	var res []int64
	if err := json.Unmarshal([]byte(`[512,4096]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceTypeBlockSizePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceTypeBlockSizePropEnum, v)
	}
}

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) validateBlockSizeEnum(path, location string, value int64) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceTypeBlockSizePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) validateBlockSize(formats strfmt.Registry) error {
	if swag.IsZero(m.BlockSize) { // not required
		return nil
	}

	// value enum
	if err := m.validateBlockSizeEnum("space"+"."+"block_size", "body", *m.BlockSize); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) validateSize(formats strfmt.Registry) error {
	if swag.IsZero(m.Size) { // not required
		return nil
	}

	if err := validate.MinimumInt("space"+"."+"size", "body", *m.Size, 4096, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("space"+"."+"size", "body", *m.Size, 1.40737488355328e+14, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 namespaces items0 space based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee Properties that request and report the space guarantee for the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee struct {

	// The requested space reservation policy for the NVMe namespace. If _true_, a space reservation is requested for the namespace; if _false_, the namespace is thin provisioned. Guaranteeing a space reservation request for a namespace requires that the volume in which the namespace resides also be space reserved and that the fractional reserve for the volume be 100%.<br/>
	// The space reservation policy for an NVMe namespace is determined by ONTAP.
	//
	Requested *bool `json:"requested,omitempty"`

	// Reports if the NVMe namespace is space guaranteed.<br/>
	// This property is _true_ if a space guarantee is requested and the containing volume and aggregate support the request. This property is _false_ if a space guarantee is not requested or if a space guarantee is requested and either the containing volume and aggregate do not support the request.
	//
	Reserved *bool `json:"reserved,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0 space guarantee
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 namespaces items0 space guarantee based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SpaceGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status Status information about the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status struct {

	// The state of the volume and aggregate that contain the NVMe namespace. Namespaces are only available when their containers are available.
	//
	// Enum: [online aggregate_offline volume_offline]
	ContainerState *string `json:"container_state,omitempty"`

	// Reports if the NVMe namespace is mapped to an NVMe subsystem.<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	Mapped *bool `json:"mapped,omitempty"`

	// Reports if the NVMe namespace allows only read access.
	//
	ReadOnly *bool `json:"read_only,omitempty"`

	// The state of the NVMe namespace. Normal states for a namespace are _online_ and _offline_. Other states indicate errors.
	//
	// Example: online
	// Enum: [nvfail offline online space_error]
	State *string `json:"state,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0 status
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateContainerState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeContainerStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["online","aggregate_offline","volume_offline"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeContainerStatePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeContainerStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// online
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateOnline captures enum value "online"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateOnline string = "online"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// aggregate_offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateAggregateOffline captures enum value "aggregate_offline"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateAggregateOffline string = "aggregate_offline"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// volume_offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateVolumeOffline captures enum value "volume_offline"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusContainerStateVolumeOffline string = "volume_offline"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) validateContainerStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeContainerStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) validateContainerState(formats strfmt.Registry) error {
	if swag.IsZero(m.ContainerState) { // not required
		return nil
	}

	// value enum
	if err := m.validateContainerStateEnum("status"+"."+"container_state", "body", *m.ContainerState); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["nvfail","offline","online","space_error"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeStatePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// state
	// State
	// nvfail
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateNvfail captures enum value "nvfail"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateNvfail string = "nvfail"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// state
	// State
	// offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateOffline captures enum value "offline"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateOffline string = "offline"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// state
	// State
	// online
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateOnline captures enum value "online"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateOnline string = "online"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	// state
	// State
	// space_error
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateSpaceError captures enum value "space_error"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusStateSpaceError string = "space_error"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0StatusTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("status"+"."+"state", "body", *m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 namespaces items0 status based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0Status
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap The NVMe subsystem with which the NVMe namespace is associated. A namespace can be mapped to zero (0) or one (1) subsystems.<br/>
// There is an added computational cost to retrieving property values for `subsystem_map`.
// They are not populated for either a collection GET or an instance GET unless explicitly requested using the `fields` query parameter.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The Asymmetric Namespace Access Group ID (ANAGRPID) of the NVMe namespace.<br/>
	// The format for an ANAGRPID is 8 hexadecimal digits (zero-filled) followed by a lower case "h".<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	// Example: 00103050h
	// Read Only: true
	Anagrpid *string `json:"anagrpid,omitempty"`

	// The NVMe namespace identifier. This is an identifier used by an NVMe controller to provide access to the NVMe namespace.<br/>
	// The format for an NVMe namespace identifier is 8 hexadecimal digits (zero-filled) followed by a lower case "h".
	//
	// Example: 00000001h
	// Read Only: true
	Nsid *string `json:"nsid,omitempty"`

	// The NVMe subsystem to which the NVMe namespace is mapped.
	//
	Subsystem *ConsistencyGroupNvmeSubsystem `json:"subsystem,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 namespaces items0 subsystem map
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubsystem(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) validateSubsystem(formats strfmt.Registry) error {
	if swag.IsZero(m.Subsystem) { // not required
		return nil
	}

	if m.Subsystem != nil {
		if err := m.Subsystem.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "subsystem")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 namespaces items0 subsystem map based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateAnagrpid(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNsid(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSubsystem(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) contextValidateAnagrpid(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "subsystem_map"+"."+"anagrpid", "body", m.Anagrpid); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) contextValidateNsid(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "subsystem_map"+"."+"nsid", "body", m.Nsid); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) contextValidateSubsystem(ctx context.Context, formats strfmt.Registry) error {

	if m.Subsystem != nil {
		if err := m.Subsystem.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "subsystem")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0NamespacesItems0SubsystemMap
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup The parent consistency group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the consistency group.
	// Example: my_consistency_group
	Name *string `json:"name,omitempty"`

	// The unique identifier of the consistency group.
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 parent consistency group
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 parent consistency group based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ParentConsistencyGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// storage service
	StorageService *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService `json:"storage_service,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 provisioning options based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService Determines the placement of any storage object created during this operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService struct {

	// Storage service name. If not specified, the default value is the most performant for the platform.
	//
	// Enum: [extreme performance value]
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 provisioning options storage service
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceTypeNamePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNameExtreme captures enum value "extreme"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNamePerformance captures enum value "performance"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNameValue captures enum value "value"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceNameValue string = "value"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("provisioning_options"+"."+"storage_service"+"."+"name", "body", *m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 provisioning options storage service based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0ProvisioningOptionsStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos consistency group response records items0 consistency groups items0 qos
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos struct {

	// policy
	Policy *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 qos
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 qos based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Qos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy The QoS policy
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 qos policy
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 qos policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0QosPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo Use to restore a consistency group to a previous Snapshot copy
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo struct {

	// snapshot
	Snapshot *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot `json:"snapshot,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 restore to
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) validateSnapshot(formats strfmt.Registry) error {
	if swag.IsZero(m.Snapshot) { // not required
		return nil
	}

	if m.Snapshot != nil {
		if err := m.Snapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to" + "." + "snapshot")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 restore to based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSnapshot(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) contextValidateSnapshot(ctx context.Context, formats strfmt.Registry) error {

	if m.Snapshot != nil {
		if err := m.Snapshot.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to" + "." + "snapshot")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreTo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot A consistency group's Snapshot copy
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot struct {

	// The name of the consistency group's Snapshot copy to restore to.
	Name *string `json:"name,omitempty"`

	// The UUID of the consistency group's Snapshot copy to restore to.
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 restore to snapshot
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 restore to snapshot based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0RestoreToSnapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space Space information for the consistency group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space struct {

	// The amount of space available in the consistency group, in bytes.<br/>
	//
	// Example: 5737418
	Available *int64 `json:"available,omitempty"`

	// The total provisioned size of the consistency group, in bytes.<br/>
	//
	// Example: 1073741824
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed in the consistency group, in bytes.<br/>
	//
	// Example: 5737418
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 space
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 space based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm The Storage Virtual Machine (SVM) in which the consistency group is located.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm struct {

	// links
	Links *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks `json:"_links,omitempty"`

	// The name of the SVM.
	//
	// Example: svm1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the SVM.
	//
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 svm
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 svm based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Svm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks consistency group response records items0 consistency groups items0 svm links
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 svm links
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 svm links based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0SvmLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering The tiering placement and policy definitions for volumes in this consistency group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering struct {

	// Storage tiering placement rules for the object.
	// Enum: [allowed best_effort disallowed required]
	Control *string `json:"control,omitempty"`

	// Object stores to use. Used for placement.
	//
	// Max Items: 2
	// Min Items: 0
	ObjectStores []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0 `json:"object_stores"`

	// Policy that determines whether the user data blocks of a volume in a FabricPool will be tiered to the cloud store when they become cold.
	// <br>FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of a volume block increases if it is accessed frequently and decreases when it is not. Valid in POST or PATCH.<br/>all &dash; Allows tiering of both Snapshot copies and active file system user data to the cloud store as soon as possible by ignoring the temperature on the volume blocks.<br/>auto &dash; Allows tiering of both snapshot and active file system user data to the cloud store<br/>none &dash; Volume blocks are not be tiered to the cloud store.<br/>snapshot_only &dash; Allows tiering of only the volume Snapshot copies not associated with the active file system.
	// <br>The default tiering policy is "snapshot-only" for a FlexVol volume and "none" for a FlexGroup volume. The default minimum cooling period for the "snapshot-only" tiering policy is 2 days and for the "auto" tiering policy it is 31 days.
	//
	// Enum: [all auto backup none snapshot_only]
	Policy *string `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 tiering
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateControl(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateObjectStores(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypeControlPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["allowed","best_effort","disallowed","required"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypeControlPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypeControlPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// control
	// Control
	// allowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlAllowed captures enum value "allowed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlAllowed string = "allowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// control
	// Control
	// best_effort
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlBestEffort captures enum value "best_effort"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlBestEffort string = "best_effort"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// control
	// Control
	// disallowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlDisallowed captures enum value "disallowed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlDisallowed string = "disallowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// control
	// Control
	// required
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlRequired captures enum value "required"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringControlRequired string = "required"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) validateControlEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypeControlPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) validateControl(formats strfmt.Registry) error {
	if swag.IsZero(m.Control) { // not required
		return nil
	}

	// value enum
	if err := m.validateControlEnum("tiering"+"."+"control", "body", *m.Control); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) validateObjectStores(formats strfmt.Registry) error {
	if swag.IsZero(m.ObjectStores) { // not required
		return nil
	}

	iObjectStoresSize := int64(len(m.ObjectStores))

	if err := validate.MinItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 2); err != nil {
		return err
	}

	for i := 0; i < len(m.ObjectStores); i++ {
		if swag.IsZero(m.ObjectStores[i]) { // not required
			continue
		}

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypePolicyPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypePolicyPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// policy
	// Policy
	// all
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyAll captures enum value "all"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyAll string = "all"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// policy
	// Policy
	// auto
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyAuto captures enum value "auto"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyAuto string = "auto"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// policy
	// Policy
	// backup
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyBackup captures enum value "backup"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyBackup string = "backup"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// policy
	// Policy
	// none
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyNone captures enum value "none"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicyNone string = "none"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	// policy
	// Policy
	// snapshot_only
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicySnapshotOnly captures enum value "snapshot_only"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringTypePolicyPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", *m.Policy); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 tiering based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateObjectStores(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) contextValidateObjectStores(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ObjectStores); i++ {

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0Tiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0 consistency group response records items0 consistency groups items0 tiering object stores items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0 struct {

	// The name of the object store to use. Used for placement.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 tiering object stores items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 tiering object stores items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0TieringObjectStoresItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0 consistency group response records items0 consistency groups items0 volumes items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0 struct {

	// A comment for the volume. Valid in POST or PATCH.
	// Max Length: 1023
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Language encoding setting for volume. If no language is specified, the volume inherits its SVM language encoding setting.
	// Enum: [ar ar.utf_8 c c.utf_8 cs cs.utf_8 da da.utf_8 de de.utf_8 en en.utf_8 en_us en_us.utf_8 es es.utf_8 fi fi.utf_8 fr fr.utf_8 he he.utf_8 hr hr.utf_8 hu hu.utf_8 it it.utf_8 ja ja.utf_8 ja_jp.932 ja_jp.932.utf_8 ja_jp.pck ja_jp.pck.utf_8 ja_jp.pck_v2 ja_jp.pck_v2.utf_8 ja_v1 ja_v1.utf_8 ko ko.utf_8 nl nl.utf_8 no no.utf_8 pl pl.utf_8 pt pt.utf_8 ro ro.utf_8 ru ru.utf_8 sk sk.utf_8 sl sl.utf_8 sv sv.utf_8 tr tr.utf_8 utf8mb4 zh zh.gbk zh.gbk.utf_8 zh.utf_8 zh_tw zh_tw.big5 zh_tw.big5.utf_8 zh_tw.utf_8]
	Language *string `json:"language,omitempty"`

	// Volume name. The name of volume must start with an alphabetic character (a to z or A to Z) or an underscore (_). The name must be 197 or fewer characters in length for FlexGroups, and 203 or fewer characters in length for all other types of volumes. Volume names must be unique within an SVM. Required on POST.
	// Example: vol_cs_dept
	// Max Length: 203
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// nas
	Nas *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas `json:"nas,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos `json:"qos,omitempty"`

	// The Snapshot copy policy for this volume.
	//
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space `json:"space,omitempty"`

	// tiering
	Tiering *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering `json:"tiering,omitempty"`

	// Unique identifier for the volume. This corresponds to the instance-uuid that is exposed in the CLI and ONTAPI. It does not change due to a volume move.
	// Example: 028baa66-41bd-11e9-81d5-00a0986138f7
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLanguage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNas(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 1023); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TypeLanguagePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ar","ar.utf_8","c","c.utf_8","cs","cs.utf_8","da","da.utf_8","de","de.utf_8","en","en.utf_8","en_us","en_us.utf_8","es","es.utf_8","fi","fi.utf_8","fr","fr.utf_8","he","he.utf_8","hr","hr.utf_8","hu","hu.utf_8","it","it.utf_8","ja","ja.utf_8","ja_jp.932","ja_jp.932.utf_8","ja_jp.pck","ja_jp.pck.utf_8","ja_jp.pck_v2","ja_jp.pck_v2.utf_8","ja_v1","ja_v1.utf_8","ko","ko.utf_8","nl","nl.utf_8","no","no.utf_8","pl","pl.utf_8","pt","pt.utf_8","ro","ro.utf_8","ru","ru.utf_8","sk","sk.utf_8","sl","sl.utf_8","sv","sv.utf_8","tr","tr.utf_8","utf8mb4","zh","zh.gbk","zh.gbk.utf_8","zh.utf_8","zh_tw","zh_tw.big5","zh_tw.big5.utf_8","zh_tw.utf_8"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TypeLanguagePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TypeLanguagePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ar
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageAr captures enum value "ar"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageAr string = "ar"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ar.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageArDotUTF8 captures enum value "ar.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageArDotUTF8 string = "ar.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// c
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageC captures enum value "c"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageC string = "c"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// c.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCDotUTF8 captures enum value "c.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCDotUTF8 string = "c.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// cs
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCs captures enum value "cs"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCs string = "cs"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// cs.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCsDotUTF8 captures enum value "cs.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageCsDotUTF8 string = "cs.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// da
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDa captures enum value "da"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDa string = "da"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// da.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDaDotUTF8 captures enum value "da.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDaDotUTF8 string = "da.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// de
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDe captures enum value "de"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDe string = "de"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// de.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDeDotUTF8 captures enum value "de.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageDeDotUTF8 string = "de.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// en
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEn captures enum value "en"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEn string = "en"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// en.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnDotUTF8 captures enum value "en.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnDotUTF8 string = "en.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// en_us
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnUs captures enum value "en_us"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnUs string = "en_us"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// en_us.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnUsDotUTF8 captures enum value "en_us.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEnUsDotUTF8 string = "en_us.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// es
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEs captures enum value "es"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEs string = "es"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// es.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEsDotUTF8 captures enum value "es.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageEsDotUTF8 string = "es.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// fi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFi captures enum value "fi"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFi string = "fi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// fi.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFiDotUTF8 captures enum value "fi.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFiDotUTF8 string = "fi.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// fr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFr captures enum value "fr"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFr string = "fr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// fr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFrDotUTF8 captures enum value "fr.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageFrDotUTF8 string = "fr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// he
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHe captures enum value "he"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHe string = "he"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// he.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHeDotUTF8 captures enum value "he.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHeDotUTF8 string = "he.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// hr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHr captures enum value "hr"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHr string = "hr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// hr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHrDotUTF8 captures enum value "hr.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHrDotUTF8 string = "hr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// hu
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHu captures enum value "hu"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHu string = "hu"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// hu.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHuDotUTF8 captures enum value "hu.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageHuDotUTF8 string = "hu.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// it
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageIt captures enum value "it"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageIt string = "it"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// it.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageItDotUTF8 captures enum value "it.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageItDotUTF8 string = "it.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJa captures enum value "ja"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJa string = "ja"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaDotUTF8 captures enum value "ja.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaDotUTF8 string = "ja.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.932
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDot932 captures enum value "ja_jp.932"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDot932 string = "ja_jp.932"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.932.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDot932DotUTF8 captures enum value "ja_jp.932.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDot932DotUTF8 string = "ja_jp.932.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPck captures enum value "ja_jp.pck"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPck string = "ja_jp.pck"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckDotUTF8 captures enum value "ja_jp.pck.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckDotUTF8 string = "ja_jp.pck.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck_v2
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckV2 captures enum value "ja_jp.pck_v2"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckV2 string = "ja_jp.pck_v2"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck_v2.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckV2DotUTF8 captures enum value "ja_jp.pck_v2.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaJpDotPckV2DotUTF8 string = "ja_jp.pck_v2.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_v1
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaV1 captures enum value "ja_v1"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaV1 string = "ja_v1"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ja_v1.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaV1DotUTF8 captures enum value "ja_v1.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageJaV1DotUTF8 string = "ja_v1.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ko
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageKo captures enum value "ko"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageKo string = "ko"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ko.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageKoDotUTF8 captures enum value "ko.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageKoDotUTF8 string = "ko.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// nl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNl captures enum value "nl"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNl string = "nl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// nl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNlDotUTF8 captures enum value "nl.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNlDotUTF8 string = "nl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// no
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNo captures enum value "no"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNo string = "no"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// no.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNoDotUTF8 captures enum value "no.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageNoDotUTF8 string = "no.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// pl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePl captures enum value "pl"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePl string = "pl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// pl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePlDotUTF8 captures enum value "pl.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePlDotUTF8 string = "pl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// pt
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePt captures enum value "pt"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePt string = "pt"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// pt.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePtDotUTF8 captures enum value "pt.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguagePtDotUTF8 string = "pt.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ro
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRo captures enum value "ro"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRo string = "ro"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ro.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRoDotUTF8 captures enum value "ro.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRoDotUTF8 string = "ro.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ru
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRu captures enum value "ru"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRu string = "ru"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// ru.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRuDotUTF8 captures enum value "ru.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageRuDotUTF8 string = "ru.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sk
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSk captures enum value "sk"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSk string = "sk"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sk.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSkDotUTF8 captures enum value "sk.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSkDotUTF8 string = "sk.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSl captures enum value "sl"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSl string = "sl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSlDotUTF8 captures enum value "sl.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSlDotUTF8 string = "sl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sv
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSv captures enum value "sv"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSv string = "sv"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// sv.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSvDotUTF8 captures enum value "sv.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageSvDotUTF8 string = "sv.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// tr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageTr captures enum value "tr"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageTr string = "tr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// tr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageTrDotUTF8 captures enum value "tr.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageTrDotUTF8 string = "tr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// utf8mb4
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageUtf8mb4 captures enum value "utf8mb4"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageUtf8mb4 string = "utf8mb4"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZh captures enum value "zh"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZh string = "zh"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh.gbk
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotGbk captures enum value "zh.gbk"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotGbk string = "zh.gbk"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh.gbk.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotGbkDotUTF8 captures enum value "zh.gbk.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotGbkDotUTF8 string = "zh.gbk.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotUTF8 captures enum value "zh.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhDotUTF8 string = "zh.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh_tw
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTw captures enum value "zh_tw"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTw string = "zh_tw"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh_tw.big5
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotBig5 captures enum value "zh_tw.big5"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotBig5 string = "zh_tw.big5"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh_tw.big5.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotBig5DotUTF8 captures enum value "zh_tw.big5.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotBig5DotUTF8 string = "zh_tw.big5.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	// language
	// Language
	// zh_tw.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotUTF8 captures enum value "zh_tw.utf_8"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0LanguageZhTwDotUTF8 string = "zh_tw.utf_8"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateLanguageEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TypeLanguagePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateLanguage(formats strfmt.Registry) error {
	if swag.IsZero(m.Language) { // not required
		return nil
	}

	// value enum
	if err := m.validateLanguageEnum("language", "body", *m.Language); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", *m.Name, 203); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateNas(formats strfmt.Registry) error {
	if swag.IsZero(m.Nas) { // not required
		return nil
	}

	if m.Nas != nil {
		if err := m.Nas.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateSnapshotPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) validateTiering(formats strfmt.Registry) error {
	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateNas(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSnapshotPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTiering(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateNas(ctx context.Context, formats strfmt.Registry) error {

	if m.Nas != nil {
		if err := m.Nas.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateSnapshotPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateTiering(ctx context.Context, formats strfmt.Registry) error {

	if m.Tiering != nil {
		if err := m.Tiering.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas The CIFS share policy and/or export policies for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas struct {

	// cifs
	Cifs *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs `json:"cifs,omitempty"`

	// export policy
	ExportPolicy *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy `json:"export_policy,omitempty"`

	// The UNIX group ID of the volume. Valid in POST or PATCH.
	Gid *int64 `json:"gid,omitempty"`

	// junction parent
	JunctionParent *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent `json:"junction_parent,omitempty"`

	// The fully-qualified path in the owning SVM's namespace at which the volume is mounted. The path is case insensitive and must be unique within an SVM's namespace. Path must begin with '/' and must not end with '/'. Only one volume can be mounted at any given junction path. An empty path in POST creates an unmounted volume. An empty path in PATCH deactivates and unmounts the volume. Taking a volume offline or restricted state removes its junction path. This attribute is reported in GET only when the volume is mounted.
	// Example: /user/my_volume
	Path *string `json:"path,omitempty"`

	// Security style associated with the volume. Valid in POST or PATCH.<br>mixed &dash; Mixed-style security<br>ntfs &dash; NTFS/WIndows-style security<br>unified &dash; Unified-style security, unified UNIX, NFS and CIFS permissions<br>unix &dash; UNIX-style security.
	// Enum: [mixed ntfs unified unix]
	SecurityStyle *string `json:"security_style,omitempty"`

	// The UNIX user ID of the volume. Valid in POST or PATCH.
	UID *int64 `json:"uid,omitempty"`

	// UNIX permissions to be viewed as an octal number, consisting of 4 digits derived by adding up bits 4 (read), 2 (write), and 1 (execute). First digit selects the set user ID (4), set group ID (2), and sticky (1) attributes. Second digit selects permission for the owner of the file. Third selects permissions for other users in the same group while the fourth selects permissions for other users not in the group. Valid in POST or PATCH. For security style "mixed" or "unix", the default setting is 0755 in octal (493 in decimal) and for security style "ntfs", the default setting is 0000. In cases where only owner, group, and other permissions are given (as in 755, representing the second, third and fourth digit), the first digit is assumed to be zero.
	// Example: 755
	UnixPermissions *int64 `json:"unix_permissions,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 nas
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCifs(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateExportPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateJunctionParent(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSecurityStyle(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) validateCifs(formats strfmt.Registry) error {
	if swag.IsZero(m.Cifs) { // not required
		return nil
	}

	if m.Cifs != nil {
		if err := m.Cifs.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "cifs")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) validateExportPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.ExportPolicy) { // not required
		return nil
	}

	if m.ExportPolicy != nil {
		if err := m.ExportPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) validateJunctionParent(formats strfmt.Registry) error {
	if swag.IsZero(m.JunctionParent) { // not required
		return nil
	}

	if m.JunctionParent != nil {
		if err := m.JunctionParent.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent")
			}
			return err
		}
	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasTypeSecurityStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["mixed","ntfs","unified","unix"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasTypeSecurityStylePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasTypeSecurityStylePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// mixed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleMixed captures enum value "mixed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleMixed string = "mixed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// ntfs
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleNtfs captures enum value "ntfs"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleNtfs string = "ntfs"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// unified
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleUnified captures enum value "unified"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleUnified string = "unified"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// unix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleUnix captures enum value "unix"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasSecurityStyleUnix string = "unix"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) validateSecurityStyleEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasTypeSecurityStylePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) validateSecurityStyle(formats strfmt.Registry) error {
	if swag.IsZero(m.SecurityStyle) { // not required
		return nil
	}

	// value enum
	if err := m.validateSecurityStyleEnum("nas"+"."+"security_style", "body", *m.SecurityStyle); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 nas based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCifs(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateExportPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateJunctionParent(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) contextValidateCifs(ctx context.Context, formats strfmt.Registry) error {

	if m.Cifs != nil {
		if err := m.Cifs.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "cifs")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) contextValidateExportPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.ExportPolicy != nil {
		if err := m.ExportPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) contextValidateJunctionParent(ctx context.Context, formats strfmt.Registry) error {

	if m.JunctionParent != nil {
		if err := m.JunctionParent.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Nas
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs consistency group response records items0 consistency groups items0 volumes items0 nas cifs
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs struct {

	// shares
	Shares []*ConsistencyGroupCifsShare `json:"shares"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 nas cifs
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateShares(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) validateShares(formats strfmt.Registry) error {
	if swag.IsZero(m.Shares) { // not required
		return nil
	}

	for i := 0; i < len(m.Shares); i++ {
		if swag.IsZero(m.Shares[i]) { // not required
			continue
		}

		if m.Shares[i] != nil {
			if err := m.Shares[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "cifs" + "." + "shares" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 nas cifs based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateShares(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) contextValidateShares(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Shares); i++ {

		if m.Shares[i] != nil {
			if err := m.Shares[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "cifs" + "." + "shares" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasCifs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy The policy associated with volumes to export them for protocol access.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Name of the export policy.
	Name *string `json:"name,omitempty"`

	// The set of rules that govern the export policy.
	Rules []*ExportRules `json:"rules"`

	// Identifier for the export policy.
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 nas export policy
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRules(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) validateRules(formats strfmt.Registry) error {
	if swag.IsZero(m.Rules) { // not required
		return nil
	}

	for i := 0; i < len(m.Rules); i++ {
		if swag.IsZero(m.Rules[i]) { // not required
			continue
		}

		if m.Rules[i] != nil {
			if err := m.Rules[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "export_policy" + "." + "rules" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 nas export policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRules(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) contextValidateRules(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Rules); i++ {

		if m.Rules[i] != nil {
			if err := m.Rules[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "export_policy" + "." + "rules" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "nas"+"."+"export_policy"+"."+"uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasExportPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent consistency group response records items0 consistency groups items0 volumes items0 nas junction parent
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the parent volume that contains the junction inode of this volume. The junction parent volume must belong to the same SVM that owns this volume.
	// Example: vs1_root
	Name *string `json:"name,omitempty"`

	// Unique identifier for the parent volume.
	// Example: 75c9cfb0-3eb4-11eb-9fb4-005056bb088a
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 nas junction parent
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 nas junction parent based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0NasJunctionParent
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create add remove]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`

	// storage service
	StorageService *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService `json:"storage_service,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create","add","remove"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionCreate string = "create"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// add
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionAdd captures enum value "add"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionAdd string = "add"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// remove
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionRemove captures enum value "remove"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsActionRemove string = "remove"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 provisioning options based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService Determines the placement of any storage object created during this operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService struct {

	// Storage service name. If not specified, the default value is the most performant for the platform.
	//
	// Enum: [extreme performance value]
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 provisioning options storage service
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNameExtreme captures enum value "extreme"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNamePerformance captures enum value "performance"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNameValue captures enum value "value"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceNameValue string = "value"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("provisioning_options"+"."+"storage_service"+"."+"name", "body", *m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 volumes items0 provisioning options storage service based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0ProvisioningOptionsStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos The QoS policy for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos struct {

	// policy
	Policy *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 qos
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 qos based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Qos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy The QoS policy
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 qos policy
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 qos policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0QosPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space consistency group response records items0 consistency groups items0 volumes items0 space
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space struct {

	// The available space, in bytes.
	Available *int64 `json:"available,omitempty"`

	// Total provisioned size, in bytes.
	Size *int64 `json:"size,omitempty"`

	// The virtual space used (includes volume reserves) before storage efficiency, in bytes.
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 space
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 volumes items0 space based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering The tiering placement and policy definitions for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering struct {

	// Storage tiering placement rules for the object.
	// Enum: [allowed best_effort disallowed required]
	Control *string `json:"control,omitempty"`

	// Object stores to use. Used for placement.
	//
	// Max Items: 2
	// Min Items: 0
	ObjectStores []*ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0 `json:"object_stores"`

	// Policy that determines whether the user data blocks of a volume in a FabricPool will be tiered to the cloud store when they become cold.
	// <br>FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of a volume block increases if it is accessed frequently and decreases when it is not. Valid in POST or PATCH.<br/>all &dash; Allows tiering of both Snapshot copies and active file system user data to the cloud store as soon as possible by ignoring the temperature on the volume blocks.<br/>auto &dash; Allows tiering of both snapshot and active file system user data to the cloud store<br/>none &dash; Volume blocks are not be tiered to the cloud store.<br/>snapshot_only &dash; Allows tiering of only the volume Snapshot copies not associated with the active file system.
	// <br>The default tiering policy is "snapshot-only" for a FlexVol volume and "none" for a FlexGroup volume. The default minimum cooling period for the "snapshot-only" tiering policy is 2 days and for the "auto" tiering policy it is 31 days.
	//
	// Enum: [all auto backup none snapshot_only]
	Policy *string `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 tiering
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateControl(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateObjectStores(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypeControlPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["allowed","best_effort","disallowed","required"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypeControlPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypeControlPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// control
	// Control
	// allowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlAllowed captures enum value "allowed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlAllowed string = "allowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// control
	// Control
	// best_effort
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlBestEffort captures enum value "best_effort"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlBestEffort string = "best_effort"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// control
	// Control
	// disallowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlDisallowed captures enum value "disallowed"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlDisallowed string = "disallowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// control
	// Control
	// required
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlRequired captures enum value "required"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringControlRequired string = "required"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) validateControlEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypeControlPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) validateControl(formats strfmt.Registry) error {
	if swag.IsZero(m.Control) { // not required
		return nil
	}

	// value enum
	if err := m.validateControlEnum("tiering"+"."+"control", "body", *m.Control); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) validateObjectStores(formats strfmt.Registry) error {
	if swag.IsZero(m.ObjectStores) { // not required
		return nil
	}

	iObjectStoresSize := int64(len(m.ObjectStores))

	if err := validate.MinItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 2); err != nil {
		return err
	}

	for i := 0; i < len(m.ObjectStores); i++ {
		if swag.IsZero(m.ObjectStores[i]) { // not required
			continue
		}

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypePolicyPropEnum = append(consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypePolicyPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// policy
	// Policy
	// all
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyAll captures enum value "all"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyAll string = "all"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// policy
	// Policy
	// auto
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyAuto captures enum value "auto"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyAuto string = "auto"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// policy
	// Policy
	// backup
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyBackup captures enum value "backup"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyBackup string = "backup"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// policy
	// Policy
	// none
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyNone captures enum value "none"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicyNone string = "none"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	// policy
	// Policy
	// snapshot_only
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicySnapshotOnly captures enum value "snapshot_only"
	ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringTypePolicyPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", *m.Policy); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 consistency groups items0 volumes items0 tiering based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateObjectStores(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) contextValidateObjectStores(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ObjectStores); i++ {

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0Tiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0 consistency group response records items0 consistency groups items0 volumes items0 tiering object stores items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0
type ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0 struct {

	// The name of the object store to use. Used for placement.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 consistency groups items0 volumes items0 tiering object stores items0
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 consistency groups items0 volumes items0 tiering object stores items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0ConsistencyGroupsItems0VolumesItems0TieringObjectStoresItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0 A LUN is the logical representation of storage in a storage area network (SAN).<br/>
// In ONTAP, a LUN is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
// A LUN can be created to a specified size using thin or thick provisioning. A LUN can then be renamed, resized, cloned, and moved to a different volume. LUNs support the assignment of a quality of service (QoS) policy for performance management or a QoS policy can be assigned to the volume containing the LUN. See the LUN object model to learn more about each of the properties supported by the LUN REST API.<br/>
// A LUN must be mapped to an initiator group to grant access to the initiator group's initiators (client hosts). Initiators can then access the LUN and perform I/O over a Fibre Channel (FC) fabric using the Fibre Channel Protocol or a TCP/IP network using iSCSI.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0
type ConsistencyGroupResponseRecordsItems0LunsItems0 struct {

	// clone
	Clone *ConsistencyGroupResponseRecordsItems0LunsItems0Clone `json:"clone,omitempty"`

	// A configurable comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// The time the LUN was created.
	// Example: 2018-06-04T19:00:00Z
	// Read Only: true
	// Format: date-time
	CreateTime *strfmt.DateTime `json:"create_time,omitempty"`

	// The enabled state of the LUN. LUNs can be disabled to prevent access to the LUN. Certain error conditions also cause the LUN to become disabled. If the LUN is disabled, you can consult the `state` property to determine if the LUN is administratively disabled (_offline_) or has become disabled as a result of an error. A LUN in an error condition can be brought online by setting the `enabled` property to _true_ or brought administratively offline by setting the `enabled` property to _false_. Upon creation, a LUN is enabled by default. Valid in PATCH.
	//
	Enabled *bool `json:"enabled,omitempty"`

	// An array of LUN maps.<br/>
	// A LUN map is an association between a LUN and an initiator group. When a LUN is mapped to an initiator group, the initiator group's initiators are granted access to the LUN. The relationship between a LUN and an initiator group is many LUNs to many initiator groups.
	//
	LunMaps []*ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0 `json:"lun_maps"`

	// The fully qualified path name of the LUN composed of the "/vol" prefix, the volume name, the qtree name (optional), and the base name of the LUN. Valid in POST and PATCH.
	//
	// Example: /vol/volume1/lun1
	Name *string `json:"name,omitempty"`

	// The operating system type of the LUN.<br/>
	// Required in POST when creating a LUN that is not a clone of another. Disallowed in POST when creating a LUN clone.
	//
	// Enum: [aix hpux hyper_v linux netware openvms solaris solaris_efi vmware windows windows_2008 windows_gpt xen]
	OsType *string `json:"os_type,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseRecordsItems0LunsItems0Qos `json:"qos,omitempty"`

	// The LUN serial number. The serial number is generated by ONTAP when the LUN is created.
	//
	// Read Only: true
	// Max Length: 12
	// Min Length: 12
	SerialNumber *string `json:"serial_number,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0LunsItems0Space `json:"space,omitempty"`

	// The unique identifier of the LUN.  The UUID is generated by ONTAP when the LUN is created.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateClone(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreateTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLunMaps(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSerialNumber(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateClone(formats strfmt.Registry) error {
	if swag.IsZero(m.Clone) { // not required
		return nil
	}

	if m.Clone != nil {
		if err := m.Clone.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateCreateTime(formats strfmt.Registry) error {
	if swag.IsZero(m.CreateTime) { // not required
		return nil
	}

	if err := validate.FormatOf("create_time", "body", "date-time", m.CreateTime.String(), formats); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateLunMaps(formats strfmt.Registry) error {
	if swag.IsZero(m.LunMaps) { // not required
		return nil
	}

	for i := 0; i < len(m.LunMaps); i++ {
		if swag.IsZero(m.LunMaps[i]) { // not required
			continue
		}

		if m.LunMaps[i] != nil {
			if err := m.LunMaps[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lun_maps" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseRecordsItems0LunsItems0TypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","hpux","hyper_v","linux","netware","openvms","solaris","solaris_efi","vmware","windows","windows_2008","windows_gpt","xen"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0LunsItems0TypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0LunsItems0TypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// hpux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeHpux captures enum value "hpux"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeHpux string = "hpux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// hyper_v
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeHyperv captures enum value "hyper_v"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeHyperv string = "hyper_v"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// netware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeNetware captures enum value "netware"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeNetware string = "netware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// openvms
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeOpenvms captures enum value "openvms"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeOpenvms string = "openvms"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// solaris
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeSolaris captures enum value "solaris"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeSolaris string = "solaris"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// solaris_efi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeSolarisEfi captures enum value "solaris_efi"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeSolarisEfi string = "solaris_efi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindows string = "windows"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// windows_2008
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindows2008 captures enum value "windows_2008"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindows2008 string = "windows_2008"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// windows_gpt
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindowsGpt captures enum value "windows_gpt"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeWindowsGpt string = "windows_gpt"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// ConsistencyGroupResponseRecordsItems0LunsItems0
	// os_type
	// OsType
	// xen
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeXen captures enum value "xen"
	ConsistencyGroupResponseRecordsItems0LunsItems0OsTypeXen string = "xen"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0LunsItems0TypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateSerialNumber(formats strfmt.Registry) error {
	if swag.IsZero(m.SerialNumber) { // not required
		return nil
	}

	if err := validate.MinLength("serial_number", "body", *m.SerialNumber, 12); err != nil {
		return err
	}

	if err := validate.MaxLength("serial_number", "body", *m.SerialNumber, 12); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateClone(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCreateTime(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLunMaps(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSerialNumber(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateClone(ctx context.Context, formats strfmt.Registry) error {

	if m.Clone != nil {
		if err := m.Clone.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateCreateTime(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "create_time", "body", m.CreateTime); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateLunMaps(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.LunMaps); i++ {

		if m.LunMaps[i] != nil {
			if err := m.LunMaps[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("lun_maps" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateSerialNumber(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "serial_number", "body", m.SerialNumber); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0Clone This sub-object is used in POST to create a new LUN as a clone of an existing LUN, or PATCH to overwrite an existing LUN as a clone of another. Setting a property in this sub-object indicates that a LUN clone is desired. Consider the following other properties when cloning a LUN: `auto_delete`, `qos_policy`, `space.guarantee.requested` and `space.scsi_thin_provisioning_support_enabled`.<br/>
// When used in a PATCH, the patched LUN's data is over-written as a clone of the source and the following properties are preserved from the patched LUN unless otherwise specified as part of the PATCH: `class`, `auto_delete`, `lun_maps`, `serial_number`, `status.state`, and `uuid`.<br/>
// Persistent reservations for the patched LUN are also preserved.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0Clone
type ConsistencyGroupResponseRecordsItems0LunsItems0Clone struct {

	// source
	Source *ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource `json:"source,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 clone
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSource(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) validateSource(formats strfmt.Registry) error {
	if swag.IsZero(m.Source) { // not required
		return nil
	}

	if m.Source != nil {
		if err := m.Source.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "source")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 clone based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSource(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) contextValidateSource(ctx context.Context, formats strfmt.Registry) error {

	if m.Source != nil {
		if err := m.Source.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("clone" + "." + "source")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Clone) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0Clone
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource The source LUN for a LUN clone operation. This can be specified using property `clone.source.uuid` or `clone.source.name`. If both properties are supplied, they must refer to the same LUN.<br/>
// Valid in POST to create a new LUN as a clone of the source.<br/>
// Valid in PATCH to overwrite an existing LUN's data as a clone of another.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource
type ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource struct {

	// The fully qualified path name of the clone source LUN composed of a "/vol" prefix, the volume name, the (optional) qtree name, and base name of the LUN. Valid in POST and PATCH.
	//
	// Example: /vol/volume1/lun1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the clone source LUN. Valid in POST and PATCH.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 clone source
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 luns items0 clone source based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0CloneSource
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0 A LUN map is an association between a LUN and an initiator group.<br/>
// When a LUN is mapped to an initiator group, the initiator group's initiators are granted access to the LUN. The relationship between a LUN and an initiator group is many LUNs to many initiator groups.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0
type ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0 struct {

	// igroup
	Igroup *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup `json:"igroup,omitempty"`

	// The logical unit number assigned to the LUN when mapped to the specified initiator group. The number is used to identify the LUN to initiators in the initiator group when communicating through the Fibre Channel Protocol or iSCSI. Optional in POST; if no value is provided, ONTAP assigns the lowest available value.
	//
	LogicalUnitNumber *int64 `json:"logical_unit_number,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 lun maps items0
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIgroup(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) validateIgroup(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroup) { // not required
		return nil
	}

	if m.Igroup != nil {
		if err := m.Igroup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 lun maps items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIgroup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) contextValidateIgroup(ctx context.Context, formats strfmt.Registry) error {

	if m.Igroup != nil {
		if err := m.Igroup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("igroup")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup The initiator group that directly owns the initiator, which is where modification of the initiator is supported. This property will only be populated when the initiator is a member of a nested initiator group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
type ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup struct {

	// A comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Separate igroup definitions to include in this igroup.
	//
	Igroups []*ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 `json:"igroups"`

	// The initiators that are members of the group.
	//
	Initiators []*ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 `json:"initiators"`

	// The name of the initiator group. Required in POST; optional in PATCH.
	//
	// Example: igroup1
	// Max Length: 96
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// The host operating system of the initiator group. All initiators in the group should be hosts of the same operating system. Required in POST; optional in PATCH.
	//
	// Enum: [aix hpux hyper_v linux netware openvms solaris vmware windows xen]
	OsType *string `json:"os_type,omitempty"`

	// The protocols supported by the initiator group. This restricts the type of initiators that can be added to the initiator group. Optional in POST; if not supplied, this defaults to _mixed_.<br/>
	// The protocol of an initiator group cannot be changed after creation of the group.
	//
	// Enum: [fcp iscsi mixed]
	Protocol *string `json:"protocol,omitempty"`

	// The unique identifier of the initiator group.
	//
	// Example: 4ea7a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 lun maps items0 igroup
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIgroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInitiators(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProtocol(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("igroup"+"."+"comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("igroup"+"."+"comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateIgroups(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroups) { // not required
		return nil
	}

	for i := 0; i < len(m.Igroups); i++ {
		if swag.IsZero(m.Igroups[i]) { // not required
			continue
		}

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateInitiators(formats strfmt.Registry) error {
	if swag.IsZero(m.Initiators) { // not required
		return nil
	}

	for i := 0; i < len(m.Initiators); i++ {
		if swag.IsZero(m.Initiators[i]) { // not required
			continue
		}

		if m.Initiators[i] != nil {
			if err := m.Initiators[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "initiators" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("igroup"+"."+"name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("igroup"+"."+"name", "body", *m.Name, 96); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","hpux","hyper_v","linux","netware","openvms","solaris","vmware","windows","xen"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// hpux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeHpux captures enum value "hpux"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeHpux string = "hpux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// hyper_v
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeHyperv captures enum value "hyper_v"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeHyperv string = "hyper_v"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// netware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeNetware captures enum value "netware"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeNetware string = "netware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// openvms
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeOpenvms captures enum value "openvms"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeOpenvms string = "openvms"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// solaris
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeSolaris captures enum value "solaris"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeSolaris string = "solaris"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeWindows string = "windows"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// os_type
	// OsType
	// xen
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeXen captures enum value "xen"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupOsTypeXen string = "xen"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("igroup"+"."+"os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fcp","iscsi","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum = append(consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// fcp
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolFcp captures enum value "fcp"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolFcp string = "fcp"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// iscsi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolIscsi captures enum value "iscsi"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolIscsi string = "iscsi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	// protocol
	// Protocol
	// mixed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolMixed captures enum value "mixed"
	ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupProtocolMixed string = "mixed"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateProtocolEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupTypeProtocolPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) validateProtocol(formats strfmt.Registry) error {
	if swag.IsZero(m.Protocol) { // not required
		return nil
	}

	// value enum
	if err := m.validateProtocolEnum("igroup"+"."+"protocol", "body", *m.Protocol); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 lun maps items0 igroup based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIgroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInitiators(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) contextValidateIgroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Igroups); i++ {

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) contextValidateInitiators(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Initiators); i++ {

		if m.Initiators[i] != nil {
			if err := m.Initiators[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroup" + "." + "initiators" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "igroup"+"."+"uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0Igroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 consistency group response records items0 luns items0 lun maps items0 igroup igroups items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0
type ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0 struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the initiator group.
	//
	// Example: igroup1
	// Max Length: 96
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the initiator group.
	//
	// Example: 4ea7a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 lun maps items0 igroup igroups items0
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", *m.Name, 96); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 lun maps items0 igroup igroups items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupIgroupsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 The initiators that are members of the initiator group.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0
type ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0 struct {

	// A comment available for use by the administrator.
	//
	// Example: my comment
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Name of initiator that is a member of the initiator group.
	//
	// Example: iqn.1998-01.com.corp.iscsi:name1
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 lun maps items0 igroup initiators items0
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 luns items0 lun maps items0 igroup initiators items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0LunMapsItems0IgroupInitiatorsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 luns items0 provisioning options based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0Qos consistency group response records items0 luns items0 qos
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0Qos
type ConsistencyGroupResponseRecordsItems0LunsItems0Qos struct {

	// policy
	Policy *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 qos
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 qos based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Qos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0Qos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy The QoS policy
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy
type ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 qos policy
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 qos policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0QosPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0Space The storage space related properties of the LUN.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0Space
type ConsistencyGroupResponseRecordsItems0LunsItems0Space struct {

	// guarantee
	Guarantee *ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee `json:"guarantee,omitempty"`

	// The total provisioned size of the LUN. The LUN size can be increased but not reduced using the REST interface.
	// The maximum and minimum sizes listed here are the absolute maximum and absolute minimum sizes, in bytes. The actual minimum and maxiumum sizes vary depending on the ONTAP version, ONTAP platform, and the available space in the containing volume and aggregate.
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	// Example: 1073741824
	// Maximum: 1.40737488355328e+14
	// Minimum: 4096
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed by the main data stream of the LUN.<br/>
	// This value is the total space consumed in the volume by the LUN, including filesystem overhead, but excluding prefix and suffix streams. Due to internal filesystem overhead and the many ways SAN filesystems and applications utilize blocks within a LUN, this value does not necessarily reflect actual consumption/availability from the perspective of the filesystem or application. Without specific knowledge of how the LUN blocks are utilized outside of ONTAP, this property should not be used as an indicator for an out-of-space condition.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 space
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) validateSize(formats strfmt.Registry) error {
	if swag.IsZero(m.Size) { // not required
		return nil
	}

	if err := validate.MinimumInt("space"+"."+"size", "body", *m.Size, 4096, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("space"+"."+"size", "body", *m.Size, 1.40737488355328e+14, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 luns items0 space based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee Properties that request and report the space guarantee for the LUN.
//
// swagger:model ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee
type ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee struct {

	// The requested space reservation policy for the LUN. If _true_, a space reservation is requested for the LUN; if _false_, the LUN is thin provisioned. Guaranteeing a space reservation request for a LUN requires that the volume in which the LUN resides is also space reserved and that the fractional reserve for the volume is 100%. Valid in POST and PATCH.
	//
	Requested *bool `json:"requested,omitempty"`

	// Reports if the LUN is space guaranteed.<br/>
	// If _true_, a space guarantee is requested and the containing volume and aggregate support the request. If _false_, a space guarantee is not requested or a space guarantee is requested and either the containing volume or aggregate do not support the request.
	//
	Reserved *bool `json:"reserved,omitempty"`
}

// Validate validates this consistency group response records items0 luns items0 space guarantee
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 luns items0 space guarantee based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0LunsItems0SpaceGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0 An NVMe namespace is a collection of addressable logical blocks presented to hosts connected to the storage virtual machine using the NVMe over Fabrics protocol.<br/>
// In ONTAP, an NVMe namespace is located within a volume. Optionally, it can be located within a qtree in a volume.<br/>
// An NVMe namespace is created to a specified size using thin or thick provisioning as determined by the volume on which it is created. NVMe namespaces support being cloned. An NVMe namespace cannot be renamed, resized, or moved to a different volume. NVMe namespaces do not support the assignment of a QoS policy for performance management, but a QoS policy can be assigned to the volume containing the namespace. See the NVMe namespace object model to learn more about each of the properties supported by the NVMe namespace REST API.<br/>
// An NVMe namespace must be mapped to an NVMe subsystem to grant access to the subsystem's hosts. Hosts can then access the NVMe namespace and perform I/O using the NVMe over Fabrics protocol.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0
type ConsistencyGroupResponseRecordsItems0NamespacesItems0 struct {

	// This property marks the NVMe namespace for auto deletion when the volume containing the namespace runs out of space. This is most commonly set on namespace clones.<br/>
	// When set to _true_, the NVMe namespace becomes eligible for automatic deletion when the volume runs out of space. Auto deletion only occurs when the volume containing the namespace is also configured for auto deletion and free space in the volume decreases below a particular threshold.<br/>
	// This property is optional in POST and PATCH. The default value for a new NVMe namespace is _false_.<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	AutoDelete *bool `json:"auto_delete,omitempty"`

	// A configurable comment available for use by the administrator. Valid in POST and PATCH.
	//
	// Max Length: 254
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// The time the NVMe namespace was created.
	// Example: 2018-06-04T19:00:00Z
	// Read Only: true
	// Format: date-time
	CreateTime *strfmt.DateTime `json:"create_time,omitempty"`

	// The enabled state of the NVMe namespace. Certain error conditions cause the namespace to become disabled. If the namespace is disabled, you can check the `state` property to determine what error disabled the namespace. An NVMe namespace is enabled automatically when it is created.
	//
	// Read Only: true
	Enabled *bool `json:"enabled,omitempty"`

	// The fully qualified path name of the NVMe namespace composed of a "/vol" prefix, the volume name, the (optional) qtree name and base name of the namespace. Valid in POST.<br/>
	// NVMe namespaces do not support rename, or movement between volumes.
	//
	// Example: /vol/volume1/qtree1/namespace1
	Name *string `json:"name,omitempty"`

	// The operating system type of the NVMe namespace.<br/>
	// Required in POST when creating an NVMe namespace that is not a clone of another. Disallowed in POST when creating a namespace clone.
	//
	// Enum: [aix linux vmware windows]
	OsType *string `json:"os_type,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space `json:"space,omitempty"`

	// status
	Status *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status `json:"status,omitempty"`

	// subsystem map
	SubsystemMap *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap `json:"subsystem_map,omitempty"`

	// The unique identifier of the NVMe namespace.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCreateTime(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubsystemMap(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 254); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateCreateTime(formats strfmt.Registry) error {
	if swag.IsZero(m.CreateTime) { // not required
		return nil
	}

	if err := validate.FormatOf("create_time", "body", "date-time", m.CreateTime.String(), formats); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0NamespacesItems0TypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","linux","vmware","windows"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0NamespacesItems0TypeOsTypePropEnum = append(consistencyGroupResponseRecordsItems0NamespacesItems0TypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeAix captures enum value "aix"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeLinux captures enum value "linux"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeVmware captures enum value "vmware"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeWindows captures enum value "windows"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0OsTypeWindows string = "windows"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0NamespacesItems0TypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", *m.OsType); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.Status) { // not required
		return nil
	}

	if m.Status != nil {
		if err := m.Status.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) validateSubsystemMap(formats strfmt.Registry) error {
	if swag.IsZero(m.SubsystemMap) { // not required
		return nil
	}

	if m.SubsystemMap != nil {
		if err := m.SubsystemMap.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 namespaces items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCreateTime(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateEnabled(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSubsystemMap(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateCreateTime(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "create_time", "body", m.CreateTime); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateEnabled(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "enabled", "body", m.Enabled); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateStatus(ctx context.Context, formats strfmt.Registry) error {

	if m.Status != nil {
		if err := m.Status.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateSubsystemMap(ctx context.Context, formats strfmt.Registry) error {

	if m.SubsystemMap != nil {
		if err := m.SubsystemMap.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 namespaces items0 provisioning options based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0Space The storage space related properties of the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0Space
type ConsistencyGroupResponseRecordsItems0NamespacesItems0Space struct {

	// The size of blocks in the namespace, in bytes.<br/>
	// Valid in POST when creating an NVMe namespace that is not a clone of another. Disallowed in POST when creating a namespace clone.
	//  Valid in POST.
	//
	// Enum: [512 4096]
	BlockSize *int64 `json:"block_size,omitempty"`

	// guarantee
	Guarantee *ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee `json:"guarantee,omitempty"`

	// The total provisioned size of the NVMe namespace. Valid in POST and PATCH. The NVMe namespace size can be increased but not reduced using the REST interface.<br/>
	// The maximum and minimum sizes listed here are the absolute maximum and absolute minimum sizes, in bytes. The maximum size is variable with respect to large NVMe namespace support in ONTAP. If large namespaces are supported, the maximum size is 128 TB (140737488355328 bytes) and if not supported, the maximum size is just under 16 TB (17557557870592 bytes). The minimum size supported is always 4096 bytes.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	// Example: 1073741824
	// Maximum: 1.40737488355328e+14
	// Minimum: 4096
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed by the main data stream of the NVMe namespace.<br/>
	// This value is the total space consumed in the volume by the NVMe namespace, including filesystem overhead, but excluding prefix and suffix streams. Due to internal filesystem overhead and the many ways NVMe filesystems and applications utilize blocks within a namespace, this value does not necessarily reflect actual consumption/availability from the perspective of the filesystem or application. Without specific knowledge of how the namespace blocks are utilized outside of ONTAP, this property should not be used as an indicator for an out-of-space condition.<br/>
	// For more information, see _Size properties_ in the _docs_ section of the ONTAP REST API documentation.
	//
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0 space
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBlockSize(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateGuarantee(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0NamespacesItems0SpaceTypeBlockSizePropEnum []interface{}

func init() {
	var res []int64
	if err := json.Unmarshal([]byte(`[512,4096]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0NamespacesItems0SpaceTypeBlockSizePropEnum = append(consistencyGroupResponseRecordsItems0NamespacesItems0SpaceTypeBlockSizePropEnum, v)
	}
}

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) validateBlockSizeEnum(path, location string, value int64) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0NamespacesItems0SpaceTypeBlockSizePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) validateBlockSize(formats strfmt.Registry) error {
	if swag.IsZero(m.BlockSize) { // not required
		return nil
	}

	// value enum
	if err := m.validateBlockSizeEnum("space"+"."+"block_size", "body", *m.BlockSize); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) validateGuarantee(formats strfmt.Registry) error {
	if swag.IsZero(m.Guarantee) { // not required
		return nil
	}

	if m.Guarantee != nil {
		if err := m.Guarantee.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) validateSize(formats strfmt.Registry) error {
	if swag.IsZero(m.Size) { // not required
		return nil
	}

	if err := validate.MinimumInt("space"+"."+"size", "body", *m.Size, 4096, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("space"+"."+"size", "body", *m.Size, 1.40737488355328e+14, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 namespaces items0 space based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateGuarantee(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) contextValidateGuarantee(ctx context.Context, formats strfmt.Registry) error {

	if m.Guarantee != nil {
		if err := m.Guarantee.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space" + "." + "guarantee")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee Properties that request and report the space guarantee for the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee
type ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee struct {

	// The requested space reservation policy for the NVMe namespace. If _true_, a space reservation is requested for the namespace; if _false_, the namespace is thin provisioned. Guaranteeing a space reservation request for a namespace requires that the volume in which the namespace resides also be space reserved and that the fractional reserve for the volume be 100%.<br/>
	// The space reservation policy for an NVMe namespace is determined by ONTAP.
	//
	Requested *bool `json:"requested,omitempty"`

	// Reports if the NVMe namespace is space guaranteed.<br/>
	// This property is _true_ if a space guarantee is requested and the containing volume and aggregate support the request. This property is _false_ if a space guarantee is not requested or if a space guarantee is requested and either the containing volume and aggregate do not support the request.
	//
	Reserved *bool `json:"reserved,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0 space guarantee
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 namespaces items0 space guarantee based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0SpaceGuarantee
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status Status information about the NVMe namespace.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
type ConsistencyGroupResponseRecordsItems0NamespacesItems0Status struct {

	// The state of the volume and aggregate that contain the NVMe namespace. Namespaces are only available when their containers are available.
	//
	// Enum: [online aggregate_offline volume_offline]
	ContainerState *string `json:"container_state,omitempty"`

	// Reports if the NVMe namespace is mapped to an NVMe subsystem.<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	Mapped *bool `json:"mapped,omitempty"`

	// Reports if the NVMe namespace allows only read access.
	//
	ReadOnly *bool `json:"read_only,omitempty"`

	// The state of the NVMe namespace. Normal states for a namespace are _online_ and _offline_. Other states indicate errors.
	//
	// Example: online
	// Enum: [nvfail offline online space_error]
	State *string `json:"state,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0 status
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateContainerState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeContainerStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["online","aggregate_offline","volume_offline"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeContainerStatePropEnum = append(consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeContainerStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// online
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateOnline captures enum value "online"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateOnline string = "online"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// aggregate_offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateAggregateOffline captures enum value "aggregate_offline"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateAggregateOffline string = "aggregate_offline"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// container_state
	// ContainerState
	// volume_offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateVolumeOffline captures enum value "volume_offline"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusContainerStateVolumeOffline string = "volume_offline"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) validateContainerStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeContainerStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) validateContainerState(formats strfmt.Registry) error {
	if swag.IsZero(m.ContainerState) { // not required
		return nil
	}

	// value enum
	if err := m.validateContainerStateEnum("status"+"."+"container_state", "body", *m.ContainerState); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["nvfail","offline","online","space_error"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeStatePropEnum = append(consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// state
	// State
	// nvfail
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateNvfail captures enum value "nvfail"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateNvfail string = "nvfail"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// state
	// State
	// offline
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateOffline captures enum value "offline"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateOffline string = "offline"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// state
	// State
	// online
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateOnline captures enum value "online"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateOnline string = "online"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	// state
	// State
	// space_error
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateSpaceError captures enum value "space_error"
	ConsistencyGroupResponseRecordsItems0NamespacesItems0StatusStateSpaceError string = "space_error"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0NamespacesItems0StatusTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("status"+"."+"state", "body", *m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 namespaces items0 status based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0Status) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0Status
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap The NVMe subsystem with which the NVMe namespace is associated. A namespace can be mapped to zero (0) or one (1) subsystems.<br/>
// There is an added computational cost to retrieving property values for `subsystem_map`.
// They are not populated for either a collection GET or an instance GET unless explicitly requested using the `fields` query parameter.
//
// swagger:model ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap
type ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The Asymmetric Namespace Access Group ID (ANAGRPID) of the NVMe namespace.<br/>
	// The format for an ANAGRPID is 8 hexadecimal digits (zero-filled) followed by a lower case "h".<br/>
	// There is an added computational cost to retrieving this property's value. It is not populated for either a collection GET or an instance GET unless it is explicitly requested using the `fields` query parameter. See [`Requesting specific fields`](#Requesting_specific_fields) to learn more.
	//
	// Example: 00103050h
	// Read Only: true
	Anagrpid *string `json:"anagrpid,omitempty"`

	// The NVMe namespace identifier. This is an identifier used by an NVMe controller to provide access to the NVMe namespace.<br/>
	// The format for an NVMe namespace identifier is 8 hexadecimal digits (zero-filled) followed by a lower case "h".
	//
	// Example: 00000001h
	// Read Only: true
	Nsid *string `json:"nsid,omitempty"`

	// The NVMe subsystem to which the NVMe namespace is mapped.
	//
	Subsystem *ConsistencyGroupNvmeSubsystem `json:"subsystem,omitempty"`
}

// Validate validates this consistency group response records items0 namespaces items0 subsystem map
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubsystem(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) validateSubsystem(formats strfmt.Registry) error {
	if swag.IsZero(m.Subsystem) { // not required
		return nil
	}

	if m.Subsystem != nil {
		if err := m.Subsystem.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "subsystem")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 namespaces items0 subsystem map based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateAnagrpid(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNsid(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSubsystem(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) contextValidateAnagrpid(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "subsystem_map"+"."+"anagrpid", "body", m.Anagrpid); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) contextValidateNsid(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "subsystem_map"+"."+"nsid", "body", m.Nsid); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) contextValidateSubsystem(ctx context.Context, formats strfmt.Registry) error {

	if m.Subsystem != nil {
		if err := m.Subsystem.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subsystem_map" + "." + "subsystem")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0NamespacesItems0SubsystemMap
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup The parent consistency group.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_parent_consistency_group
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the consistency group.
	// Example: my_consistency_group
	Name *string `json:"name,omitempty"`

	// The unique identifier of the consistency group.
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline parent consistency group
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline parent consistency group based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("parent_consistency_group" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineParentConsistencyGroup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions Options that are applied to the operation.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_provisioning_options
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions struct {

	// Operation to perform
	// Enum: [create]
	Action *string `json:"action,omitempty"`

	// storage service
	StorageService *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService `json:"storage_service,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline provisioning options
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_provisioning_options
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsActionCreate string = "create"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline provisioning options based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService Determines the placement of any storage object created during this operation.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_provisioning_options_inline_storage_service
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService struct {

	// Storage service name. If not specified, the default value is the most performant for the platform.
	//
	// Enum: [extreme performance value]
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline provisioning options inline storage service
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceTypeNamePropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_provisioning_options_inline_storage_service
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNameExtreme captures enum value "extreme"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_provisioning_options_inline_storage_service
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNamePerformance captures enum value "performance"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_provisioning_options_inline_storage_service
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNameValue captures enum value "value"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceNameValue string = "value"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("provisioning_options"+"."+"storage_service"+"."+"name", "body", *m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline provisioning options inline storage service based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineProvisioningOptionsInlineStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos consistency group response inline records inline array item inline qos
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_qos
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos struct {

	// policy
	Policy *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline qos
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline qos based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy The QoS policy
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_qos_inline_policy
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline qos inline policy
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline qos inline policy based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineQosInlinePolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo Use to restore a consistency group to a previous Snapshot copy
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_restore_to
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo struct {

	// snapshot
	Snapshot *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot `json:"snapshot,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline restore to
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSnapshot(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) validateSnapshot(formats strfmt.Registry) error {
	if swag.IsZero(m.Snapshot) { // not required
		return nil
	}

	if m.Snapshot != nil {
		if err := m.Snapshot.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to" + "." + "snapshot")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline restore to based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSnapshot(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) contextValidateSnapshot(ctx context.Context, formats strfmt.Registry) error {

	if m.Snapshot != nil {
		if err := m.Snapshot.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("restore_to" + "." + "snapshot")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreTo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot A consistency group's Snapshot copy
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_restore_to_inline_snapshot
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot struct {

	// The name of the consistency group's Snapshot copy to restore to.
	Name *string `json:"name,omitempty"`

	// The UUID of the consistency group's Snapshot copy to restore to.
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline restore to inline snapshot
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline restore to inline snapshot based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineRestoreToInlineSnapshot
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace Space information for the consistency group.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_space
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace struct {

	// The amount of space available in the consistency group, in bytes.<br/>
	//
	// Example: 5737418
	Available *int64 `json:"available,omitempty"`

	// The total provisioned size of the consistency group, in bytes.<br/>
	//
	// Example: 1073741824
	Size *int64 `json:"size,omitempty"`

	// The amount of space consumed in the consistency group, in bytes.<br/>
	//
	// Example: 5737418
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline space
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response inline records inline array item inline space based on context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSpace
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm The Storage Virtual Machine (SVM) in which the consistency group is located.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_svm
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm struct {

	// links
	Links *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks `json:"_links,omitempty"`

	// The name of the SVM.
	//
	// Example: svm1
	Name *string `json:"name,omitempty"`

	// The unique identifier of the SVM.
	//
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline svm
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline svm based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks consistency group response inline records inline array item inline svm inline links
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_svm_inline__links
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline svm inline links
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline svm inline links based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineSvmInlineLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering The tiering placement and policy definitions for volumes in this consistency group.
//
// swagger:model consistency_group_response_inline_records_inline_array_item_inline_tiering
type ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering struct {

	// Storage tiering placement rules for the object.
	// Enum: [allowed best_effort disallowed required]
	Control *string `json:"control,omitempty"`

	// Object stores to use. Used for placement.
	//
	// Max Items: 2
	// Min Items: 0
	ObjectStores []*ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0 `json:"object_stores"`

	// Policy that determines whether the user data blocks of a volume in a FabricPool will be tiered to the cloud store when they become cold.
	// <br>FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of a volume block increases if it is accessed frequently and decreases when it is not. Valid in POST or PATCH.<br/>all &dash; Allows tiering of both Snapshot copies and active file system user data to the cloud store as soon as possible by ignoring the temperature on the volume blocks.<br/>auto &dash; Allows tiering of both snapshot and active file system user data to the cloud store<br/>none &dash; Volume blocks are not be tiered to the cloud store.<br/>snapshot_only &dash; Allows tiering of only the volume Snapshot copies not associated with the active file system.
	// <br>The default tiering policy is "snapshot-only" for a FlexVol volume and "none" for a FlexGroup volume. The default minimum cooling period for the "snapshot-only" tiering policy is 2 days and for the "auto" tiering policy it is 31 days.
	//
	// Enum: [all auto backup none snapshot_only]
	Policy *string `json:"policy,omitempty"`
}

// Validate validates this consistency group response inline records inline array item inline tiering
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateControl(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateObjectStores(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypeControlPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["allowed","best_effort","disallowed","required"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypeControlPropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypeControlPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// control
	// Control
	// allowed
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlAllowed captures enum value "allowed"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlAllowed string = "allowed"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// control
	// Control
	// best_effort
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlBestEffort captures enum value "best_effort"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlBestEffort string = "best_effort"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// control
	// Control
	// disallowed
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlDisallowed captures enum value "disallowed"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlDisallowed string = "disallowed"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// control
	// Control
	// required
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlRequired captures enum value "required"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringControlRequired string = "required"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) validateControlEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypeControlPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) validateControl(formats strfmt.Registry) error {
	if swag.IsZero(m.Control) { // not required
		return nil
	}

	// value enum
	if err := m.validateControlEnum("tiering"+"."+"control", "body", *m.Control); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) validateObjectStores(formats strfmt.Registry) error {
	if swag.IsZero(m.ObjectStores) { // not required
		return nil
	}

	iObjectStoresSize := int64(len(m.ObjectStores))

	if err := validate.MinItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 2); err != nil {
		return err
	}

	for i := 0; i < len(m.ObjectStores); i++ {
		if swag.IsZero(m.ObjectStores[i]) { // not required
			continue
		}

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypePolicyPropEnum = append(consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypePolicyPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// policy
	// Policy
	// all
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyAll captures enum value "all"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyAll string = "all"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// policy
	// Policy
	// auto
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyAuto captures enum value "auto"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyAuto string = "auto"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// policy
	// Policy
	// backup
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyBackup captures enum value "backup"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyBackup string = "backup"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// policy
	// Policy
	// none
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyNone captures enum value "none"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicyNone string = "none"

	// BEGIN DEBUGGING
	// consistency_group_response_inline_records_inline_array_item_inline_tiering
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	// policy
	// Policy
	// snapshot_only
	// END DEBUGGING
	// ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicySnapshotOnly captures enum value "snapshot_only"
	ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseInlineRecordsInlineArrayItemInlineTieringTypePolicyPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", *m.Policy); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response inline records inline array item inline tiering based on the context it is used
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateObjectStores(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) contextValidateObjectStores(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ObjectStores); i++ {

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseInlineRecordsInlineArrayItemInlineTiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0 consistency group response records items0 tiering object stores items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0
type ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0 struct {

	// The name of the object store to use. Used for placement.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 tiering object stores items0
func (m *ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 tiering object stores items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0TieringObjectStoresItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0 consistency group response records items0 volumes items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0
type ConsistencyGroupResponseRecordsItems0VolumesItems0 struct {

	// A comment for the volume. Valid in POST or PATCH.
	// Max Length: 1023
	// Min Length: 0
	Comment *string `json:"comment,omitempty"`

	// Language encoding setting for volume. If no language is specified, the volume inherits its SVM language encoding setting.
	// Enum: [ar ar.utf_8 c c.utf_8 cs cs.utf_8 da da.utf_8 de de.utf_8 en en.utf_8 en_us en_us.utf_8 es es.utf_8 fi fi.utf_8 fr fr.utf_8 he he.utf_8 hr hr.utf_8 hu hu.utf_8 it it.utf_8 ja ja.utf_8 ja_jp.932 ja_jp.932.utf_8 ja_jp.pck ja_jp.pck.utf_8 ja_jp.pck_v2 ja_jp.pck_v2.utf_8 ja_v1 ja_v1.utf_8 ko ko.utf_8 nl nl.utf_8 no no.utf_8 pl pl.utf_8 pt pt.utf_8 ro ro.utf_8 ru ru.utf_8 sk sk.utf_8 sl sl.utf_8 sv sv.utf_8 tr tr.utf_8 utf8mb4 zh zh.gbk zh.gbk.utf_8 zh.utf_8 zh_tw zh_tw.big5 zh_tw.big5.utf_8 zh_tw.utf_8]
	Language *string `json:"language,omitempty"`

	// Volume name. The name of volume must start with an alphabetic character (a to z or A to Z) or an underscore (_). The name must be 197 or fewer characters in length for FlexGroups, and 203 or fewer characters in length for all other types of volumes. Volume names must be unique within an SVM. Required on POST.
	// Example: vol_cs_dept
	// Max Length: 203
	// Min Length: 1
	Name *string `json:"name,omitempty"`

	// nas
	Nas *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas `json:"nas,omitempty"`

	// provisioning options
	ProvisioningOptions *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions `json:"provisioning_options,omitempty"`

	// qos
	Qos *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos `json:"qos,omitempty"`

	// The Snapshot copy policy for this volume.
	//
	SnapshotPolicy *SnapshotPolicyReference `json:"snapshot_policy,omitempty"`

	// space
	Space *ConsistencyGroupResponseRecordsItems0VolumesItems0Space `json:"space,omitempty"`

	// tiering
	Tiering *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering `json:"tiering,omitempty"`

	// Unique identifier for the volume. This corresponds to the instance-uuid that is exposed in the CLI and ONTAPI. It does not change due to a volume move.
	// Example: 028baa66-41bd-11e9-81d5-00a0986138f7
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateComment(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLanguage(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNas(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProvisioningOptions(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateQos(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSnapshotPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSpace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTiering(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateComment(formats strfmt.Registry) error {
	if swag.IsZero(m.Comment) { // not required
		return nil
	}

	if err := validate.MinLength("comment", "body", *m.Comment, 0); err != nil {
		return err
	}

	if err := validate.MaxLength("comment", "body", *m.Comment, 1023); err != nil {
		return err
	}

	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0TypeLanguagePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ar","ar.utf_8","c","c.utf_8","cs","cs.utf_8","da","da.utf_8","de","de.utf_8","en","en.utf_8","en_us","en_us.utf_8","es","es.utf_8","fi","fi.utf_8","fr","fr.utf_8","he","he.utf_8","hr","hr.utf_8","hu","hu.utf_8","it","it.utf_8","ja","ja.utf_8","ja_jp.932","ja_jp.932.utf_8","ja_jp.pck","ja_jp.pck.utf_8","ja_jp.pck_v2","ja_jp.pck_v2.utf_8","ja_v1","ja_v1.utf_8","ko","ko.utf_8","nl","nl.utf_8","no","no.utf_8","pl","pl.utf_8","pt","pt.utf_8","ro","ro.utf_8","ru","ru.utf_8","sk","sk.utf_8","sl","sl.utf_8","sv","sv.utf_8","tr","tr.utf_8","utf8mb4","zh","zh.gbk","zh.gbk.utf_8","zh.utf_8","zh_tw","zh_tw.big5","zh_tw.big5.utf_8","zh_tw.utf_8"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0TypeLanguagePropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0TypeLanguagePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ar
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageAr captures enum value "ar"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageAr string = "ar"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ar.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageArDotUTF8 captures enum value "ar.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageArDotUTF8 string = "ar.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// c
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageC captures enum value "c"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageC string = "c"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// c.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCDotUTF8 captures enum value "c.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCDotUTF8 string = "c.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// cs
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCs captures enum value "cs"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCs string = "cs"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// cs.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCsDotUTF8 captures enum value "cs.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageCsDotUTF8 string = "cs.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// da
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDa captures enum value "da"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDa string = "da"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// da.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDaDotUTF8 captures enum value "da.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDaDotUTF8 string = "da.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// de
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDe captures enum value "de"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDe string = "de"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// de.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDeDotUTF8 captures enum value "de.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageDeDotUTF8 string = "de.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// en
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEn captures enum value "en"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEn string = "en"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// en.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnDotUTF8 captures enum value "en.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnDotUTF8 string = "en.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// en_us
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnUs captures enum value "en_us"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnUs string = "en_us"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// en_us.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnUsDotUTF8 captures enum value "en_us.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEnUsDotUTF8 string = "en_us.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// es
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEs captures enum value "es"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEs string = "es"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// es.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEsDotUTF8 captures enum value "es.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageEsDotUTF8 string = "es.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// fi
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFi captures enum value "fi"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFi string = "fi"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// fi.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFiDotUTF8 captures enum value "fi.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFiDotUTF8 string = "fi.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// fr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFr captures enum value "fr"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFr string = "fr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// fr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFrDotUTF8 captures enum value "fr.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageFrDotUTF8 string = "fr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// he
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHe captures enum value "he"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHe string = "he"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// he.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHeDotUTF8 captures enum value "he.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHeDotUTF8 string = "he.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// hr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHr captures enum value "hr"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHr string = "hr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// hr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHrDotUTF8 captures enum value "hr.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHrDotUTF8 string = "hr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// hu
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHu captures enum value "hu"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHu string = "hu"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// hu.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHuDotUTF8 captures enum value "hu.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageHuDotUTF8 string = "hu.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// it
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageIt captures enum value "it"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageIt string = "it"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// it.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageItDotUTF8 captures enum value "it.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageItDotUTF8 string = "it.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJa captures enum value "ja"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJa string = "ja"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaDotUTF8 captures enum value "ja.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaDotUTF8 string = "ja.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.932
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDot932 captures enum value "ja_jp.932"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDot932 string = "ja_jp.932"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.932.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDot932DotUTF8 captures enum value "ja_jp.932.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDot932DotUTF8 string = "ja_jp.932.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPck captures enum value "ja_jp.pck"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPck string = "ja_jp.pck"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckDotUTF8 captures enum value "ja_jp.pck.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckDotUTF8 string = "ja_jp.pck.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck_v2
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckV2 captures enum value "ja_jp.pck_v2"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckV2 string = "ja_jp.pck_v2"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_jp.pck_v2.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckV2DotUTF8 captures enum value "ja_jp.pck_v2.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaJpDotPckV2DotUTF8 string = "ja_jp.pck_v2.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_v1
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaV1 captures enum value "ja_v1"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaV1 string = "ja_v1"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ja_v1.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaV1DotUTF8 captures enum value "ja_v1.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageJaV1DotUTF8 string = "ja_v1.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ko
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageKo captures enum value "ko"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageKo string = "ko"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ko.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageKoDotUTF8 captures enum value "ko.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageKoDotUTF8 string = "ko.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// nl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNl captures enum value "nl"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNl string = "nl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// nl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNlDotUTF8 captures enum value "nl.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNlDotUTF8 string = "nl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// no
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNo captures enum value "no"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNo string = "no"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// no.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNoDotUTF8 captures enum value "no.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageNoDotUTF8 string = "no.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// pl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePl captures enum value "pl"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePl string = "pl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// pl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePlDotUTF8 captures enum value "pl.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePlDotUTF8 string = "pl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// pt
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePt captures enum value "pt"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePt string = "pt"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// pt.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePtDotUTF8 captures enum value "pt.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguagePtDotUTF8 string = "pt.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ro
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRo captures enum value "ro"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRo string = "ro"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ro.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRoDotUTF8 captures enum value "ro.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRoDotUTF8 string = "ro.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ru
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRu captures enum value "ru"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRu string = "ru"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// ru.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRuDotUTF8 captures enum value "ru.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageRuDotUTF8 string = "ru.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sk
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSk captures enum value "sk"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSk string = "sk"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sk.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSkDotUTF8 captures enum value "sk.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSkDotUTF8 string = "sk.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sl
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSl captures enum value "sl"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSl string = "sl"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sl.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSlDotUTF8 captures enum value "sl.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSlDotUTF8 string = "sl.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sv
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSv captures enum value "sv"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSv string = "sv"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// sv.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSvDotUTF8 captures enum value "sv.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageSvDotUTF8 string = "sv.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// tr
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageTr captures enum value "tr"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageTr string = "tr"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// tr.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageTrDotUTF8 captures enum value "tr.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageTrDotUTF8 string = "tr.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// utf8mb4
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageUtf8mb4 captures enum value "utf8mb4"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageUtf8mb4 string = "utf8mb4"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZh captures enum value "zh"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZh string = "zh"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh.gbk
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotGbk captures enum value "zh.gbk"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotGbk string = "zh.gbk"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh.gbk.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotGbkDotUTF8 captures enum value "zh.gbk.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotGbkDotUTF8 string = "zh.gbk.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotUTF8 captures enum value "zh.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhDotUTF8 string = "zh.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh_tw
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTw captures enum value "zh_tw"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTw string = "zh_tw"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh_tw.big5
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotBig5 captures enum value "zh_tw.big5"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotBig5 string = "zh_tw.big5"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh_tw.big5.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotBig5DotUTF8 captures enum value "zh_tw.big5.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotBig5DotUTF8 string = "zh_tw.big5.utf_8"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// ConsistencyGroupResponseRecordsItems0VolumesItems0
	// language
	// Language
	// zh_tw.utf_8
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotUTF8 captures enum value "zh_tw.utf_8"
	ConsistencyGroupResponseRecordsItems0VolumesItems0LanguageZhTwDotUTF8 string = "zh_tw.utf_8"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateLanguageEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0TypeLanguagePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateLanguage(formats strfmt.Registry) error {
	if swag.IsZero(m.Language) { // not required
		return nil
	}

	// value enum
	if err := m.validateLanguageEnum("language", "body", *m.Language); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	if err := validate.MinLength("name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", *m.Name, 203); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateNas(formats strfmt.Registry) error {
	if swag.IsZero(m.Nas) { // not required
		return nil
	}

	if m.Nas != nil {
		if err := m.Nas.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateProvisioningOptions(formats strfmt.Registry) error {
	if swag.IsZero(m.ProvisioningOptions) { // not required
		return nil
	}

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateQos(formats strfmt.Registry) error {
	if swag.IsZero(m.Qos) { // not required
		return nil
	}

	if m.Qos != nil {
		if err := m.Qos.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateSnapshotPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.SnapshotPolicy) { // not required
		return nil
	}

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateSpace(formats strfmt.Registry) error {
	if swag.IsZero(m.Space) { // not required
		return nil
	}

	if m.Space != nil {
		if err := m.Space.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) validateTiering(formats strfmt.Registry) error {
	if swag.IsZero(m.Tiering) { // not required
		return nil
	}

	if m.Tiering != nil {
		if err := m.Tiering.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateNas(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProvisioningOptions(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateQos(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSnapshotPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSpace(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTiering(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateNas(ctx context.Context, formats strfmt.Registry) error {

	if m.Nas != nil {
		if err := m.Nas.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateProvisioningOptions(ctx context.Context, formats strfmt.Registry) error {

	if m.ProvisioningOptions != nil {
		if err := m.ProvisioningOptions.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateQos(ctx context.Context, formats strfmt.Registry) error {

	if m.Qos != nil {
		if err := m.Qos.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateSnapshotPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.SnapshotPolicy != nil {
		if err := m.SnapshotPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("snapshot_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateSpace(ctx context.Context, formats strfmt.Registry) error {

	if m.Space != nil {
		if err := m.Space.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("space")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateTiering(ctx context.Context, formats strfmt.Registry) error {

	if m.Tiering != nil {
		if err := m.Tiering.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("tiering")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas The CIFS share policy and/or export policies for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
type ConsistencyGroupResponseRecordsItems0VolumesItems0Nas struct {

	// cifs
	Cifs *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs `json:"cifs,omitempty"`

	// export policy
	ExportPolicy *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy `json:"export_policy,omitempty"`

	// The UNIX group ID of the volume. Valid in POST or PATCH.
	Gid *int64 `json:"gid,omitempty"`

	// junction parent
	JunctionParent *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent `json:"junction_parent,omitempty"`

	// The fully-qualified path in the owning SVM's namespace at which the volume is mounted. The path is case insensitive and must be unique within an SVM's namespace. Path must begin with '/' and must not end with '/'. Only one volume can be mounted at any given junction path. An empty path in POST creates an unmounted volume. An empty path in PATCH deactivates and unmounts the volume. Taking a volume offline or restricted state removes its junction path. This attribute is reported in GET only when the volume is mounted.
	// Example: /user/my_volume
	Path *string `json:"path,omitempty"`

	// Security style associated with the volume. Valid in POST or PATCH.<br>mixed &dash; Mixed-style security<br>ntfs &dash; NTFS/WIndows-style security<br>unified &dash; Unified-style security, unified UNIX, NFS and CIFS permissions<br>unix &dash; UNIX-style security.
	// Enum: [mixed ntfs unified unix]
	SecurityStyle *string `json:"security_style,omitempty"`

	// The UNIX user ID of the volume. Valid in POST or PATCH.
	UID *int64 `json:"uid,omitempty"`

	// UNIX permissions to be viewed as an octal number, consisting of 4 digits derived by adding up bits 4 (read), 2 (write), and 1 (execute). First digit selects the set user ID (4), set group ID (2), and sticky (1) attributes. Second digit selects permission for the owner of the file. Third selects permissions for other users in the same group while the fourth selects permissions for other users not in the group. Valid in POST or PATCH. For security style "mixed" or "unix", the default setting is 0755 in octal (493 in decimal) and for security style "ntfs", the default setting is 0000. In cases where only owner, group, and other permissions are given (as in 755, representing the second, third and fourth digit), the first digit is assumed to be zero.
	// Example: 755
	UnixPermissions *int64 `json:"unix_permissions,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 nas
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCifs(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateExportPolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateJunctionParent(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSecurityStyle(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) validateCifs(formats strfmt.Registry) error {
	if swag.IsZero(m.Cifs) { // not required
		return nil
	}

	if m.Cifs != nil {
		if err := m.Cifs.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "cifs")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) validateExportPolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.ExportPolicy) { // not required
		return nil
	}

	if m.ExportPolicy != nil {
		if err := m.ExportPolicy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) validateJunctionParent(formats strfmt.Registry) error {
	if swag.IsZero(m.JunctionParent) { // not required
		return nil
	}

	if m.JunctionParent != nil {
		if err := m.JunctionParent.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent")
			}
			return err
		}
	}

	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0NasTypeSecurityStylePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["mixed","ntfs","unified","unix"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0NasTypeSecurityStylePropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0NasTypeSecurityStylePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// mixed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleMixed captures enum value "mixed"
	ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleMixed string = "mixed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// ntfs
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleNtfs captures enum value "ntfs"
	ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleNtfs string = "ntfs"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// unified
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleUnified captures enum value "unified"
	ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleUnified string = "unified"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	// security_style
	// SecurityStyle
	// unix
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleUnix captures enum value "unix"
	ConsistencyGroupResponseRecordsItems0VolumesItems0NasSecurityStyleUnix string = "unix"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) validateSecurityStyleEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0NasTypeSecurityStylePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) validateSecurityStyle(formats strfmt.Registry) error {
	if swag.IsZero(m.SecurityStyle) { // not required
		return nil
	}

	// value enum
	if err := m.validateSecurityStyleEnum("nas"+"."+"security_style", "body", *m.SecurityStyle); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 nas based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCifs(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateExportPolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateJunctionParent(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) contextValidateCifs(ctx context.Context, formats strfmt.Registry) error {

	if m.Cifs != nil {
		if err := m.Cifs.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "cifs")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) contextValidateExportPolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.ExportPolicy != nil {
		if err := m.ExportPolicy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) contextValidateJunctionParent(ctx context.Context, formats strfmt.Registry) error {

	if m.JunctionParent != nil {
		if err := m.JunctionParent.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Nas) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0Nas
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs consistency group response records items0 volumes items0 nas cifs
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs
type ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs struct {

	// shares
	Shares []*ConsistencyGroupCifsShare `json:"shares"`
}

// Validate validates this consistency group response records items0 volumes items0 nas cifs
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateShares(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) validateShares(formats strfmt.Registry) error {
	if swag.IsZero(m.Shares) { // not required
		return nil
	}

	for i := 0; i < len(m.Shares); i++ {
		if swag.IsZero(m.Shares[i]) { // not required
			continue
		}

		if m.Shares[i] != nil {
			if err := m.Shares[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "cifs" + "." + "shares" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 nas cifs based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateShares(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) contextValidateShares(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Shares); i++ {

		if m.Shares[i] != nil {
			if err := m.Shares[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "cifs" + "." + "shares" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0NasCifs
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy The policy associated with volumes to export them for protocol access.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy
type ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Name of the export policy.
	Name *string `json:"name,omitempty"`

	// The set of rules that govern the export policy.
	Rules []*ExportRules `json:"rules"`

	// Identifier for the export policy.
	// Read Only: true
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 nas export policy
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRules(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) validateRules(formats strfmt.Registry) error {
	if swag.IsZero(m.Rules) { // not required
		return nil
	}

	for i := 0; i < len(m.Rules); i++ {
		if swag.IsZero(m.Rules[i]) { // not required
			continue
		}

		if m.Rules[i] != nil {
			if err := m.Rules[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "export_policy" + "." + "rules" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 nas export policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateRules(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "export_policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) contextValidateRules(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Rules); i++ {

		if m.Rules[i] != nil {
			if err := m.Rules[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nas" + "." + "export_policy" + "." + "rules" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "nas"+"."+"export_policy"+"."+"uuid", "body", m.UUID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0NasExportPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent consistency group response records items0 volumes items0 nas junction parent
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent
type ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// The name of the parent volume that contains the junction inode of this volume. The junction parent volume must belong to the same SVM that owns this volume.
	// Example: vs1_root
	Name *string `json:"name,omitempty"`

	// Unique identifier for the parent volume.
	// Example: 75c9cfb0-3eb4-11eb-9fb4-005056bb088a
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 nas junction parent
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 nas junction parent based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("nas" + "." + "junction_parent" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0NasJunctionParent
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions Options that are applied to the operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
type ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions struct {

	// Operation to perform
	// Enum: [create add remove]
	Action *string `json:"action,omitempty"`

	// Number of elements to perform the operation on.
	Count *int64 `json:"count,omitempty"`

	// storage service
	StorageService *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService `json:"storage_service,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 provisioning options
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAction(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["create","add","remove"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// create
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionCreate captures enum value "create"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionCreate string = "create"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// add
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionAdd captures enum value "add"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionAdd string = "add"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	// action
	// Action
	// remove
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionRemove captures enum value "remove"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsActionRemove string = "remove"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) validateActionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsTypeActionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) validateAction(formats strfmt.Registry) error {
	if swag.IsZero(m.Action) { // not required
		return nil
	}

	// value enum
	if err := m.validateActionEnum("provisioning_options"+"."+"action", "body", *m.Action); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 provisioning options based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("provisioning_options" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptions
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService Determines the placement of any storage object created during this operation.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
type ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService struct {

	// Storage service name. If not specified, the default value is the most performant for the platform.
	//
	// Enum: [extreme performance value]
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 provisioning options storage service
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNameExtreme captures enum value "extreme"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNamePerformance captures enum value "performance"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNameValue captures enum value "value"
	ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceNameValue string = "value"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("provisioning_options"+"."+"storage_service"+"."+"name", "body", *m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this consistency group response records items0 volumes items0 provisioning options storage service based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0ProvisioningOptionsStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0Qos The QoS policy for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0Qos
type ConsistencyGroupResponseRecordsItems0VolumesItems0Qos struct {

	// policy
	Policy *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 qos
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 qos based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Qos) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0Qos
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy The QoS policy
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy
type ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Specifies the maximum throughput in IOPS, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 10000
	MaxThroughputIops *int64 `json:"max_throughput_iops,omitempty"`

	// Specifies the maximum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MaxThroughputMbps *int64 `json:"max_throughput_mbps,omitempty"`

	// Specifies the minimum throughput in IOPS, 0 means none. Setting "min_throughput" is supported on AFF platforms only, unless FabricPool tiering policies are set. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 2000
	MinThroughputIops *int64 `json:"min_throughput_iops,omitempty"`

	// Specifies the minimum throughput in Megabytes per sec, 0 means none. This is mutually exclusive with name and UUID during POST and PATCH.
	// Example: 500
	MinThroughputMbps *int64 `json:"min_throughput_mbps,omitempty"`

	// The QoS policy group name. This is mutually exclusive with UUID and other QoS attributes during POST and PATCH.
	// Example: performance
	Name *string `json:"name,omitempty"`

	// The QoS policy group UUID. This is mutually exclusive with name and other QoS attributes during POST and PATCH.
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID *string `json:"uuid,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 qos policy
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 qos policy based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("qos" + "." + "policy" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0QosPolicy
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0Space consistency group response records items0 volumes items0 space
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0Space
type ConsistencyGroupResponseRecordsItems0VolumesItems0Space struct {

	// The available space, in bytes.
	Available *int64 `json:"available,omitempty"`

	// Total provisioned size, in bytes.
	Size *int64 `json:"size,omitempty"`

	// The virtual space used (includes volume reserves) before storage efficiency, in bytes.
	Used *int64 `json:"used,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 space
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Space) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 volumes items0 space based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Space) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Space) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Space) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0Space
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering The tiering placement and policy definitions for this volume.
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
type ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering struct {

	// Storage tiering placement rules for the object.
	// Enum: [allowed best_effort disallowed required]
	Control *string `json:"control,omitempty"`

	// Object stores to use. Used for placement.
	//
	// Max Items: 2
	// Min Items: 0
	ObjectStores []*ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0 `json:"object_stores"`

	// Policy that determines whether the user data blocks of a volume in a FabricPool will be tiered to the cloud store when they become cold.
	// <br>FabricPool combines flash (performance tier) with a cloud store into a single aggregate. Temperature of a volume block increases if it is accessed frequently and decreases when it is not. Valid in POST or PATCH.<br/>all &dash; Allows tiering of both Snapshot copies and active file system user data to the cloud store as soon as possible by ignoring the temperature on the volume blocks.<br/>auto &dash; Allows tiering of both snapshot and active file system user data to the cloud store<br/>none &dash; Volume blocks are not be tiered to the cloud store.<br/>snapshot_only &dash; Allows tiering of only the volume Snapshot copies not associated with the active file system.
	// <br>The default tiering policy is "snapshot-only" for a FlexVol volume and "none" for a FlexGroup volume. The default minimum cooling period for the "snapshot-only" tiering policy is 2 days and for the "auto" tiering policy it is 31 days.
	//
	// Enum: [all auto backup none snapshot_only]
	Policy *string `json:"policy,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 tiering
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateControl(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateObjectStores(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0TieringTypeControlPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["allowed","best_effort","disallowed","required"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0TieringTypeControlPropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0TieringTypeControlPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// control
	// Control
	// allowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlAllowed captures enum value "allowed"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlAllowed string = "allowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// control
	// Control
	// best_effort
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlBestEffort captures enum value "best_effort"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlBestEffort string = "best_effort"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// control
	// Control
	// disallowed
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlDisallowed captures enum value "disallowed"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlDisallowed string = "disallowed"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// control
	// Control
	// required
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlRequired captures enum value "required"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringControlRequired string = "required"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) validateControlEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0TieringTypeControlPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) validateControl(formats strfmt.Registry) error {
	if swag.IsZero(m.Control) { // not required
		return nil
	}

	// value enum
	if err := m.validateControlEnum("tiering"+"."+"control", "body", *m.Control); err != nil {
		return err
	}

	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) validateObjectStores(formats strfmt.Registry) error {
	if swag.IsZero(m.ObjectStores) { // not required
		return nil
	}

	iObjectStoresSize := int64(len(m.ObjectStores))

	if err := validate.MinItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 0); err != nil {
		return err
	}

	if err := validate.MaxItems("tiering"+"."+"object_stores", "body", iObjectStoresSize, 2); err != nil {
		return err
	}

	for i := 0; i < len(m.ObjectStores); i++ {
		if swag.IsZero(m.ObjectStores[i]) { // not required
			continue
		}

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

var consistencyGroupResponseRecordsItems0VolumesItems0TieringTypePolicyPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["all","auto","backup","none","snapshot_only"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		consistencyGroupResponseRecordsItems0VolumesItems0TieringTypePolicyPropEnum = append(consistencyGroupResponseRecordsItems0VolumesItems0TieringTypePolicyPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// policy
	// Policy
	// all
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyAll captures enum value "all"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyAll string = "all"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// policy
	// Policy
	// auto
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyAuto captures enum value "auto"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyAuto string = "auto"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// policy
	// Policy
	// backup
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyBackup captures enum value "backup"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyBackup string = "backup"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// policy
	// Policy
	// none
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyNone captures enum value "none"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicyNone string = "none"

	// BEGIN DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	// policy
	// Policy
	// snapshot_only
	// END DEBUGGING
	// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicySnapshotOnly captures enum value "snapshot_only"
	ConsistencyGroupResponseRecordsItems0VolumesItems0TieringPolicySnapshotOnly string = "snapshot_only"
)

// prop value enum
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) validatePolicyEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, consistencyGroupResponseRecordsItems0VolumesItems0TieringTypePolicyPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	// value enum
	if err := m.validatePolicyEnum("tiering"+"."+"policy", "body", *m.Policy); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this consistency group response records items0 volumes items0 tiering based on the context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateObjectStores(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) contextValidateObjectStores(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.ObjectStores); i++ {

		if m.ObjectStores[i] != nil {
			if err := m.ObjectStores[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("tiering" + "." + "object_stores" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0Tiering
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0 consistency group response records items0 volumes items0 tiering object stores items0
//
// swagger:model ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0
type ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0 struct {

	// The name of the object store to use. Used for placement.
	Name *string `json:"name,omitempty"`
}

// Validate validates this consistency group response records items0 volumes items0 tiering object stores items0
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this consistency group response records items0 volumes items0 tiering object stores items0 based on context it is used
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0) UnmarshalBinary(b []byte) error {
	var res ConsistencyGroupResponseRecordsItems0VolumesItems0TieringObjectStoresItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
